'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'   
'                                               . 19.08.2004

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function rpl_get_current_terrain_descr(cn)
 set rpl_get_current_terrain_descr=nothing

 dim rs
 set rs=cn.execute("select t.terrain_global_id,t.name"&vbCrLf& _
                   "from rpl_current_terrain ct join rpl_terrain t"&vbCrLf& _
                          "on ct.terrain_id=t.terrain_id")

 if(rs.eof)then
  exit function
 end if
 
 dim x
 set x=new t_terrain_descr
 
 x.global_id=rs("terrain_global_id").value
 x.name     =rs("name")
 
 if(IsNull(x.global_id))then
  call err.raise(-1,c_err_source,"DATABASE ["&db_location&"] HAS [NULL] TERRAIN GLOBAL ID")
 end if

 '      
 call rs.movenext()

 if(not rs.eof)then
  call err.raise(-1,c_err_source,"DATABASE ["&db_location&"] HAS MANY OWN TERRAIN ID's")
 end if
 
 set rpl_get_current_terrain_descr=x
end function 'rpl_get_current_terrain_descr

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function rpl_get_backup_state_name(id)
 dim t

 select case (id)
  case 0 '  rplBackState_Start
   t="Start"

  case 1 '  rplBackState_Analyse
   t="Analyse"

  case 2 '  rplBackState_BuildElements
   t="BuildElements"

  case 3 '  rplBackState_SaveDependencies
   t="SaveDependencies"

  case 4 '  rplBackState_SaveBornIDs
   t="SaveBornIDs"

  case 5 '  rplBackState_SaveElements
   t="SaveElements"

  case 6 '  rplBackState_FixChanges
   t="FixChanges"

  case 7 '  rplBackState_InternalCheck
   t="InternalCheck"

  case 8 '  rplBackState_MarkDeadElements
   t="MarkDeadElements"

  case 9 '  rplBackState_RemoveDeadElements
   t="RemoveDeadElements"

  case -1'  rplBackState_Error
   t="Error"

  case else
   t="Unknown state #"&cstr(id)
 end select
 
 rpl_get_backup_state_name=t
end function 'rpl_get_backup_state_name

'-------------------------------------------------------------------------------
function rpl_std_backup_eng_OnProgress_Message(state)
 dim msg

 msg="BACK:"&rpl_get_backup_state_name(state.state)&" - "

 msg=msg&"total:["&cstr(state.CurCount)&"/"&cstr(state.TotalCount)&"] "

 msg=msg&"pack:["&cstr(state.PackCount)&"]"
 
 msg=msg&"["&cstr(state.CurPackProcessed)&"/"&cstr(state.CurPackSize)&"]"

 rpl_std_backup_eng_OnProgress_Message=msg
end function 'rpl_std_backup_eng_OnProgress_Message

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function rpl_get_restore_state_name(state_id)
 dim t

 select case clng(state_id)
  case 0
   t="Start"
  case 1
   t="LoadPackData"
  case 2
   t="LoadDependencies"
  case 3
   t="Sort"
  case 4
   t="BuildIndex"
  case 5
   t="Restore"
  case 6
   t="SaveBornID"
  case 7
   t="LoadBornID"
  case 8
   t="LoadLinkDependencies"
  case 9
   t="LoadLinkBornID"
  case 10
   t="FixChanges"
  case -1
   t="Error"

  case else
   t="Unknown state #"&cstr(state_id)
 end select
 
 rpl_get_restore_state_name=t
end function 'rpl_get_restore_state_name

'-------------------------------------------------------------------------
function rpl_std_restore_eng_OnProgress_Message(state)
 dim msg

 msg="REST: "&rpl_get_restore_state_name(state.state)
 
 msg=msg&" CurCount:"&cstr(state.CurCount)
 msg=msg&" TotalCount:"&cstr(state.TotalCount)&"."
 msg=msg&" TerrainGlobalID:"&cstr(state.SourceTerrainGlobalID)
 msg=msg&" PackID:"&cstr(state.SourcePackID)

 rpl_std_restore_eng_OnProgress_Message=msg
end function 'rpl_std_restore_eng_OnProgress_Message

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function rpl_build_id_null_mask(byref id1,  _
                                byref id2,  _
                                byref id3,  _
                                byref id4,  _
                                byref id5,  _
                                byref id6,  _
                                byref id7,  _
                                byref id8)
 dim x
 
 x=0
 
 '----------------
 if(IsNull(id1))then
  x=x+1

  id1=0
 end if
 
 '----------------
 if(IsNull(id2))then
  x=x+2

  id2=0
 end if

 '----------------
 if(IsNull(id3))then
  x=x+4

  id3=0
 end if

 '----------------
 if(IsNull(id4))then
  x=x+8

  id4=0
 end if

 '----------------
 if(IsNull(id5))then
  x=x+16

  id5=0
 end if

 '----------------
 if(IsNull(id6))then
  x=x+32

  id6=0
 end if

 '----------------
 if(IsNull(id7))then
  x=x+64

  id7=0
 end if

 '----------------
 if(IsNull(id8))then
  x=x+128

  id8=0
 end if

 '----------------
 rpl_build_id_null_mask=x
end function 'rpl_build_id_null_mask
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

