'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'RPL Backup Engine.    
'                                                 . 24.08.2005.

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_rpl_backup_engine_journal

class t_rpl_backup_engine_journal
 private c_err_source
 
 private m_cn
 
 '   
 private m_collection
 
 '  (:   m_collection)
 private m_collection_idx
 
 'class_initialize -------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_rpl_backup_engine_journal"
  
  set m_cn              =nothing
  set m_collection      =nothing
  set m_collection_idx  =nothing
  
  set m_collection      =su_create_object("LCPI.DBS.RPL.BackupCollection")
  set m_collection_idx  =su_create_object("Scripting.Dictionary")
 end sub 'class_initialize
 
 'properties -------------------------------------------------------------
 public property set connection(cn)
  set m_cn=cn
  
  m_collection.Connection=m_cn
 end property 'connectiton
 
 '------------------------------------------------------------------------
 public property get connection()
  set connection=m_cn
 end property 'connection
 
 '------------------------------------------------------------------------
 public property get elements()
  set elements=m_collection
 end property 'elements

 '------------------------------------------------------------------------
 public property get size()
  size=m_collection.Count
 end property 'size
 
 '------------------------------------------------------------------------
 public function Item(index)
  set Item=m_collection.Item(Index)
 end function 'Item

 'interface --------------------------------------------------------------
 public sub AddObj(obj_id,obj_class)
  dim msg

  if(IsNull(obj_id) and IsNull(obj_class))then
   exit sub
  end if
  
  if(IsNull(obj_id) or IsNull(obj_class))then
   call error_raise(-1,"  ")
  end if
  
  if(not verify_rpl_id_type(obj_id))then
   msg=" vt- ["&vartype(obj_id)&"] obj_id"

   call error_raise(-1,msg)
  end if

  if(not verify_rpl_id_type(obj_class))then
   msg=" vt- ["&vartype(obj_class)&"] obj_class"
  
   call error_raise(-1,msg)
  end if
  
  dim idx_str
  idx_str="obj_"&cstr(obj_id)&"_"&cstr(obj_class)
  
  if(m_collection_idx.Exists(idx_str))then
   exit sub '  
  end if
  
  '   (rplDBEvent_Update)
  dim old_cnt
  old_cnt=m_collection.Count
  
  call m_collection.AddObj(2,null,obj_id,obj_class)
  
  if(m_collection.Count<>old_cnt+1)then
   msg=" "&su_dbobj_id_to_str(obj_id,obj_class)&"     "

   call error_raise(-1,msg)
  end if
  
  '   
  call m_collection_idx.Add(idx_str,old_cnt)
 end sub 'AddObj
 
 '------------------------------------------------------------------------
 private function verify_rpl_id_type(x)
  dim vt
  vt=vartype(x)
  
  '18 - UI2
  '19 - UI4
  '20 - I8
  '21 - UI8
  
  verify_rpl_id_type=(vt=vbInteger or _
                      vt=vbLong    or _
                      vt=18        or _
                      vt=19        or _
                      vt=20        or _
                      vt=21)
 end function 'verify_rpl_id_type
 
 'error raising ----------------------------------------------------------
 private sub error_raise(code,msg)
  call err.raise(code,c_err_source,msg)
 end sub 'error_raise
end class 't_rpl_backup_engine_journal

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

