'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'  RPL-BORN-IDs    
'                                           . 19  2005 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
dim g_enum_rpl_ids_columns

set g_enum_rpl_ids_columns=createobject("Scripting.Dictionary")

g_enum_rpl_ids_columns("id1") =1
g_enum_rpl_ids_columns("id2") =2
g_enum_rpl_ids_columns("id3") =4
g_enum_rpl_ids_columns("id4") =8
g_enum_rpl_ids_columns("id5") =16
g_enum_rpl_ids_columns("id6") =32
g_enum_rpl_ids_columns("id7") =64
g_enum_rpl_ids_columns("id8") =128

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_rpl_map_born_id_cmd

class t_rpl_map_born_id_cmd
 private c_err_source

 private m_cn
 private m_cmd
 
 'constructor ------------------------------------------------------------
 private sub class_initiaize()
  c_err_source="t_rpl_map_born_id_cmd"

  set m_cn   =nothing
  set m_cmd  =nothing
 end sub 'class_initialize
 
 'properties -------------------------------------------------------------
 public property set connection(x)
  set m_cn  =x
  set m_cmd =nothing
 end property
 
 '------------------------------------------------------------------------
 public property get connection()
  set connection=m_cn
 end property 'connection
 
 '------------------------------------------------------------------------
 public function execute(byval born_terrain_global_id, _
                         byval born_table_id, _
                         byval born_id1, _
                         byval born_id2, _
                         byval born_id3, _
                         byval born_id4, _
                         byval born_id5, _
                         byval born_id6, _
                         byval born_id7, _
                         byval born_id8)
                         
  if(m_cn is nothing)then
   call err.raise(-1,c_err_source,"    ")
  end if

  if(m_cmd is nothing)then
   set m_cmd=su_create_object("ADODB.Command")
   
   m_cmd.ActiveConnection=m_cn
  
   m_cmd.commandtext= _
    "select b.table_id,"&vbCrLf& _
           "b.id_null_mask,"&vbCrLf& _
           "b.id1,"&vbCrLf& _
           "b.id2,"&vbCrLf& _
           "b.id3,"&vbCrLf& _
           "b.id4,"&vbCrLf& _
           "b.id5,"&vbCrLf& _
           "b.id6,"&vbCrLf& _
           "b.id7,"&vbCrLf& _
           "b.id8"&vbCrLf&  _
    "from rpl_born_id b join rpl_terrain t on b.born_terrain_id=t.terrain_id"&vbCrLf& _
    "where t.terrain_global_id=:born_terrain_global_id and"&vbCrLf& _
          "b.born_table_id=:born_table_id and "&vbCrLf& _
          "b.born_id_null_mask=:born_id_null_mask and"&vbCrLf& _
          "b.born_id1=:born_id1 and"&vbCrLf& _
          "b.born_id2=:born_id2 and"&vbCrLf& _
          "b.born_id3=:born_id3 and"&vbCrLf& _
          "b.born_id4=:born_id4 and"&vbCrLf& _
          "b.born_id5=:born_id5 and"&vbCrLf& _
          "b.born_id6=:born_id6 and"&vbCrLf& _
          "b.born_id7=:born_id7 and"&vbCrLf& _
          "b.born_id8=:born_id8"
  end if

  m_cmd("born_terrain_global_id")=born_terrain_global_id
  m_cmd("born_table_id")         =born_table_id
  m_cmd("born_id_null_mask")     =rpl_build_id_null_mask(born_id1, _
                                                         born_id2, _
                                                         born_id3, _
                                                         born_id4, _
                                                         born_id5, _
                                                         born_id6, _
                                                         born_id7, _
                                                         born_id8)

  m_cmd("born_id1")              =born_id1
  m_cmd("born_id2")              =born_id2
  m_cmd("born_id3")              =born_id3
  m_cmd("born_id4")              =born_id4
  m_cmd("born_id5")              =born_id5
  m_cmd("born_id6")              =born_id6
  m_cmd("born_id7")              =born_id7
  m_cmd("born_id8")              =born_id8

  dim rs
  set rs=new t_rpl_map_born_id_result

  call rs.init(m_cmd.execute)

  set execute=rs
 end function 'execute
end class 't_rpl_map_born_id_cmd

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_rpl_map_born_id_result

class t_rpl_map_born_id_result
 private c_err_source
 private m_rs
 
 'class_initialize -------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_rpl_map_born_id_result"
 
  set m_rs=nothing
 end sub 'class_initialize
 
 '------------------------------------------------------------------------
 public sub init(rs)
  set m_rs=rs
 end sub 'init
 
 '------------------------------------------------------------------------
 public property get eof()
  if(m_rs is nothing)then
   eof=true
  else
   eof=m_rs.eof
  end if
 end property 'eof
 
 '------------------------------------------------------------------------
 public default property get fields(index)
  set fields=nothing
 
  if(m_rs is nothing)then
   call err.raise(-1,c_err_source,"  ")
  end if
 
  dim field
  set field=m_rs.fields(index)
 
  if(g_enum_rpl_ids_columns.exists(lcase(field.name)))then
   if((g_enum_rpl_ids_columns(lcase(field.name)) and m_rs("id_null_mask").value)<>0)then
    set fields=create_rpl_map_born_id_field(null)

    exit property
   end if
  end if
  
  set fields=create_rpl_map_born_id_field(field.value)
 end property 'fields
 
 '------------------------------------------------------------------------
 public sub movenext()
  if(m_rs is nothing)then
   call err.raise(-1,c_err_source,"  ")
  end if

  call m_rs.movenext()
 end sub 'movenext
end class 't_rpl_map_born_id_result

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function create_rpl_map_born_id_field(value)
 set x=new t_rpl_map_born_id_result_field
 
 x.value=value
 
 set create_rpl_map_born_id_field=x
end function 'create_rpl_map_born_id_field

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_rpl_map_born_id_result_field

class t_rpl_map_born_id_result_field
 dim value
end class 't_rpl_map_born_id_result_field

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

