'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'    
' 
' 
'                                        . 2  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_rpl_pack_descr

class t_rpl_pack_descr
 private c_err_source

 private m_gdb_file                   ' GDB . Scripting File Object

 private m_terrain_global_id          '   
 private m_terrain_name               '   
 private m_pack_id                    '  
 private m_pack_date_create           '   

 private m_pack_num                   '  
 private m_pack_cat                   '  

 private m_is_installed               ' true    

 private m_link_with_rpl_journal      '   RPL_JOURNAL

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  c_err_source         ="t_rpl_pack_descr"

  set m_gdb_file       =nothing

  m_terrain_global_id  =null
  m_terrain_name       =""
  m_pack_id            =null
  m_pack_date_create   =null
  
  m_pack_num           =null
  m_pack_cat           =null
  
  m_is_installed       =false
 end sub'class_initialize

 'set properties ---------------------------------------------------------
 public property set gdb_file(f)
  set m_gdb_file=f
 end property

 '------------------------------------------------------------------------
 public property let terrain_global_id(v)
  call check_not_null(v,"terrain_global_id")
  m_terrain_global_id=v
 end property

 '------------------------------------------------------------------------
 public property let terrain_name(v)
  m_terrain_name=v
 end property

 '------------------------------------------------------------------------
 public property let pack_id(v)
  call check_not_null(v,"pack_id")
  m_pack_id=v
 end property

 '------------------------------------------------------------------------
 public property let is_installed(v)
  m_is_installed=v
 end property

 '------------------------------------------------------------------------
 public property let pack_date_create(v)
  'call check_not_null(v,"pack_date_create")
  m_pack_date_create=v
 end property
 
 '------------------------------------------------------------------------
 public property let pack_cat(v)
  'call check_not_null(v,"pack_cat")
  m_pack_cat=v
 end property
 
 '------------------------------------------------------------------------
 public property let pack_num(v)
  'call check_not_null(v,"pack_num")
  m_pack_num=v
 end property

 '------------------------------------------------------------------------
 public property let link_with_rpl_journal(v)
  m_link_with_rpl_journal=v
 end property

 'get properties ---------------------------------------------------------
 public property get gdb_file()
  set gdb_file=m_gdb_file
 end property

 '------------------------------------------------------------------------
 public property get terrain_global_id()
  terrain_global_id=m_terrain_global_id
 end property

 '------------------------------------------------------------------------
 public property get terrain_name()
  terrain_name=m_terrain_name
 end property

 '------------------------------------------------------------------------
 public property get pack_id()
  pack_id=m_pack_id
 end property

 '------------------------------------------------------------------------
 public property get pack_cat()
  pack_cat = m_pack_cat
 end property
 
 '------------------------------------------------------------------------
 public property get pack_num()
  pack_num = m_pack_num
 end property
 
 '------------------------------------------------------------------------
 public property get pack_date_create()
  pack_date_create=m_pack_date_create
 end property

 '------------------------------------------------------------------------
 public property get is_installed()
  is_installed=m_is_installed
 end property 'is_installed

 '------------------------------------------------------------------------
 public property get link_with_rpl_journal()
  link_with_rpl_journal=m_link_with_rpl_journal
 end property 'link_with_rpl_journal

 '------------------------------------------------------------------------
 public function get_descr(with_gdb_file)
  dim t

  t="TerrainGlobalID ["&cstr(m_terrain_global_id)&"] PackID ["&cstr(m_pack_id)&"]- "&m_terrain_name

  if(with_gdb_file and not(m_gdb_file is nothing))then
   t=t&vbCrLf&"GDB File:["&m_gdb_file.Name&"]"
  end if

  get_descr=t
 end function 'get_descr

 '------------------------------------------------------------------------
 'return: true - *this<x
 public function LessThat_for_restore(x)
  LessThat_for_restore=(cmp_3way(m_pack_date_create,x.pack_date_create)<0)
 end function 'LessThat_for_restore

 '------------------------------------------------------------------------
 public function LessThat_by_id(x)
  dim res

  res=cmp_3way(m_terrain_global_id,x.terrain_global_id)

  if(res=0)then
   res=cmp_3way(m_pack_id,x.pack_id)
  end if

  LessThat_by_id=(res<0)
 end function'LessThat_by_id

 '------------------------------------------------------------------------
 private sub check_not_null(val,name)
  if(IsNull(val))then
   call err.raise(-1,c_err_source,name&" can't be NULL !!!")
  end if
 end sub 'check_not_null

 '------------------------------------------------------------------------
 private function cmp_3way(a,b)
  if(a<b)then
   cmp_3way=-1
  elseif(b<a)then
   cmp_3way=1
  else
   cmp_3way=0
  end if
 end function 'cmp_3way
end class 't_rpl_pack_descr

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_rpl_pack_descr_compare_for_restore

class t_rpl_pack_descr_compare_for_restore
 public function less(p1,p2)
  less=p1.LessThat_for_restore(p2)
 end function
end class 't_rpl_pack_descr_compare_for_restore

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_rpl_pack_descr_compare_by_id

class t_rpl_pack_descr_compare_by_id
 public function less(p1,p2)
  less=p1.LessThat_by_id(p2)
 end function 'less
end class 't_rpl_pack_descr_compare_by_id

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' 
' host_name     -       
' rpl_pack_file - Scripting File
'                 GDB-  
' rpl_packs     - LCPI.DBS.Utility.Vector
'                  t_rpl_pack_descr

'    

function load_rpl_pack_descrs(host_name,rpl_pack_file,rpl_packs)
 load_rpl_pack_descrs=0

 dim cn
 set cn=su_create_object("ADODB.Connection")
 
 call cn.open("provider=LCPI.IBProvider;"& _
              "location="&host_name&":"&rpl_pack_file.Path&";"& _
              "ctype=win1251;"& _
              "ole db services=0", _
              "gamer","vermut")
              
 cn.IsolationLevel=65536 'adXactRepeatableRead

 call cn.BeginTrans()

 'TODO:   pack_num  pack_cat (   !!!)

 dim rs
 set rs=cn.Execute("select rp.pack_id,"&vbCrLf& _
                          "rp.pack_num,"&vbCrLf& _
                          "rp.pack_cat,"&vbCrLf& _
                          "rp.pack_date_create,"&vbCrLf& _
                          "rpt.terrain_global_id,"&vbCrLf& _
                          "rpt.name"&vbCrLf& _
                   "from rpl_pack rp join rpl_pack_terrain rpt"&vbCrLf& _
                        "on rp.terrain_id=rpt.terrain_id")

 dim p
 dim c
 
 c=0
 
 while(not rs.eof)
  set p=new t_rpl_pack_descr
  
  set p.gdb_file       =rpl_pack_file

  p.terrain_global_id  =rs("terrain_global_id").value
  p.terrain_name       =rs("name").value
  p.pack_id            =rs("pack_id").value
  p.pack_num           =rs("pack_num").value
  p.pack_cat           =rs("pack_cat").value
  p.pack_date_create   =rs("pack_date_create").value

  '-----------------------
  call rpl_packs.PushBack(p)

  rs.movenext
  
  c=c+1
 wend

 set rs=nothing

 call cn.CommitTrans()
 call cn.Close()
 
 load_rpl_pack_descrs=c
end function 'load_rpl_pack_descrs

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'  ,   

'rpl_packs - LCPI.DBS.Utility.Vector  t_rpl_pack_descr

function get_rpl_pack_descr_for_terrain2(rpl_packs,terrain_global_id)
 dim v
 set v=su_create_object("LCPI.DBS.Utility.Vector")
 
 dim p
 for each p in rpl_packs
  if(p.terrain_global_id=terrain_global_id)then v.PushBack(p)
 next 'p
 
 set get_rpl_pack_descr_for_terrain2=v
end function 'get_rpl_pack_descr_for_terrain2

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' ,   

'rpl_packs - LCPI.DBS.Utility.Vector  t_rpl_pack_descr

'   

function remove_rpl_pack_descr_of_terrain2(rpl_packs,terrain_global_id)
 dim x
 x=0
 
 dim i
 for i=rpl_packs.Count-1 to 0 step -1
  if(rpl_packs(i).terrain_global_id=terrain_global_id)then
   call rpl_packs.Remove(i)
   x=x+1
  end if
 next 'i
 
 remove_rpl_pack_descr_of_terrain2=x
end function 'remove_rpl_pack_descr_of_terrain2

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

