'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'         

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function std_main(byval run_func,byval error_handler)
 dim err_code
 dim err_source
 dim err_descr

 on error resume next

 if(not IsObject(run_func))then
  set run_func=getref(run_func)
 end if

 call run_func()

 err_code   =err.number
 err_source =err.source
 err_descr  =err.description

 on error goto 0

 call err.clear()

 std_main=std_main_process_error(error_handler, _
                                 err_code,      _
                                 err_source,    _
                                 err_descr)
end function 'std_main

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function std_main_1(byval run_func,byval error_handler,run_func_argument)
 dim err_code
 dim err_source
 dim err_descr

 on error resume next

 if(not IsObject(run_func))then
  set run_func=getref(run_func)
 end if

 call run_func(run_func_argument)
 
 err_code   =err.number
 err_source =err.source
 err_descr  =err.description

 on error goto 0

 call err.clear()

 std_main_1=std_main_process_error(error_handler, _
                                   err_code,      _
                                   err_source,    _
                                   err_descr)
end function 'std_main_1

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'  
private function std_main_process_error(byval error_handler, _
                                        byref err_code,      _
                                        byref err_source,    _
                                        byref err_descr)
 if(err_code<>0)then
  if(IsObject(error_handler))then
   if(not (error_handler is nothing))then
    call error_handler(err_code,err_source,err_descr)

    exit function
   end if
  elseif(vartype(error_handler)=vbString)then
   call getref(error_handler)(err_code,err_source,err_descr)

   exit function
  end if

  call wscript.echo("ERROR: [code:"&cstr(err_code)&"]["&err_source&"]:"&err_descr)
 end if
 
 std_main_process_error=err_code
end function 'std_main_process_error

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

