'*******************************************************************************
'       
'   , 04.12.2007
'*******************************************************************************

Option Explicit

'*******************************************************************************

'    t_db_object
Function create_db_object(obj_id, obj_class)
  Set create_db_object = New t_db_object
  Call create_db_object.init(obj_id, obj_class)
End Function  ' create_db_object

'*******************************************************************************

'       
Class t_db_object
  Private m_id     ' ID 
  Private m_class  ' Class 
  Private m_key    '   

  '-----------------------------------------------------------------------------
  ' 
  Private Sub class_initialize()
    m_id    = Null
    m_class = Null
    m_key   = Null
  End Sub  ' class_initialize

  '-----------------------------------------------------------------------------
  '  
  Public Sub init(obj_id, obj_class)
    If (Not(IsNumeric(obj_id) And IsNumeric(obj_class))) Then
      Call dbs_err_raise(TypeName(Me) & " -> init", "   .   ID  Class")
    End If

    m_id    = obj_id
    m_class = obj_class

    '       ID  Class
    m_key = create_db_object_key(obj_id, obj_class)
  End Sub  ' init

  '-----------------------------------------------------------------------------
  '                               Public 
  '-----------------------------------------------------------------------------

  ' ID
  Public Property Get obj_id()
    obj_id = m_id
  End Property  ' Get obj_id

  '-----------------------------------------------------------------------------
  ' Class
  Public Property Get obj_class()
    obj_class = m_class
  End Property  ' Get obj_class

  '-----------------------------------------------------------------------------
  '    
  Public Property Get key()
    key = m_key
  End Property  ' Get key

  '-----------------------------------------------------------------------------
  '                                Public 
  '-----------------------------------------------------------------------------

  '    
  Public Function is_equals(obj)
    '    
    is_equals = IsObject(obj)
    If (Not is_equals) Then Exit Function

    '    Id  Class 
    is_equals = is_equals_ex(obj.obj_id, obj.obj_class)
  End Function  ' is_equals

  '-----------------------------------------------------------------------------
  '         obj_id  obj_class
  Public Function is_equals_ex(obj_id2, obj_class2)
    '    -  ,    
    is_equals_ex = (IsNumeric(obj_id2) And IsNumeric(obj_class2))
    If (Not is_equals_ex) Then Exit Function

    '     ,   ID  Class
    is_equals_ex = (obj_id = obj_id2) And (obj_class = obj_class2)
  End Function  ' is_equals_ex

  '-----------------------------------------------------------------------------
  '    
  Public Function to_string()
    to_string = "[" & CStr(key) & "]"
  End Function  ' to_string

  '-----------------------------------------------------------------------------
End Class ' t_db_object

'*******************************************************************************

'     id  class
Private Function create_db_object_key(obj_id, obj_class)
  On Error Resume Next

  create_db_object_key = CStr(obj_id) & ":" & CStr(obj_class)

  If (err.Number <> 0) Then
    Call dbs_err_raise("create_db_object_key", "   .  ID  Class  Null")
  End If

  On Error GoTo 0
End Function  ' create_db_object_key

'*******************************************************************************