'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'   
'                                          . 27  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'    

'      
const c_log_msg_group_flag__tmp =1

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_log_message_descr

class t_log_message_descr
 public group
 public ts
 public code
 public source
 public description

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  ts=now()
 end sub
end class 't_log_message_descr

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_log_msg_group_descr

class t_log_msg_group_descr
 public flags

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  flags=0
 end sub
end class 't_log_msg_group_descr

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_log

class t_log
 private m_log_file       '   
 private m_error_count    ' 
 private m_warning_count  ' 
 private m_success_count  '  

 private m_print_on_screen

 private m_msg_group_descrs '  

 private m_errors         '  
 private m_warnings       '  
 private m_successes      '  
 private m_files          '  

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  set m_log_file=nothing
  
  m_error_count=0
  m_warning_count=0
  m_success_count=0
  
  m_print_on_screen=true
  
  set m_errors    =nothing
  set m_warnings  =nothing
  set m_successes =nothing
  set m_files     =nothing
  
  set m_msg_group_descrs =nothing

  set m_errors    =su_create_object("LCPI.DBS.Utility.Vector")
  set m_warnings  =su_create_object("LCPI.DBS.Utility.Vector")
  set m_successes =su_create_object("LCPI.DBS.Utility.Vector")
  set m_files     =su_create_object("LCPI.DBS.Utility.Vector")
  
  'wscript.echo "CREATE LOG MANAGER"
 end sub 'class_initialize
 
 'properties -------------------------------------------------------------
 public property set log_file(x)
  set m_log_file=x
 end property
 
 '------------------------------------------------------------------------
 public property let print_on_screen(x)
  m_print_on_screen=x
 end property
 
 '------------------------------------------------------------------------
 public sub reg_msg_group(name,flags)
  if(m_msg_group_descrs is nothing)then
   set m_msg_group_descrs=su_create_object("Scripting.Dictionary")
  elseif(m_msg_group_descrs.Exists(name))then
   call err.raise(-1,typename(me),"    ["&name&"]")
  end if

  dim descr
  set descr=new t_log_msg_group_descr

  descr.flags=flags

  call m_msg_group_descrs.Add(name,descr)
 end sub 'reg_msg_group
 
 '------------------------------------------------------------------------
 public function get_msg_group_flags(name)
  get_msg_group_flags=0

  if(not (m_msg_group_descrs is nothing))then
   if(m_msg_group_descrs.Exists(name))then
    get_msg_group_flags=m_msg_group_descrs(name).flags
   end if
  end if
 end function 'get_msg_group_flags

 '------------------------------------------------------------------------
 public function get_error_count()
  get_error_count=m_error_count
 end function
 
 '------------------------------------------------------------------------
 public function get_errors()
  set get_errors=m_errors
 end function
 
 '------------------------------------------------------------------------
 public function get_warning_count()
  get_warning_count=m_warning_count
 end function

 '------------------------------------------------------------------------
 public function get_warnings()
  set get_warnings=m_warnings
 end function
 
 '------------------------------------------------------------------------
 public function get_success_count()
  get_success_count=m_success_count
 end function

 '------------------------------------------------------------------------
 public function get_successes()
  set get_successes=m_successes
 end function

 '------------------------------------------------------------------------
 public function get_files()
  set get_files=m_files
 end function
 
 '------------------------------------------------------------------------
 public sub inc_error_count()
  m_error_count=m_error_count+1
 end sub

 '------------------------------------------------------------------------
 public sub inc_warning_count()
  m_warning_count=m_warning_count+1
 end sub

 '------------------------------------------------------------------------
 public sub send_msg(msg)
  if(not (m_log_file is nothing))then
   m_log_file.WriteLine(msg)
  end if
  
  if(m_print_on_screen)then
   wscript.echo msg
  end if
 end sub 'send_msg
 
 '------------------------------------------------------------------------
 public default sub send_error(err_code,err_source,err_descr)
  dim msg,ts

  ts=now()

  msg="ERROR IN ["&err_source&"]. CODE:"&cstr(err_code)&vbCrLf& _
      "TIMESTAMP:"&cstr(ts)&vbCrLf& _
      err_descr
 
  m_error_count=m_error_count+1
  
  call send_msg(msg)
  
  'TODO:  
  call add_message_descr(m_errors,"errors",err_code,err_source,err_descr)
 end sub 'send_error
 
 '------------------------------------------------------------------------
 public sub send_warning(err_code,err_source,err_descr)
  dim msg,ts

  ts=now()

  msg="WARNING IN ["&err_source&"]. CODE:"&cstr(err_code)&vbCrLf& _
      "TIMESTAMP:"&cstr(ts)&vbCrLf& _
      err_descr

  m_warning_count=m_warning_count+1

  call send_msg(msg)

  'TODO:  
  call add_message_descr(m_warnings,"warnings",err_code,err_source,err_descr)
 end sub 'send_warning

 '------------------------------------------------------------------------
 public sub send_success(source,descr)
  dim msg,ts

  ts=now()
  
  msg="MESSAGE IN ["&source&"]"&vbCrLf&"TIMESTAMP:"&cstr(ts)&vbCrLf&descr

  m_success_count=m_success_count+1
  
  call send_msg(msg)
  
  call add_message_descr(m_successes,"DoneTaskList_"&source,0,source,descr)
 end sub 'send_success
 
 '------------------------------------------------------------------------
 public sub send_success_ex(group,code,source,descr)
  call add_message_descr(m_successes,group,code,source,descr)
 end sub 'send_success_ex
 
 '------------------------------------------------------------------------
 public sub add_file(title,msg)
  dim file
  set file = new t_temp_file

  call file.create_with_name(title&"_"&su_gen_ts_str()&".log",empty)

  call m_files.pushback(file)
  
  call file.file.WriteLine(msg)
  
  call file.file.Close()
 end sub 'add_file

 '------------------------------------------------------------------------
 private sub add_message_descr(errors,group,err_code,err_source,err_descr)
  dim x
  set x=new t_log_message_descr

  x.group       =group
  x.code        =err_code
  x.source      =err_source
  x.description =err_descr

  call errors.PushBack(x)
 end sub 'add_error_descr
end class 't_log

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
