'*******************************************************************************
'     Scripting.Dictionary
'   , 04.12.2007
'*******************************************************************************

Option Explicit

'*******************************************************************************

'      t_object_collection
Function create_object_collection()
  Set create_object_collection = New t_object_collection
End Function  ' create_object_collection

'*******************************************************************************

'  
Class t_object_collection
  Private m_items  ' Scripting.Dictionary   

  '-----------------------------------------------------------------------------
  ' 
  Private Sub class_initialize()
    Set m_items = CreateObject("Scripting.Dictionary")
  End Sub  ' class_initialize

  '-----------------------------------------------------------------------------
  '    
  Public Property Get count()
    count = m_items.Count
  End Property  ' count

  '-----------------------------------------------------------------------------
  '      
  Public Function item(key)
    If m_items.Exists(key) Then
      Set item = m_items.Item(key)
    Else
      Set item = Nothing
    End If
  End Function  ' get_item

  '-----------------------------------------------------------------------------
  '    
  Public Function add(obj)
    If (Not m_items.Exists(obj.key)) Then
      Call m_items.Add(obj.key, obj)
    End If
    Set add = m_items.Item(obj.key)
  End Function  ' add

  '-----------------------------------------------------------------------------
  '        
  Public Sub add_collection(coll)
    If (Not IsObject(coll)) Then Exit Sub
    If (coll Is Nothing) Then Exit Sub
    If (coll.count < 1) Then Exit Sub

    Dim keys : keys = coll.get_keys()

    Dim i, count_items
    count_items = UBound(keys)

    For i = 0 To count_items
      Call add(coll.item(keys(i)))
    Next
  End Sub  ' add_collection

  '-----------------------------------------------------------------------------
  '    
  Public Sub remove(value)
    If IsObject(value) Then
      Call remove_key(value.key)
    Else
      Call remove_key(value)
    End If
  End Sub  ' remove

  '-----------------------------------------------------------------------------
  '     key  
  Private Sub remove_key(key)
    If (m_items.Exists(key)) Then
      Call m_items.Remove(key)
    End If
  End Sub  ' remove_key

  '-----------------------------------------------------------------------------
  '  true,     
  Public Function exists(value)
    If IsObject(value) Then
      If (value Is Nothing) Then
        exists = False
      Else
        exists = m_items.Exists(value.key)
      End If

    Else
      exists = m_items.Exists(value)
    End If
  End Function  ' exists

  '-----------------------------------------------------------------------------
  '  
  Public Function clear()
    Call m_items.RemoveAll()
  End Function  ' clear

  '-----------------------------------------------------------------------------
  '   
  Public Function get_keys()
    get_keys = m_items.Keys
  End Function  ' get_keys

  '-----------------------------------------------------------------------------
  '    
  Public Function get_items()
    get_items = m_items.Items
  End Function  ' get_keys

  '-----------------------------------------------------------------------------
  '   
  Public Function clone()
    Set clone = create_object_collection()
    Call clone.add_collection(Me)
  End Function  ' clone

  '-----------------------------------------------------------------------------
End Class  ' t_object_collection

'*******************************************************************************