'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'       
'                                        . 4  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
const c_prog_arg_no_value   =0
const c_prog_arg_with_value =1

const c_prog_arg_is_primary =2

const c_prog_arg_require    =4   ' 

const c_prog_arg_unique     =8   ' 

const c_prog_arg_value_req  =16  '  

const c_prog_arg__req__unique__req_value=29 '1+4+8+16

const c_prog_arg__req__req_value=21 '1+4+16

const c_prog_arg__unique__req_value=25 '1+8+16

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'  

const c_cpa_no_unk_named    =1  '     
const c_cpa_no_unnamed      =2  '    
const c_cpa_required        =4  '   
const c_cpa_unique          =8  '  
const c_cpa_value_req       =16 '  

const c_cpa_ALL             =31 '1+2+4+8+16

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'internal enums

private const c_is_value =0
private const c_is_name  =1

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_prog_arg

class t_prog_arg
 private m_name
 private m_value
 
 'constructor ------------------------------------------------------------
 private sub class_initialize()
  m_name  =""
  m_value =empty
 end sub
 
 'properties -------------------------------------------------------------
 public property get name()
  name=m_name
 end property
 
 '------------------------------------------------------------------------
 public default property get value()
  value=m_value
 end property

 '------------------------------------------------------------------------
 public property let name(x)
  m_name=x
 end property

 '------------------------------------------------------------------------
 public property let value(x)
  m_value=x
 end property
end class 't_prog_arg

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_prog_arg_descr -  

class t_prog_arg_descr
 dim flags

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  flags=c_prog_arg_no_value
 end sub 'class_initialize
end class 't_prog_arg_descr

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_prog_arg_list

class t_prog_arg_list
 private c_err_source

 private m_args_info      'Scripting.Dictionary  [name,descr]
 private m_args           'LCPI.DBS.Utility.Vector
 
 'constructor ------------------------------------------------------------
 private sub class_initialize()
  c_err_source=typename(me)
 
  set m_args_info =su_create_object("Scripting.Dictionary")
  set m_args      =su_create_object("LCPI.DBS.Utility.Vector")
 end sub 'class_initialize
 
 '------------------------------------------------------------------------
 public property get item(i)
  set item=m_args(i)
 end property
 
 '------------------------------------------------------------------------
 public property get count()
  count=m_args.count
 end property
 
 '------------------------------------------------------------------------
 public property get arg_by_name(name)
  dim a
  
  for each a in m_args
   if(a.name=name)then
    set arg_by_name=a
    exit property
   end if
  next 'a
  
  call err.raise(-1,c_err_source,"program argument """&name&""" not found")
 end property 'arg_by_name
 
 '------------------------------------------------------------------------
 public property get arg_by_name_n(name)
  dim a

  for each a in m_args
   if(a.name=name)then
    set arg_by_name_n=a
    exit property
   end if
  next 'a

  set arg_by_name_n=nothing
 end property 'arg_by_name

 '------------------------------------------------------------------------
 public function value_by_name(name,def_value)
  dim x
  set x=arg_by_name_n(name)
  
  if(x is nothing)then
   value_by_name=def_value
  else
   value_by_name=x.value
  end if
 end function 'value_by_name

 '  ------------------------------------------------------
 public sub init()
  call m_args.clear()
  
  dim pa
  dim arg,arg_name,arg_value

  set arg=nothing

  for each pa in wscript.arguments
   select case (test_str(pa,arg_name,arg_value))
    case c_is_name
     '   
     set arg=new t_prog_arg
    
     arg.name=arg_name
    
     call m_args.PushBack(arg)
    
     '    ,   
     if(not arg_has_flag(arg_name,c_prog_arg_with_value))then
      set arg=nothing
     end if
     
    case else
     ' 
     if(arg is nothing)then
      set arg=new t_prog_arg

      call m_args.PushBack(arg)
     end if

     arg.value=arg_value

     set arg=nothing
   end select
  next 'pa
 end sub 'init
 
 '------------------------------------------------------------------------
 '  
 'flags -  c_cpa_xxxx
 
 public sub check(flags)
  dim i,ei,arg

  ei=m_args.count-1

  dim args
  set args=su_create_object("Scripting.Dictionary")

  for i=0 to ei
   set arg=m_args(i)

   '       
   if(not args.Exists(arg.name))then
    args(arg.name)=1
   else
    args(arg.name)=args(arg.name)+1
   end if

   '----------------    
   if((flags and c_cpa_value_req)<>0)then
    if(IsEmpty(arg.value))then
     if(m_args_info.Exists(arg.name))then
      if((m_args_info(arg.name).flags and c_prog_arg_value_req)<>0)then
       call err.raise(-1,typename(me), _
                      "   ["&arg.name&"]")
      end if
     end if
    end if 'empty value
   end if 'c_cpa_value_req
   
   '----------------
   if(arg.name<>"")then
    ' 
    if((flags and c_cpa_no_unk_named)<>0)then
     if(not m_args_info.Exists((arg.name)))then
      call err.raise(-1,typename(me), _
                     "    : "& _
                     arg.name)
     end if
    end if
   else
    '  
    if((flags and c_cpa_no_unnamed)<>0)then
     call err.raise(-1,typename(me), _
                    "    . "& _
                    " ["&arg.value&"]")
    end if
   end if
  next 'i
  
  '  -------------------------------------------------
  dim arg_name,c
  
  if((flags and c_cpa_unique)<>0)then
   for each arg_name in args.keys
    c=args(arg_name)

    if(c>1)then
     if(m_args_info.Exists(arg_name))then
      if((m_args_info(arg_name).flags and c_prog_arg_unique)<>0)then
       call err.raise(-1,typename(me), _
                      "   ["&arg_name&"]")
      end if
     end if
    end if 'c>1
   next 'arg_name
  end if 'c_cpa_unique
  
  '    -------------------------
  if((flags and c_cpa_required)<>0)then
   for each arg_name in m_args_info.keys
    if((m_args_info(arg_name).flags and c_prog_arg_require)<>0)then
     if(not args.exists(arg_name))then
      call err.raise(-1,typename(me), _
                     "      ["&arg_name&"]")
     end if
    end if
   next 'arg_name
  end if 'c_cpa_required
  
 end sub 'check
 
 '------------------------------------------------------------------------
 'info - c_prog_arg_xxx
 public sub reg_arg(name,flags)
  get_arg_descr(name).flags=flags
 end sub 'reg_arg
 
 '------------------------------------------------------------------------
 private function get_arg_descr(name)
  if(m_args_info.exists(name))then
   set get_arg_descr=m_args_info.item(name)
  else
   set get_arg_descr=new t_prog_arg_descr
   
   set m_args_info(name)=get_arg_descr
  end if
 end function 'get_arg_descr

 '------------------------------------------------------------------------
 public sub add_arg(arg_obj)
  call m_args.PushBack(arg_obj)
 end sub 'add_arg

 '------------------------------------------------------------------------
 public function get_args(name)
  set get_args=su_create_object("LCPI.DBS.Utility.Vector")
  
  dim a
  for each a in m_args
   if(a.name=name)then call get_args.PushBack(a)
  next 'a
 end function 'get_args
 
 '------------------------------------------------------------------------
 public function get_args_values(name)
  set get_args_values=su_create_object("LCPI.DBS.Utility.Vector")

  dim a
  for each a in m_args
   if(a.name=name)then call get_args_values.PushBack(a.value)
  next 'a
 end function 'get_args_values

 '------------------------------------------------------------------------
 public function has_arg(name)
  has_arg=true
 
  dim a
  for each a in m_args
   if(a.name=name)then exit function
  next 'a
  
  has_arg=false
 end function 'has_arg
 
 '------------------------------------------------------------------------
 public function get_next_args_group(byref i)
  set get_next_args_group=nothing

  '  
  do while(i<m_args.count)
   if(arg_has_flag(m_args(i).name,c_prog_arg_is_primary))then
    exit do
   end if
   
   i=i+1
  loop
  
  dim x
  set x=nothing
  
  do while(i<m_args.count)
   if(x is nothing)then
    set x=new t_prog_arg_list
   elseif(arg_has_flag(m_args(i).name,c_prog_arg_is_primary))then
    '   
    exit do
   end if
   
   call x.add_arg(m_args(i))
   
   i=i+1
  loop
  
  set get_next_args_group=x
 end function 'get_next_args_group
 
 '------------------------------------------------------------------------
 private function test_str(byval s,name,value)
  test_str=c_is_value
  
  name=""
  value=s
  
  dim str_len
  str_len = len(s)
  
  if(str_len = 0) then exit function
  
 '    \/
  if((str_len > 2) and left(s,2) = "\/") then
   '   \      
     value=right(s,str_len-1)
     exit function
  end if

  dim c
  c=left(s,1)

  '          ,  
  if(c<>"/")then exit function

  if(str_len = 1)then
   call err.raise(-1,c_err_source,"unknown name of program argument ["&c&"]")
  end if

  ' "//xxx" - translate as "/xxx"
  if(mid(s,2,1)=c)then     '    "//xxx" .. cscript  
   value=right(s,str_len-1)
   exit function
  end if

  if(not is_alpha(mid(s,2,1)))then
   exit function
  end if

  name  =right(s,str_len-1)
  value =empty

  test_str=c_is_name
 end function 'test_str
 
 '------------------------------------------------------------------------
 private function is_alpha(c)
  '            1234567890123456789012345612345678901234567890123456
  const c_sym="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"
  
  is_alpha=true
  
  dim i
  for i=0 to len(c_sym)-1
   if(mid(c_sym,i+1,1)=c)then exit function
  next 'i
  
  is_alpha=false
 end function 'is_alpha
 
 '------------------------------------------------------------------------
 private function arg_has_flag(name,flag)
  arg_has_flag=false

  if(m_args_info.Exists(name))then
   arg_has_flag=(m_args_info.item(name).flags and flag)<>0
  end if
 end function 'arg_has_flag
end class 't_prog_arg_list

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
