'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'     
'                                           . 27  2004 .

' exec
'   -   
'      return: true -    
'
' is_active
'   - return: true -    
'
' get_error_code
'   - return:   
'
' log
'   -     
'     send_msg(msg)
'     send_error(err_code,err_source,err_descr)

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_prog_executor

class t_prog_executor
 private c_err_source
 
 private m_exec_obj
 private m_start_ts
 private m_title
 private m_wsh
 private m_log
 
 'constructor ------------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_prog_executor"
  
  set m_exec_obj=nothing
  set m_log     =nothing
  set m_wsh     =nothing
 end sub 'class_initialize
 
 'properties -------------------------------------------------------------
 public property set log(x)
  set m_log=x
 end property
 
 '------------------------------------------------------------------------
 public property get start_ts()
  start_ts=m_start_ts
 end property
 
 '------------------------------------------------------------------------
 public function exec(prog_arg,title)
  exec=false

  'call err.raise(-1,c_err_source,"Test Exception !!!")

  if(m_wsh is nothing)then
   set m_wsh=su_create_object("LCPI.WSHE.Shell")
  end if
  
  if(title="")then
   title=prog_arg
  end if

  m_start_ts=now()
  m_title=title

  dim msg
  msg="EXEC ["&cstr(m_start_ts)&"]: "&title

  call log_msg(msg)
 
  call log_msg(vbCrLf&prog_arg)
 
  if(prog_arg<>title)then
   msg=msg&vbCrLf&prog_arg
  end if
 
  dim err_code
  dim err_descr

  on error resume next
  set m_exec_obj=m_wsh.Exec(prog_arg)
  
  'save error status
  err_code  =err.number
  err_descr =err.description
  
  on error goto 0
  
  ' 
  if(err_code<>0)then
   msg=msg&vbCrLf&vbCrLf&err_descr

   call log_error(err_code,msg)
   exit function
  end if
  
  '   
  if(m_exec_obj is nothing)then
   msg=msg&vbCrLf&vbCrLf&"Not return control object!!!"

   call log_error(-1,msg)
   exit function
  end if
  
  exec=true
 end function 'exec
 
 '------------------------------------------------------------------------
 public function is_active()
  is_active=false
  
  if(not (m_exec_obj is nothing))then
   if(m_exec_obj.status=0)then
    is_active=true
   end if
  end if
 end function 'is_active
 
 '------------------------------------------------------------------------
 public function get_exit_code()
  if(m_exec_obj is nothing)then
   get_exit_code=-1
  else
   get_exit_code=m_exec_obj.ExitCode
  end if
 end function 'get_exit_code
 
 'trace methods ----------------------------------------------------------
 private sub log_msg(msg)
  if(not (m_log is nothing))then
   call m_log.send_msg(msg)
  end if
 end sub 'log_msg
 
 '------------------------------------------------------------------------
 private sub log_error(err_code,err_descr)
  if(not(m_log is nothing))then
   call m_log.send_error(err_code,c_err_source,err_descr)
  end if
 end sub 'log_error
end class 't_db_backup

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

