'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'     

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_prog_prolog

'  
'  prog_name
'  mail_cfg
'  log_dir
'  log_in_sys_journal

private const c_pp_normal_exit = 0
private const c_pp_wait_timeout = 102

class t_prog_prolog
 private c_err_source

 private m_log
 private m_fso
 private m_ws
 private m_wnet

 ' .         
 private m_prog_name

 '   
 private m_mail_cfg

 '    
 private m_temp_dir

 '      
 private m_log_dir

 '       
 private m_log_in_sys_journal

 '  
 private m_start_ts

 '    
 private m_normal_exit

 '      
 private m_view_errors_in_notepad

 ' ,     .
 private m_mail_by_error

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_prog_prolog"

  set m_log     =nothing
  set m_fso     =su_create_object("Scripting.FileSystemObject")
  set m_ws      =su_create_object("WScript.Shell")
  set m_wnet    =su_create_object("WScript.Network")

  m_prog_name           ="Unknown Prog"
  m_temp_dir            =Empty '   

  m_log_in_sys_journal  =false

  m_start_ts            =now()

  m_view_errors_in_notepad=false

  m_normal_exit =false

  m_mail_by_error = false
 end sub 'class_initialize

 'destructor -------------------------------------------------------------
 private sub class_terminate()
  if(m_normal_exit)then exit sub

  if(err.number=0)then exit sub

  '      
  dim err_code
  dim err_source
  dim err_descr

  err_code   =err.number
  err_source =err.source
  err_descr  =err.description

  '    
  dim msg

  msg="Abnormal exit of prog ["&m_prog_name&"]"&vbCrLf& _
      "Source:"&err_source&vbCrLf& _
      "Code  :"&cstr(err_code)&vbCrLf& _
      err_descr

  if(m_log_in_sys_journal)then
   call m_ws.LogEvent(1,msg)
  end if

  '   
  if(not (m_log is nothing))then
   call m_log.send_error(err_code,err_source,err_descr)
  end if

  '   
  call mail_of_finish("Abnormal "&m_prog_name,msg)
 end sub 'class_terminate

 'properties -------------------------------------------------------------
 public property set log (x)
  set m_log=x
 end property

 '------------------------------------------------------------------------
 public property let prog_name (x)
  m_prog_name=x
 end property

 '------------------------------------------------------------------------
 public property let mail_cfg(x)
  m_mail_cfg=x
 end property

 '------------------------------------------------------------------------
 public property let temp_dir(x)
  m_temp_dir=x
 end property

 '------------------------------------------------------------------------
 public property let log_dir(x)
  m_log_dir=x
 end property

 public property let log_in_sys_journal(x)
  m_log_in_sys_journal=x
 end property

 public property let view_errors_in_notepad(x)
  m_view_errors_in_notepad=x
 end property

 '------------------------------------------------------------------------
 public property let normal_exit(x)
  m_normal_exit=x
 end property

 '------------------------------------------------------------------------
 public property let mail_by_error(x)
  m_mail_by_error=x
 end property

 '    ---------------------------------------
 public sub ev_start()
  m_normal_exit=false

  m_start_ts=now()

  dim s
  call log_msg2(s,"++++++++++++++++++++++++++++++++++++++++++++++++")
  call log_msg2(s,"START ["&m_prog_name&"] TS:"&cstr(m_start_ts))

  '   
  if (not m_mail_by_error)then
    call send_mail("Start "&m_prog_name,s,nothing)
  end if
 end sub 'ev_start

 '     -----------------------------
 public sub ev_finish()
  call mail_of_finish("Finish "&m_prog_name,"")
 end sub

 '------------------------------------------------------------------------
 private sub mail_of_finish(mail_title,message)
  dim stop_ts
  stop_ts=now()

  dim s
  dim i

  s=message&vbCrLf

  ' 
  dim attach_files,fn
  set attach_files=su_create_object("LCPI.DBS.Utility.Vector")

  '  
  dim tmp_files
  set tmp_files=su_create_object("LCPI.DBS.Utility.Vector")

  call log_msg2(s,"------------------------------------------------")
  call log_msg2(s,"STOP PROG            : "&m_prog_name)
  call log_msg2(s,"STOP TS              : "&cstr(stop_ts))
  call log_msg2(s,"DURATION             : "&cstr(datediff("s",m_start_ts,stop_ts))&" sec.")

  if(not (m_log is nothing))then
   call log_msg2(s,"TOTAL ERROR COUNT    : "&cstr(m_log.get_error_count()))
   call log_msg2(s,"TOTAL WARNING COUNT  : "&cstr(m_log.get_warning_count()))

   if(m_log.get_error_count()<>0)then
    mail_title=mail_title&" [error_count:"&clng(m_log.get_error_count())&"]"

    if(save_errors_list_in_file("ErrorList",m_log.get_errors(),fn))then
     call attach_files.PushBack(fn)

     if(m_view_errors_in_notepad)then
      call open_file_in_notepad(fn)
     end if
    end if
   end if

   if(m_log.get_warning_count()<>0)then
    mail_title=mail_title&" [warning_count:"&clng(m_log.get_warning_count())&"]"

    if(save_errors_list_in_file("WarningList",m_log.get_warnings(),fn))then
     call attach_files.PushBack(fn)
    end if
   end if

   dim task_msg_list
   set task_msg_list=su_create_object("Scripting.Dictionary")

   for each i in m_log.get_successes()
    if(not task_msg_list.Exists(i.group)) then
     call log_msg("add message group:"&i.group)

     call task_msg_list.Add(i.group,su_create_object("LCPI.DBS.Utility.Vector"))
    end if

    call task_msg_list.Item(i.group).PushBack(i)
   next 'i

   for each i in task_msg_list.items
    if(save_errors_list_in_file(i.front.group,i,fn))then
     call attach_files.PushBack(fn)

     if((m_log.get_msg_group_flags(i.front.group) and c_log_msg_group_flag__tmp)<>0)then
      call tmp_files.PushBack(fn)
     end if
    end if
   next 'i

   ' ,   
   for each i in m_log.get_files
    call attach_files.pushback(i.file_name)
   next
  end if 'not (m_log is nothing)

  dim num_errors
  num_errors = 0

  if (not m_log is nothing) then
    num_errors = m_log.get_error_count()
  end if

  '    
  if (not m_mail_by_error or num_errors <> 0)then
   call send_mail(mail_title,s,attach_files)
  end if

  '    
  for each i in tmp_files
   call remove_file(i)
  next 'i
 end sub 'mail_of_finish

 '------------------------------------------------------------------------
 private sub remove_file(file_name)
  if(not m_fso.FileExists(file_name))then
   exit sub
  end if

  dim err_code
  dim err_descr

  on error resume next

  call m_fso.DeleteFile(file_name,true)

  err_code=err.number
  err_descr=err.description

  on error goto 0

  if(err_code<>0)then
   call log_err(err_code,"FAIL REMOVE FILE ["&file_name&"]")
  end if
 end sub 'remove_file

 '------------------------------------------------------------------------
 '   

 private sub open_file_in_notepad(fn)
  call log_msg("OPEN ["&fn&"] in notepad")

  dim run_arg
  run_arg="notepad.exe """&fn&""""

  dim err_code
  dim err_descr

  on error resume next

  call m_ws.Run(run_arg,4,false)

  err_code  =err.number
  err_descr =err.description

  call err.clear()

  on error goto 0

  if(err_code<>0)then
   call log_err(err_code,err_descr)
  end if
 end sub 'open_file_in_notepad

 '------------------------------------------------------------------------
 '    

 'list - LCPI.DBS.Utility.Vector  t_log_error_descr
 private function save_errors_list_in_file(title,list,byref file_name)
  save_errors_list_in_file=false

  if(IsEmpty(list))then    exit function
  if(list is nothing)then  exit function
  if(list.IsEmpty())then   exit function

  '-----------
  dim report_dir
  report_dir=m_log_dir

  if(report_dir="")then
   report_dir=m_fso.GetSpecialFolder(2) 'TemporaryFolder
  end if

  '    
  if(not m_fso.FolderExists(report_dir))then
   call log_warning(-1,"LOG FOLDER ["&report_dir&"] NOT FOUND")
   exit function
  end if

  file_name=m_prog_name&"_"&title&"_"&su_gen_ts_str()&".log"
  file_name=m_fso.BuildPath(report_dir,file_name)

  dim err_code
  dim err_descr

  on error resume next

  call save_errors_list_in_file_impl(file_name,list)

  err_code=err.number
  err_descr=err.description

  call err.clear()

  on error goto 0

  if(err_code<>0)then
   call log_warning(err_code,"FAIL WRITE ["&title&"] to file ["&file_name&"]"&vbCrLf&_
                             err_descr)
  end if

  save_errors_list_in_file=(err_code=0)
 end function 'save_errors_list_in_file

 '------------------------------------------------------------------------
 private sub save_errors_list_in_file_impl(file_location,list)
  dim f
  set f=m_fso.CreateTextFile(file_location,false)

  call f.writeline("PROG NAME     :"&m_prog_name)
  call f.writeline("RECORDS COUNT :"&list.Count)

  dim x
  for each x in list
   call f.writeline("- - - - - - - - - - - - - - - - - - - - - -")
   call f.writeline("Source      :"&x.source)
   call f.writeline("Code        :"&clng(x.code))
   call f.writeline("Timestamp   :"&su_date_to_str(x.ts))
   call f.writeline("Description :"&x.description)
  next 'x
 end sub 'save_errors_list_in_file_impl

 '------------------------------------------------------------------------
 private sub log_msg2(s,msg)
  s=s&msg&vbCrLf

  if(not(m_log is nothing))then
   call m_log.send_msg(msg)
  else
   call wscript.echo(msg)
  end if
 end sub 'log_msg2

 '------------------------------------------------------------------------
 private sub log_msg(msg)
  if(not(m_log is nothing))then
   call m_log.send_msg(msg)
  else
   call wscript.echo(msg)
  end if
 end sub 'log_msg2

 '------------------------------------------------------------------------
 private sub log_err(err_code,err_msg)
  if(not (m_log is nothing))then
   call m_log.send_error(err_code,c_err_source,err_msg)
  end if
 end sub 'log_err

 '------------------------------------------------------------------------
 private sub log_warning(err_code,err_msg)
  if(not (m_log is nothing))then
   call m_log.send_warning(err_code,c_err_source,err_msg)
  end if
 end sub 'log_warning

 '------------------------------------------------------------------------
 ' 
 private sub send_mail(byval title,message,txt_files)
  if(m_mail_cfg="")then exit sub

  title="[DAEMON] ["&m_wnet.ComputerName&"] "&title

  dim mail_arg
  mail_arg="prog_mailer.wsf /cfg_file """&m_mail_cfg&""" /subj """&title&""" "

  '      -------------
  dim tmf
  set tmf=new t_temp_file

  if(message<>"")then
   if(tmf.create(m_temp_dir,"mail_"))then
    call tmf.file.WriteLine(message)

    mail_arg=mail_arg&" /msg_file """&tmf.file_name&""" "

    call tmf.close()
   end if
  end if 'message<>""

  '   ------------------------------
  dim i

  if(not(txt_files is nothing))then
   if(not txt_files.IsEmpty())then

    for i=0 to txt_files.count-1


     mail_arg=mail_arg&" /attach """&cstr(txt_files(i))&""""
    next 'i
   end if
  end if

  '    ----------------------------
  dim err_code
  dim err_descr

  dim executor, prog
  set executor = su_create_object("LCPI.WSHE.Shell")

  on error resume next

  set prog = executor.Exec(mail_arg)

  err_code  =err.number
  err_descr =err.description

  call err.clear()

  on error goto 0

  if(err_code<>0)then
   call log_err(err_code,"FAIL SEND MAIL. "&err_descr)
   exit sub
  end if

  ' .
  if (prog.wait (600000) = c_pp_wait_timeout) then
   call log_err(err_code,"SEND MAIL TIMEOUT.")

   exit sub
  end if

  if(prog.ExitCode<>0)then
   call log_err(err_code,"FAIL SEND MAIL.")
  else
   call log_msg("SEND MAIL: ["&title&"]")
  end if
 end sub 'send_mail
end class 't_prog_prolog

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
