'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'    

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_temp_file

class t_temp_file
 private m_fso
 private m_ws
 private m_file
 private m_file_name
 
 'constructor ------------------------------------------------------------
 private sub class_initialize()
  set m_fso  =nothing
  set m_ws   =nothing
  set m_file =nothing

  set m_fso  =su_create_object("Scripting.FileSystemObject")
  set m_ws   =su_create_object("WScript.Shell")
 end sub 'class_initialize
 
 'destructor -------------------------------------------------------------
 private sub class_terminate()
  call destroy()
 end sub 'class_terminate

 'properties -------------------------------------------------------------
 public property get file()
  set file=m_file
 end property
 
 public property get file_name()
  file_name=m_file_name
 end property
 
 '   ----------------------------------------------
 'dir:
 ' Empty -     
 ' ""    -     
 ' <>""  -     
 public function create(byval dir,byval prefix)
  create=false
 
  dim tfolder
  
  if(IsEmpty(dir))then
   set tfolder=m_fso.GetSpecialFolder(2) 'TemporaryFolder
  else
   if(dir="")then dir=m_ws.CurrentDirectory

   set tfolder=m_fso.GetFolder(dir)
  end if
  
  dim file_name
  
  dim i
  dim err_code
  
  for i=0 to 10
   file_name=prefix&m_fso.GetTempName()
   
   if(not m_fso.FileExists(m_fso.BuildPath(tfolder.Path,file_name)))then
    on error resume next

    set m_file=tfolder.CreateTextFile(file_name,false)
    
    err_code=err.number
    
    call err.clear()
    on error goto 0

    if(err_code=0)then
     m_file_name=m_fso.BuildPath(tfolder.Path,file_name)
     m_file_name=m_fso.GetFile(m_file_name).Path
     
     create=true
     exit function
    end if
   end if
  next 'y
 end function 'create
 
 '      -----------------------------
 public function create_with_name(byval file_name,byval dir)
  create_with_name=false

  dim tfolder

  if(IsEmpty(dir))then
   set tfolder=m_fso.GetSpecialFolder(2) 'TemporaryFolder
  else
   if(dir="")then dir=m_ws.CurrentDirectory

   set tfolder=m_fso.GetFolder(dir)
  end if

  dim i
  dim err_code

  if(not m_fso.FileExists(m_fso.BuildPath(tfolder.Path,file_name)))then
   on error resume next

   set m_file=tfolder.CreateTextFile(file_name,false)

   err_code=err.number

   call err.clear()
   on error goto 0

   if(err_code=0)then
    m_file_name=m_fso.BuildPath(tfolder.Path,file_name)
    m_file_name=m_fso.GetFile(m_file_name).Path

    create_with_name=true
   end if
  end if'not FileExists

 end function'create_with_name
 
 '   ----------------------------------------------
 public sub close()
  set m_file=nothing
 end sub 'close
 
 '   -------------------------------------------
 public sub destroy()
  call close()
  
  if(m_file_name="") then exit sub
  
  dim err_code
  dim err_descr
  
  on error resume next
  
  call m_fso.DeleteFile(m_file_name,true)
  
  err_code  =err.number
  err_descr =err.description
  
  call err.clear()
  
  on error goto 0
  
  m_file_name=""
 end sub 'destroy
end class 't_temp_file

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

