'*******************************************************************************
 '  .     su_xxx
 '   , 29.07.2004
'*******************************************************************************

Option Explicit

'*******************************************************************************
'                          
'*******************************************************************************

Function su_cstr_sn(s)
  su_cstr_sn = su_cstr_sn_ex(s, "NULL")
End Function  ' su_cstr_sn

'*******************************************************************************

Function su_cstr_se(s)
  su_cstr_se = su_cstr_sn_ex(s, "")
End Function  ' su_cstr_se

'*******************************************************************************

Function su_cstr_sn_ex(s,null_str)
  If (IsNull(s)) Then
    su_cstr_sn_ex = null_str
  Else
    su_cstr_sn_ex = CStr(s)
  End If
End Function ' su_cstr_sn_ex

'*******************************************************************************

Function su_cstr_sne(s)
  If (IsEmpty(s)) Then
    su_cstr_sne = "EMPTY"
  ElseIf (IsNull(s)) Then
    su_cstr_sne = "NULL"
  Else
    su_cstr_sne = CStr(s)
  End If
End Function  ' su_cstr_sne

'*******************************************************************************

Function su_fnum_ex(byval n,byval min_len,byval fill_sym)
 n=cstr(n)

 While(len(n)<min_len)
  n=fill_sym&n
 Wend

 su_fnum_ex=n
End Function 'su_fnum_ex

'*******************************************************************************

Function su_fnum(byval n,byval min_len)
 su_fnum=su_fnum_ex(n,min_len,"0")
End Function 'su_fnum

'*******************************************************************************

Function su_fnum_sn(ByVal n, ByVal min_len)
  Dim fsym

  If (IsNull(n)) Then
    n = "NULL"
    fsym = " "
  Else
    n = CStr(n)
    fsym="0"
  End If

  While (Len(n) < min_len)
    n = fsym & n
  Wend

  su_fnum_sn = n
End Function  'su_fnum_sn

'*******************************************************************************

function su_date_to_str(d)
 if(IsNull(d))then
  su_date_to_str="NULL"
 else
  su_date_to_str= _
   su_fnum(day(d),2)&"."&su_fnum(month(d),2)&"."&su_fnum(year(d),4)&" "& _
   su_fnum(hour(d),2)&":"&su_fnum(minute(d),2)&":"&su_fnum(second(d),2)
 end if
end function  ' su_date_to_str

'*******************************************************************************

Function su_lstr(byval s, byval min_len)
 s=cstr(s)

 while(len(s)<min_len)
  s=s&" "
 wend

 su_lstr=s
end function 'su_lstr

'*******************************************************************************

function su_rstr(byval s,byval min_len)
 s=cstr(s)

 while(len(s)<min_len)
  s=" "&s
 wend

 su_rstr=s
end function 'su_rstr

'*******************************************************************************

function su_gen_ts_str()
 dim ts
 ts=now()

 su_gen_ts_str=su_fnum(year(ts),2)& _
               su_fnum(month(ts),2)& _
               su_fnum(day(ts),2)&"_"& _
               su_fnum(hour(ts),2)& _
               su_fnum(minute(ts),2)& _
               su_fnum(second(ts),2)
end function 'su_gen_ts_str

'*******************************************************************************

Function su_date_diff(d1,d2)
  su_date_diff = DateAdd("s",DateDiff("s",d1,d2),CDate("00:00"))
End Function  ' su_date_diff


'*******************************************************************************
'                          
'*******************************************************************************

'  true,  str  
Function su_is_empty_string(str)
  If (IsNull(str)) Then
    su_is_empty_string = True
  ElseIf (Len(str) > 0) Then
    su_is_empty_string = False
  Else
    su_is_empty_string = True
  End If
End Function  ' su_is_empty_string

'*******************************************************************************

'  true,  str   
Function su_is_not_empty_string(str)
  su_is_not_empty_string = (Not su_is_empty_string(str))
End Function  ' su_is_not_empty_string

'*******************************************************************************

'  true,  obj  ,   
Function su_is_empty_object(obj)
  su_is_empty_object = True

  If (IsObject(obj)) Then
    If (Not (obj Is Nothing)) Then su_is_empty_object = False
  End If
End Function  ' su_is_empty_object

'*******************************************************************************

'  true,  obj ,   
Function su_is_not_empty_object(obj)
  su_is_not_empty_object = (Not su_is_empty_object(obj))
End Function  ' su_is_not_empty_object

'*******************************************************************************

'  true,    dic  ,    
Function su_is_empty_dictionary(dic)
  su_is_empty_dictionary = True

  If (su_is_not_empty_object(dic)) Then
    If (dic.Count > 0) Then su_is_empty_dictionary = False
  End If
End Function  ' su_is_empty_dictionary

'*******************************************************************************

'  true,    dic  
Function su_is_not_empty_dictionary(dic)
  su_is_not_empty_dictionary = (Not su_is_empty_dictionary(dic))
End Function  ' su_is_not_empty_dictionary

'*******************************************************************************
sub su_print_error_and_exit(exit_code,msg)
 call wscript.echo(msg)

 call wscript.quit(exit_code)
end sub 'su_print_error_and_exit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function su_dbobj_id_to_str(obj_id,obj_class)
 su_dbobj_id_to_str="["&su_cstr_sn(obj_id)&":"&su_cstr_sn(obj_class)&"]"
end function 'su_dbobj_id_to_str

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function su_create_object(progID)
 on error resume next

 set su_create_object=createobject(progID)

 dim err_descr
 dim err_source
 dim err_code

 err_descr   =err.description
 err_source  =err.source
 err_code    =err.number

 call err.clear()

 on error goto 0

 if(err_code<>0)then
  call err.raise(err_code, _
                 err_source, _
                 "Fail create ActiveX object ["&progID&"]"&vbCrLf&err_descr)
 end if
end function 'su_create_object

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function su_equal_db_value(a,b)
 if(IsNull(a))then
  su_equal_db_value=IsNull(b)

  exit function
 end if

 if(IsNull(b))then
  su_equal_db_value=false
 else
  su_equal_db_value=(a=b)
 end if
end function 'su_equal_db_value

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function su_get_cn_one_prop(cn,prop_name)
 su_get_cn_one_prop="Unknown"

 dim prop
 set prop=nothing

 on error resume next

 set prop=cn.Properties(prop_name)

 on error goto 0

 call err.clear()

 if(not (prop is nothing))then
  su_get_cn_one_prop=su_cstr_sne(prop.value)
 end if
end function 'su_get_cn_one_prop

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'   

' imode:
'  1 - ForReading
'  2 - ForWriting
'  8 - ForAppending

'NOTE: format
'   -2 = TristateUseDefault. Opens the file using the system default.
'   -1 = TristateTrue. Opens the file as Unicode.
'    0 = TristateFalse. Opens the file as ASCII.
function su_open_text_file(file_name,imode,create)
 const c_err_source="su_open_text_file"

 dim fso

 set fso=su_create_object("Scripting.FileSystemObject")

 dim err_code
 dim err_descr

 on error resume next

 set su_open_text_file=fso.OpenTextFile(file_name,imode,create)

 err_code  =err.number
 err_descr =err.description

 call err.clear()

 on error goto 0

 if(err_code<>0)then
  err_descr="FAIL OPEN TEXT FILE ["&file_name&"] imode:"&su_cstr_sn(imode)&vbCrLf& _
            err_descr

  call err.raise(err_code,c_err_source,err_descr)
 end if
end function 'su_open_text_file

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'    
' -   
' -        -1   
'     

function su_move_files(source_dir,dest_dir)
 const c_err_source="su_move_files"

 su_move_files=-1

 dim fso

 set fso=su_create_object("Scripting.FileSystemObject")

 if(not fso.FolderExists(source_dir))then
  call err.raise(-1,c_err_source,"SOURCE FOLDER ["&source_dir&"] NOT FOUND")
  exit function
 end if

 if(not fso.FolderExists(dest_dir))then
  call err.raise(-1,c_err_source,"DEST FOLDER ["&source_dir&"] NOT FOUND")
  exit function
 end if

 dim s_folder
 dim d_folder

 set s_folder=fso.GetFolder(source_dir)
 set d_folder=fso.GetFolder(dest_dir)

 dim s_files
 set s_files=s_folder.Files

 dim sf
 dim msg

 dim err_code
 dim err_descr

 dim sf_path

 for each sf in s_files
  sf_path=sf.Path

  '     
  if(fso.FileExists(fso.BuildPath(d_folder.Path,sf.Name)))then
   if(not su_is_equal_files(sf_path,fso.BuildPath(d_folder.Path,sf.Name)))then
    ': -  -        

    call err.raise(-1,c_err_source,_
                  "FAIL MOVE FILE ["&sf_path&"] TO ["&d_folder.Path&"]."&vbCrLf&_
                  "FILE ALREADY EXISTS.")
   end if
  else '---------------------------------------------
   on error resume next
   call fso.MoveFile(sf,fso.BuildPath(d_folder.Path,sf.Name))

   err_code  =err.number
   err_descr =err.description

   on error goto 0

   err.clear

   if(err_code<>0)then
    call err.raise(err_code,c_err_source,_
                      "FAIL MOVE FILE ["&sf_path&"] TO ["&d_folder.Path&"]."&vbCrLf&_
                      err_descr)
   end if
  end if
 next 'sf

 su_move_files=0
end function 'su_move_files

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'file_list - LCPI.DBS.Utility.Vector
'location  - file or folder path

function su_scan_files(log,file_list,location,byval file_ext)
 const c_err_source="su_scan_files"

 su_scan_files=false

 dim fso
 set fso=su_create_object("Scripting.FileSystemObject")

 if(fso.FileExists(location))then
  call file_list.PushBack(fso.GetFile(location))
 else
  if(not fso.FolderExists(location))then
   call log.send_error(-1,c_err_source,"FOLDER ["&location&"] NOT FOUND")
   exit function
  end if

  file_ext=ucase(file_ext)

  dim f
  for each f in fso.GetFolder(location).Files
   if(ucase(fso.GetExtensionName(f.Name))=file_ext)then
    call file_list.PushBack(f)
   end if
  next 'f
 end if 'scan folder

 su_scan_files=true
end function 'su_scan_files

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function su_is_equal_files(first_path,second_path)
 const c_err_source="su_compare_files"
 const c_read_bytes=100000

 su_is_equal_files=false

 dim cmd_str
 cmd_str = "_FC.exe /fl1 """&first_path&""" /fl2 """&second_path&""""&_
            "/block_size "&c_read_bytes

 dim err_code
 dim err_descr
 dim ret

 on error resume next

 dim ws
 set ws=su_create_object("WScript.Shell")

 ret = ws.Run(cmd_str,4,true)

 err_code  =err.number
 err_descr =err.description

 call err.clear()

 on error goto 0

 if(err_code<>0)then '  _FC.exe
  err_descr="FAIL Run: "&cmd_str&vbCrLf&err_descr

  call err.raise(err_code,c_err_source,err_descr)
 end if

 if(ret = 0)then
  su_is_equal_files = true
  exit function
 end if

 if(ret = 1)then
  su_is_equal_files = false
  exit function
 end if

 '_FC.exe   
 err_descr="Fail compare files ["&first_path&"] and ["&second_path&"]"

 call err.raise(err_code,c_err_source,err_descr)
end function 'su_is_equal_files

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'    

sub su_remove_file_dublicate(files)
 dim dic
 set dic=su_create_object("Scripting.Dictionary")

 dim f
 for each f in files
  set dic.item(f.path)=f
 next 'f

 call files.clear()

 for each f in dic.items
  call files.PushBack(f)
 next 'f
end sub 'su_remove_file_dublicate

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'  

class t_su_string_compare
 public function less(a,b)
  less=a<b
 end function 'less
end class 't_su_string_compare

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'   

function su_get_database_file_name(db_location)
 dim l,s

 l=len(db_location)
 s=l

 do while(s>=1)
  select case mid(db_location,s,1)
   case "\","/",":"
    exit do
  end select

  s=s-1
 loop

 su_get_database_file_name=right(db_location,l-s)
end function 'su_get_database_file_name

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

'       
Function su_get_connection_str(location, codepage, user, password)
  su_get_connection_str = "provider=LCPI.IBProvider" & ";" & _
                          "location=" & location & ";" &     _
                          "ctype=" & codepage & ";" &        _
                          "user id=" & user & ";" &          _
                          "password=" & password
End Function  ' su_get_connection_str

'*******************************************************************************

'      
Function su_get_db_connection(location, user, password)
  Set su_get_db_connection = su_get_db_connection_ex(location, "win1251", user, password)
End Function  ' su_get_db_connection

'*******************************************************************************

'      
Function su_get_db_connection_ex(location, codepage, user, password)
  Set su_get_db_connection_ex = Nothing

  Dim connection : Set connection = CreateObject("ADODB.Connection")
  Call connection.Open(su_get_connection_str(location, codepage, user, password))
  connection.IsolationLevel = 65536

  Set su_get_db_connection_ex = connection
End Function  ' su_get_db_connection

'*******************************************************************************

'  [root_log_dir\name_of(db_location)]

function su_create_own_log_dir_for_db(byval root_log_dir,byval db_location)
 const c_err_source="su_create_own_log_dir_for_db"

 dim fso

 set fso=su_create_object("Scripting.FileSystemObject")

 if(not fso.FolderExists(root_log_dir))then
  call err.raise(-1,c_err_source,"ROOT DIR ["&root_log_dir&"] FOR LOG FILES IS NOT FOUND")
 end if

 dim t

 t=su_get_database_file_name(db_location)

 t=fso.GetBaseName(t)

 t=fso.BuildPath(root_log_dir,t)

 if(not fso.FolderExists(t))then
  dim err_code
  dim err_descr

  on error resume next

  call fso.CreateFolder(t)

  err_code=err.number
  err_descr=err.description

  call err.clear()

  on error goto 0

  if(err_code<>0)then
   err_descr="FAIL CREATE FOLDER ["&t&"]"&vbCrLf& _
             err_descr

   call err.raise(err_code,c_err_source,err_descr)
  end if
 end if 'folder not exists

 su_create_own_log_dir_for_db=t
end function 'su_create_own_log_dir_for_db

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'  

function su_get_env_param(name)
 dim wsh
 set wsh=su_create_object("WScript.Shell")

 dim env
 set env=wsh.Environment("USER")

 su_get_env_param=env(name)

 if(su_get_env_param<>"")then
  exit function
 end if

 set env=wsh.Environment("SYSTEM")

 su_get_env_param=env(name)
end function 'su_get_env_param

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function su_get_field_idx_by_name(byval fields,byval field_name)
 field_name=ucase(field_name)

 dim i

 for i=0 to fields.count-1
  if(field_name=ucase(fields(i).name))then
   su_get_field_idx_by_name=i

   exit function
  end if
 next 'i

 su_get_field_idx_by_name=-1
end function 'su_get_field_idx_by_name

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function su_build_insert_stmt(table_name,columns)
 dim part_1
 dim part_2

 dim c
 dim first

 first=true

 for each c in columns
  if(not first)then
   part_1=part_1&","
   part_2=part_2&","
  end if

  first=false

  part_1=part_1&c
  part_2=part_2&":"&c
 next 'c

 su_build_insert_stmt="insert into "&table_name&" ("&part_1&") values ("&part_2&")"
end function 'su_build_insert_stmt

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'fso   - FileSystemObject
'path  -  ,   . :
'          
'             : d:\temp\
'           \\machine\net_resource\file_system_path

sub su_createPath(byval fso,byval path) 'throw
 const c_err_source="su_createPath"

 dim path_len

 path_len=len(path)

 dim start_dir_name
 start_dir_name=su_createPath_SkeepDrivePart(path)

 dim i,c,folder

 i=start_dir_name

 dim err_code
 dim err_descr

 do while (i<=path_len)
  c=mid(path,i,1)

  if(c="/" or c="\" or i=path_len)then
   c=mid(path,1,i)

   if(i=start_dir_name)then
    c="      ["&c&"]"

    call err.raise(-1,c_err_source,c)
   end if

   if(not fso.FolderExists(c)) then
    on error resume next

    set folder=nothing
    set folder=fso.CreateFolder(c)

    err_code   =err.number
    err_descr  =err.description

    call err.clear()

    on error goto 0

    if(err_code=0 and (folder is nothing))then
     err_code  =-1
     err_descr ="  "
    end if

    if(err_code<>0)then
     err_descr="   ["&c&"] - "&err_descr

     call err.raise(-1,c_err_source,err_descr)
    end if
   end if '  

   '   
   start_dir_name=i+1
  end if '  

  i=i+1
 loop 'i
end sub 'su_createPath

'-------------------------------------------------------------------------------
function su_createPath_SkeepDrivePart(path)
 if(su_skeep_DriveName(path,su_createPath_SkeepDrivePart))then
  exit function
 end if

 if(su_skeep_NetResourceName(path,su_createPath_SkeepDrivePart))then
  exit function
 end if

 su_createPath_SkeepDrivePart=1
end function 'su_createPath_SkeepDrivePart

'-------------------------------------------------------------------------------
function su_skeep_DriveName(byval path,byref pos)
 su_skeep_DriveName=false

 dim c_path
 c_path=len(path)

 if(c_path>=2)then
  dim c1,c2

  c1=ucase(mid(path,1,1))
  c2=mid(path,2,1)

  if(not (c1>="A" and c1<="Z" and c2=":"))then
   exit function
  end if

  pos=3

  su_skeep_DriveName=true

  if(c_path>=3)then
   dim c3
   c3=mid(path,3,1)

   if(c3="/" or c3="\")then 'd:\ or d:/
    pos=pos+1
   end if
  end if
 end if
end function 'su_skeep_DriveName

'-------------------------------------------------------------------------------
function su_skeep_NetResourceName(path,byref pos)
 su_skeep_NetResourceName=false

 dim c_path
 c_path=len(path)

 if(c_path<2)then
  exit function
 end if

 dim i
 i=1

 dim c,c1,c2
 c1=mid(path,i+0,1)
 c2=mid(path,i+1,1)

 if(not(c1="\" and c2="\"))then
  exit function
 end if

 i=i+2

 '  
 dim s_cname
 s_cname=i

 do while(i<=c_path)
  c=mid(path,i,1)

  if(c="\")then
   exit do
  end if

  if(InStr(1,c,":/")>0)then
   exit function
  end if

  'TODO:        

  i=i+1
 loop

 if(i>c_path or i=s_cname)then
  exit function
 end if

 ' '\'
 i=i+1

 '   
 dim s_rname
 s_rname=i

 do while(i<=c_path)
  c=mid(path,i,1)

  if(c="\")then
   exit do
  end if

  if(InStr(1,c,":/")>0)then
   exit function
  end if

  'TODO:         

  i=i+1
 loop

 if(i>c_path or i=s_cname)then
  exit function
 end if

 ' '\'
 i=i+1

 '   OUT-
 pos=i

 su_skeep_NetResourceName=true
end function 'su_skeep_NetResourceName

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++