'-------------------------------------------------------------------------------
'   get
'                                     , 19  2003 ()

'-------------------------------------------------------------------------------
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
public sub process_get(byref cflags,byref spostflags,byref names)
 stop
 
 dim processor
 set processor=create_dbsp_processor_get()

 call processor.run(cflags,spostflags,names)
end sub 'process_get

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_dbsp_processor_get

class t_dbsp_processor_get
 private m_fso
 private m_data_source
 private m_gottenScripts

 private m_cmd_get_script_attrs
 private m_cmd_get_script_by_name

 'class_initialize -------------------------------------------------------
 private sub class_initialize()
  set m_fso                   =nothing
  set m_gottenScripts         =nothing

  call init_cmd()
 end sub 'class_initialize

 '------------------------------------------------------------------------
 public sub init()
  dim fso
  dim gss
  
  set fso=su_create_object("Scripting.FileSystemObject")
  set gss=su_create_object("Scripting.Dictionary")
 
  set m_fso           =fso
  set m_gottenScripts =gss
  
  call init_cmd()
 end sub 'init
 
 '------------------------------------------------------------------------
 private sub init_cmd()
  set m_data_source            =nothing
  set m_cmd_get_script_attrs   =nothing
  set m_cmd_get_script_by_name =nothing
 end sub 'init_cmd
 
 '------------------------------------------------------------------------
 public sub run(byref cflags,byref spostflags,byref names)
  m_gottenScripts.RemoveAll()

  set m_data_source=getDataSource(cflags)

  call m_data_source.BeginTrans()

  if hasValue(spostflags,g_isOrigin) then
   call processGetRootDir(names,spostflags)
  else
   call processGetList(cflags,names,spostflags)
  end if

  call m_data_source.CommitTrans()
 end sub 'process_get

 '------------------------------------------------------------------------
 private sub processGetRootDir(byref names,byref flags)
  stop

  if(names.IsEmpty())then
   call processAllScripts("",false)
  else
   call processAllScripts(names(0),false)
  end if
 end sub'processGetRootDir
 
 '------------------------------------------------------------------------
 private sub processGetList(cflags,byref names,byref spostflags)
  dim i

  if(names.IsEmpty())then
   call processGetDir(".",spostflags)
  else
   for each i in names
    if m_fso.FolderExists(i) then
     call processGetDir(i,spostflags)
    else'   
     call processGetFile(i,spostflags)
    end if
   next
  end if
  
  dim otherdir

  if(hasValue(spostflags,g_GetOthers))then
   '   

   '    
   otherdir=getCombinedValue(cflags,g_OtherDirFlag)

   if(otherdir="")then
    otherdir="others"
   end if

   'TODO:     call processGetFile(otherdir+"\"+scriptName,spostflags,gottenScripts)
   call processAllScripts(otherdir,true)
  end if
 end sub 'processGetList

 '------------------------------------------------------------------------
 private sub processAllScripts(byval dir,byval exclude_gottenScripts)
  dim rs
  set rs=m_data_source.Execute("select id,class,title,script,name from scripts")

  '------------------------
  call su_createPath(m_fso,dir) 'throw

  while not rs.eof
   if(not exclude_gottenScripts)then
    call saveScript(dir,rs.fields)
   elseif(not m_gottenScripts.Exists(rs("name").value))then
    call saveScript(dir,rs.fields)
   end if

   call rs.MoveNext()
  wend
 end sub 'processAllScripts

 '------------------------------------------------------------------------
 'dir -  ( ),     
 private sub saveScript(dir,script_fields)
  dim attrs_rs
  set attrs_rs=get_script_attrs_rs(script_fields("id").value, _
                                   script_fields("class").value)

  dim newFileStr
  newFileStr=makeFileStr(script_fields,attrs_rs)

  dim filespec
  filespec=m_fso.BuildPath(dir,script_fields("name").value&".dsx")

  cout "  "& _
       su_dbobj_id_to_str(script_fields("id").value,script_fields("class").value)&" - "& _
       filespec

  dim dsxFile
  set dsxFile=m_fso.CreateTextFile(filespec,true)

  call dsxFile.Write(newFileStr)

  call dsxFile.Close()
 end sub 'saveScript
 
 '------------------------------------------------------------------------
 private sub processGetDir(path,byref spostflags)
  dim workingDir
  set workingDir=m_fso.GetFolder(path)

  '  
  dim file
  dim subfolder

  for each file in workingDir.Files
   if (file.Attributes and faReadOnly)=0 and m_fso.GetExtensionName(file.Name)="dsx" then
    call  processGetFile(m_fso.BuildPath(path,file.Name),spostflags)
   end if
  next

  ' ,     
  if not hasValue(spostflags,g_NoSubFolders) then
   for each subfolder in workingDir.SubFolders
    call processGetDir(m_fso.BuildPath(path,subfolder.Name),spostflags)
   next
  end if
 
 end sub 'processGetDir

 '------------------------------------------------------------------------
 private sub processGetFile(byval filepath,byref spostflags)
  'filepath - (  path) ,  

  dim filespec
  filespec=filepath

  dim pure_fileName
  pure_fileName=m_fso.GetBaseName(filespec)

  dim extName
  extName=m_fso.GetExtensionName(filespec)

  if extName<>"" and extName<>"dsx" then
   cerr "   "+extName
   exit sub
  end if

  if extName="" then
   call strcat(filespec,".dsx")
  end if

  '   ()      filespec
  dim rs
  set rs=get_script_by_name_rs(pure_fileName)
 
  if rs.eof then
   cerr " "+pure_fileName+"   "
   exit sub
  end if

  dim newFileStr
  newFileStr=makeFileStr(rs.fields, _
                         get_script_attrs_rs(rs("id").value,rs("class").value))

  if newFileStr="" then
   exit sub
  end if

  dim dsxFile
 
  if not m_fso.FileExists(filespec) then'    ( )
   call su_createPath(m_fso,m_fso.GetParentFolderName(filespec)) 'throw

   set dsxFile=m_fso.CreateTextFile(filespec,true)
   
   call dsxFile.Write(newFileStr)

   call dsxFile.Close()
   
   cout " "&filespec
  else
   set dsxFile=m_fso.OpenTextFile(filespec)'   

   dim oldFileStr
   oldFileStr=""
  
   while not dsxFile.AtEndOfStream
    call strcat(oldFileStr,dsxFile.ReadLine&endl)
   wend

   if newFileStr<>oldFileStr then
    if not hasValue(spostflags,g_NoBackUp) then
     dim backupName
     
     backupName=makeBackupFileName(filespec)

     if m_fso.FileExists(backupName) then
      call m_fso.DeleteFile(backupName,true)'removes read-only
     end if

     call m_fso.CopyFile(filespec,backupName)

     '  (  (    - CopyFile failed))
     if m_fso.FileExists(backupName) then
      m_fso.GetFile(backupName).Attributes=m_fso.GetFile(backupName).Attributes+faReadOnly
     end if
    end if

    set dsxFile=m_fso.OpenTextFile(filespec,ForWriting)

    call dsxFile.Write(newFileStr)

    call dsxFile.Close()
   
    cout " "+filespec
   
   else
    cout filespec
   end if
  end if
  
  m_gottenScripts(rs("name").value)=0
 end sub 'processGetFile
 
 '------------------------------------------------------------------------
 '    
 private function get_script_attrs_rs(byval script_id,byval script_class)
  if(m_cmd_get_script_attrs is nothing)then
   dim cmd
   set cmd=su_create_object("ADODB.Command")
   
   cmd.ActiveConnection=m_data_source
   
   cmd.CommandText= _
    "select attribute from scripts_common_attribute where id=? and class=?"
   
   set m_cmd_get_script_attrs=cmd
  end if
  
  m_cmd_get_script_attrs(0)=script_id
  m_cmd_get_script_attrs(1)=script_class
  
  set get_script_attrs_rs=m_cmd_get_script_attrs.Execute()
 end function 'get_script_attrs_rs
 
 '------------------------------------------------------------------------
 private function get_script_by_name_rs(byval script_name)
  if(m_cmd_get_script_by_name is nothing)then
   dim cmd
   set cmd=su_create_object("ADODB.Command")
   
   cmd.ActiveConnection=m_data_source
   
   cmd.CommandText= _
    "select id,class,title,script,name from scripts"&vbCrLf& _
    "where upper(name)=?"
   
   set m_cmd_get_script_by_name=cmd
  end if
  
  m_cmd_get_script_by_name(0)=ucase(script_name)
  
  set get_script_by_name_rs=m_cmd_get_script_by_name.Execute()
 end function 'get_script_by_name_rs
end class 't_dbsp_processor_get

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function create_dbsp_processor_get()
 set create_dbsp_processor_get=new t_dbsp_processor_get

 call create_dbsp_processor_get.init()
end function 'create_dbsp_processor_get

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
