'-------------------------------------------------------------------------------
'   set
'                                     , 27  2003 ()
'-------------------------------------------------------------------------------
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
public sub process_set(cflags,spostflags,names)
 dim data_source

 set data_source=getDataSource(cflags)

 call data_source.BeginTrans()

 dim processor
 set processor=create_dbsp_processor_set(data_source)

 call processor.run(spostflags,names)

 call data_source.CommitTrans() 'throw
end sub 'process_set

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_dbsp_processor_set

class t_dbsp_processor_set
 private m_data_source
 private m_fso

 private m_cntInserted
 private m_cntUpdated
 private m_cntDeleted
 private m_cntErrors

 private m_cls_mng
 private m_cmd_update
 private m_cmd_insert
 private m_cmd_script_name_by_id
 private m_cmd_script_id_by_name
 private m_cmd_delete_script_attrs
 private m_cmd_insert_script_attr

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  set m_fso        =nothing
  set m_cls_mng    =nothing

  call init_cmd(nothing)
 end sub 'class_initialize

 '------------------------------------------------------------------------
 public sub init(data_source)
  if(m_fso is nothing)then
   set m_fso=su_create_object("Scripting.FileSystemObject")
  end if

  '-----------------------
  dim cls_mng

  if(data_source is nothing)then
   cls_mng=nothing
  else
   set cls_mng=su_create_object("LCPI.DBS.SYS.DBClassManager")

   set cls_mng.Connection=data_source

   call cls_mng.Load()
  end if

  '-----------------------
  call init_cmd(data_source)

  set m_cls_mng =cls_mng
 end sub 'init

 '------------------------------------------------------------------------
 private sub init_cmd(data_source)
  set m_data_source              = data_source
  set m_cls_mng                  = nothing
  set m_cmd_update               = nothing
  set m_cmd_insert               = nothing
  set m_cmd_script_name_by_id    = nothing
  set m_cmd_script_id_by_name    = nothing
  set m_cmd_delete_script_attrs  = nothing
  set m_cmd_insert_script_attr   = nothing
 end sub 'init_cmd

 '------------------------------------------------------------------------
 public sub run(byref spostflags,byref names)
  m_cntInserted  =0
  m_cntUpdated   =0
  m_cntDeleted   =0
  m_cntErrors    =0

  '   g_isOrigin,      ,
  '  ,   ( )
  if hasValue(spostflags,g_isOrigin) then
   'call src.Execute("delete from rpl_scripts")
   call m_data_source.Execute("delete from scripts",m_cntDeleted)
  end if

  dim i

  if(names.IsEmpty())then
   call processDir(".",spostflags)
  else
   for each i in names
    i=cstr(i)

    if m_fso.FolderExists(i) then
     call processDir(i,spostflags)

    else'   
     call processFile(i,spostflags)
    end if
   next
  end if

  ' 
  cout ": "&cstr(m_cntInserted)
  cout ": "&cstr(m_cntUpdated)
  cout "  : "&cstr(m_cntDeleted)
  cout "   : "&cstr(m_cntErrors)

  if(m_cntErrors<>0)then
   call throw_error("    ")
  end if
 end sub 'run

 '------------------------------------------------------------------------
 private sub processDir(path,byref spostflags)
  dim workingDir
  set workingDir=m_fso.GetFolder(path)

  '  
  dim file

  for each file in workingDir.Files
   if (file.Attributes and faReadOnly)=0 and m_fso.GetExtensionName(file.Name)="dsx" then
    call processFile(m_fso.BuildPath(path,file.Name),spostflags)
   end if
  next 'file

  ' ,     
  if not hasValue(spostflags,g_NoSubFolders) then
   dim subfolder,subfolderspec

   for each subfolder in workingDir.SubFolders
    subfolderspec=""

    if path<>"." then
     subfolderspec=path+"\"
    end if

    call strcat(subfolderspec,subfolder.Name)

    call processDir(subfolderspec,spostflags)
   next
  end if
 end sub 'processDir

 '------------------------------------------------------------------------
 'filepath-(   path) ,  

 private sub processFile(byval filepath,byref spostflags)
  on error resume next

  call processFile_impl(filepath,spostflags)

  dim err_code
  dim err_source
  dim err_descr

  err_code   =err.number
  err_source =err.source
  err_descr  =err.description

  if(err_code<>0)then
   cerr "["&err_source&"]: ["&filepath&"] - "&err_descr

   inc m_cntErrors
  end if

  on error goto 0

  call err.Clear()
 end sub 'processFile

 '------------------------------------------------------------------------
 private sub processFile_impl(byval filepath,byref spostflags)
  dim filespec
  filespec=filepath

  dim pure_fileName
  pure_fileName=m_fso.GetBaseName(filespec)

  dim extName
  extName=m_fso.GetExtensionName(filespec)

  if extName<>"" and extName<>"dsx" then
   call throw_error("  ")
  end if

  if extName="" then
   call strcat(filespec,".dsx")
  end if

  if not m_fso.FileExists(filespec) then
   call throw_error("  ")
  end if

  '  
  dim file
  set file=m_fso.OpenTextFile(filespec)

  dim filestr
  filestr=""

  while not file.AtEndOfStream
   filestr=filestr&file.ReadLine&endl
  wend

  dim dom
  set dom=su_create_object("MSXML2.DOMDocument")

  dom.preserveWhiteSpace=true

  if not dom.loadXML(filestr) then
   call throw_error(" XML-")
  end if

  '   
  dim backNode
  set backNode=selectXmlNode(dom,"backup_script")

  dim titleAttr
  set titleAttr=backNode.Attributes.getNamedItem("title")

  if titleAttr is nothing then
   call throw_error("  title  backup_script")
  end if

  '      filename  generate  
  dim bodyNode
  set bodyNode=selectXmlNode(backNode,"body")

  dim scriptNode
  set scriptNode=selectXmlNode(bodyNode,"script")

  '  filename
  dim idom
  set idom=su_create_object("MSXML2.DOMDocument")

  idom.preserveWhiteSpace=true

  call idom.loadXML(scriptNode.xml)'    true

  '    (   )
  dim scriptID,scriptClass
  dim generateValue

  generateValue=getScriptIDFromFile(filestr,scriptID,scriptClass)

  '   
  dim generateAttr
  set generateAttr=scriptNode.Attributes.getNamedItem("generate")

  if generateAttr is nothing then
   call idom.documentElement.setAttribute("generate",generateValue)
  end if

  '  ,   
  dim i,item_str,script

  script=""

  for i=0 to bodyNode.childNodes.Length-1
   if bodyNode.childNodes(i).nodeName="script" then
    processCache idom,spostflags'process cache

    item_str=idom.xml

    item_str=left(item_str,len(item_str)-len(endl))

    script=script+item_str
   else
    item_str=bodyNode.childNodes(i).xml

    if(i=0 or i=bodyNode.childNodes.Length-1)then
     item_str=left(item_str,len(item_str)-len(endl))
    end if

    script=script+item_str
   end if
  next

  ' 
  dim script_info
  set script_info=get_script_info_by_name(pure_fileName)

  dim IsInsert
  IsInsert=(script_info is nothing)

  dim result_cmd

  if(IsInsert)then
   if(IsNull(scriptClass))then
    scriptClass=g_CommonScriptClass
   end if

   if(not m_cls_mng.classes.Exists(scriptClass))then
    call throw_error("  ["&scriptClass&"]")
   end if

   if IsNull(scriptID) then
    '  id
    scriptID=m_cls_mng.classes.ItemByID(scriptClass).GenObjID(1)
   end if

   '   
   set script_info=get_script_info_by_id(scriptID,scriptClass)

   if(not (script_info is nothing))then
    call throw_error(" "&su_dbobj_id_to_str(scriptID,scriptClass)& _
                     "    "&script_info.name)
   end if

   if(m_cmd_insert is nothing)then
    set result_cmd=su_create_object("ADODB.Command")

    result_cmd.ActiveConnection=m_data_source

    result_cmd.CommandText= _
     "insert into scripts(name,title,script,id,class)"&vbCrLf& _
     "values(:name,:title,:script,:id,:class)"

    '  
    set m_cmd_insert=result_cmd
   else
    set result_cmd=m_cmd_insert
   end if

  else'update
   ' -  -    id:class

   if generateValue<>g_AutoGenNone then
    if(generateValue=g_AutoGenID and scriptClass<>script_info.obj_class)then
     call throw_error("    ["&cstr(script_info.obj_class)&"] "& _
                      "   ["+cstr(scriptClass)&"]")
    end if

    scriptID    =script_info.obj_id
    scriptClass =script_info.obj_class

   else'        name  scripts
    set script_info=get_script_info_by_id(scriptID,scriptClass)

    if(not (script_info is nothing))then
     if(ucase(script_info.name)<>ucase(pure_fileName))then
      call throw_error("    name   """&script_info.name&""" "& _
                       " "&su_dbobj_id_to_str(scriptID,scriptClass))
     end if
    end if
   end if

   if(m_cmd_update is nothing)then
    set result_cmd=su_create_object("ADODB.Command")

    result_cmd.ActiveConnection=m_data_source

    result_cmd.CommandText= _
     "update scripts set name=:name,title=:title,script=:script"&vbCrLf& _
     "where id=:id and class=:class"

    '  
    set m_cmd_update=result_cmd
   else
    set result_cmd=m_cmd_update
   end if
  end if

  result_cmd.NamedParameters=true

  dim msg_txt
  msg_txt=" ["+cstr(scriptID)+":"+cstr(scriptClass)+"] - "+filespec

  result_cmd("name")   =pure_fileName
  result_cmd("title")  =titleAttr.Value
  result_cmd("script") =script
  result_cmd("id")     =scriptID
  result_cmd("class")  =scriptClass

  call result_cmd.Execute()

  ' 
  dim attrNode
  set attrNode=selectXmlNode(backNode,"attribute")

  '    -    
  call delete_script_attrs(scriptID,scriptClass)

  dim attr

  for each attr in attrNode.childNodes
   if(attr.nodeName="a" and isnumeric(attr.Text))then
    call insert_script_attr(scriptID,scriptClass,clng(attr.Text))
   end if
  next

  if(IsInsert)then
   cout " "+msg_txt
   inc m_cntInserted
  else
   cout " "+msg_txt
   inc m_cntUpdated
  end if

 end sub'processSetFile

 '------------------------------------------------------------------------
 private function selectXmlNode(dom,node_name)
  set selectXmlNode=dom.selectSingleNode(node_name)

  if(selectXmlNode is nothing)then
   call throw_error("  ["&node_name&"]")
  end if
 end function 'selectXmlNode

 '------------------------------------------------------------------------
 '     
 private function get_script_info_by_id(byval script_id, _
                                        byval script_class) 't_dbsp_script_id
  set get_script_info_by_id=nothing

  if(m_cmd_script_name_by_id is nothing)then
   dim cmd
   set cmd=su_create_object("ADODB.Command")

   cmd.ActiveConnection=m_data_source

   cmd.CommandText= _
    "select name from scripts where id=? and class=?"

   set m_cmd_script_name_by_id=cmd
  end if

  m_cmd_script_name_by_id(0)=script_id
  m_cmd_script_name_by_id(1)=script_class

  dim rs
  set rs=m_cmd_script_name_by_id.Execute()

  if(not rs.eof)then
   set get_script_info_by_id=new t_dbsp_script_id

   get_script_info_by_id.obj_id    =script_id
   get_script_info_by_id.obj_class =script_class
   get_script_info_by_id.name      =rs(0).value
  end if
 end function 'get_script_info_by_id

 '------------------------------------------------------------------------
 '     

 private function get_script_info_by_name(byval script_name) 't_dbsp_script_id
  set get_script_info_by_name=nothing

  if(m_cmd_script_id_by_name is nothing)then
   dim cmd
   set cmd=su_create_object("ADODB.Command")

   cmd.ActiveConnection=m_data_source

   cmd.CommandText= _
    "select id,class from scripts where upper(name)=?"

   set m_cmd_script_id_by_name=cmd
  end if

  m_cmd_script_id_by_name(0)=ucase(script_name)

  dim rs
  set rs=m_cmd_script_id_by_name.Execute

  if(not rs.eof)then
   set get_script_info_by_name=new t_dbsp_script_id

   get_script_info_by_name.name      =script_name
   get_script_info_by_name.obj_id    =rs(0).value
   get_script_info_by_name.obj_class =rs(1).value
  end if
 end function 'get_script_info_by_name

 '------------------------------------------------------------------------
 private sub delete_script_attrs(byval script_id, _
                                 byval script_class)

  if(m_cmd_delete_script_attrs is nothing)then
   dim cmd
   set cmd=su_create_object("ADODB.Command")

   cmd.ActiveConnection=m_data_source

   cmd.CommandText= _
    "delete from scripts_common_attribute where id=? and class=?"

   set m_cmd_delete_script_attrs=cmd
  end if

  m_cmd_delete_script_attrs(0)=script_id
  m_cmd_delete_script_attrs(1)=script_class

  call m_cmd_delete_script_attrs.Execute()
 end sub 'delete_script_attrs

 '------------------------------------------------------------------------
 private sub insert_script_attr(byval script_id,       _
                                byval script_class,    _
                                byval attr_id)
  if(m_cmd_insert_script_attr is nothing)then
   dim cmd
   set cmd=createobject("ADODB.Command")

   cmd.ActiveConnection=m_data_source

   cmd.CommandText= _
    "insert into scripts_common_attribute(id,class,attribute)"&vbCrLf& _
    "values(:id,:class,:attr)"

   set m_cmd_insert_script_attr=cmd
  end if

  m_cmd_insert_script_attr("id")    =script_id
  m_cmd_insert_script_attr("class") =script_class
  m_cmd_insert_script_attr("attr")  =attr_id

  call m_cmd_insert_script_attr.Execute()
 end sub 'insert_script_attr

 '------------------------------------------------------------------------
 private sub throw_error(err_descr)
  call err.raise(-2,typename(me),err_descr)
 end sub
end class 't_dbsp_processor_set

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
public function create_dbsp_processor_set(data_source)
 set create_dbsp_processor_set=new t_dbsp_processor_set

 call create_dbsp_processor_set.init(data_source)
end function

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

