'-------------------------------------------------------------------------------
option explicit

'-------------------------------------------------------------------------------
const g_CommonScriptClass=1500

'-------------------------------------------------------------------------------
'  
const g_DataSourceFlag ="i"
const g_OtherDirFlag   ="ad"

const g_Help           ="?"

const g_GetMode        ="get"
const g_SetMode        ="set"
const g_TemplateMode   ="template"

const g_GetOthers      ="others"
const g_NoSubFolders   ="l"
const g_isOrigin       ="v"
const g_NoBackUp       ="b"
const g_NoAskOnRemove  ="r"
const g_CacheYes       ="c:yes"
const g_CacheNo        ="c:no"
const g_AutoGenNone    ="noauto"
const g_AutoGenID      ="autoid"

'-------------------------------------------------------------------------------
const ForReading      =1'Open a file for reading only. You can't write to this file.
const ForWriting      =2'Open a file for writing.
const ForAppending    =8

'-------------------------------------------------------------------------------
const faNormal     =0'Normal file. No attributes are set.
const faReadOnly   =1'Read-only file. Attribute is read/write.
const faHidden     =2'Hidden file. Attribute is read/write.
const faSystem     =4'System file. Attribute is read/write.
const faVolume     =8'Disk drive volume label. Attribute is read-only.
const faDirectory  =16'Folder or directory. Attribute is read-only.
const faArchive    =32'File has changed since last backup. Attribute is read/write.
const faAlias      =64'Link or shortcut. Attribute is read-only.
const faCompressed =128'Compressed file. Attribute is read-only.

'-------------------------------------------------------------------------------
'  
const adTypeBinary          =1
const adTypeText            =2

const adSaveCreateNotExist  =1
const adSaveCreateOverWrite =2

'-------------------------------------------------------------------------------
sub cout(msg)
 dim str
 str="dbsp: "&cstr(msg)

 wscript.echo str
end sub'cout

'-------------------------------------------------------------------------------
sub cerr(msg)
 dim str

 str="dbsp: : "&cstr(msg)

 wscript.echo str
end sub'cerr

'-------------------------------------------------------------------------------
sub print_intro()
 cout "Database script processor."
 cout "(C)  2000-2007.   ."
end sub'print_intro

'-------------------------------------------------------------------------------
sub print_use_info()
 print_intro
 cout ""
 cout ": dbsp [-arg<param>].. [mode] [dirspec] [filespec] [options]"
 cout ""
 cout "arg:"
 cout " i: param-datasource-   "
 cout ""
 cout " ad: param-   (default)-others"
 cout ""
 cout " f:    param"
 cout ""
 cout "mode: get -   "
 cout "      set -   "
 cout "      template - - "
 cout ""
 cout "dirspec... filespec... -(get,set)  ()   "
 cout "                          ,    "
 cout "filespec... -(template)  -"
 cout ""
 cout "options: -(/).."
 cout " (get): l -  "
 cout "        v - root- (   )"
 cout "        r -  -v -     root-"
 cout "        others -        ad"
 cout "        b -     "
 cout " (set): l -  "
 cout "        v -     "
 cout "        c:yes -    cache=""yes"""
 cout "        c:no -    cache=""no"""
 cout " (template): r -     "
 cout "             autoid -   "
 cout "             noauto -     "
 cout " ? - "
end sub'print_use_info

'-------------------------------------------------------------------------------
function getDataSource(byref cflags)
 const c_err_source="getDataSource"

 set getDataSource=nothing

 ' filespec   i (ifilespec)
 dim filespec
 filespec=getCombinedValue(cflags,g_DataSourceFlag)

 dim fso
 set fso=CreateObject("Scripting.FileSystemObject")

 if not fso.FileExists(filespec) then
  call err.raise(-1,c_err_source,"datasource  """&filespec&"""  ")
 end if
 
 '      datasource
 dim ibp_file
 set ibp_file=fso.OpenTextFile(filespec,ForReading)

 dim connectionString
 connectionString=""

 do while not ibp_file.AtEndOfStream
  strcat connectionString,ibp_file.ReadLine
 loop

 dim ds
 set ds=CreateObject("ADODB.Connection")
 
 ds.Provider="LCPI.IBProvider"

 call ds.Open(connectionString)
 
 dim ds_props
 set ds_props=ds.Properties

 cout "       : "&ds_props("server name").value&" "& _
                      "["&ds_props("DBMS Name").value&" "& _
                        ds_props("DBMS Version").value&"]"
 cout "   : "&ds_props("data source name").value
 cout " : "&ds_props("user name").value

 cout " : "&cstr(now())
 cout ""

 set getDataSource=ds
end function'getDataSource

'-------------------------------------------------------------------------------
function cstr2(byref str)
 cstr2=""
 if not isnull(str) then cstr2=cstr(str)
end function'cstr2

'-------------------------------------------------------------------------------
function inc(byref val)
 val=val+1
 inc=val
end function'inc

'-------------------------------------------------------------------------------
function dec(byref val)
 val=val-1
 dec=val
end function'dec

'-------------------------------------------------------------------------------
function hasValue(byref vector,value)
 dim i

 for each i in vector
  if(i=value)then
   hasValue=true
   exit function
  end if
 next

 hasValue=false
end function'hasValue

'-------------------------------------------------------------------------------
function hasValueCombined(byref std_vector,byref vector,value)
 dim i

 for each i in std_vector
  if hasValueLen(vector,value,len(cstr(i))) then
   hasValueCombined=true
   exit function
  end if
 next
 
 hasValueCombined=false
end function'hasValueCombined

'-------------------------------------------------------------------------------
function hasValueLen(byref vector,value,vallen)
 dim i

 for each i in vector
  if left(i,vallen)=left(value,vallen) then
   hasValueLen=true
   exit function
  end if
 next

 hasValueLen=false
end function'hasValueLen

'-------------------------------------------------------------------------------
function getCombinedName(byref std_vector,value)
 dim i
 
 for each i in std_vector
  if(i=left(value,len(cstr(i))))then
   getCombinedName=cstr(i)
   exit function
  end if
 next
 
 getCombinedName=""
end function'getCombinedName

'-------------------------------------------------------------------------------
function getCombinedValue(byref cflags,cflag)
 getCombinedValue=""

 dim i

 for each i in cflags
  if left(i,len(cflag))=cflag then
   getCombinedValue=mid(i,len(cflag)+1)
   exit function
  end if
 next

end function'getCombinedValue

'-------------------------------------------------------------------------------
sub print_vector(byref vector)
 dim i
 for each i in vector
  cout cstr(i)
 next
end sub'print_vector

'-------------------------------------------------------------------------------
function endl()
 endl=chr(13)+chr(10)
end function'endl

'-------------------------------------------------------------------------------
function makeAutoFileName(script_id,script_class)
 makeAutoFileName=""

 dim p1
 p1=cstr(script_class)
 while len(p1)<7
  p1="0"+p1
 wend

 dim p2
 p2=cstr(script_id)
 while len(p2)<7
  p2="0"+p2
 wend

 makeAutoFileName=p1+"-"+p2+".dsx"
end function'makeAutoFileName

'-------------------------------------------------------------------------------
function makeFileStr(rs,attr_rs)
 makeFileStr=""

 dim pure_fileName

 pure_fileName=rs("name").value
 
 '    (auto,autoid,noauto)
 dim dom
 set dom=CreateObject("MSXML2.DOMDocument")
 
 dom.preserveWhiteSpace=true

 if not dom.loadXML("<body>"+endl+cstr2(rs("script").value)+endl+"</body>") then
  cerr " DB XML- "+pure_fileName

  exit function
 end if

 '  
 dim scriptNode
 set scriptNode=dom.selectSingleNode("body/script")
 
 if scriptNode is nothing then
  cerr " DB  <script> "+pure_fileName
  exit function
 end if

 dim attribs
 set attribs=scriptNode.Attributes
 
 if attribs.length=0 then
  cerr " DB   <script> "+pure_fileName
  exit function
 end if

 dim generateAttr
 set generateAttr=attribs.getNamedItem("generate")
 
 if generateAttr is nothing then
  cerr " DB  generate  <script> "+pure_fileName
  exit function
 end if

 makeFileStr="<backup_script"

 if generateAttr.Value=g_AutoGenNone then
  strcat makeFileStr," id="""+cstr(rs("id"))+""" class="""+cstr(rs("class"))+""""
 elseif generateAttr.Value=g_AutoGenID then
  strcat makeFileStr," class="""+cstr(rs("class"))+""""
 end if

 '  generate
 attribs.removeNamedItem "generate"

 strcat makeFileStr," title="+makeTitleStr(cstr2(rs("title")))+" version=""1.0"">"+endl

 strcat makeFileStr,"<attribute>"+endl

 while not attr_rs.eof
  strcat makeFileStr,"<a>"+cstr(attr_rs(0))+"</a>"+endl
  attr_rs.MoveNext
 wend

 call strcat(makeFileStr,"</attribute>"+endl+dom.xml+"</backup_script>"+endl)
end function'makeFileStr

'-------------------------------------------------------------------------------
function makeTitleStr(str)
 makeTitleStr=""""

 dim char
 dim i
 
 for i=1 to len(str)
  char=mid(str,i,1)

  select case (char)
   case "<"
     char="&lt;"
   case ">"
     char="&gt;"
   case char="&"
     char="&amp;"
   case """"
     char="&quot;"
   case "'"
     char="&apos;"
  end select
  
  makeTitleStr=makeTitleStr+char
 next

 makeTitleStr=makeTitleStr&""""
end function'makeTitleStr

'-------------------------------------------------------------------------------
function makeBackupFileName(str)
 makeBackupFileName=left(str,len(str)-1)+"~"
end function'makeBackupFileName

'-------------------------------------------------------------------------------
function getScriptIDFromFile(byref filestr,byref scriptID,byref scriptClass)
 'filestr-  
 getScriptIDFromFile="auto"

 scriptID    =null
 scriptClass =null

 dim dom: set dom=CreateObject("MSXML2.DOMDocument")
 dom.LoadXML filestr'        script

 dim backNode: set backNode=dom.selectSingleNode("backup_script")

 dim classAttr: set classAttr=backNode.Attributes.getNamedItem("class")
 if not classAttr is nothing then
  getScriptIDFromFile=g_AutoGenID
  if isnumeric(classAttr.Value) then scriptClass=clng(classAttr.Value)
 end if

 dim idAttr: set idAttr=backNode.Attributes.getNamedItem("id")
 if not idAttr is nothing then
  getScriptIDFromFile=g_AutoGenNone
  if isnumeric(idAttr.Value) then scriptID=clng(idAttr.Value)
 end if

end function'getScriptIDFromFile

'-------------------------------------------------------------------------------
function createSubFolders(path)
 'path      
 createSubFolders=false

 dim fso
 set fso=CreateObject("Scripting.FileSystemObject")
 
 dim filename
 filename=fso.GetBaseName(path)
 
 dim i,namepos
 namepos=instrrev(path,filename)

 dim dirname
 dirname=""

 dim char
 dim folder

 for i=1 to namepos-1'      "\"  "/" ( )
  char=mid(path,i,1)

  if char="/" or char="\" then
   if not fso.FolderExists(dirname) then
    set folder=nothing

    set folder=fso.CreateFolder(dirname)
    
    if folder is nothing then
     exit function
    end if
   end if
  end if

  dirname=dirname+char
 next

 on error goto 0

 createSubFolders=true
end function'createSubFolders

'-------------------------------------------------------------------------------
function processCache(byref dom,byref spostflags)
 'dom -DOMDocument (script node)
 processCache=false

 if dom is nothing then exit function

 dim attributes: set attributes=dom.selectSingleNode("script").attributes
 if dom is nothing then exit function

 dim cache_attr
 set cache_attr=attributes.getNamedItem("cache")

 if cache_attr is nothing then exit function

 if hasValue(spostflags,g_CacheYes) then
  cache_attr.Text="yes"
 elseif hasValue(spostflags,g_CacheNo) then
  cache_attr.Text="no"
 end if

 processCache=true
end function'processCache

'-------------------------------------------------------------------------------
function strcat(byref str1,byref str2)
 str1=str1+str2
 strcat=str1
end function'strcat

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_dbsp_script_id

class t_dbsp_script_id
 public obj_id
 public obj_class
 public name

 private sub class_initialize()
  obj_id     =null
  obj_class  =null
  name       =null 
 end sub 'class_initialize
end class 't_dbsp_script_id

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

