'*******************************************************************************
 '        
 '   , 22.06.2005
 '   , 25.06.2007
'*******************************************************************************

Option Explicit

'*******************************************************************************
'                         t_type_address_item_descr
'*******************************************************************************

Class t_type_address_item_descr
  Private m_type_id
  Private m_obj_class

  Private m_name
  Private m_aliase
  Private m_delete  ' ,       

  Private m_address_item_transforms  '    

  '-----------------------------------------------------------------------------
  ' 
  Private Sub class_initialize()
    m_type_id   = Null
    m_obj_class = Null

    m_name      = Null
    m_aliase    = Null
    m_delete    = True

    Set m_address_item_transforms = CreateObject("LCPI.DBS.Utility.Vector")
  End Sub  ' class_initialize

  '-----------------------------------------------------------------------------
  '                               Public 
  '-----------------------------------------------------------------------------

  public property get type_id()
    type_id = m_type_id
  end property 'get type_id

  public property let type_id(byval x)
    m_type_id = x
  end property 'let type_id

  '-----------------------------------------------------------------------------
  public property get obj_class()
    obj_class = m_obj_class
  end property 'get obj_class

  public property let obj_class(byval x)
    m_obj_class = x
  end property 'let obj_class

  '-----------------------------------------------------------------------------
  public property get name()
    name = m_name
  end property 'get name

  public property let name(byval x)
    m_name = x
  end property 'let name

  '-----------------------------------------------------------------------------
  public property get aliase()
    aliase = m_aliase
  end property 'get aliase

  public property let aliase(byval x)
    m_aliase = x
  end property 'let aliase

  '-----------------------------------------------------------------------------
  ' ,       
  Public Property Get delete()
    delete = m_delete
  End Property  ' get delete

  Public Property Let delete(value)
    m_delete = value
  End Property  ' let delete

  '-----------------------------------------------------------------------------
  '     
  Public Property Get address_item_transforms()
    Set address_item_transforms = m_address_item_transforms
  End Property  ' Get address_item_transforms

 'selectors -----------
 public function print_name()
  dim t

  if(not IsNull(m_type_id))then
   t="type_id:["&su_cstr_sn(m_type_id)&"] "
  end if

  t=t&"obj_class:["&obj_class&"] "& _
      "name:["&su_cstr_sn(name)&"] "& _
      "aliase:["&su_cstr_sn(aliase)&"]"

  print_name=t
 end function 'print_name

  '-----------------------------------------------------------------------------
End Class  ' t_type_address_item_descr


'*******************************************************************************
'                          t_adress_item_transform
'*******************************************************************************

'    t_adress_item_transform
Public Function create_adress_item_transform()
  Set create_adress_item_transform = New t_adress_item_transform
End Function  ' create_adress_item_transform

'*******************************************************************************

'      
Class t_adress_item_transform
  Private m_name      '  
  Private m_new_name  '  

  '-----------------------------------------------------------------------------
  ' 
  Private Sub class_initialize()
    m_name     = Null
    m_new_name = Null
  End Sub  ' class_initialize

  '-----------------------------------------------------------------------------
  '                               Public 
  '-----------------------------------------------------------------------------

  '  
  Public Property Get name()
    name = m_name
  End Property  ' Get name

  Public Property Let name(value)
    m_name = value
  End Property  ' Let name

  '-----------------------------------------------------------------------------
  '  
  Public Property Get new_name()
    new_name = m_new_name
  End Property  ' Get new_name

  Public Property Let new_name(value)
    m_new_name = value
  End Property  ' Let new_name

  '-----------------------------------------------------------------------------
  '                                Public 
  '-----------------------------------------------------------------------------

  '  true,       
  Public Function is_rename()
    is_rename = False

    If (IsNull(m_new_name)) Then Exit Function
    If (IsEmpty(m_new_name)) Then Exit Function
    If (Len(m_new_name) < 1) Then Exit Function
    If (m_name = m_new_name) Then Exit Function

    is_rename = True
  End Function  ' is_rename

  '-----------------------------------------------------------------------------
End Class  ' t_adress_item_transform


'*******************************************************************************
'                              t_address_item
'*******************************************************************************

'    t_address_item
Private Function create_address_item(node, is_unique)
  Dim ai
  Set ai = New t_address_item

  Dim obj_class, name, type_name, recursive

  Call xml_read_attr_lng    (node, "class",     True,  obj_class)
  Call xml_read_attr_str    (node, "name",      False, name)
  Call xml_read_attr_str    (node, "type_name", True,  type_name)

  ai.obj_class = obj_class
  ai.name      = name
  ai.type_name = type_name
  ai.recursive = xml_read_attr_bool_ex(node, "recursive", False)

  '   
  Dim child_item, child_items
  Set child_items = node.selectNodes("address_item")

  '         
  ' (    ,     )
  If (is_unique) Then
    ' ,     
    If (child_items.length > 1) Then
      Call Err.Raise(-1, TypeName(Me) & " -> create_address_item", _
                     "       ")
    End If
  End If

  For Each child_item In child_items
    Call ai.child_items.PushBack(create_address_item(child_item, is_unique))
  Next  ' child_items

  Set create_address_item = ai
End Function  ' create_address_item

'-------------------------------------------------------------------------------
'     
Class t_address_item
  Public obj_id           ' 
  Public obj_class        '  
  Public name             ' 
  Public type_name        '  
  Public recursive        '     

  Private m_child_items   '    

  '-----------------------------------------------------------------------------
  '                               Public 
  '-----------------------------------------------------------------------------

  '  
  Public Property Get child_items()
    If (IsEmpty(m_child_items)) Then
      Set m_child_items = su_create_object("LCPI.DBS.Utility.Vector")
    End If

    Set child_items = m_child_items
  End Property  ' Get child_items

 '-----------------------------------------------------------------------------
End Class  ' t_address_item


'*******************************************************************************
'                              t_ai_duplicate
'*******************************************************************************

'      
Class t_ai_duplicate
  Public valid_item       '    
  Public duplicate_items  '   

  '-----------------------------------------------------------------------------
  ' 
  Private Sub class_initialize()
    Set duplicate_items = su_create_object("LCPI.DBS.Utility.Vector")
  End Sub  ' class_initialize

  '-----------------------------------------------------------------------------
End Class  ' t_ai_duplicate


'*******************************************************************************
'                       t_type_address_item_map_item
'*******************************************************************************

'class t_type_address_item_map_item
Class t_type_address_item_map_item
  Private m_element
  Private m_dublicates
  Private m_address_items  '     

  '-----------------------------------------------------------------------------
  ' 
  Private Sub class_initialize()
    Set m_element       = New t_type_address_item_descr
    Set m_dublicates    = su_create_object("LCPI.DBS.Utility.Vector")
    Set m_address_items = su_create_object("LCPI.DBS.Utility.Vector")
  End Sub 'class_initialize

  '-----------------------------------------------------------------------------
  '                               Public 
  '-----------------------------------------------------------------------------

  Public Property Get element()
    Set element = m_element
  End Property  ' Get element

  '------------------------------------------------------------------------
  Public Property Get dublicates()
    Set dublicates = m_dublicates
  End Property  ' Get dublicates

  '------------------------------------------------------------------------
  '     
  Public Property Get address_items()
    Set address_items = m_address_items
  End Property  ' Get address_items

  '------------------------------------------------------------------------
End Class  ' t_type_address_item_map_item


'*******************************************************************************
'                         t_address_processing_map
'*******************************************************************************

'    
Class t_address_processing_map
  Private m_elements       '      
  Private m_ai_duplicates  '      
  Private m_ai_delete      '     

  '-----------------------------------------------------------------------------
  '                               Public 
  '-----------------------------------------------------------------------------

  '      
  Public Property Get elements()
    If (IsEmpty(m_elements)) Then
      Set m_elements = su_create_object("LCPI.DBS.Utility.Vector")
    End If

    Set elements = m_elements
  End Property  ' Get elements

  '------------------------------------------------------------------------
  '     
  Public Property Get ai_duplicates()
    If (IsEmpty(m_ai_duplicates)) Then
      Set m_ai_duplicates = su_create_object("LCPI.DBS.Utility.Vector")
    End If

    Set ai_duplicates = m_ai_duplicates
  End Property  ' Get ai_duplicates

  '------------------------------------------------------------------------
  '     
  Public Property Get ai_delete()
    If (IsEmpty(m_ai_delete)) Then
      Set m_ai_delete = su_create_object("LCPI.DBS.Utility.Vector")
    End If

    Set ai_delete = m_ai_delete
  End Property  ' Get ai_delete

  '-----------------------------------------------------------------------------
End Class  ' t_address_processing_map


'*******************************************************************************

'    XML-
Function load_ai_types_map_from_xml_doc(xml_doc)
  Set load_ai_types_map_from_xml_doc = Nothing

  Dim map
  Set map = New t_address_processing_map

  Dim root_node
  Set root_node = xml_get_node(xml_doc, "ai_type_map", True)

  Dim element, elements
  Set elements = root_node.selectNodes("element")

  For Each element In elements
    Dim obj_class, type_name, type_aliase, delete

    call xml_read_attr_str(element, "class", True, obj_class)
    call xml_read_attr_str(element, "name",  True, type_name)
    call xml_read_attr_str(element, "alias", True, type_aliase)

    Dim item : Set item = New t_type_address_item_map_item

    item.element.obj_class = obj_class
    item.element.name      = type_name
    item.element.aliase    = type_aliase

    '   
    Dim dublicate, dublicates
    Set dublicates = element.selectNodes("dublicate")

    For Each dublicate In dublicates
      Call xml_read_attr_str(dublicate, "name",   True, type_name)
      Call xml_read_attr_str(dublicate, "alias",  True, type_aliase)

      Dim dublicate_data : Set dublicate_data = New t_type_address_item_descr

      dublicate_data.obj_class = obj_class
      dublicate_data.name      = type_name
      dublicate_data.aliase    = type_aliase
      dublicate_data.delete    = xml_read_attr_bool_ex(dublicate, "delete", True)

      Call item.dublicates.PushBack(dublicate_data)

      '     
      Dim adsress_item, adsress_items
      Set adsress_items = dublicate.selectNodes("address_item")

      For Each adsress_item In adsress_items
        Dim ai_name, ai_new_name
        ai_name     = Null
        ai_new_name = Null

        Call xml_read_attr_str(adsress_item, "name",     True,  ai_name)
        Call xml_read_attr_str(adsress_item, "new_name", False, ai_new_name)

        Dim ai_transform : Set ai_transform = create_adress_item_transform()
        ai_transform.name     = ai_name
        ai_transform.new_name = ai_new_name

        Call dublicate_data.address_item_transforms.PushBack(ai_transform)
      Next  ' adsress_item
    Next  ' dublicate

    Call map.elements.PushBack(item)
  Next  ' element

  '-----------------------------
  '      
  Dim ai_duplicate, ai_duplicates
  Set ai_duplicates = root_node.selectNodes("ai_duplicate")

'  Dim root_ai, duplicate_ai

  For Each ai_duplicate In ai_duplicates
    '     
    Dim ai_valids_items
    Set ai_valids_items = ai_duplicate.selectNodes("valid_item")

    ' ,     
    If (ai_valids_items.length <> 1) Then
      call Err.Raise(-1, TypeName(Me) & " -> load_ai_types_map_from_xml_doc", _
                     "  ai_duplicate       ")
    End If

    Dim ai_duplicate_obj
    Set ai_duplicate_obj = New t_ai_duplicate

    Set ai_duplicate_obj.valid_item = create_address_item(ai_valids_items(0), True)

    '    
    Dim ai_duplicates_item, ai_duplicates_items
    Set ai_duplicates_items = ai_duplicate.selectNodes("duplicate_item")

    For Each ai_duplicates_item In ai_duplicates_items
      Call ai_duplicate_obj.duplicate_items.PushBack(create_address_item(ai_duplicates_item, False))
    Next  ' ai_duplicates_item

    '         
    Call map.ai_duplicates.PushBack(ai_duplicate_obj)
  Next  ' ai_duplicates

  '      
  Dim ai_delete_item, ai_delete_items
  Set ai_delete_items = root_node.selectNodes("ai_delete")

  For Each ai_delete_item In ai_delete_items
    Call map.ai_delete.PushBack(create_address_item(ai_delete_item, False))
  Next

  Set load_ai_types_map_from_xml_doc = map
End Function  ' load_ai_types_map_from_xml_doc

'*******************************************************************************

'    

' log - t_log
' map - LCPI.DBS.Utility.Vector / t_type_address_item_map_item

sub verify_ai_types_map(log,map,make_upper)
 const c_err_source="verify_ai_types_map"

 if(not IsObject(map))then
  call err.raise(-1,c_err_source,"   map")
 end if

 if(map is nothing)then
  call err.raise(-1,c_err_source,"   ")
 end if

 dim item
 dim dublicate

 dim items
 set items=createobject("LCPI.DBS.Utility.Vector")

 for each item in map
  call verify_ai_types_map_item(log,items,item.element,make_upper)

  for each dublicate in item.dublicates
   call verify_ai_types_map_item(log,items,dublicate,make_upper)
  next 'dublicate
 next 'item
end sub 'verify_ai_types_map

'*******************************************************************************

sub verify_ai_types_map_item(log,items,test_item,make_upper)
 const c_err_source="verify_ai_types_map_item"

  '     ,        
  If (Not test_item.delete) Then Exit Sub

 dim name
 dim aliase

 if(make_upper)then
  name   =ucase(test_item.name)
  aliase =ucase(test_item.aliase)
 else
  name   =test_item.name
  aliase =test_item.aliase
 end if

 dim name2
 dim aliase2

 dim item
 dim msg

 for each item in items
  if(make_upper)then
   name2   =ucase(item.name)
   aliase2 =ucase(item.aliase)
  else
   name2   =item.name
   aliase2 =item.aliase
  end if

  if(name=name2 and aliase=aliase2)then
   if(item.obj_class=test_item.obj_class)Then
    msg="   obj_class:"&item.obj_class& _
          " name:["&name&"] aliase:["&aliase&"]"

    call err.raise(-1,c_err_source,msg)
   else
    msg="  ["&item.obj_class&"] "& _
         " ["&test_item.obj_class&"]   "& _
         " name:["&name&"] aliase:["&aliase&"]"

    call log.send_warning(-1,c_err_source,msg)
   end if
  end if
 next 'item

 call items.PushBack(test_item)
end sub 'verify_ai_types_map_item

'*******************************************************************************