',   

'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

'    dsx_modify
const c_dsx_cmd_cfg  = "config"
const c_dsx_cmd_help = "h"

'    dsx_build_xml
const c_dsx_cmd_source_folder      = "source"
const c_dsx_cmd_destination_folder = "destination"

'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class t_dsx_cmd_line

 private m_arg_obj

'-------------------------------------------------------------------------

 private sub class_initialize ()
  set m_arg_obj = nothing
  
  set m_arg_obj = new t_prog_arg_list
  
  call init()
 end sub 'class_initialize
 
'-------------------------------------------------------------------------
 private sub init()
  call m_arg_obj.reg_arg (c_dsx_cmd_cfg  , c_prog_arg_with_value )
  call m_arg_obj.reg_arg (c_dsx_cmd_help , c_prog_arg_no_value   )
  
  call m_arg_obj.reg_arg (c_dsx_cmd_source_folder     , c_prog_arg_with_value)
  call m_arg_obj.reg_arg (c_dsx_cmd_destination_folder, c_prog_arg_with_value)
  
  call m_arg_obj.init()
 end sub 'init

'-------------------------------------------------------------------------
'   name       value
 public sub read_from_cmd(name, byref value, required)
 
  '       ,    
  '   value
  if (m_arg_obj.has_arg(name)) then
   if (m_arg_obj.arg_by_name(name).value <> "") then
    value = m_arg_obj.arg_by_name(name)
    exit sub
   end if
  end if
  
  if (required) then
   call main_log.send_error(-1, "t_prog_pm_cmd_line.vbs","   "&name)
  end if
  
 end sub 'read_from_cmd
 
'-------------------------------------------------------------------------
'  true,     
 public function is_print_help()
  is_print_help = false
  if (m_arg_obj.has_arg(c_dsx_cmd_help) or m_arg_obj.count = 0) then
   is_print_help = true
  end if
 end function 'print_help
 
'-------------------------------------------------------------------------
 public sub print_build_xml_help()
  call wscript.echo("   xml-    dsx")
  call wscript.echo("")
  call wscript.echo(" /"&c_dsx_cmd_source_folder&"      - ,   dsx")
  call wscript.echo(" /"&c_dsx_cmd_destination_folder&" - ,    ")
  call wscript.echo("[   ,      help    dsx]")
  call wscript.echo("")
  call wscript.echo(" /"&c_dsx_cmd_help&"           - ")
 end sub

'-------------------------------------------------------------------------
 public sub print_help()
  call wscript.echo("     xml- ")
  call wscript.echo("")
  call wscript.echo(" /"&c_dsx_cmd_cfg&"  -   ")
  call wscript.echo(" /"&c_dsx_cmd_help&"       - ")
 end sub 'print_help
 
end class 't_dsx_cmd_line