'     

'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

'private const c_err_source = "t_prog_dsx_file_system.vbs"

private const c_root_node        = "backup_script"
private const c_body_node        = "body"
private const c_dsx_insert_after = "script"

class t_insert_tags
 public sub insert(byval folder_path, byref modification_info)
  dim fso
  set fso = createObject("Scripting.FileSystemObject")

  ' 
  dim root_folder
  set root_folder = fso.getFolder(folder_path)
  
  call wscript.echo(root_folder.name)
  
  ' 
  dim offset_var
  offset_var = 0
  
  '   
  call processing_files(root_folder, offset_var, modification_info)
  '    
  call go_child(root_folder, offset_var, modification_info)
 end sub 'insert

'-------------------------------------------------------------------------
  
 private sub go_child(byref folder, byval offset_var, byref modification_info)
  dim child_folders
  set child_folders = folder.subFolders
 
  '      2
  offset_var = offset_var + 3
 
  dim iterator
  for each iterator in child_folders
   call wscript.echo (offset(offset_var)&iterator.name)
   call processing_files(iterator, offset_var, modification_info)
   call go_child(iterator, offset_var, modification_info)
  next
 end sub

'-------------------------------------------------------------------------

 private function offset (byval size)
  dim str
  str = ""
 
  dim iterator
  for iterator = 1 to size
   str = str & " "
  next
  
  offset = str
 end function

'-------------------------------------------------------------------------
'        
 private sub processing_files(byref folder, byval offset_val, byref modification_info)
  dim files
  set files = folder.files
 
  dim reg_exp
  set reg_exp = new RegExp
  reg_exp.ignoreCase = true
  reg_exp.global     = true
  reg_exp.pattern    = ".*\.dsx"
 
  dim file, mach, str
  for each file in files
   str = file.name
   if (reg_exp.test(str))then
    call wscript.echo(offset(offset_val)& "*" &file.name & " ["& file.type &"]")
    call insert_new_tags(file, modification_info)
   end if
  next
 end sub 'processing_files
 
'-------------------------------------------------------------------------
 private sub insert_new_tags(byref file, modification_info)
  '  
  dim full_name, short_name
  full_name  = file.path
  short_name = file.name
  
  '     -
  dim bkp_full_name, bkp_short_name
  bkp_full_name  = get_backup_file_name(full_name)
  bkp_short_name = get_backup_file_name(short_name)
  
  '    .bkp
  file.name = bkp_short_name
  
  '  
  dim reg_exp
  set reg_exp = new RegExp
  reg_exp.ignoreCase = true
  reg_exp.global     = true
  '    
  reg_exp.pattern    = "<"&c_dsx_insert_after&" .*>"
  
  dim fso, f
  set fso = CreateObject("Scripting.FileSystemObject")
  
  'call wscript.echo(file_name)
  set f = fso.OpenTextFile(bkp_full_name, 1)
  
  '   
  dim str
  str = f.readAll
  call f.close()
  
  dim matches, match, new_str
  
  '     
  if (reg_exp.test(str))then
  
   set matches = reg_exp.execute(str)
  
   '    
   for each match in matches
    
    dim result_value
    
    result_value = match.value
    new_str      = result_value
    
    dim tag, insert_str
    for each tag in modification_info.node_list
     '         ,    writer,   
     if (not need_modification(tag, str, bkp_full_name))then
      insert_str = insert_str & vbCrLf & tag.xml
     end if
    next
    
    if (insert_str <> "")then
     new_str = new_str & insert_str
    end if
    
    '  
    str = reg_exp.replace(str, new_str)
    
    ' 
    set f = fso.OpenTextFile(full_name, 2, true)
    call f.write(str)
    
    ' 
    call file.delete()
   next
  end if
 end sub 'insert_new_tags
 
'-------------------------------------------------------------------------
'  ,    
' false,        
'  
 private function need_modification(byref new_tag, byref str, byval xml_file_source)
  need_modification = false
  
  dim xml_doc, node_root, body_node, after_node
  set xml_doc    = xml_load_param_file_not_unicode(xml_file_source, c_err_source)
  xml_doc.preserveWhiteSpace = true
  
  set node_root  = xml_get_node(xml_doc  , c_root_node       ,true)
  set body_node  = xml_get_node(node_root, c_body_node       ,true)
  set after_node = xml_get_node(body_node, c_dsx_insert_after,true)
  
  '++++++++++++++++++++++++++++++++++++++++++ DEBUG
  'call wscript.echo (new_tag.nodeName)
  'call wscript.echo ("Text : "&new_tag.text)
  '++++++++++++++++++++++++++++++++++++++++++
  
  dim old_tag
  set old_tag = xml_get_node(after_node, new_tag.nodeName, false)
  
  if(old_tag is nothing)then
   need_modification = false
   exit function
  end if
  
  need_modification = true
  
  if (new_tag.text <> "" and new_tag.text <> old_tag.text)then
   call replace_tag(new_tag, str)
  end if
 end function 'restore_value
 
'-------------------------------------------------------------------------
 private sub replace_tag(byref new_tag, byref str)
  '  
  dim reg_exp
  set reg_exp = new RegExp
  reg_exp.ignoreCase = true
  reg_exp.global     = true
  '    
  reg_exp.pattern    = "<"&new_tag.nodeName&".*>"
  
  
  '     
  if (reg_exp.test(str))then
   
   dim matches, match
   set matches = reg_exp.execute(str)
  
   '    
   for each match in matches
    dim result_value
    result_value = match.value
    str = reg_exp.replace(str, new_tag.xml)
   next
  end if
 end sub 'replace_tag
 
'-------------------------------------------------------------------------
'     .bkp
 private function get_backup_file_name(byval file_name)

  dim reg_exp
  set reg_exp = new RegExp
  reg_exp.ignoreCase = true
  reg_exp.global     = true
  reg_exp.pattern    = "[^\.]*"

  dim matches
  set matches = reg_exp.execute(file_name)

  dim new_name
  dim match
  for each match in matches
   new_name = match.value
   exit for
  next

  get_backup_file_name = new_name & ".bkp"
 end function'get_backup_file_name
end class 't_file_system