'   xml- .
'                  2006.

'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

private const c_err_source = "t_dsx_xml_parser"

private const c_root_node_cfg  = "modify"
private const c_directory_node = "directory"
private const c_tags_node      = "tags"

private const c_atr_directory  = "path"
private const c_atr_after_tag  = "tag"

private const c_node_comment   = 8

'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

class t_dsx_xml_parser
 
 private m_xml_doc
 private m_node_root
 
'-------------------------------------------------------------------------
 public property let xml_doc (byval arg_xml_doc)
  set m_xml_doc = arg_xml_doc
 end property
 
 public property get xml_doc ()
  set xml_doc = m_xml_doc
 end property
 
 public property let node_root (byval arg_node_root)
  set m_node_root = arg_node_root
 end property
 
 public property get node_root ()
  set node_root = m_node_root
 end property
'-------------------------------------------------------------------------
 
 public sub init(byval cfg_file)
  set m_xml_doc=xml_load_param_file(cfg_file,c_err_source)
  
  set m_node_root=xml_get_node(xml_doc, c_root_node_cfg ,true)
 end sub 'init

'-------------------------------------------------------------------------
 public function get_modification_object()
  dim directory_node
  set directory_node=xml_get_node(node_root, c_directory_node ,true)
  
  dim directory_path
  call xml_read_attr_str(directory_node, c_atr_directory, true, directory_path)
  
  dim tags
  set tags = xml_get_node(directory_node, c_tags_node, true)
  
  dim new_tag_list
  set new_tag_list = tags.childNodes
  
  dim tag_container
  set tag_container = createobject("LCPI.DBS.Utility.Vector")
  
  dim child_node
  for each child_node in new_tag_list
   if(child_node.nodeType <> c_node_comment)then
    call tag_container.pushback(child_node)
   end if
  next
  
  dim modification_obj
  set modification_obj = new t_modification
  modification_obj.directory    = directory_path
  modification_obj.node_list    = tag_container
  
  set get_modification_object = modification_obj
 end function 'get_modification_object
 
end class 't_dsx_xml_parser