'*******************************************************************************
 '  ,  
 '   , 18.11.2005
 '   , 25.06.2007
'*******************************************************************************

Option Explicit

'*******************************************************************************
'class t_sender

Class t_sender
 Private c_err_source

 private m_server_output
 Private m_user
 Private m_password
 private m_from_field
 private m_to_field
 private m_subject_field
 private m_body_field
 private m_attach_field
 private m_charset


'constructor -------------------------------------------------------------
 private sub class_initialize
  c_err_source = "t_sender"

  set m_attach_field = createobject("LCPI.DBS.Utility.Vector")
 end sub 'class_initialize

'properties --------------------------------------------------------------
 public property let server_output(byval server_val)
  m_server_output = server_val
 end property

 Public Property Let user(ByVal value)
   m_user = value
 End Property  ' user

 Public Property let password(ByVal value)
   m_password = value
 End Property  ' password

 public property let from_field (byval from_val)
  m_from_field = from_val
 end property

 public property let to_field (byval to_val)
  m_to_field = to_val
 end property

 public property let subject_field (byval subject_val)
  m_subject_field = subject_val
 end property

 public property let body_field (byval body_val)
  m_body_field = body_val
 end property

 public property let attach_field (attach_val)
  set m_attach_field = attach_val
 end property

 public property let charset (byval charset_val)
  m_charset = charset_val
 end property

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'-------------------------------------------------------------------------
'     
function get_file (file_name)
 dim fso_obj
 set fso_obj = CreateObject("Scripting.FileSystemObject")

 dim err_code
 dim err_descr

 on error resume next

 set get_file= fso_obj.GetFile(file_name)

 err_code  =err.number
 err_descr =err.description

 call err.clear()

 on error goto 0
 if(err_code<>0)then
  err_descr="FAIL OPEN TEXT FILE ["&file_name&"]"

  call err.raise(err_code,c_err_source,err_descr)
 end if
end function 'get_file

'-------------------------------------------------------------------------
',   
 public sub send_mail()
  dim msg, conf, flds, iterator
  dim file_handler

  set msg = createobject("CDO.Message")
  set conf = createobject("CDO.Configuration")
  set flds = conf.fields
  flds.item("http://schemas.microsoft.com/cdo/configuration/sendusing") = 2

  '    
  If (is_string_set(m_user)) Then
    flds.item("http://schemas.microsoft.com/cdo/configuration/sendusername") = m_user

    '    
    If (is_string_set(m_password)) Then
      flds.item("http://schemas.microsoft.com/cdo/configuration/smtpauthenticate") = 1
      flds.item("http://schemas.microsoft.com/cdo/configuration/sendpassword") = m_password
    End If
  Else
    flds.item("http://schemas.microsoft.com/cdo/configuration/smtpauthenticate") = 0
  End If

  flds.item("http://schemas.microsoft.com/cdo/configuration/smtpserver") = m_server_output
  flds.item("http://schemas.microsoft.com/cdo/configuration/smtpusessl") = False

  call flds.update()

  set msg.configuration = conf
  msg.bodyPart.charset = m_charset '"windows-1251"
  msg.from = m_from_field
  msg.to = m_to_field
  msg.subject = m_subject_field
  msg.textbody = m_body_field
  '  
  if (m_attach_field.count > 0) then
   for each iterator in m_attach_field
    if (iterator <> "") then
	  set file_handler = get_file(iterator)
     msg.addattachment (file_handler.path) 'optional
    end if
   next
  end if

  call msg.send()

  set msg = nothing
  set conf = nothing
  set flds = nothing
 end sub 'send_mail


  '-----------------------------------------------------------------------------
  '    
  Private Function is_string_set(value)
    is_string_set = False

    If IsEmpty(value) Then Exit Function
    If IsNull(value) Then Exit Function
    If (Len(value) < 1) Then Exit Function

    is_string_set = True
  End Function  ' is_string_set

  '-----------------------------------------------------------------------------
End Class  ' t_sender

'*******************************************************************************