'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'*******************************************************************************
'     ibescript.exe

private Function detect_ibescript_path()
  Dim path

  Dim fso
  Set fso = CreateObject("Scripting.FileSystemObject")

  On Error Resume Next

  '  Windows Management Instrumentation    
  Dim oReg
  
  Set oReg=GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\default:StdRegProv")

  '     IBExpert  
  Call oReg.GetStringValue(&H80000001, "Software\HK Software\IBExpert\RunDir", "", path)

  path = path & "\ibescript.exe"

  '      ,  
  If (Err.Number = 0) Then
    If fso.FileExists(path) Then
      detect_ibescript_path = fso.GetAbsolutePathName(path)
      Exit Function
    End If
  Else
    Call Err.Clear()
  End If

  On Error GoTo 0

  '     ,   
  If fso.FileExists("D:\program files\ibexpert\ibescript.exe") Then
    detect_ibescript_path = fso.GetAbsolutePathName("D:\program files\ibexpert\ibescript.exe")
  ElseIf fso.FileExists("C:\program files\ibexpert\ibescript.exe") Then
    detect_ibescript_path = fso.GetAbsolutePathName("C:\program files\ibexpert\ibescript.exe")
  End If
End Function ' detect_ibescript_path

'*******************************************************************************
'  t_pf_run_sql_script -    IB Expert Script Executor

'     c_pf_IBE_ScriptExecutorPath
'     "ibescript.exe" 
'*******************************************************************************

Class t_pf_run_sql_script_ibe
  Private m_ibscript_path
  Private m_script_path
  Private m_db_location
  Private m_db_user
  Private m_db_pswd
  Private m_db_ctype
  Private m_log_path

  Private m_fso           ' Scripting.FileSystemObject

  '-----------------------------------------------------------------------
  ' 
  Private Sub class_initialize()
    Set m_fso = su_create_object("Scripting.FileSystemObject")
  End Sub  ' class_initialize

  '-----------------------------------------------------------------------
  Public Sub init(script_path,db_location,db_user,db_pswd,db_ctype,log_path)
    m_script_path = script_path

    m_db_location = db_location
    m_db_user     = db_user
    m_db_pswd     = db_pswd
    m_db_ctype    = db_ctype
    m_log_path    = log_path
  End Sub  ' init

  '-----------------------------------------------------------------------
  Public Property Get name()
    name = "sql script:""" & m_script_path & """"
  End Property  ' name

  '-----------------------------------------------------------------------
  Public Sub run(ctx)
    Dim msg

    '   
    If (Not m_fso.FileExists(m_script_path)) Then
      msg = "Script File [" & m_script_path & "] NOT FOUND"
      call err.raise(-1,typename(me),msg)
    End If

    If (UCase(m_fso.GetExtensionName(m_script_path)) = "log") Then
      msg = "     "
      Call err.raise(-1, typename(me), msg)
    End If

    Dim ws
    Set ws = su_create_object("WSCript.Shell")

    '   
    Dim run_arg

    run_arg=""""&c_pf_IBE_ScriptExecutorPath&""" "&   _
            """"&m_script_path&""" "&                 _
            "-v"""&m_log_path&""" -T -C -L3 "&        _
            "-D"""&m_db_location&""" "&               _
            "-U"""&m_db_user&""" "&                   _
            "-P"""&m_db_pswd&""" "&                   _
            "-C"""&m_db_ctype&""" "

    Call ctx.send_msg("RUN: " & run_arg)

    '  
    Dim err_code

    err_code = ws.Run(run_arg, 8, True)

    If (err_code <> 0) Then
      msg = "FAIL EXECUTE SCRIPT FILE [" & m_script_path & "]" & vbCrLf & _
            "SEE LOG FILE [" & m_log_path & "]"

      Call err.raise(err_code, typename(me), msg)
    End If
  End Sub  ' run
End Class  ' t_pf_run_sql_script_ibe

'*******************************************************************************

Function pf_create_run_sql_script_ibe(script_path,     _
                                      db_location,     _
                                      db_user,         _
                                      db_pswd,         _
                                      db_ctype,        _
                                      log_file_prefix)
 '  LOG-
 dim fso
 set fso=su_create_object("Scripting.FileSystemObject")

 dim log_path

 '      
 log_path=fso.GetBaseName(script_path)&".log"

 if(log_file_prefix<>"")then
  log_path=log_file_prefix&"_"&log_path
 end if

 '-----------------
 set pf_create_run_sql_script_ibe=new t_pf_run_sql_script_ibe

 call pf_create_run_sql_script_ibe.init(script_path, _
                                        db_location, _
                                        db_user,     _
                                        db_pswd,     _
                                        db_ctype,    _
                                        log_path)
end function 'pf_create_run_sql_script_ibe

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++