'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'*******************************************************************************
'Class t_pf_run_sql_script_provider -  SQL-   

Class t_pf_run_sql_script_provider
  Private m_name               '  
  Private m_sql                '  SQL-
  Private m_connection_string  '     
  Private m_log_file_name      '  log-

  Private m_log_file

  '-----------------------------------------------------------------------
  ' 
  Private Sub class_initialize()
   set m_log_file=nothing
  End Sub  ' class_initialize

  '-----------------------------------------------------------------------
  '  
  Public Sub init(name, sql, connection_string, log_file_name)
    m_name              = name
    m_sql               = sql
    m_connection_string = connection_string
    m_log_file_name     = log_file_name

   set m_log_file=nothing
  End Sub  ' init

  '-----------------------------------------------------------------------
  '  
  Public Property Get name()
    name = m_name
  End Property  ' name

  '-----------------------------------------------------------------------
  '    
  Public Sub run(ctx)
    Set m_log_file = su_open_text_file(m_log_file_name, 8, True)

    Dim err_num, err_descr

    On Error Resume Next

    call run_impl()

    err_num   = err.Number
    err_descr = err.Description

    On Error GoTo 0

    If (err_num <> 0) Then
      Call LogLine("")
      Call LogLine("Error!")
      Call LogLine(err_descr)
      Call LogLine(vbCrLf & "ERROR EXECUTE SCRIPT!")
      Call LogLine("-------------------------------------------" & vbCrLf)

      Dim msg

      msg = "FAIL EXECUTE SQL [" & m_name & "]" & vbCrLf & _
            "SEE LOG FILE [" & m_log_file_name & "]" & vbCrLf & _
            err_descr

      Call err.raise(err_num, typename(me), msg)
    End if

    Call LogLine(vbCrLf & "SUCCESSFULLY EXECUTE SCRIPT!")
    Call LogLine("-------------------------------------------" & vbCrLf)

    set m_log_file=nothing
  End Sub  ' run

  '-----------------------------------------------------------------------
  Private Sub run_impl()
    Dim cn
    Set cn = su_create_object("ADODB.Connection")

    '    
    Call LogLine("Connect to database...")

    Call cn.Open(m_connection_string)
    cn.IsolationLevel = 65536

    Call LogLine("Server:   " & cn.Properties("Server Name").Value)
    Call LogLine("Database: " & cn.Properties("Data Source Name").Value)
    Call LogLine("User:     " & cn.Properties("User ID").Value)

    '  
    Call LogLine("")
    Call LogLine("Begin transaction...")

    Call cn.BeginTrans()

    '  
    Call LogLine("")
    Call LogLine("Execute SQL script...    ")

    Dim ra
    Call cn.Execute(m_sql, ra)

    Call LogLine("")
    Call LogLine("Records Affected:     " & CStr(ra))

    '  
    Call LogLine("")
    Call LogLine("Commit transaction...")

    Call cn.CommitTrans()
  End Sub 'run_impl

  '-----------------------------------------------------------------------
  Private Sub LogLine(msg)
    Call m_log_file.WriteLine(msg)
  End sub

End Class  ' t_pf_run_sql_script_provider

'*******************************************************************************

'    t_pf_run_sql_script_provider
Public Function create_pf_run_sql_script_provider(name,              _
                                                  sql,               _
                                                  connection_string, _
                                                  log_file_name)

 Set create_pf_run_sql_script_provider = New t_pf_run_sql_script_provider

 Call create_pf_run_sql_script_provider.init(name, sql, connection_string, log_file_name)
End Function 'create_pf_run_sql_script_provider

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++