'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_pf_run_vbs_code

Class t_pf_run_vbs_code
 Private m_name          '  
 Private m_vbs_code      '   VBS
 Private m_cn_str        '     
 Private m_log_file_name '  log-

 Private m_log_file

 '------------------------------------------------------------------------
 private sub class_initialize()
  set m_log_file=nothing
 end sub 'class_initialize

 '------------------------------------------------------------------------
 '  
 Public Sub init(name, vbs_code, cn_str, log_file_name)
  m_name          = name
  m_vbs_code      = vbs_code
  m_cn_str        = cn_str
  m_log_file_name = log_file_name

  set m_log_file=nothing
 End Sub  ' init

 '------------------------------------------------------------------------
 '  
 Public Property Get name()
   name = m_name
 End Property  ' name

 '------------------------------------------------------------------------
 Public Sub run(ctx)
  Set m_log_file = su_open_text_file(m_log_file_name, 8, True)

  Dim err_num, err_descr

  On Error Resume Next

  call run_impl()

  err_num   = err.Number
  err_descr = err.Description

  On Error GoTo 0

  If (err_num <> 0) Then
   Call LogLine("")
   Call LogLine("Error!")
   Call LogLine(err_descr)
   Call LogLine(vbCrLf & "ERROR EXECUTE SCRIPT!")
   Call LogLine("-------------------------------------------" & vbCrLf)

   Dim msg

   msg = "FAIL EXECUTE VBS [" & m_name & "]" & vbCrLf & _
         "SEE LOG FILE [" & m_log_file_name & "]" & vbCrLf & _
         err_descr

   Call err.raise(err_num, typename(me), msg)
  end if

  Call LogLine(vbCrLf & "SUCCESSFULLY EXECUTE VB-SCRIPT!")
  Call LogLine("-------------------------------------------" & vbCrLf)

  set m_log_file=nothing
 End Sub 'ctx

 '------------------------------------------------------------------------
 Private Sub run_impl()
  dim local_log
  set local_log=new t_log

  set local_log.log_file=m_log_file

  '-------
  dim cn
  set cn=su_create_object("ADODB.Connection")

  '    
  call LogLine("")
  Call LogLine("Connect to database...")

  Call cn.Open(m_cn_str)

  Call LogLine("Server:   " & cn.Properties("Server Name").Value)
  Call LogLine("Database: " & cn.Properties("Data Source Name").Value)
  Call LogLine("User:     " & cn.Properties("User ID").Value)

  '--------------
  dim sc
  set sc=su_create_object("MSScriptControl.ScriptControl.1")

  sc.Language="vbscript"

  '--------------
  call LogLine("")
  Call LogLine("Add wscript object ...")

  call sc.AddObject("wscript",wscript,false)

  '--------------
  call LogLine("")
  Call LogLine("Add vb-code...")

  call sc.AddCode(m_vbs_code)

  '--------------
  call LogLine("")
  call LogLine("Begin trans...")

  cn.IsolationLevel=65536

  call cn.BeginTrans()

  '--------------
  call LogLine("")
  call LogLine("Run...")

  call sc.Run("main", cn, local_log)

  '--------------
  call LogLine("")
  call LogLine("Commit trans...")

'  call cn.RollbackTrans()
  call cn.CommitTrans()
 End Sub 'run_impl

 '-----------------------------------------------------------------------
 Private Sub LogLine(msg)
   Call m_log_file.WriteLine(msg)
 End sub
End Class 't_pf_run_vbs_code

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

function create_pf_run_vbs_code(name,            _
                                vbs_code,        _
                                cn_str,          _
                                log_file_name)

 set create_pf_run_vbs_code=new t_pf_run_vbs_code

 call create_pf_run_vbs_code.init(name,vbs_code,cn_str,log_file_name)
end function 'create_pf_run_vbs_code

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
