',   
'read_machine_from_cmd   !!!!!!!!!!!!
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

const c_cmd_date_source    = "db"
const c_cmd_user           = "db_user"
const c_cmd_password       = "db_pswd"
const c_cmd_charset        = "db_charset"
const c_cmd_help           = "h"

const c_cmd_cfg_file       = "cfg_file"
const c_cmd_log_dir        = "log_dir"
const c_cmd_cfg_mail       = "cfg_mail"
const c_cmd_log_file       = "log_file"

const c_cmd_kill_min       = "kill_min"
const c_cmd_kill_hour      = "kill_hour"
const c_cmd_kill_day       = "kill_day"

class t_cmd_line
 private m_arg_obj

 private sub class_initialize ()
  set m_arg_obj = nothing
  
  set m_arg_obj = new t_prog_arg_list
  call init()
 end sub 'class_initialize
 
 private sub init()
  call m_arg_obj.reg_arg (c_cmd_cfg_file       , c_prog_arg_with_value )
  call m_arg_obj.reg_arg (c_cmd_log_dir        , c_prog_arg_with_value )
  call m_arg_obj.reg_arg (c_cmd_cfg_mail       , c_prog_arg_with_value )
  call m_arg_obj.reg_arg (c_cmd_log_file       , c_prog_arg_with_value )
  
  call m_arg_obj.reg_arg (c_cmd_date_source    , c_prog_arg_with_value )
  call m_arg_obj.reg_arg (c_cmd_user           , c_prog_arg_with_value )
  call m_arg_obj.reg_arg (c_cmd_password       , c_prog_arg_with_value )
  call m_arg_obj.reg_arg (c_cmd_charset        , c_prog_arg_with_value )
  call m_arg_obj.reg_arg (c_cmd_help           , c_prog_arg_no_value   )
  
  call m_arg_obj.reg_arg (c_cmd_kill_min       , c_prog_arg_with_value )
  call m_arg_obj.reg_arg (c_cmd_kill_hour      , c_prog_arg_with_value )
  call m_arg_obj.reg_arg (c_cmd_kill_day       , c_prog_arg_with_value )
  
  call m_arg_obj.init()
 end sub 'init
 
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'  true,     
 public function is_print_help()
  is_print_help = false
  if (m_arg_obj.has_arg(c_cmd_help) or m_arg_obj.count = 0) then
   is_print_help = true
  end if
 end function 'print_help
 
'-------------------------------------------------------------------------
'   name       value
 public sub read_from_cmd(name, byref value, required)
 
  '       ,    
  '   value
  if (m_arg_obj.has_arg(name)) then
   if (m_arg_obj.arg_by_name(name).value <> "") then
    value = m_arg_obj.arg_by_name(name)
    exit sub
   end if
  end if
  
  if (required) then
   call main_log.send_error(-1, "t_prog_pm_cmd_line.vbs","   "&name)
   call wscript.quit (-1)
  end if
  
 end sub 'strote_body_from_cmd

'-------------------------------------------------------------------------
'        prog_proc_terminate
 public sub print_help_terminate()
  call wscript.echo("")
  call wscript.echo("    :")
  
  call wscript.echo("")  
  call wscript.echo(" /"&c_cmd_date_source&"           -     ")
  call wscript.echo(" /"&c_cmd_user&       "      -  ")
  call wscript.echo(" /"&c_cmd_password&   "      -  ")
  call wscript.echo(" /"&c_cmd_charset&    "   -  [OPT]  (  win1251)")
  
  call wscript.echo("")
  call wscript.echo("  :")
  call wscript.echo("")
  call wscript.echo(" /"&c_cmd_cfg_file&  "     -   ,     ")
  call wscript.echo(" /"&c_cmd_log_file&  "     -  [OPT] ,     ")
  call wscript.echo(" /"&c_cmd_log_dir&  "      -  ,     ")
  call wscript.echo(" /"&c_cmd_cfg_mail&  "     -  [OPT]       email")
  
  call wscript.echo("")
  call wscript.echo(" /"&c_cmd_kill_min&"     -   ,    ")
  call wscript.echo(" /"&c_cmd_kill_hour&"    -   ,    ")
  call wscript.echo(" /"&c_cmd_kill_day&"     -   ,    ")
  
  call wscript.echo("")
  call wscript.echo(" /"&c_cmd_help&       "            -  ")
 
 end sub 'print_help

'-------------------------------------------------------------------------
'        prog_proc_log
 public sub print_help_log()
  call wscript.echo("   :")
  
  call wscript.echo("")  
  call wscript.echo(" /"&c_cmd_date_source&"          -     ")
  call wscript.echo(" /"&c_cmd_user&       "     -  ")
  call wscript.echo(" /"&c_cmd_password&   "     -  ")
  call wscript.echo(" /"&c_cmd_charset&    "  -  [OPT]  (  win1251)")
  'call wscript.echo(" /"&c_cmd_mach_name&  "     -   ")
  
  call wscript.echo("")
  call wscript.echo("  :")
  call wscript.echo("")
  call wscript.echo(" /"&c_cmd_cfg_file&  "    -   ,     ")
  call wscript.echo(" /"&c_cmd_log_file&  "    -  [OPT] ,     ")
  call wscript.echo(" /"&c_cmd_log_dir&  "     -  ,     ")
  call wscript.echo(" /"&c_cmd_cfg_mail&  "    -  [OPT]       email")
  
  call wscript.echo("")
  call wscript.echo(" /"&c_cmd_help&       "           -  ")
 
 end sub 'print_help_log
 
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
end class 't_cmd_line