',     

'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
const c_pm_machine_pk           = "ID_MACHINE"
const c_pm_machine_name         = "MACHINE_NAME"

const c_pm_proc_pk              = "ID_PROCESS"
const c_pm_proc_fk_machine      = "MACHINE"
const c_pm_proc_name            = "NAME"
const c_pm_proc_pid             = "PID"
const c_pm_proc_date_create     = "DATE_CREATE"
const c_pm_proc_date_update     = "LAST_UPDATE"
const c_pm_proc_date_check      = "LAST_CHECK"

const c_pm_proc_log_pk          = "PROCESS_LOG"
const c_pm_proc_log_fk_process  = "PROCESS"
const c_pm_proc_log_date_update = "LAST_UPDATE"
const c_pm_proc_log_hdl_count   = "HANDLE_COUNT"
const c_pm_proc_log_thrd_count  = "THREAD_COUNT"
const c_pm_proc_log_read_count  = "READ_COUNT"
const c_pm_proc_log_read_byte   = "READ_BYTE"
const c_pm_proc_log_write_count = "WRITE_COUNT"
const c_pm_proc_log_write_byte  = "WRITE_BYTE"
const c_pm_proc_log_other_count = "OTHER_COUNT"
const c_pm_proc_log_other_byte  = "OTHER_BYTE"
const c_pm_proc_log_time_core   = "TIME_CORE"
const c_pm_proc_log_time_user   = "TIME_USER"

const c_err_cm_source = "t_command"
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

class t_command
 private m_connect
 private m_log_obj
 
 private m_com_update
 private m_com_select_last_proc
 private m_com_select_id_mach
 private m_com_select_row_proc
 private m_get_generator
 private m_insert_into_mach
 private m_insert_into_proc_log
 private m_insert_into_proc
 private m_delete_row
 private m_select_for_erase
 private m_select_younger_row
 private m_erase_from_proc_log
 private m_select_date_fields
 private m_intellectual_add_process
 
'-------------------------------------------------------------------------
 private sub class_initialize ()
  set m_com_update               = nothing
  set m_com_select_last_proc     = nothing
  set m_com_select_id_mach       = nothing
  set m_com_select_row_proc      = nothing
  set m_get_generator            = nothing
  set m_insert_into_mach         = nothing
  set m_insert_into_proc_log     = nothing
  set m_insert_into_proc         = nothing
  set m_delete_row               = nothing
  set m_select_younger_row       = nothing
  set m_erase_from_proc_log      = nothing
  set m_select_date_fields       = nothing
  set m_intellectual_add_process = nothing
  
  set m_com_update               = CreateObject("ADODB.Command")
  set m_com_select_last_proc     = CreateObject("ADODB.Command")
  set m_com_select_id_mach       = CreateObject("ADODB.Command")
  set m_com_select_row_proc      = CreateObject("ADODB.Command")
  set m_get_generator            = CreateObject("ADODB.Command")
  set m_insert_into_mach         = CreateObject("ADODB.Command")
  set m_insert_into_proc_log     = CreateObject("ADODB.Command")
  set m_delete_row               = CreateObject("ADODB.Command")
  set m_select_for_erase         = CreateObject("ADODB.Command")
  set m_select_younger_row       = CreateObject("ADODB.Command")
  set m_erase_from_proc_log      = CreateObject("ADODB.Command")
  set m_select_date_fields       = CreateObject("ADODB.Command")
  'set m_intellectual_add_process = CreateObject("ADODB.Command")
 end sub
 
 public sub init(byref connect, byref log_obj)
  set m_connect = connect
  set m_log_obj = log_obj
 end sub 'init
 
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
',   

'-------------------------------------------------------------------------
'       PID
 public function select_last_proc_log(table_name, pid_val)
  
  dim query1, query2
  query1 = "SELECT * FROM "&table_name&" WHERE "&c_pm_proc_log_fk_process&" = :pid"
  query2 = " ORDER BY "&c_pm_proc_log_date_update&" DESC;"
  
  m_com_select_last_proc.activeConnection = m_connect
  
  m_com_select_last_proc.commandText = query1
  m_com_select_last_proc("pid") = pid_val
  
  'set select_last_proc_log = m_com_select_last_proc.Execute
  
  dim err_select_last_proc_log
  err_select_last_proc_log = "   select_last_proc_log." & vbCrLf & _
    "    : " & pid_val
  set select_last_proc_log = execute_func_command (m_com_select_last_proc, err_select_last_proc_log)
 end function 'select_last_proc_log
 
'-------------------------------------------------------------------------
'  ID    
 public function select_id_machine(table_name, machine_name)
  
  dim query1, query2
  query1 = "select "&c_pm_machine_pk&" from "&table_name&" where "
  query2 = c_pm_machine_name&"= :mach_name;"
  
  
  m_com_select_id_mach.activeConnection = m_connect
  
  m_com_select_id_mach.commandText = query1 & query2
  m_com_select_id_mach("mach_name") = machine_name
  
  dim err_select_id_machine
  err_select_id_machine = "   select_id_machine." & vbCrLf & _
    "    : " & machine_name
  
  set select_id_machine = execute_func_command (m_com_select_id_mach, err_select_id_machine)
 end function 'select_id_machine
 
'-------------------------------------------------------------------------
'        PM_PROCESS ()
 public function select_row_in_proc(table_name, proc, id_mach)
  
  dim query, str_time
  
  query = "select "&c_pm_proc_pk&" from "&table_name&" where "& _
           c_pm_proc_name&"=:name and "&c_pm_proc_pid&"=:pid and "& _
           c_pm_proc_date_create&"=:time and "&c_pm_proc_fk_machine&"=:id_mach;"
  
  m_com_select_row_proc.activeConnection = m_connect
  
  m_com_select_row_proc.commandText = query
  m_com_select_row_proc("name")    = proc.name
  m_com_select_row_proc("pid")     = proc.process_id
  m_com_select_row_proc("time")    = proc.date_create
  m_com_select_row_proc("id_mach") = id_mach
  
  dim err_select_row_in_proc
  err_select_row_in_proc = "   select_row_in_proc." & vbCrLf & _
    "    : " & proc.name & vbCrLf & _
    "   PID: " & proc.process_id & vbCrLf & _
    "    : " & proc.date_create & vbCrLf & _
    "   ID : " & id_mach
  
   set select_row_in_proc = execute_func_command (m_com_select_row_proc, err_select_row_in_proc)
 end function 'select_row_in_proc
 
'-------------------------------------------------------------------------
'     PM_PROCESS_LOG   PID
'      
 public function select_younger_row(byval table_name, byval compered_time, byval pid)
  
  dim query
  query = "SELECT "&c_pm_proc_log_pk&" FROM "&table_name& _
          " WHERE "&c_pm_proc_log_date_update&" > :date and "&c_pm_proc_log_fk_process&" = :pid;"
  
  m_select_younger_row.activeConnection = m_connect
  
  m_select_younger_row.CommandText = query
  m_select_younger_row("date") = compered_time
  m_select_younger_row("pid" ) = pid
  
  'set select_younger_row = m_select_younger_row.Execute()
  dim err_select_younger_row
  err_select_younger_row = "   select_younger_row." & vbCrLf & _
    "    : " & cstr(compered_time) & vbCrLf & _ 
    "       PM_PROCESS: " & pid
  
  set select_younger_row = execute_func_command (m_select_younger_row, err_select_younger_row)
  
 end function 'select_row_in_proc

'-------------------------------------------------------------------------
'     
'    
' : ID, PID
 public function select_for_erase(byval table_name, byval compered_time)
  
  dim query
  query = "SELECT "&c_pm_proc_log_pk&", "&c_pm_proc_log_fk_process& _ 
          " FROM "&table_name&" WHERE "&c_pm_proc_log_date_update&" < :date"& _
          " ORDER BY "&c_pm_proc_log_date_update&";"
  
  m_select_for_erase.activeConnection = m_connect
  
  m_select_for_erase.CommandText = query
  m_select_for_erase("date" ) = compered_time
  
  'set select_for_erase = m_select_for_erase.Execute()
  
  dim err_select_for_erase
  err_select_for_erase = "   select_for_erase." & vbCrLf & _
    "    : " & cstr(compered_time)
  
  set select_for_erase = execute_func_command (m_select_for_erase, err_select_for_erase)
  
 end function 'select_for_erase

'-------------------------------------------------------------------------
',   PM_PROCESS,     
'       
 public function select_date_fields(byval table_name, byref proc, byval id_mach)
  dim query, str_time
  
  query = "select "&c_pm_proc_date_update&", "&c_pm_proc_date_check& _ 
           " from "&table_name&" where "&c_pm_proc_name&"=:name and "& _
           c_pm_proc_pid&"=:pid and "&c_pm_proc_date_create&"=:time and "& _
           c_pm_proc_fk_machine&"=:id_mach;"
  
  m_select_date_fields.activeConnection = m_connect
  
  m_select_date_fields.commandText = query
  m_select_date_fields("name")    = proc.name
  m_select_date_fields("pid")     = proc.process_id
  m_select_date_fields("time")    = proc.date_create
  m_select_date_fields("id_mach") = id_mach
  
  'set select_date_fields = m_select_date_fields.Execute
  dim err_select_date_fields
  err_select_date_fields = "   select_date_fields." & vbCrLf & _
    "    : " & proc.name & vbCrLf & _
    "   PID: " & proc.process_id & vbCrLf & _
    "    : " & proc.date_create & vbCrLf & _
    "   ID : " & id_mach
  set select_date_fields = execute_func_command (m_select_date_fields, err_select_date_fields)
  
 end function 'select_date_fields

'-------------------------------------------------------------------------
'     MACHINE    
 public function insert_into_machine(table_name, machine_name, gen_name)
  
  dim id_mach
  id_mach = get_generator(gen_name)
  
  dim query1, query2
  query1 = "INSERT INTO "&table_name&" ("&c_pm_machine_name&", "&c_pm_machine_pk&")"
  query2 = " VALUES(:mach_name, :id_mach);"
  
  m_insert_into_mach.activeConnection = m_connect
  
  m_insert_into_mach.commandText = query1 & query2
  m_insert_into_mach("mach_name") = machine_name
  m_insert_into_mach("id_mach")   = id_mach
  
  'call m_insert_into_mach.Execute
  
  dim err_insert_into_machine
  err_insert_into_machine = "    ." & vbCrLf & _
   " : " & machine_name
   
  call execute_proc_command(m_insert_into_mach, err_insert_into_machine)
  
  insert_into_machine = id_mach
  
 end function 'insert_into_machine
 
'-------------------------------------------------------------------------
'  ,    proc   PROCESS_LOG
 public sub insert_into_proc_log(table_name, proc, id)
  
  dim query
  
  query = "insert into "&table_name&"("&c_pm_proc_log_fk_process& _
           ","&c_pm_proc_log_hdl_count&","&c_pm_proc_log_thrd_count&","& _
           c_pm_proc_log_read_count&","&c_pm_proc_log_read_byte&","&_
           c_pm_proc_log_write_count&","&c_pm_proc_log_write_byte&","&c_pm_proc_log_other_count& _
           ","&c_pm_proc_log_other_byte&","&c_pm_proc_log_time_core&","&c_pm_proc_log_time_user& _
           ")VALUES(:id, :handle_count, :thread_count, :read_count, :read_byte, "& _
           ":write_count, :write_byte, :other_oper_count, :other_oper_byte, :kernel_time, :user_time);"
  
  m_insert_into_proc_log.activeConnection = m_connect
  m_insert_into_proc_log.commandText      = query
  
  m_insert_into_proc_log("id")              = id
  m_insert_into_proc_log("handle_count")    = proc.handle_count
  m_insert_into_proc_log("thread_count")    = proc.thread_count
  m_insert_into_proc_log("read_count")      = proc.read_count
  m_insert_into_proc_log("read_byte")       = proc.read_byte
  m_insert_into_proc_log("write_count")     = proc.write_count
  m_insert_into_proc_log("write_byte")      = proc.write_byte
  m_insert_into_proc_log("other_oper_count")= proc.other_oper_count
  m_insert_into_proc_log("other_oper_byte" )= proc.other_oper_byte
  m_insert_into_proc_log("kernel_time")     = proc.kernel_time
  m_insert_into_proc_log("user_time")       = proc.user_time
  
  call m_insert_into_proc_log.Execute()
  
 end sub 'insert_into_proc_log

'-------------------------------------------------------------------------
'  ,    proc   PROCESS
 public sub insert_into_proc(table_name, proc, id_mach)
  if(m_insert_into_proc is nothing)then
   set m_insert_into_proc=createobject("ADODB.Command")
   
   m_insert_into_proc.activeConnection = m_connect

   m_insert_into_proc.commandText = _
    "insert into "&table_name&"("&c_pm_proc_name&","&c_pm_proc_pid& _
    ","&c_pm_proc_date_create&","&c_pm_proc_fk_machine&")" & _
    " VALUES (:name_proc , :process_id, :time, :id_mach);"
  end if

  m_insert_into_proc("name_proc")   = proc.name
  m_insert_into_proc("process_id")  = proc.process_id
  m_insert_into_proc("time")        = proc.date_create'str_date
  m_insert_into_proc("id_mach")     = id_mach
  
  call m_insert_into_proc.Execute()
 end sub 'store_proc_to_process
 
'-------------------------------------------------------------------------
'  
 private function get_generator(gen_name)
  m_get_generator.activeConnection = m_connect
  
  m_get_generator.commandtext = "select GEN_ID("&gen_name&",1) from rdb$database;"
  
  get_generator = m_get_generator.execute().fields(0)
 end function 'select_where_order 

'-------------------------------------------------------------------------
 public sub update_date_change(table_name, name_field_date, val_date, val_id)
  dim query
  query = "UPDATE "&table_name&" SET "&name_field_date&"="&val_date& _
          " WHERE "&c_pm_proc_pk&"= :id ;"
  
  m_com_update.activeConnection = m_connect
  
  m_com_update.CommandText = query
  
  m_com_update("id" ) = val_id
  
  'call m_com_update.Execute()
  
  dim err_update_date_change
  err_update_date_change = "  ." & vbCrLf & _
   "    " & name_field_date & vbCrLf & _
   " : " & cstr(val_date) & vbCrLf & _
   "ID : " & cstr(val_id)
   
  call execute_proc_command(m_com_update, err_update_date_change)
  
 end sub 'update_date_change
 
'-------------------------------------------------------------------------
 public sub erase_row(table_name, name_field_pk, id_proc)
  
  dim query
  query = "DELETE FROM "&table_name&" WHERE "&name_field_pk&" = :id ;"
  
  m_delete_row.activeConnection = m_connect
  
  m_delete_row.CommandText = query
  m_delete_row("id" ) = id_proc
  
  'call m_delete_row.Execute()
  dim err_erase_row
  err_erase_row = "   . " & vbCrLf & _
   ",    : " & name_field_pk & vbCrLf & _
   " : " & id_proc
  
  call execute_proc_command(m_delete_row, err_erase_row)
  
 end sub 'erase_row

'-------------------------------------------------------------------------
'
'
 public sub erase_old_row(byval table_name, byval name_field, byval time_cut)
  
  dim query
  query = "DELETE FROM "&table_name&" WHERE "&name_field&" < :time_cut ;"
  
  m_erase_from_proc_log.activeConnection = m_connect
  
  m_erase_from_proc_log.CommandText = query
  m_erase_from_proc_log("time_cut") = time_cut
  
  'call m_erase_from_proc_log.Execute()
  dim err_erase_old_row
  err_erase_old_row = "    .   : " & vbCrLf & _
   ",    : " & name_field & vbCrLf & _
   " : " & time_cut
  
  call execute_proc_command(m_erase_from_proc_log, err_erase_old_row)
 end sub 'erase_from_proc_log
 
 '------------------------------------------------------------------------
 '   .      pm_process,
 '       pm_process,     pm_process_log,  
 '      pm_process_log  . 
 '       pm_process,     , 
 '    pm_process_log      ,  
 ' ,       .
 public sub intellectual_add_process(byval mach_id, byref proc)
  if(m_intellectual_add_process is nothing)then
   set m_intellectual_add_process = createobject("ADODB.Command")
   
   m_intellectual_add_process.activeConnection = m_connect

   m_intellectual_add_process.commandText =                 _
    "exec insert_new_process ("                             _
                             &":ID_MACH,"                   _
                             &":DATE_CREATE,"               _
                             &":PID,"                       _
                             &":NAME,"                      _
                             &":HANDLE_COUNT,"          _
                             &":THREAD_COUNT,"          _
                             &":READ_COUNT,"            _
                             &":READ_BYTE,"             _
                             &":WRITE_COUNT,"   _
                             &":WRITE_BYTE,"            _
                             &":OTHER_COUNT,"   _
                             &":OTHER_BYTE,"    _
                             &":TIME_CORE,"     _
                             &":TIME_USER);"
  end if
  
  m_intellectual_add_process("ID_MACH")     = mach_id
  m_intellectual_add_process("DATE_CREATE") = proc.date_create
  m_intellectual_add_process("PID")         = proc.process_id
  m_intellectual_add_process("NAME")        = proc.name
  
  m_intellectual_add_process("HANDLE_COUNT")    = proc.handle_count
  m_intellectual_add_process("THREAD_COUNT")    = proc.thread_count
  m_intellectual_add_process("READ_COUNT")      = proc.read_count
  m_intellectual_add_process("READ_BYTE")       = proc.read_byte
  m_intellectual_add_process("WRITE_COUNT")     = proc.write_count
  m_intellectual_add_process("WRITE_BYTE")      = proc.write_byte
  m_intellectual_add_process("OTHER_COUNT")     = proc.other_oper_count
  m_intellectual_add_process("OTHER_BYTE" )     = proc.other_oper_byte
  m_intellectual_add_process("TIME_CORE")       = proc.kernel_time
  m_intellectual_add_process("TIME_USER")       = proc.user_time

  'call m_intellectual_add_process.Execute()
  
  dim err_add_proc
  err_add_proc = "    .    :" & vbCrLf
  err_add_proc = err_add_proc & "     : " & proc.name & vbCrLf
  err_add_proc = err_add_proc & "     : " & cstr (proc.date_create) & vbCrLf
  err_add_proc = err_add_proc & "    PID: " & proc.process_id & vbCrLf
  err_add_proc = err_add_proc & "    ID : " & mach_id
 
  call execute_proc_command(m_intellectual_add_process, err_add_proc)
  
 end sub 'intellectual_add_process
 
 
 '------------------------------------------------------------------------
 '       .
 private sub execute_proc_command (byref command, byval err_text)
  dim err_code
  dim err_descr
  
  on error resume next

  call command.Execute()
  
  err_code  =err.number
  err_descr =err.description
  
  call err.clear()
  
  on error goto 0
  
  if(err_code<>0)then
   call m_log_obj.send_error (-1, c_err_cm_source, err_text & vbCrLf & vbCrLf & err_descr)
  end if
 end sub 'execute_proc_command
 
 '------------------------------------------------------------------------
 '       .
 private function execute_func_command (byref command, byval err_text)
  dim err_code
  dim err_descr
  
  on error resume next

  set execute_func_command =  command.Execute()
  
  err_code  =err.number
  err_descr =err.description
  
  call err.clear()
  
  on error goto 0
  
  if(err_code<>0)then
   call m_log_obj.send_error (-1, c_err_cm_source, err_text & vbCrLf & vbCrLf & err_descr)
  end if
 end function 'execute_proc_command
 

end class 't_command

'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++