option explicit

private const c_err_source = "t_prog_pm_proc"

private const c_log_mode = 1
private const c_terminate_mode = 2
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_process

class t_process
 
 private m_name
 private m_year
 private m_month
 private m_day
 private m_hour
 private m_minute
 private m_second
 private m_handle_count
 private m_other_oper_count
 private m_other_oper_byte
 private m_process_id
 private m_read_count
 private m_read_byte
 private m_thread_count
 private m_write_count
 private m_write_byte
 private m_user_time
 private m_kernel_time
 private m_date_create
 
 '------------------------------------------------------------------------
 'properties
 
 public property let date_create (byval arg_date)
  m_date_create = arg_date
 end property
 
 public property let year (byval arg_year)
  m_year = arg_year
 end property
 
 public property let month (byval arg_month)
  m_month = arg_month
 end property
 
 public property let day (byval arg_day)
  m_day = arg_day
 end property
 
 public property let hour (byval arg_hour)
  m_hour = arg_hour
 end property
 
 public property let minute (byval arg_minute)
  m_minute = arg_minute
 end property
 
 public property let second (byval arg_second)
  m_second = arg_second
 end property
 
 public property let name (byval arg_name)
  m_name = arg_name
 end property
 
 public property let handle_count (byval arg_handle_count)
  m_handle_count = arg_handle_count
 end property
 
 public property let other_oper_count (byval arg_other_oper_count)
  m_other_oper_count = arg_other_oper_count
 end property
 
 
  public property let other_oper_byte (byval arg_other_oper_byte)
  m_other_oper_byte = arg_other_oper_byte
 end property 
 
 public property let process_id (byval arg_process_id)
  m_process_id = arg_process_id
 end property
 
 public property let read_count (byval arg_read_count)
  m_read_count = arg_read_count
 end property
 
 public property let read_byte (byval arg_read_byte)
  m_read_byte = arg_read_byte
 end property
 
 public property let thread_count (byval arg_thread_count)
  m_thread_count = arg_thread_count
 end property
 
 public property let write_count (byval arg_write_count)
  m_write_count = arg_write_count
 end property
 
 public property let write_byte (byval arg_write_byte)
  m_write_byte = arg_write_byte
 end property

 public property let user_time (byval arg_user_time)
  m_user_time = arg_user_time
 end property

 public property let kernel_time (byval arg_kernel_time)
  m_kernel_time = arg_kernel_time
 end property

 public property get date_create ()
  date_create = m_date_create
 end property
 
 public property get year ()
  year = m_year
 end property
 
 public property get month ()
  month = m_month
 end property
 
 public property get day ()
  day = m_day
 end property
 
 public property get hour ()
  hour = m_hour
 end property
 
 public property get minute ()
  minute = m_minute
 end property
 
 public property get second ()
  second = m_second
 end property
 
 public property get name ()
  name = m_name
 end property
 
 public property get handle_count ()
  handle_count = m_handle_count
 end property
 
 public property get other_oper_count ()
  other_oper_count = m_other_oper_count
 end property
 
 
 public property get other_oper_byte ()
  other_oper_byte = m_other_oper_byte
 end property
 
 public property get process_id ()
  process_id = m_process_id
 end property
 
 public property get read_count ()
  read_count = m_read_count
 end property
 
 public property get read_byte ()
  read_byte = m_read_byte
 end property
 
 public property get thread_count ()
  thread_count = m_thread_count
 end property
 
 public property get write_count ()
  write_count = m_write_count
 end property
 
 public property get write_byte ()
  write_byte = m_write_byte
 end property
 
 public property get user_time ()
  user_time = m_user_time
 end property
 
 public property get kernel_time ()
  kernel_time = m_kernel_time
 end property

end class 't_process

'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_process_list

class t_process_list

 private m_obj_process
 private m_obj_proc
 private m_proc_list
 private m_obj_locator
 private m_obj_service
 private m_creat_date
'-------------------------------------------------------------------------
'constructor

 private sub class_initialize ()
  set m_proc_list   = nothing
  set m_obj_locator = nothing
  set m_obj_service = nothing
  set m_creat_date  = nothing
  
  set m_proc_list   = createobject("LCPI.DBS.Utility.Vector")
  set m_obj_locator = CreateObject("WbemScripting.SWbemLocator")
  
  set m_creat_date  = CreateObject("WbemScripting.SWbemDateTime")
 end sub 'class_initialize
 
 public property get obj_service ()
  set obj_service = m_obj_service
 end property

'-------------------------------------------------------------------------
'  Vector,      t_process
'    
'    ,   nothing
 public function get_proc_list(access_info, except_proc, terminate_proc, mode, log_obj)
  
  '####################### ERROR HANDLING #######################
  dim err_code
  dim err_descr
 
  on error resume next
  
  if (access_info.password <> "")then
  set m_obj_service = m_obj_locator.ConnectServer(access_info.machine_name, _
                                                  "root\cimv2",             _
                                                  access_info.user,         _
                                                  access_info.password)
  else
   set m_obj_service = m_obj_locator.ConnectServer(access_info.machine_name, _
                                                  "root\cimv2")
  end if
 
  err_code  =err.number
  err_descr =err.description
 
  call err.clear()
 
  on error goto 0
  
  if (err_code <> 0)then
   call log_obj.send_error (-1, c_err_source,"      "&access_info.machine_name)
   set get_proc_list = nothing
   exit function
  end if
  '##############################################################
  
  dim processes, proc
  set processes = m_obj_service.instancesof("Win32_Process")
  
  dim dat
  for each proc in processes
   dim need_get_process
    need_get_process = false
  
    select case mode
      case c_log_mode
        if (not_except_process(proc, except_proc)) then
          need_get_process = true
        end if
      case c_terminate_mode
        if (terminated_process(proc, terminate_proc)) then
          need_get_process = true
        end if
    end select
   '            
   if (need_get_process)then
   
    set m_obj_proc = nothing
    set m_obj_proc = new t_process
   
    if (proc.CreationDate <> "")then
     m_creat_date.Value = proc.CreationDate
    end if
 
    m_obj_proc.name               = proc.name
    m_obj_proc.handle_count       = proc.handlecount
    m_obj_proc.other_oper_count   = proc.otherOperationCount
    m_obj_proc.other_oper_byte    = proc.otherTransferCount
    m_obj_proc.process_id         = proc.processId
    m_obj_proc.read_count         = proc.readOperationCount
    m_obj_proc.read_byte          = proc.readTransferCount 
    m_obj_proc.thread_count       = proc.threadCount
    m_obj_proc.write_count        = proc.writeOperationCount
    m_obj_proc.write_byte         = proc.writeTransferCount
    m_obj_proc.user_time		  = proc.userModeTime
    m_obj_proc.kernel_time		  = proc.kernelModeTime
   
    m_obj_proc.year    = m_creat_date.year
    m_obj_proc.month   = m_creat_date.month
    m_obj_proc.day     = m_creat_date.day
    m_obj_proc.hour    = m_creat_date.hours
    m_obj_proc.minute  = m_creat_date.minutes
    m_obj_proc.second  = m_creat_date.seconds
    
    ' 
    
    dat = m_obj_proc.day&"/"&m_obj_proc.month&"/"&m_obj_proc.year& _
       	" "&m_obj_proc.hour&":"&m_obj_proc.minute&":"&m_obj_proc.second
    
    if (isdate(dat))then
     m_obj_proc.date_create = cdate(dat)
    else
     call log_obj.send_error (-1, c_err_source,"      date")
    end if
  
    m_proc_list.pushback(m_obj_proc)
   end if
  next
 
  set get_proc_list = m_proc_list
 end function 'get_proc_list
 
'-------------------------------------------------------------------------
',      
' true,   
 private function not_except_process(proc, except_proc)
  not_except_process = true
  
  if (except_proc is nothing)then
   not_except_process = true
   exit function
  end if
  
  dim except
  
  for each except in except_proc
   if (proc.name = except)then
  
    not_except_process = false
    exit function
  
   end if
  next
 end function'not_except_process
 
'-------------------------------------------------------------------------
 private function terminated_process(proc, terminate_proc)
  terminated_process = false
  
  if(terminate_proc is nothing)then
   terminated_process = true
   exit function
  end if
  
  dim terminate
  
  for each terminate in terminate_proc
   '      
   if (proc.name = terminate)then
   
   ' true
   terminated_process = true
   '  
   exit function
   
   end if
  next
 end function 'terminated_process
 
end class 't_process_list
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++