'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'         
'                                                  . 04.12.2007

option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_bad_address_report_file

class t_bad_address_report_file
 private m_file_name        '    

 private m_oc2_loader       '   

 private m_ali_types        '   TYPE_ADDRESS_LAST_ITEM

 private m_file             '  
 
 private m_last_addr_data   '   

 private m_err_total_count  '   
 private m_err_addr_count   '   
 private m_err_local_count  '     

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  call init(empty,nothing,nothing)
 end sub 'class_initialize

 '------------------------------------------------------------------------
 public sub init(file_name,oc2_loader,ali_types)
  m_file_name          = file_name
  set m_oc2_loader     = oc2_loader
  set m_ali_types      = ali_types
  set m_file           = nothing
  set m_last_addr_data = nothing

  m_err_total_count =0
  m_err_addr_count  =0
  m_err_local_count =0
 end sub 'init

 '------------------------------------------------------------------------
 public sub WriteLine(msg)
  call get_file().WriteLine(msg)
 end sub 'WriteLine
 
 '------------------------------------------------------------------------
 public sub report(addr_fields,msg)
  '   
  m_err_total_count=m_err_total_count+1

  if(not (m_last_addr_data is nothing))then
   if(not(m_last_addr_data.ObjID=addr_fields("id").value and _
          m_last_addr_data.ObjClass=addr_fields("class").value))then
    set m_last_addr_data=nothing
   end if
  end if

  '-------
  dim file
  set file=get_file()

  '  
  if(m_last_addr_data is nothing)then
   m_err_addr_count  =m_err_addr_count+1
   m_err_local_count =0 '     

   call file.WriteLine()

   call file.WriteLine(su_fnum(m_err_addr_count,9)& _
                       " ---------------------------------------------------")
   
   '   
   dim owner_data
   set owner_data=m_oc2_loader.LoadData(addr_fields("owner").value,         _
                                        addr_fields("owner_class").value,   _
                                        256)

   call file.WriteLine(":")
   call file.WriteLine(owner_data.GetDisplayName(2))
   call file.WriteLine("["&su_cstr_sn(owner_data.ObjID)&":"&su_cstr_sn(owner_data.ObjClass)&"]")

   '  
   set m_last_addr_data=m_oc2_loader.LoadData(addr_fields("id").value,     _
                                              addr_fields("class").value,  _
                                              257)
   
   call file.WriteLine("")
   call file.WriteLine(":")
   call file.WriteLine("ID   :"&"["&su_cstr_sn(m_last_addr_data.ObjID)&":"&su_cstr_sn(m_last_addr_data.ObjClass)&"]")

   call file.WriteLine("HOUSE:"&build_ali_str(addr_fields,"HOUSE"))
   call file.WriteLine("BUILD:"&build_ali_str(addr_fields,"BUILDING"))
   call file.WriteLine("FLAT :"&build_ali_str(addr_fields,"APARTMENT"))
   call file.WriteLine("DESCR:"&su_cstr_sn(addr_fields("descriptions").value))
   
   call file.WriteLine("")
   call file.WriteLine(" :")
   
   dim ai
   dim ai_n
   
   ai_n=0

   for each ai in m_last_addr_data.Childs
    if(ucase(ai.ObjType)="ADDRESS_ITEM")then
     ai_n=ai_n+1

     file.WriteLine(su_fnum(ai_n,2)&". "&ai.GetDisplayName(2))
    end if
   next 'ai
  end if ' 

  '--------------------------------------
  m_err_local_count=m_err_local_count+1

  call file.WriteLine("")

  call file.WriteLine(su_fnum(m_err_local_count,2)&" -----------")
  call file.WriteLine(msg)
 end sub 'report

 '------------------------------------------------------------------------
 private function build_ali_str(addr_fields,ali_element)
  build_ali_str=""

  build_ali_str=su_cstr_sn(addr_fields(ali_element).value)

  build_ali_str=build_ali_str&" : ["

  dim type_id
  type_id=addr_fields(ali_element&"_type").value

  build_ali_str=build_ali_str&su_cstr_sn(type_id)

  build_ali_str=build_ali_str&"] "

  if(not IsNull(type_id))then
   build_ali_str=build_ali_str&m_ali_types.ItemByID(type_id).Name
  end if
 end function 'build_ali_str

 '------------------------------------------------------------------------
 private function get_file()
  if(m_file is nothing)then
   ' 
   set m_file=su_open_text_file(m_file_name,8,true)
  end if

  set get_file=m_file
 end function 'get_file
end class 't_bad_address_report_file

'--------------------------------------------------------------------------
private function create_bad_address_report_file(file_name,    _
                                                oc2_loader,   _
                                                ali_types)
 set create_bad_address_report_file=new t_bad_address_report_file

 call create_bad_address_report_file.init(file_name,oc2_loader,ali_types)
end function 'create_bad_address_report_file

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
