'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'       
'                                       . 7  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_prog_scan_rpl_delete

class t_prog_scan_rpl_delete
 private m_log
 private m_cn
 private m_mng

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  set m_log =nothing
  set m_cn  =nothing
  set m_mng =createobject("LCPI.DBS.SYS.DBClassManager")
 end sub 'class_initialize
 
 'properties -------------------------------------------------------------
 public property set log(x)
  set m_log=x
 end property
 
 '------------------------------------------------------------------------
 public property set cn(x)
  set m_cn=x

  m_mng.connection=x
 
  if(not(x is nothing))then
   call m_mng.Load() '     
  end if
 end property
 
 '------------------------------------------------------------------------
 public property get cn()
  set cn=m_cn
 end property
 
 '------------------------------------------------------------------------
 public function get_base_table(byval table_name,byref base_table_name)
  get_base_table=false
  
  base_table_name=empty
  
  '  
  table_name=ucase(table_name)
  
  dim i
  
  for i=0 to m_mng.Tables.Count-1
   if(ucase(m_mng.Tables(i).name)=table_name)then
    exit for
   end if
  next 'i
  
  if(i=m_mng.Tables.Count)then
   call m_log.send_msg("error: unknown table name """&table_name&"""")
   call m_log.inc_error_count()
   
   exit function
  end if
  
  dim table_info
  set table_info=m_mng.Tables(i)
  
  ' ,   
  for i=0 to m_mng.Classes.Count-1
   if(m_mng.Classes(i).Table.id=table_info.id)then
    exit for
   end if
  next 'i
  
  if(i=m_mng.Classes.Count-1)then
   call m_log.send_msg("error: object table """&table_name&""" without class")
   call m_log.inc_error_count()
   
   exit function
  end if 'i
  
  '-------------------------------------
  '  
  
  dim class_info
  set class_info=m_mng.Classes(i)
  
  while(not (class_info.super is nothing))
   set class_info=class_info.super
  wend
  
  '-------------------------------------
  base_table_name=class_info.Table.Name
  
  get_base_table=true
 end function 'get_base_table
 
 '------------------------------------------------------------------------
 '   ,   
 public function get_table_classes(byval table_name)
  dim cl_list
  set cl_list=createobject("LCPI.DBS.Utility.Vector")
  
  dim cl_info
  
  for each cl_info in m_mng.Classes
   if(test_use_table_in_class(cl_info,table_name))then
    call cl_list.PushBack(cl_info)
   end if
  next 'cl_info
  
  set get_table_classes=cl_list
 end function 'get_table_classes
 
 '------------------------------------------------------------------------
 private function test_use_table_in_class(byval cl_info,byval table_name)
  table_name=ucase(table_name)
  
  do while(not (cl_info is nothing))
   if(ucase(cl_info.Table.name)=table_name)then
    exit do
   end if
   
   set cl_info=cl_info.super
  loop

  test_use_table_in_class=not (cl_info is nothing)
 end function 'test_use_table_in_class
 
 '------------------------------------------------------------------------
 public function build_where_part(cl_list)
  dim res
  
  res=" not(date_destroy is null) and "&_
      "user_destroy='REPLICATOR'"
  
  if(not (cl_list is nothing))then
   dim stmt_in
   dim cl

   for each cl in cl_list
    if(not(cl is cl_list.front))then stmt_in=stmt_in&","

    stmt_in=stmt_in&cstr(cl.id)
   next 'cl

   res=res&" and (class in ("&stmt_in&"))"
  end if
  
  build_where_part=res
 end function 'build_where_part

 '------------------------------------------------------------------------
 public sub delete_records(byval table_name,byval cl_list)
  dim select_cmd
  set select_cmd=createobject("ADODB.Command")
  
  select_cmd.activeconnection=m_cn
  
  select_cmd.commandtext="select id,class from "&table_name&vbCrLf& _
                         "where "&build_where_part(cl_list)

  '-----------------------
  dim delete_cmd
  set delete_cmd=createobject("ADODB.Command")
  
  delete_cmd.activeconnection=m_cn
  delete_cmd.commandtext="delete from "&table_name&" where id=:id and class=:class"

  '-----------------------
  dim delete_born_id_cmd
  set delete_born_id_cmd=createobject("ADODB.Command")
  
  delete_born_id_cmd.activeconnection=m_cn
  delete_born_id_cmd.commandtext= _
   "delete from rpl_born_id"&vbCrLf& _
   "where table_id=:table_id and"&vbCrLf&_
         "id_null_mask=252 and"&vbCrLf&_
         "id1=:id1 and"&vbCrLf&_
         "id2=:id2 and"&vbCrLf&_
         "id3=0 and"&vbCrLf&_
         "id4=0 and"&vbCrLf&_
         "id5=0 and"&vbCrLf&_
         "id6=0 and"&vbCrLf&_
         "id7=0 and"&vbCrLf&_
         "id8=0"

  '-----------------------
  dim rs
  dim tot_cnt,del_cnt

  dim err_code
  dim err_descr

  dim tot_del_cnt '   
  tot_del_cnt=0

  dim row_affected

  do while(true)
   set rs=nothing
   set rs=select_cmd.execute
   
   tot_cnt=0
   del_cnt=0

   while(not rs.eof)
    tot_cnt=tot_cnt+1
   
    'call m_log.send_msg(su_dbobj_id_to_str(rs("id").value,rs("class").value))

    delete_cmd("id").value    =rs("id").value
    delete_cmd("class").value =rs("class").value
    
    '------------
    on error resume next
   
    call delete_cmd.execute(row_affected)
    
    err_code  =err.number
    err_descr =err.description
    
    call err.clear()
    
    on error goto 0
   
    '------------
    if(err_code=0)then
     del_cnt=del_cnt+1
     
     tot_del_cnt=tot_del_cnt+1
     
     '   RPL_BORN_ID
     delete_born_id_cmd("table_id").value=m_mng.Classes.ItemByID(rs("class").value).Table.id
     delete_born_id_cmd("id1").value     =rs("id").value
     delete_born_id_cmd("id2").value     =rs("class").value
     
     call delete_born_id_cmd.execute(row_affected)
    end if
    
    call rs.movenext()
   wend
   
   if(del_cnt=0)then exit do
  loop
  
  call g_log.send_msg(table_name&": remove ["&tot_del_cnt&"] record(s)")
  
  if(tot_cnt<>0)then
   call m_log.send_msg(table_name&": can't delete ["&tot_cnt&"] record(s)")
   
   call m_log.inc_error_count()
  end if
 end sub 'delete_records
end class 't_prog_scan_rpl_delete

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

