'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'      
'                                        . 9  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_prog_scan_rpl_delete_elements

class t_prog_scan_rpl_delete_elements
 private m_target_cn
 private m_pack_cn

 private m_scan_cmd
 private m_born_id_cmd
 private m_map_born_id_cmd
 
 'constructor ------------------------------------------------------------
 private sub class_initialize()
  set m_pack_cn     =nothing
  set m_scan_cmd    =createobject("ADODB.Command")
  set m_born_id_cmd =createobject("ADODB.Command")

  set m_map_born_id_cmd=new t_rpl_map_born_id_cmd

  m_born_id_cmd.commandtext= _
   "select t.terrain_global_id as born_terrain_global_id,"&vbCrLf& _
          "t.name as born_terrain_name,"&vbCrLf& _
          "b.born_terrain_id,"&vbCrLf& _
          "b.born_table_id,"&vbCrLf& _
          "b.born_id1,"&vbCrLf&  _
          "b.born_id2,"&vbCrLf&  _
          "b.born_id3,"&vbCrLf&  _
          "b.born_id4,"&vbCrLf&  _
          "b.born_id5,"&vbCrLf&  _
          "b.born_id6,"&vbCrLf&  _
          "b.born_id7,"&vbCrLf&  _
          "b.born_id8"&vbCrLf&   _
   "from rpl_pack_data_born_id b join rpl_pack_terrain t "&vbCrLf& _
          "on b.terrain_id=t.terrain_id"&vbCrLf& _
   "where t.terrain_global_id=:terrain_global_id and b.data_id=:data_id"

 end sub 'class_initialize
 
 'properties -------------------------------------------------------------
 public sub init(target_cn,pack_cn)
  set m_target_cn  =target_cn
  set m_pack_cn    =pack_cn
  
  m_scan_cmd.activeconnection    = pack_cn
  m_born_id_cmd.activeconnection = pack_cn
  
  set m_map_born_id_cmd.connection = target_cn
  
  m_scan_cmd.commandtext=""
 end sub 'connection
 
 '------------------------------------------------------------------------
 public sub scan(pack_descr)
  dim header_is_printed

  header_is_printed=false

  if(g_args.has_arg(c_prog_arg_print_all_packs))then
   call g_log.send_msg(build_rpl_pack_header(pack_descr))
   header_is_printed=true
  end if

  '     ---------------------------
  dim table_ids
  set table_ids=convert_table_ids(cn,pack_descr,g_args.get_args(c_prog_arg_element_table))

  '    --------------------------------------------
  dim t
  dim rs

  dim stmt,stmt_part_in

  stmt="select t.terrain_global_id,rpd.data_id,rpd.table_id,"&vbCrLf& _
              "rpd.id1,rpd.id2,rpd.id3,rpd.id4,rpd.id5,rpd.id6,rpd.id7,rpd.id8,"&vbCrLf& _
              "rpt.name as table_name"&vbCrLf& _
       "from rpl_pack_element rpe join"&vbCrLf& _
             "(rpl_pack_data rpd join "&vbCrLf& _
               "(rpl_pack_table_name rpt join rpl_pack_terrain t"&vbCrLf& _
                 "on rpt.terrain_id=t.terrain_id)"&vbCrLf& _
              "on rpd.table_id=rpt.table_id)"&vbCrLf& _
           "on rpe.terrain_id=rpd.terrain_id and rpe.data_id=rpd.data_id"&vbCrLf& _
       "where t.terrain_global_id=:terrain_global_id and rpe.pack_id=:pack_id and rpe.element_status=4"

  if(table_ids.count>0)then
   '    

   for each t in table_ids.keys
    if(stmt_part_in<>"")then stmt_part_in=stmt_part_in&","

    stmt_part_in=stmt_part_in&t
   next 't

   stmt=stmt&" and rpd.table_id in ("&stmt_part_in&")"
  end if ' in 

  set rs=nothing

  m_scan_cmd.commandtext=stmt
  m_scan_cmd("terrain_global_id")=pack_descr.terrain_global_id
  m_scan_cmd("pack_id")=pack_descr.pack_id

  set rs=m_scan_cmd.execute

  dim num,msg
  num=1

  dim print_born_ids
  print_born_ids=not(m_target_cn is nothing) and g_args.has_arg(c_prog_arg_print_born_id)

  dim print_target_ids
  print_target_ids=not(m_target_cn is nothing) and g_args.has_arg(c_prog_arg_print_target_id)

  dim local_id_rs

  while(not rs.eof)
   if(not header_is_printed)then
    call g_log.send_msg(build_rpl_pack_header(pack_descr))
    header_is_printed=true
   end if

   msg=su_fnum(num,5)&vbTab&rs("table_name").value&vbTab& _
       "["&rpl_obj_id_to_str(rs.fields,"id")&"]"

   if(print_target_ids)then
    set local_id_rs=nothing
    set local_id_rs=m_map_born_id_cmd.execute(rs("terrain_global_id").value, _
                                              rs("table_id").value, _
                                              rs("id1").value, _
                                              rs("id2").value, _
                                              rs("id3").value, _
                                              rs("id4").value, _
                                              rs("id5").value, _
                                              rs("id6").value, _
                                              rs("id7").value, _
                                              rs("id8").value)
    
    while(not local_id_rs.eof)
     msg=msg&" local:["&rpl_obj_id_to_str(local_id_rs,"id")&"]"
    
     call local_id_rs.movenext()
    wend
   end if
   
   call g_log.send_msg(msg)

   if(print_born_ids)then
    call scan_born_ids2(pack_descr.terrain_global_id,rs("data_id").value)
   end if

   num=num+1

   call rs.movenext()
  wend 'while
 end sub 'scan
 
 '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 'table_args - LCPI.DBS.Utility.Vector -  t_prog_arg

 function convert_table_ids(cn,pack_descr,table_args)
  dim table_ids
  set table_ids=createobject("Scripting.Dictionary")

  dim cmd,rs
  set cmd=createobject("ADODB.Command")
  cmd.activeconnection=m_pack_cn

  '     --------------------------
  if(not table_args.IsEmpty())then
   cmd.commandtext= _
    "select rptn.table_id"&vbCrLf& _
    "from rpl_pack_table_name rptn join rpl_pack_terrain t on rptn.terrain_id=t.terrain_id"&vbCrLf& _
    "where t.terrain_global_id=:terrain_global_id and UPPER(rptn.name)=:table_name"

   cmd("terrain_global_id")=pack_descr.terrain_global_id

   dim a
   for each a in table_args
    if(IsNumeric(a.value))then
     table_ids.item(clng(a.value))=0
    else
     '     
     set rs=nothing

     cmd("table_name")=ucase(a.value)

     set rs=cmd.execute

     if(rs.eof)then
      call g_log.send_warning(-1,c_err_source,"table ["&a.value&"] not found")
     else
      table_ids.item(clng(rs(0).value))=0
     end if
    end if 'convert name to table_id
   next 'a
  end if 'not table_args.IsEmpty

  set convert_table_ids=table_ids
 end function 'convert_table_ids

 '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 '  BORN_IDs

 private sub scan_born_ids2(terrain_global_id,data_id)
  dim cmd
  set cmd=m_born_id_cmd
  
  cmd("terrain_global_id") =terrain_global_id
  cmd("data_id")           =data_id
  
  dim rs
  set rs=cmd.execute
  
  dim msg,num
  
  dim print_target_ids
  dim local_id_rs
  
  print_target_ids=not(m_target_cn is nothing) and g_args.has_arg(c_prog_arg_print_target_id)

  num=1
  while(not rs.eof)
   msg=vbTab& _
       su_fnum(num,4)&vbTab& _
       su_lstr("["&rpl_obj_id_to_str(rs.fields,"born_id")&"]",20)&" - "& _
       rs("born_terrain_name").value
   
   if(print_target_ids)then
    set local_id_rs=nothing
    set local_id_rs=m_map_born_id_cmd.execute(rs("born_terrain_global_id").value, _
                                              rs("born_table_id").value, _
                                              rs("born_id1").value, _
                                              rs("born_id2").value, _
                                              rs("born_id3").value, _
                                              rs("born_id4").value, _
                                              rs("born_id5").value, _
                                              rs("born_id6").value, _
                                              rs("born_id7").value, _
                                              rs("born_id8").value)

    while(not local_id_rs.eof)
     msg=msg&" local:["&rpl_obj_id_to_str(local_id_rs,"id")&"]"

     call local_id_rs.movenext()
    wend
   end if

   call g_log.send_msg(msg)
   
   num=num+1
   
   call rs.movenext
  wend
 end sub 'scan_born_ids2

 '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 function rpl_obj_id_to_str(fields,id_prefix)
  dim c,i

  c=8
  do while(c>0)
   if(not IsNull(fields(id_prefix&cstr(c)).value))then exit do

   c=c-1
  loop

  dim str
  for i=1 to c
   if(str<>"")then str=str&","

   str=str&su_cstr_sn(fields(id_prefix&cstr(i)).value)
  next 'i

  rpl_obj_id_to_str=str
 end function 'rpl_obj_id_to_str

 '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 function build_rpl_pack_header(pack_descr)
  dim s

  s=vbCrLf&"+++++++++++++++++++++++++++++++++++++++++"&vbCrLf& _
    pack_descr.terrain_name&vbCrLf& _
    pack_descr.terrain_global_id&vbTab&su_fnum(pack_descr.pack_id,6)&vbCrLf& _
    pack_descr.gdb_file.Name&vbCrLf
    
  if(pack_descr.is_installed)then
   s=s&vbTab&"installed"
  end if
  
  build_rpl_pack_header=s
 end function 'build_rpl_pack_header
end class 't_prog_scan_rpl_delete_elements
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
