'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'     
'                                        . 5  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_rpl_pack_gdb_file_info

class t_rpl_pack_gdb_file_info
 private m_file                'Scripting File
 private m_packs               ' 
 
 'constructor ------------------------------------------------------------
 private sub class_initialize()
  set m_file    =nothing
  set m_packs   =createobject("LCPI.DBS.Utility.Vector")
 end sub
 
 'properties -------------------------------------------------------------
 public property set file(x)
  set m_file=x
  
  call m_packs.clear()
 end property
 
 '------------------------------------------------------------------------
 public property get file()
  set file=m_file
 end property
 
 public property get packs()
  set packs=m_packs
 end property
end class 't_rpl_pack_gdb_file_info

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_prog_scan_rpl_packs

class t_prog_scan_rpl_packs
 private c_err_source

 private m_fso

 private m_log
 private m_gdb_files     '  t_rpl_pack_gdb_file_info
 private m_rpl_packs
 private m_terrains
 
 'constructor ------------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_prog_scan_rpl_packs"
 
  set m_fso      =createobject("Scripting.FileSystemObject")
 
  set m_log      =nothing
  set m_gdb_files=createobject("Scripting.Dictionary")
  set m_rpl_packs=createobject("LCPI.DBS.Utility.Vector")
  set m_terrains =createobject("LCPI.DBS.Utility.Vector")
 end sub 'class_initialize
 
 'properties -------------------------------------------------------------
 public property set log(x)
  set m_log=x
 end property
 
 '------------------------------------------------------------------------
 public property get gdb_files()
  set gdb_files=m_gdb_files
 end property
 
 '------------------------------------------------------------------------
 public property get rpl_packs()
  set rpl_packs=m_rpl_packs
 end property
 
 '------------------------------------------------------------------------
 public property get terrains()
  set terrains=m_terrains
 end property

 '  GDB  -------------------------------------------
 public function scan_gdb_files(gdb_files_dir)
  scan_gdb_files=false
 
  if(m_fso.FileExists(gdb_files_dir))then
   call add_unique_gdb_file(m_gdb_files,m_fso.GetFile(gdb_files_dir))
  else
   dim fv
   set fv=createobject("LCPI.DBS.Utility.Vector")

   if(not su_scan_files(m_log,fv,gdb_files_dir,"gdb"))then
    exit function
   end if

   dim f
   for each f in fv
    call add_unique_gdb_file(m_gdb_files,f)
   next 'f
  end if
  
  scan_gdb_files=true
 end function 'scan_gdb_files

 '------------------------------------------------------------------------
 private sub add_unique_gdb_file(gdb_files,f)
  dim x

  set x=new t_rpl_pack_gdb_file_info

  set x.file=f

  set gdb_files.item(f.path)=x
 end sub 'add_unique_gdb_file

 '    ---------------------------------
 public sub scan_rpl_packs(print)
  dim file_descr
  dim num
  dim msg
  dim p

  num=1
  for each file_descr in m_gdb_files.items
   file_descr.packs.clear

   call load_rpl_pack_descrs("localhost",file_descr.file,file_descr.packs)

   for each p in file_descr.packs
    call m_rpl_packs.PushBack(p)
   next 'p

   if(print)then
    call m_log.send_msg(su_fnum(num,4)&". "&file_descr.file.Name&": "& _
         cstr(file_descr.packs.count)&" packs.")
   end if
   
   num=num+1
  next 'file

  call sort_buble(m_rpl_packs,new t_rpl_pack_descr_compare_for_restore)
 end sub 'scan_rpl_packs
 
 '   GDB  ----------------------------------------
 public sub print_empty_gdb_files()
  dim f
  dim num
  
  num=1
  
  for each f in m_gdb_files.items
   if(f.packs.IsEmpty())then
    m_log.send_msg(su_fnum(num,5)&vbTab&f.file.Name)
    num=num+1
   end if
  next 'f
 end sub 'print_empty_gdb_files
 
 '   --------------------------------------------------
 public sub print_rpl_packs(pv)
  dim p
  dim num
  
  num=1
  
  for each p in pv
   call m_log.send_msg(su_fnum(num,4)&vbTab&build_rpl_pack_descr(p,vbTab))
   
   num=num+1
  next
 end sub 'print_rpl_packs

 '   -----------------------------------------------
 'pv -   
 public sub print_rpl_pack_ranges(pv,title)
  dim ip,s_p
  
  set s_p=nothing

  dim ranges
  set ranges=createobject("LCPI.DBS.Utility.Vector")

  for ip=0 to pv.count-1
   if(s_p is nothing)then
    set s_p=pv(ip)
   elseif(pv(ip).pack_id<>pv(ip-1).pack_id+1)then
    call ranges.PushBack(create_rpl_pack_range(s_p,pv(ip-1)))

    set s_p=pv(ip)
   end if
  next 'ip

  '  
  if(not (s_p is nothing))then
   call ranges.PushBack(create_rpl_pack_range(s_p,pv.Back))
  end if

  '-------------------------------
  if(not ranges.IsEmpty())then
   call m_log.send_msg(title)

   call print_build_rpl_pack_ranges(ranges)
  end if
 end sub 'print_rpl_pack_ranges

 '     --------------------------------
 'pv -   
 public sub print_rpl_pack_empty_ranges(pv,title)
  dim ip
  
  dim ranges
  set ranges=createobject("LCPI.DBS.Utility.Vector")
  
  for ip=1 to pv.count-1
   if(pv(ip).pack_id<>pv(ip-1).pack_id+1)then
    call ranges.PushBack(create_rpl_pack_range(pv(ip-1),pv(ip)))
   end if
  next 'ip
  
  '-------------------------------
  if(not ranges.IsEmpty())then
   call m_log.send_msg(title)

   call print_build_rpl_pack_ranges(ranges)
  end if
 end sub 'print_rpl_pack_empty_ranges

 '     ----------------------
 public sub print_installed_rpl_pack_ranges(pv,installed,scan_number_ranges,title)
  dim ip,s_p
  
  set s_p=nothing
  
  dim ranges
  set ranges=createobject("LCPI.DBS.Utility.Vector")

  for ip=0 to pv.count-1
   if(not(pv(ip).is_installed xor installed))then
    '     is_installed

    if(s_p is nothing)then
     set s_p=pv(ip) '  
    else
     if(scan_number_ranges and pv(ip).pack_id<>pv(ip-1).pack_id+1)then
      '    
      call ranges.PushBack(create_rpl_pack_range(s_p,pv(ip-1)))

      set s_p=pv(ip) '  
     end if
    end if
   elseif(not(s_p is nothing))then
    '     is_installed
    call ranges.PushBack(create_rpl_pack_range(s_p,pv(ip-1)))

    set s_p=nothing
   end if
  next 'ip
  
  '  
  if(not (s_p is nothing))then
   call ranges.PushBack(create_rpl_pack_range(s_p,pv.Back))
  end if

  '-------------------------------
  if(not ranges.IsEmpty())then
   call m_log.send_msg(title)

   call print_build_rpl_pack_ranges(ranges)
  end if
 end sub'print_installed_rpl_pack_ranges

 '    -------------------------------------
 public sub scan_dublicates()
  dim ip1,p1
  dim ip2,p2

  dim msg

  for ip1=0 to m_rpl_packs.count-1
   set p1=m_rpl_packs(ip1)

   for ip2=ip1+1 to m_rpl_packs.count-1
    set p2=m_rpl_packs(ip2)

    if(p1.terrain_global_id=p2.terrain_global_id and p1.pack_id=p2.pack_id)then
     msg="DUBLICATE PACKS:"&vbCrLf& _
         build_rpl_pack_descr(p1," ")&vbCrLf& _
         build_rpl_pack_descr(p2," ")

     call g_log.send_error(-1,c_err_source,msg)
    end if
   next 'ip2
  next 'p1
 end sub 'scan_dublicates

 '   -------------------------------------------
 sub scan_terrains()
  m_terrains.clear

  dim p,it,t
  
  for each p in m_rpl_packs
   it=0
   do while (it<m_terrains.count)
    if(m_terrains(it).global_id=p.terrain_global_id)then exit do
    it=it+1
   loop

   if(it=m_terrains.count)then
    set t=new t_terrain_descr

    t.global_id   =p.terrain_global_id
    t.name        =p.terrain_name

    call m_terrains.PushBack(t)
   end if
  next 'p

  ' 
  call sort_buble(m_terrains,new t_terrain_descr_compare)
 end sub 'build_terrain_list

 '   -----------------------------------------------
 public sub print_terrains()
  dim t,num
  num=1

  for each t in m_terrains
   g_log.send_msg(su_fnum(num,2)&"."&vbTab&t.global_id&vbTab&t.name)
   num=num+1
  next 't
 end sub 'print_terrains

 '   ----------------------------------------------
 
 'is_inst=true  -   
 '        false -  
 public function filter_installed_rpl_packs(target_cn,pv,is_inst)
  dim cmd
  set cmd=createobject("ADODB.Command")
  
  cmd.activeconnection=target_cn
  
  cmd.commandtext="select p.rec_id"&vbCrLf& _
                  "from rpl_restored_pack p join rpl_terrain t"&vbCrLf& _
                        "on p.terrain_id=t.terrain_id"&vbCrLf& _
                  "where t.terrain_global_id=? and p.pack_id=?"
  
  dim p
  
  dim fpv
  set fpv=createobject("LCPI.DBS.Utility.Vector")
  
  for each p in pv
   cmd(0)=p.terrain_global_id
   cmd(1)=p.pack_id
   
   if((not cmd.execute.eof)=is_inst)then call fpv.PushBack(p)
  next 'p
  
  set filter_installed_rpl_packs=fpv
 end function 'filter_installed_rpl_packs

 '------------------------------------------------------------------------
 '      
 public sub load_installed_rpl_packs(target_cn,all_terrains,base_pack_id)
  dim p

  '   
  dim dic_terrains
  set dic_terrains=createobject("Scripting.Dictionary")
  
  '  
  dim dic_local_packs
  set dic_local_packs=createobject("Scripting.Dictionary")
  
  for each p in m_rpl_packs
   dic_local_packs(build_pack_id_sign(p.terrain_global_id,p.pack_id))=0
  
   if(not all_terrains)then dic_terrains(p.terrain_global_id)=0
  next 'p
  
  dim stmt
  dim stmt_in
  
  dim where_parts
  set where_parts=createobject("LCPI.DBS.Utility.Vector")
  
  stmt="select t.terrain_global_id,"&vbCrLf& _
              "t.name as terrain_name,"&vbCrLf& _
              "r.pack_id,"&vbCrLf& _
              "r.pack_cat,"&vbCrLf& _
              "r.pack_num,"&vbCrLf& _
              "r.pack_create_date"&vbCrLf& _
       "from rpl_restored_pack r join rpl_terrain t on r.terrain_id=t.terrain_id"
  
  '-------------------
  if(dic_terrains.Count<>0)then
   for each p in dic_terrains.keys
    if(stmt_in<>"")then stmt_in=stmt_in&","
    
    stmt_in=stmt_in&"'"&cstr(p)&"'"
   next 'p
   
   stmt_in="t.terrain_global_id in ("&stmt_in&")"
   
   call where_parts.PushBack(stmt_in)
  end if
  
  '-------------------
  if(not IsEmpty(base_pack_id))then
   call where_parts.PushBack("r.pack_id>="&cstr(base_pack_id))
  end if
  
  '-------------------
  if(not where_parts.IsEmpty)then
   stmt=stmt&vbCrLf&"where "
   
   for p=0 to where_parts.count-1
    if(p<>0)then stmt=stmt&" and "
    
    stmt=stmt&" "&where_parts(p)
   next 'p
  end if

  '-------------------
  dim cmd
  set cmd=createobject("ADODB.Command")
  
  cmd.activeconnection=target_cn
  
  cmd.commandtext=stmt
  
  dim rs
  set rs=cmd.execute()
  
  while(not rs.eof)
   if(not dic_local_packs.Exists(build_pack_id_sign(rs("terrain_global_id").value,rs("pack_id").value)))then
    set p=new t_rpl_pack_descr
    
    p.terrain_global_id  =rs("terrain_global_id").value
    p.pack_id            =rs("pack_id").value
    p.pack_num           =rs("pack_num").value
    p.pack_cat           =rs("pack_cat").value
    p.terrain_name       =rs("terrain_name").value
    p.pack_date_create   =rs("pack_create_date").value
    
    call m_rpl_packs.PushBack(p)
   end if
   call rs.movenext()
  wend
 end sub 'load_installed_rpl_packs

 '------------------------------------------------------------------------
 private function build_pack_id_sign(terrain_global_id,pack_id)
  build_pack_id_sign=cstr(terrain_global_id)&"_"&cstr(pack_id)
 end function

 '------------------------------------------------------------------------
 '    
 public sub test_rpl_packs_date_create(target_db_location,pv)
  dim cn
  set cn=createobject("ADODB.Connection")
  
  cn.Provider="LCPI.IBProvider"
  
  call cn.Open("location="&target_db_location&";ctype=win1251","gamer","vermut")
  
  cn.IsolationLevel=65536
  
  call cn.BeginTrans()
  
  dim cmd
  set cmd=createobject("ADODB.Command")
  
  cmd.activeconnection=cn
  
  cmd.commandtext="select p.pack_create_date"&vbCrLf&_
                  "from rpl_restored_pack p join rpl_terrain t on p.terrain_id=t.terrain_id"&vbCr& _
                  "where t.terrain_global_id=? and p.pack_id=?"
  
  dim rs,p,msg
  for each p in pv
   cmd(0)=p.terrain_global_id
   cmd(1)=p.pack_id
   
   set rs=nothing
   set rs=cmd.execute
   
   while(not rs.eof)
    if(not IsNull(rs("pack_create_date").value))then
     if(rs("pack_create_date").value<>p.pack_date_create)then
      msg="Different create date of pack "&vbCrLf& _
          "TerrainGlobalID     :"&p.terrain_global_id&" - "&p.terrain_name&vbCrLf&_
          "PackID              :"&su_fnum(p.pack_id,6)&"]"&vbCrLf&_
          "Date from pack db   :"&su_date_to_str(p.pack_date_create)&vbCrLf&_
          "Date from target db :"&su_date_to_str(rs("pack_create_date").value)
          
      call m_log.send_error(-1,c_err_source,msg)
     end if
    end if
    
    call rs.movenext()
   wend
  next 'p
  
  call cn.CommitTrans()
 end sub 'test_rpl_packs_date_create
 
 '------------------------------------------------------------------------
 public sub test_rpl_packs_sequentials(pv)
  dim ip1,p1
  dim ip2,p2
  
  dim msg
  
  for ip1=0 to pv.count-1
   set p1=pv(ip1)

   for ip2=ip1+1 to pv.count-1
    set p2=pv(ip2)
    
    if(p1.terrain_global_id=p2.terrain_global_id)then
     if(p1.pack_id<p2.pack_id xor p1.pack_date_create<p2.pack_date_create)then
      msg="Terrain         :"&cstr(p1.terrain_name)&vbCrLf&_
          "TerrainGlobalID :"&cstr(p1.terrain_global_id)&vbCrLf&_
          "Pack1:"&su_fnum(p1.pack_id,6)&" Date Create:"&su_date_to_str(p1.pack_date_create)&vbCrLf& _
          "Pack2:"&su_fnum(p2.pack_id,6)&" Date Create:"&su_date_to_str(p2.pack_date_create)
          
      call m_log.send_error(-1,c_err_source,msg)
      
      exit for
     end if
    end if 'equal terrains
   next 'ip2
  next 'ip1

 end sub
 
 '------------------------------------------------------------------------
 public function build_rpl_pack_descr(p,sep)
  dim t
 
  t=su_date_to_str(p.pack_date_create)&sep& _
    p.terrain_global_id&sep& _
    su_fnum(p.pack_id,6)

  if(not(p.gdb_file is nothing))then
   t=t&sep&p.gdb_file.Name
  end if
  
  if(p.is_installed)then t=t&vbTab&"installed"
  
  build_rpl_pack_descr=t
 end function 'build_rpl_pack_descr

 '------------------------------------------------------------------------
 private sub print_build_rpl_pack_ranges(ranges)
  dim r
  
  for each r in ranges
   call m_log.send_msg(build_rpl_pack_range_descr(r.first,r.second))
  next 'r
 end sub 'print_build_rpl_pack_ranges

 '------------------------------------------------------------------------
 private function build_rpl_pack_range_descr(p1,p2)
  build_rpl_pack_range_descr= _
   su_fnum(p1.pack_id,6)&vbTab& _
   su_fnum(p2.pack_id,6)&vbTab& _
   su_date_to_str(p1.pack_date_create)&vbTab& _
   su_date_to_str(p2.pack_date_create)
 end function 'build_rpl_pack_range_descr
 
 '------------------------------------------------------------------------
 private function create_rpl_pack_range(p1,p2)
  dim r
  set r=new t_pair
  
  set r.first  =p1
  set r.second =p2
  
  set create_rpl_pack_range=r
 end function 'create_rpl_pack_range
end class 't_prog_scan_rpl_packs

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

