'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'    re_deal   
'                                        . 23  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_re_deal_descr

class t_re_deal_descr
 private m_terrain_global_id
 private m_data_id
 private m_table_id
 private m_obj_id
 private m_obj_class
 private m_part_with_num '  ,   (num_reg,num_year,num_reg,num)
 private m_title
 
 private m_oc2_obj_data
 private m_local_deals
 
 'constructor ------------------------------------------------------------
 private sub class_initialize()
  m_terrain_global_id =null
  m_data_id           =null
  m_table_id          =null
  m_obj_id            =null
  m_obj_class         =null
  m_title             =""

  set m_oc2_obj_data=nothing
  set m_local_deals =createobject("LCPI.DBS.Utility.Vector")
 end sub 'class_initialize
 
 'properties -------------------------------------------------------------
 public property let terrain_global_id(x)
  m_terrain_global_id=x
 end property
 
 public property let data_id(x)
  m_data_id=x
 end property
 
 public property let table_id(x)
  m_table_id=x
 end property
 
 public property let obj_id(x)
  m_obj_id=x
 end property
 
 public property let obj_class(x)
  m_obj_class=x
 end property
 
 public property let part_with_num(x)
  m_part_with_num=x
 end property
 
 public property let title(x)
  m_title=x
 end property
 
 public property set oc2_obj_data(x)
  set m_oc2_obj_data=x
 end property
 
 '------------------------------------------------------------------------
 public property get terrain_global_id()
  terrain_global_id=m_terrain_global_id
 end property

 public property get data_id()
  data_id=m_data_id
 end property

 public property get table_id()
  table_id=m_table_id
 end property

 public property get obj_id()
  obj_id=m_obj_id
 end property

 public property get obj_class()
  obj_class=m_obj_class
 end property

 public property get title()
  title=m_title
 end property

 public property get part_with_num()
  part_with_num=m_part_with_num
 end property

 public property get oc2_obj_data()
  set oc2_obj_data=m_oc2_obj_data
 end property
 
 public property get local_deals()
  set local_deals=m_local_deals
 end property
end class 't_re_deal_descr

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_pack_services

class t_pack_services
 private   m_cn
 private   m_sel_born_ids
 
 'constructor ------------------------------------------------------------
 private sub class_initialize()
  set m_cn=createobject("ADODB.Connection")
  
  m_cn.Provider="LCPI.IBProvider"

  m_cn.IsolationLevel=65536
  
  set m_sel_born_ids=nothing
 end sub
 
 'properties -------------------------------------------------------------
 public property get cn()
  set cn=m_cn
 end property
 
 '------------------------------------------------------------------------
 public function get_born_ids(terrain_id,data_id)
  if(m_sel_born_ids is nothing)then
   set m_sel_born_ids=createobject("ADODB.Command")
   
   m_sel_born_ids.ActiveConnection=m_cn
   
   m_sel_born_ids.commandtext= _
    "select t.terrain_global_id as born_terrain_global_id,"&vbCrLf& _
           "b.born_table_id,"&vbCrLf& _
           "b.born_id1,"&vbCrLf& _
           "b.born_id2,"&vbCrLf& _
           "b.born_id3,"&vbCrLf& _
           "b.born_id4,"&vbCrLf& _
           "b.born_id5,"&vbCrLf& _
           "b.born_id6,"&vbCrLf& _
           "b.born_id7,"&vbCrLf& _
           "b.born_id7"&vbCrLf& _
    "from rpl_pack_data_born_id b join rpl_pack_terrain t"&vbCrLf& _
           "on b.born_terrain_id=t.terrain_id"&vbCrLf& _
    "where b.terrain_id=:terrain_id and b.data_id=:data_id"
  end if
  
  m_sel_born_ids("terrain_id") = terrain_id
  m_sel_born_ids("data_id")    = data_id
  
  set get_born_ids=m_sel_born_ids.execute()
 end function 'get_born_ids
end class 't_pack_services

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_target_services

class t_target_services
 private m_cn
 private m_map_born_id
 private m_class_mng
 private m_obj_loader
 private m_map_born_id_cmd 't_rpl_map_born_id_cmd

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  set m_cn              =nothing
  
  call init(nothing)
 end sub 'class_initialize
 
 ' -----------------------------------------------------------
 public sub init(cn)
  set m_cn=cn
  
  if(cn is nothing)then
   set m_map_born_id       =nothing
   set m_class_mng         =nothing
   set m_obj_loader        =nothing
   set m_map_born_id_cmd   =nothing
  else
   set m_class_mng         =createobject("LCPI.DBS.SYS.DBClassManager")
   set m_obj_loader        =createobject("LCPI.DBS.OC2_ObjectLoader")
   set m_map_born_id_cmd   =new t_rpl_map_born_id_cmd

   m_class_mng.connection  =cn
   m_obj_loader.connection =cn

   set m_map_born_id_cmd.connection=cn

   call m_class_mng.Load()
  end if
 end sub 'init
 
 'properties -------------------------------------------------------------
 public property get cn()
  set cn=m_cn
 end property 'cn
 
 '------------------------------------------------------------------------
 public property get class_mng()
  set class_mng=m_class_mng
 end property

 public property get obj_loader()
  set obj_loader=m_obj_loader
 end property
 
 public property get map_born_id_cmd()
  set map_born_id_cmd=m_map_born_id_cmd
 end property
end class 't_target_services

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_prog_scan_rpl_re_deals

class t_prog_scan_rpl_re_deals
 private m_log
 private m_target_svc

 private m_dic_ft '    
 private m_oc2_obj_ldr

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  set m_log                =nothing
  set m_target_svc         =nothing
  set m_dic_ft             =createobject("Scripting.Dictionary")
  
  set m_oc2_obj_ldr        =createobject("LCPI.DBS.OC2_ObjectXMLReader")
 end sub 'class_initialize
 
 'properties -------------------------------------------------------------
 public property set log(x)
  set m_log=x
 end property 'log
 
 '------------------------------------------------------------------------
 public property set target_cn(x)
  set m_target_svc=nothing
  
  if(not (x is nothing))then
   set m_target_svc=new t_target_services
   
   call m_target_svc.init(x)
  end if
 end property 'target_cn
 
 '------------------------------------------------------------------------
 public property get dic_ft()
  set dic_ft=m_dic_ft
 end property

 '------------------------------------------------------------------------
 '  .    
 
 'object_table_name - RE_DEAL
 
 public function scan_re_deals(object_table_name,pack_db_location)
  dim printed_db_location
  printed_db_location=false
 
  '    
  dim pack_srv

  set pack_srv=new t_pack_services
  
  call pack_srv.cn.Open("location="&pack_db_location&";"& _
                        "ctype=win1251;ole db services=0;", _
                        "gamer","vermut")

  call pack_srv.cn.BeginTrans()
  
  '     re_deals      
  dim sel_re_deals
  set sel_re_deals=createobject("ADODB.Command")
  
  sel_re_deals.activeconnection=pack_srv.cn
  
  dim stmt
  dim stmt_in
  dim terrain_global_id
  
  stmt="select rpt.terrain_global_id,"&vbCrLf& _
              "rpd.terrain_id,"&vbCrLf& _
              "rpd.data_id,"&vbCrLf& _
              "rpd.table_id,"&vbCrLf&_
              "rpd.id1,"&vbCrLf& _
              "rpd.id2,"&vbCrLf& _
              "rpd.element_data"&vbCrLf&_
       "from rpl_pack_terrain rpt"&vbCrLf&_
             "join rpl_pack_data rpd"&vbCrLf&_
              "join rpl_pack_table_name rptn"&vbCrLf&_
              "on rpd.terrain_id=rptn.terrain_id and rpd.table_id=rptn.table_id"&vbCrLf&_
             "on rpt.terrain_id=rpd.terrain_id"&vbCrLf&_
       "where UPPER(rptn.name)=:name"

  '    
  if(m_dic_ft.count>0)then
   for each terrain_global_id in m_dic_ft.keys
    if(stmt_in<>"")then stmt_in=stmt_in&","
    
    stmt_in=stmt_in&"'"&cstr(terrain_global_id)&"'"
   next 'terrain_global_id
   
   stmt=stmt&" and rpt.terrain_global_id in ("&stmt_in&")"
  end if
  
  sel_re_deals.commandtext=stmt

  sel_re_deals("name")=trim(ucase(object_table_name)) '   !!!

  dim rs
  set rs=sel_re_deals.execute
  
  '-----------------------------------------------------------------------
  dim msg
  dim re_deal_descr

  dim re_deals
  set re_deals=createobject("LCPI.DBS.Utility.Vector")

  while(not rs.eof)
   if(not printed_db_location)then
    call m_log.send_msg(vbCrLf&"process: "&pack_db_location)

    printed_db_location=true
   end if

   '-------------------
   set re_deal_descr  = new t_re_deal_descr
   
   re_deal_descr.terrain_global_id = rs("terrain_global_id").value
   re_deal_descr.data_id           = rs("data_id").value
   re_deal_descr.table_id          = rs("table_id").value
   re_deal_descr.obj_id            = rs("id1").value
   re_deal_descr.obj_class         = rs("id2").value
   re_deal_descr.part_with_num     = object_table_name
   
   if(IsNull(re_deal_descr.obj_id) or IsNull(re_deal_descr.obj_class))then
    msg="error: incorrect object id:"& _
        su_dbobj_id_to_str(re_deal_descr.obj_id,re_deal_descr.obj_class)
    
    call m_log.send_msg(msg)
    
    call m_log.inc_error_count()
   else
    call get_element_obj(re_deal_descr,rs("element_data").value)
   
    '-------------------
    '   
   
    call scan_re_deals_in_target_db(pack_srv,               _
                                    rs("terrain_id").value, _
                                    re_deal_descr)
    
    '-------------------
    call re_deals.PushBack(re_deal_descr)
   end if
   
   '-------------------
   call rs.movenext()
  wend
  
  '-----------------------------------------------------------------------
  call pack_srv.cn.CommitTrans()
  
  set scan_re_deals=re_deals
 end function 'scan_re_deals
 
 '------------------------------------------------------------------------
 public sub print_re_deals(re_deals)
  dim num,num1,msg
  dim re_deal_descr
  dim local_re_deal

  num=0
  
  dim skeep_line
  skeep_line=false
  
  for each re_deal_descr in re_deals
   if(skeep_line)then
    call m_log.send_msg(vbCrLf)
   end if
  
   num=num+1

   msg=su_fnum(num,4)&vbTab& _
       re_deal_descr.terrain_global_id&" - "& _
       dbobj_to_2fnum(re_deal_descr.obj_id,re_deal_descr.obj_class)&" - "& _
       re_deal_descr.title

   call m_log.send_msg(msg)
   
   '  . 
   num1=0

   skeep_line=(not re_deal_descr.local_deals.IsEmpty)

   for each local_re_deal in re_deal_descr.local_deals
    num1=num1+1

    msg=su_lstr(" ",9)& _
        dbobj_to_2fnum(local_re_deal.ObjID,local_re_deal.ObjClass)&" - "& _
        build_re_deal_title(re_deal_descr.part_with_num,local_re_deal)
   
    if(not (re_deal_descr.oc2_obj_data is nothing))then
     if(not equal_re_deal_number(re_deal_descr.oc2_obj_data.PropSets(re_deal_descr.part_with_num), _
                                 local_re_deal.PropSets(re_deal_descr.part_with_num)))then
      msg=msg&" - number is changed"
     end if
    end if
    
    call m_log.send_msg(vbTab&msg)
   next 'local_re_deal
  next 're_deal_descr
 end sub 'print_re_deals
 
 '------------------------------------------------------------------------
 function dbobj_to_2fnum(byval obj_id,byval obj_class)
  obj_id    =su_fnum_sn(obj_id,6)
  obj_class =su_fnum_sn(obj_class,5)
  
  dbobj_to_2fnum="["&obj_id&":"&obj_class&"]"
 end function 'dbobj_to_2fnum

 '------------------------------------------------------------------------
 function equal_re_deal_number(props1,props2)
  equal_re_deal_number=false
  
  dim n,x
  n=array("num_reg","num_year","num_jur","num")
  
  for each x in n
   if(not su_equal_db_value(props1(x,false).value,props2(x,false).value))then
    exit function
   end if
  next
  
  equal_re_deal_number=true
 end function 'equal_re_deal_number
 
 '------------------------------------------------------------------------
 private sub get_element_obj(re_deal_descr,element_data)
  set re_deal_descr.oc2_obj_data=nothing

  if(IsNull(element_data))then
   re_deal_descr.title="null element data"
   
   exit sub
  end if

  call m_oc2_obj_ldr.Objects.Clear()

  dim err_code
  dim err_descr
  
  on error resume next
  
  call m_oc2_obj_ldr.LoadObject(element_data)

  err_code  =err.number
  err_descr =err.description
  
  call err.clear()
  
  on error goto 0

  if(err_code<>0)then
   re_deal_descr.title="error: fail unpack element data"

   call m_log.inc_error_count()

   exit sub
  end if

  '--------------------------
  if(m_oc2_obj_ldr.Objects.Count=0)then
   re_deal_descr.title="error: element data without object"

   call m_log.inc_error_count()

   exit sub
  end if

  '--------------------------
  if(m_oc2_obj_ldr.Objects.Count>1)then
   re_deal_descr.title="error: many objects in element data"
   
   call m_log.inc_error_count()
   
   exit sub
  end if

  '--------------------------
  on error resume next

  re_deal_descr.title=build_re_deal_title(re_deal_descr.part_with_num,m_oc2_obj_ldr.Objects(0))
  
  err_code  =err.number
  err_descr =err.description
  
  call err.clear()
  
  on error goto 0
  
  if(err_code<>0)then
   re_deal_descr.title="fail build object descriptor"
   
   call m_log.inc_error_count()
   
   exit sub
  end if
  
  '-------------------------
  set re_deal_descr.oc2_obj_data=m_oc2_obj_ldr.Objects(0)
 end sub 'get_element_obj
 
 '------------------------------------------------------------------------
 private sub scan_re_deals_in_target_db(pack_srv,         _
                                        pack_terrain_id,  _
                                        re_deal_descr)
  if(m_target_svc is nothing)then exit sub
  
  '    
  call scan_re_deal_by_born_id(re_deal_descr,                   _
                               re_deal_descr.terrain_global_id, _
                               re_deal_descr.table_id,          _
                               re_deal_descr.obj_id,            _
                               re_deal_descr.obj_class)
  
  '   BORN-
  dim rs
  set rs=pack_srv.get_born_ids(pack_terrain_id, _
                               re_deal_descr.data_id)
  
  while(not rs.eof)
   'TODO:      BORN-

   call scan_re_deal_by_born_id(re_deal_descr,                       _
                                rs("born_terrain_global_id").value,  _
                                rs("born_table_id").value,           _
                                rs("born_id1").value,                _
                                rs("born_id2").value)

   call rs.movenext()
  wend
 end sub 'scan_re_deals_in_target_db

 '------------------------------------------------------------------------
 private sub scan_re_deal_by_born_id(re_deal_descr,           _
                                     born_terrain_global_id,  _
                                     born_table_id,           _
                                     born_id,                 _
                                     born_class)
  dim msg

  dim local_id_rs
  set local_id_rs=m_target_svc.map_born_id_cmd.execute(born_terrain_global_id, _
                                                       born_table_id,          _
                                                       born_id,                _
                                                       born_class,             _
                                                       null,                   _
                                                       null,                   _
                                                       null,                   _
                                                       null,                   _
                                                       null,                   _
                                                       null)
  
  while(not local_id_rs.eof)
   call process_local_obj(re_deal_descr,local_id_rs)
  
   call local_id_rs.movenext()
  wend
  
 end sub 'scan_re_deal_by_born_id
 
 '------------------------------------------------------------------------
 private sub process_local_obj(re_deal_descr,local_id)
  dim local_obj_id
  dim local_obj_class

  local_obj_id    =local_id("id1").value
  local_obj_class =local_id("id2").value

  '  
  if(re_deal_descr.obj_class<>local_obj_class)then
   msg="   "

   call m_log.send_error(-1,c_err_source,mng)
   
   exit sub
  end if

  '  
  if(not m_target_svc.class_mng.ObjectIsExists(local_obj_id,local_obj_class))then
   exit sub
  end if

  'TODO:     
  dim re_deal_obj
  for each re_deal_obj in re_deal_descr.local_deals
   if(re_deal_obj.ObjID=local_obj_id and re_deal_obj.ObjClass=local_obj_class)then
    exit sub
   end if
  next 're_deal_obj

  '   
  set re_deal_obj=m_target_svc.obj_loader.LoadData(local_obj_id,local_obj_class,0)

  re_deal_descr.local_deals.PushBack(re_deal_obj)
 end sub 'process_local_obj

 '------------------------------------------------------------------------
 private function build_re_deal_title(part_with_num,object_data)
  dim props
  
  set props=object_data.PropSets(part_with_num,false)

  dim t

  t=su_fnum_sn(props("num_reg",false).value,6)&"/"& _
    su_fnum_sn(props("num",false).value,6)&"-"& _
    su_fnum_sn(props("num_jur",false).value,2)&"/"& _
    su_fnum_sn(props("num_year",false).value,4)
    
  build_re_deal_title=t
 end function 'build_re_deal_title
end class 't_prog_scan_rpl_re_deals

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
