'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'XBackup.   
'                                                 . 26.08.2005.

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'  

const c_def_oledb_provider              ="LCPI.IBProvider"

const c_def_source_ctype                ="win1251"
const c_def_source_user                 ="gamer"
const c_def_source_pswd                 ="vermut"

const c_def_pack_ctype                  ="win1251"
const c_def_pack_user                   ="gamer"
const c_def_pack_pswd                   ="vermut"

const c_def_app_name                    ="prog_build_rpl_backup_collection"

const c_def_allow_ui                    =false
const c_def_timeout_sec                 =600

const c_def_xbackup_plugin_name         ="rpl.xbackup.plugin"

const c_def_backup_plugin_name          ="rpl.backup.plugin"
const c_def_backup_mps                  =20000
const c_def_backup_mpc                  =0
const c_def_backup_rpl_event            =false

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'XML elements

private const c_xml_smap_tag_root                     ="script_map"
private const c_xml_smap_tag_script                   ="script"

private const c_xml_smap_attr_script_table_id         ="table_id"
private const c_xml_smap_attr_script_table_name       ="table_name"
private const c_xml_smap_attr_script_name             ="name"

'   [optional]
private const c_xml_smap_attr_init                    ="init"

'-------------------------------------------------------------------------
'       

private const c_xml_emap_tag_root                     ="elements"
private const c_xml_emap_tag_element                  ="element"

private const c_xml_emap_attr_element_type            ="type"

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'  

const c_prog_arg_source_cn_str                ="source_cn_str"
const c_prop_arg_source_db                    ="source_db"

const c_prog_arg_source_ids                   ="source_ids"
const c_prog_arg_xplugin_script               ="xplugin"
const c_prog_arg_xscripts_map                 ="xscripts_map"

const c_prog_arg_allow_ui                     ="allow_ui"
const c_prog_arg_log_dir                      ="log_dir"
const c_prog_arg_log_file                     ="log_file"
const c_prog_arg_mail_cfg                     ="mail_cfg"
const c_prog_arg_app_name                     ="app_name"

'-------
const c_prog_arg_pack_cn_str                  ="pack_cn_str"
const c_prog_arg_pack_db                      ="pack_db"

const c_prog_arg_backup_mps                   ="backup_mps"
const c_prog_arg_backup_mpc                   ="backup_mpc"
const c_prog_arg_backup_rpl_event             ="backup_rpl_event"

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_prog_build_rpl_backup_collection

class t_prog_build_rpl_backup_collection
 private c_err_source

 private m_fso

 private m_source_cn        '    
 private m_pack_cn          '    

 private m_source_ids_file_name  '      

 private m_log
 private m_log_dir

 private m_allow_ui

 private m_xplugin_script   '   XPLUGIN-
 private m_xplugin_se       '  XPLUGIN-

 private m_xbackup_journal
 private m_xbackup_record
 private m_xbackup_ctx
 private m_xbackup_log

 private m_xscripts_map_file '      
 private m_xscripts_map      'dictionary: table_id -> t_table_xbackup_scripts

 '   
 private m_build_rpl_pack

 private m_backup_mps
 private m_backup_mpc
 private m_backup_rpl_event

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_prog_build_rpl_backup_collection"

  set m_fso             = nothing
  set m_source_cn       = nothing
  set m_pack_cn         = nothing

  set m_log             = nothing

  m_allow_ui            = c_def_allow_ui

  m_xplugin_script      = c_def_xbackup_plugin_name
  set m_xplugin_se      = nothing

  set m_xbackup_journal = nothing
  set m_xbackup_record  = nothing
  set m_xbackup_ctx     = nothing
  set m_xbackup_log     = nothing

  set m_xscripts_map    = nothing

  m_build_rpl_pack      = false

  m_backup_mps          = c_def_backup_mps
  m_backup_mpc          = c_def_backup_mpc
  m_backup_rpl_event    = c_def_backup_rpl_event
 end sub 'class_initialize

 '------------------------------------------------------------------------
 public sub init(log,args)
  set m_log=log

  '---------
  set m_fso=createobject("Scripting.FileSystemObject")

  '---------
  m_source_ids_file_name =args.arg_by_name(c_prog_arg_source_ids).value

  '---------
  m_allow_ui = args.has_arg(c_prog_arg_allow_ui)

  m_log_dir  = args.value_by_name(c_prog_arg_log_dir, _
                                  empty)

  '---------
  m_xplugin_script     = args.value_by_name(c_prog_arg_xplugin_script, _
                                            c_def_xbackup_plugin_name)

  m_xscripts_map_file  = args.arg_by_name(c_prog_arg_xscripts_map).value

  '---------     
  dim backup_pack_cn_str

  backup_pack_cn_str=build_cn_str(args,                    _
                                  c_prog_arg_pack_cn_str,  _
                                  c_prog_arg_pack_db,      _
                                  c_def_pack_user,         _
                                  c_def_pack_pswd,         _
                                  c_def_pack_ctype)

  m_build_rpl_pack=backup_pack_cn_str<>""

  if(m_build_rpl_pack)then
   m_backup_mps=args.value_by_name(c_prog_arg_backup_mps, _
                                          c_def_backup_mps)

   m_backup_mpc=args.value_by_name(c_prog_arg_backup_mpc, _
                                          c_def_backup_mpc)

   m_backup_rpl_event=args.has_arg(c_prog_arg_backup_rpl_event)
  end if 'm_build_rpl_pack

  '---------
  dim source_cn_str
  
  source_cn_str=build_cn_str(args,                        _
                             c_prog_arg_source_cn_str,    _
                             c_prop_arg_source_db,        _
                             c_def_source_user,           _
                             c_def_source_pswd,           _
                             c_def_source_ctype)
  
  if(source_cn_str="")then
   call err.raise(-1,typename(me),"    ")
  end if

  set m_source_cn=create_connection("SOURCE Database",source_cn_str)

  '---------
  if(m_build_rpl_pack)then
   set m_pack_cn=create_connection("RPL_PACK Database",backup_pack_cn_str)
  end if
 end sub 'init

 '------------------------------------------------------------------------
 private function build_cn_str(args,            _
                               argn_with_cn,    _
                               argn_with_db,    _
                               def_cn_user,     _
                               def_cn_pswd,     _
                               def_cn_ctype)
  if(args.has_arg(argn_with_cn))then
   build_cn_str=args.arg_by_name(argn_with_cn).value
   
   exit function
  end if
  
  '---------
  if(args.has_arg(argn_with_db))then
   build_cn_str="provider="&c_def_oledb_provider&";"&                  _
                "location="&args.arg_by_name(argn_with_db).value&";"&  _
                "user id="&def_cn_user&";"&                            _
                "password="&def_cn_pswd&";"&                           _
                "ctype="&def_cn_ctype

   exit function
  end if

  '    
 end function 'build_cn_str
 
 '------------------------------------------------------------------------
 public sub run()
  '  
  '     
  '  TableID   
  '   

  '--------------
  call start_work()

  '--------------   
  call init_obj()

  '--------------
  call load_xplugin()

  '--------------     
  call load_xscripts_map()

  '--------------     
  call load_source_ids()

  '--------------    
  call process_journal()

  '--------------
  call finish_xbackup()

  '--------------  
  if(m_build_rpl_pack)then
   call run_rpl_backup()
  end if

  '--------------
  call finish_work()
 end sub 'run

 '------------------------------------------------------------------------
 private sub start_work()
  call m_log.send_msg("")
  call m_log.send_msg("START TRANS IN SOURCE DATABASE")

  m_source_cn.IsolationLevel=65536

  call m_source_cn.BeginTrans()
 end sub 'start_work

 '------------------------------------------------------------------------
 private sub finish_work()
  call m_log.send_msg("")
  call m_log.send_msg("COMMIT TRANS IN SOURCE DATABASE")

  call m_source_cn.CommitTrans()
 end sub 'finish_work

 '------------------------------------------------------------------------
 private sub finish_xbackup()
  call m_xplugin_se.Run("on_finish",m_xbackup_ctx)
 end sub 'finish_xbackup

 '------------------------------------------------------------------------
 private sub init_obj()
  call m_log.send_msg("create backup journal")

  set m_xbackup_journal=new t_rpl_backup_engine_journal

  set m_xbackup_journal.connection=m_source_cn

  '--------------
  set m_xbackup_log=new t_rpl_engine_log

  '--------------
  call m_log.send_msg("create backup context")

  set m_xbackup_ctx=new t_rpl_backup_engine_context

  call m_xbackup_ctx.init(m_source_cn,m_xbackup_journal,m_xbackup_log)

  '--------------
  call m_log.send_msg("create backup record object")

  set m_xbackup_record=new t_rpl_backup_engine_record

  call m_xbackup_record.init(m_xbackup_journal)
 end sub 'init_obj

 '------------------------------------------------------------------------
 private sub load_xplugin()
  call m_log.send_msg(" XPLUGIN ["&m_xplugin_script&"]")

  set m_xplugin_se=createobject("LCPI.DBS.ScriptExecutor")

  m_xplugin_se.connection=m_source_cn

  call m_xplugin_se.LoadByNameFromDatabase(m_xplugin_script)

  m_xplugin_se.Timeout =1000*c_def_timeout_sec
  m_xplugin_se.AllowUI =m_allow_ui

  '---------
  call m_xplugin_se.Run("on_start",m_xbackup_ctx)
 end sub 'load_xplugin

 '------------------------------------------------------------------------
 private sub load_xscripts_map()
  call m_log.send_msg("load xscripts map from ["&m_xscripts_map_file&"]")

  set m_xscripts_map=createobject("Scripting.Dictionary")

  dim xml_doc
  set xml_doc=xml_load_param_file(m_xscripts_map_file,c_err_source)

  dim root_node
  set root_node=xml_get_node(xml_doc,c_xml_smap_tag_root,true)

  dim script_nodes
  set script_nodes=root_node.selectNodes(c_xml_smap_tag_script)

  dim script_node

  dim table_id
  dim table_name
  dim script_name

  dim init_prog '   

  dim script_holder
  dim msg

  dim table_xscripts 't_table_xbackup_scripts

  dim xscript_holder_map 'script_name -> script_holder
  set xscript_holder_map=createobject("Scripting.Dictionary")

  '    
  dim class_mng
  set class_mng=createobject("LCPI.DBS.SYS.DBClassManager")

  class_mng.Connection=m_source_cn

  call class_mng.Load()

  for each script_node in script_nodes
   if(xml_read_attr_str(script_node,c_xml_smap_attr_script_table_name,false,table_name))then
    '  
    table_id=class_mng.Tables.ItemByName(table_name).id
   else
    call xml_read_attr_lng(script_node,c_xml_smap_attr_script_table_id,true,table_id)
   end if

   'script_name
   call xml_read_attr_str(script_node,c_xml_smap_attr_script_name,true,script_name)

   '     
   if(m_xscripts_map.Exists(table_id))then
    set table_xscripts=m_xscripts_map(table_id)
   else
    set table_xscripts=new t_table_xbackup_scripts

    call table_xscripts.init(table_id)

    set m_xscripts_map(table_id)=table_xscripts
   end if

   '-----------------
   if(xml_read_attr_str(script_node,c_xml_smap_attr_init,false,init_prog))then
    set script_holder=new t_rpl_engine_script_holder

    call script_holder.init_by_name(script_name)

    '   
    call m_log.send_msg("  ["&script_name&"]  ["&cstr(table_id)&"]")

    call script_holder.script(m_source_cn).Run(init_prog,script_node)

   elseif(xscript_holder_map.Exists(script_name))then '  script_holder

    set script_holder=xscript_holder_map(script_name)

   else
    set script_holder=new t_rpl_engine_script_holder

    call script_holder.init_by_name(script_name)

    set xscript_holder_map(script_name)=script_holder
   end if

   ' 
   call table_xscripts.add_script(script_holder)
  next 'script_node
 end sub 'load_xscripts_map

 '------------------------------------------------------------------------
 private sub load_source_ids()
  call m_log.send_msg("")
  call m_log.send_msg("load source ids ...")

  '------------------    
  dim xmaps
  set xmaps=createobject("Scripting.Dictionary")
  
  set xmaps("")          =create_xmap_obj_id_std()
  set xmaps("re_deal")   =create_xmap_obj_id_by_deal_num(m_source_cn)

  '------------------
  dim xml_doc
  set xml_doc=xml_load_param_file(m_source_ids_file_name,c_err_source)

  dim root_node
  set root_node=xml_get_node(xml_doc,c_xml_emap_tag_root,true)

  dim element_nodes
  set element_nodes=root_node.selectNodes(c_xml_emap_tag_element)
  
  dim element_node
  dim element_type

  dim obj_id
  dim obj_class

  dim msg

  for each element_node in element_nodes
   '   
   element_type=xml_read_attr_str_ex(element_node,c_xml_emap_attr_element_type,"","")
   
   if(not xmaps.exists(element_type))then
    msg="    ["&element_type&"]"
    
    call err.raise(-1,c_err_source,msg)
   end if
   
   call xmaps(element_type).map(element_node,obj_id,obj_class)
   
   '    
   call m_xbackup_journal.AddObj(obj_id,obj_class)
  next 'element_node
 end sub 'load_source_ids

 '------------------------------------------------------------------------
 private sub process_journal()
  const c_notify_step=10

  call m_log.send_msg("process backup journal")

  dim i
  i=0

  while(i<m_xbackup_journal.size)
   if(((i+1) mod c_notify_step)=0)then
    call wscript.echo("process [cur:"&cstr(i+1)&"][total:"&cstr(m_xbackup_journal.size)&"]")
   end if

   call process_record(i)

   i=i+1
  wend 'i<m_xbackup_journal.Count

  call wscript.echo("total processed:"&i)
 end sub 'process_journal

 '------------------------------------------------------------------------
 private sub process_record(i)
  '   
  call m_xbackup_record.set_record_data(m_xbackup_journal.Item(i))

  '   
  dim script_holder
  set script_holder=get_script_holders(m_xbackup_record.TableID)

  '   ,      

  if(script_holder is nothing)then exit sub

  ' 
  dim err_code
  dim err_source
  dim err_descr

  on error resume next

  call script_holder.execute(m_source_cn,"on_backup",m_xbackup_ctx,m_xbackup_record)

  err_code    =err.number
  err_source  =err.source
  err_descr   =err.description

  call err.clear()

  on error goto 0

  if(err_code=0)then exit sub

  ' 
  call m_log.send_error(err_code,err_source,err_descr)

  dim msg
  msg=" x-  "&m_xbackup_record.as_str()

  call err.raise(-1,c_err_source,msg)
 end sub 'process_record

 '------------------------------------------------------------------------
 private function get_script_holders(table_id) 't_table_xbackup_scripts
  set get_script_holders=nothing

  if(not m_xscripts_map.exists(table_id))then
   exit function
  end if

  set get_script_holders=m_xscripts_map(table_id)
 end function 'get_script_holders

 '------------------------------------------------------------------------
 private sub run_rpl_backup()
  call m_log.send_msg("-------------------")
  call m_log.send_msg("RUN RPL_BACKUP")

  '    
  '   
  '  
  '  
  '   
  '  -         
  '  

  '--------
  dim backup_eng
  set backup_eng=createobject("LCPI.DBS.RPL.BackupEngine")

  backup_eng.Params.MaxPackSize      =m_backup_mps
  backup_eng.Params.MaxPackCount     =m_backup_mpc
  backup_eng.Params.CloseLogElements =true
  backup_eng.Params.CommitEachPack   =true
  backup_eng.Params.BackupMode       =1 'rplBackMode_Compact
  backup_eng.Params.PluginScriptID   =c_def_backup_plugin_name
  backup_eng.Params.ScriptsCatID     =1300
  backup_eng.Params.CalcTotalCount   =false
  backup_eng.Params.CheckLinkID      =1 'rplBackCheckLink_ObjectID

  backup_eng.Params.AllowUI          =m_allow_ui
  backup_eng.Params.Timeout          =c_def_timeout_sec

  backup_eng.Params.PackCatID        =2 'rplPackCat_Snapshot

  '   
  if(m_backup_rpl_event)then
   call wscript.ConnectObject(backup_eng,"rpl_backup_eng_")
  end if

  '----------------------
  call m_log.send_msg("START TRANS IN PACK DATABASE")
  call m_pack_cn.BeginTrans()

  '----------------------
  backup_eng.SourceDatabase  =m_source_cn
  backup_eng.PackDatabase    =m_pack_cn

  '----------------------
  call m_log.send_msg(vbCrLf&"Start RPL Backup")

  '----------------------
  on error resume next

  dim err_code
  dim err_source
  dim err_descr

  call backup_eng.Backup(m_xbackup_journal.elements)

  err_code   = err.number
  err_source = err.source
  err_descr  = err.description

  call err.clear()

  on error goto 0

  call m_log.send_msg("")

  if(err_code=0)then
   '   
   call m_log.send_msg("COMMIT TRANS IN PACK DATABASE")

   call m_pack_cn.CommitTrans()
  else
   '   .   
   call m_log.send_error(err_code,err_source,err_descr)

   if(not IsEmpty(m_log_dir))then
    dim backup_log_file_name

    backup_log_file_name=su_get_database_file_name(su_get_cn_one_prop(m_source_cn,"data source name"))

    backup_log_file_name=m_fso.GetBaseName(backup_log_file_name)&"_RPB_"& _
                         su_gen_ts_str()&".log"

    backup_log_file_name=m_fso.BuildPath(m_log_dir, _
                                         backup_log_file_name)

   '  LOG-  
    dim f
    set f=m_fso.OpenTextFile(backup_log_file_name,8,true)

    call f.WriteLine("+++++++++++++++++++++++++++++++++++++++++++++++++++++")
    call f.WriteLine("SOURCE DATABASE:")
    call f.WriteLine(build_str_with_cn_props(m_source_cn))

    call f.WriteLine("+++++++++++++++++++++++++++++++++++++++++++++++++++++")
    call f.WriteLine("PACK DATABASE  :")
    call f.WriteLine(build_str_with_cn_props(m_pack_cn))

    call f.WriteLine("+++++++++++++++++++++++++++++++++++++++++++++++++++++"&vbCrLf)

    call f.Close()
    set f=nothing

    call g_log.send_msg("SAVE RPB LOG ["&backup_log_file_name&"]")

    '   
    call backup_eng.Log.SaveToFile(backup_log_file_name,true)
   end if '     

   call err.raise(-1,c_err_source,"FAIL CREATE RPL PACK")
  end if
 end sub 'run_rpl_backup

 '------------------------------------------------------------------------
 private function create_connection(db_name,cn_str)
  set create_connection=nothing

  call m_log.send_msg("connect to "&db_name&" ...")

  dim cn
  set cn=createobject("ADODB.Connection")

  cn.IsolationLevel=65536

  call cn.Open(cn_str)

  call m_log.send_msg("------------")
  call m_log.send_msg(build_str_with_cn_props(cn))

  set create_connection=cn
 end function 'create_connection

 '------------------------------------------------------------------------
 private function build_str_with_cn_props(cn)
  build_str_with_cn_props= _
   "Database       :"&su_get_cn_one_prop(cn,"data source name")&vbCrLf& _
   "User           :"&su_get_cn_one_prop(cn,"user name")&vbCrLf& _
   "Server Host    :"&su_get_cn_one_prop(cn,"Server Name")&vbCrLf& _
   "Server Type    :"&su_get_cn_one_prop(cn,"DBMS Name")&vbCrLf& _
   "Server Version :"&su_get_cn_one_prop(cn,"DBMS Version")
 end function 'build_str_with_cn_props
end class 't_prog_build_rpl_backup_collection

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'  

sub rpl_backup_eng_OnProgress(state)
 call wscript.echo(rpl_std_backup_eng_OnProgress_Message(state))
end sub 'rpl_backup_eng_OnProgress

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

