'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'    
'                                                . 01.09.2004

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
const c_prog_param_source_gdb         = "source"
const c_prog_param_source_user        = "source_user"
const c_prog_param_source_pswd        = "source_pswd"
const c_prog_param_pack_gdb           = "pack"

const c_prog_param_table              = "t"
const c_prog_param_file_with_tables   = "ft"
const c_prog_param_start_date         = "start_date"

const c_prog_param_backup_mps         = "backup_mps"
const c_prog_param_backup_mpc         = "backup_mpc"
const c_prog_param_backup_allow_ui    = "backup_allow_ui"

const c_prog_param_app_name           = "app_name"
const c_prog_param_mail_cfg           = "mail_cfg"

const c_prog_param_log_dir            = "log_dir"
const c_prog_param_log_sj             = "log_sj"

const c_prog_param_rpl_event          = "rpl_event"

const c_prog_param_pause_after_start  = "pause_after_start"

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_params_rpb_pack

class t_params_rpb_pack
 private c_err_source

 private m_param_source_gdb
 private m_param_source_user
 private m_param_source_pswd
 private m_param_pack_gdb
 
 private m_param_backup_tables     '   
 private m_param_start_date        '    
 
 private m_param_backup_mps        'max pack size
 private m_param_backup_mpc        'max packs count
 private m_param_backup_allow_ui
 
 private m_param_app_name          ' 
 private m_param_mail_cfg          '    
 
 private m_param_log_dir
 private m_param_log_sj            '     
 
 private m_param_rpl_event         '  
 
 private m_param_pause_after_start '   
 
 'constructor ------------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_params_rpb_pack"

  call init()
 end sub 'class_initialize
 
 ' ----------------------------------------------------------
 public sub init()
  m_param_source_gdb        =empty
  m_param_source_user       =empty
  m_param_source_pswd       =empty
  
  m_param_pack_gdb          =empty
  
  set m_param_backup_tables =nothing

  m_param_start_date        =null
  
  m_param_backup_mps        =20000
  m_param_backup_mpc        =320
  m_param_backup_allow_ui   =false
  
  m_param_app_name          ="RPL Backup"
  m_param_mail_cfg          =empty
  
  m_param_log_dir           =empty
  m_param_log_sj            =false
  
  m_param_rpl_event         =false
  m_param_pause_after_start =false
 end sub 'init
 
 '    ----------------------------------
 public sub load_args(args)
  call set_param_str_req(m_param_source_gdb  ,args ,c_prog_param_source_gdb)
  call set_param_str_req(m_param_source_user ,args ,c_prog_param_source_user)
  call set_param_str_req(m_param_source_pswd ,args ,c_prog_param_source_pswd)
  call set_param_str_req(m_param_pack_gdb    ,args ,c_prog_param_pack_gdb)
  
  '   
  dim i_arg
  dim table_name
  
  for i_arg=0 to args.count-1
   if(args.item(i_arg).name=c_prog_param_table)then
    table_name=args.item(i_arg).value
    
    if(table_name="")then
     call err.raise(-1,c_err_source,"empty table name")
    end if
    
    call reg_backup_table(table_name)
   elseif(args.item(i_arg).name=c_prog_param_file_with_tables)then
    call load_table_list(args.item(i_arg).value)
   end if
  next 'i_arg
  
  call set_param_str    (m_param_start_date  ,args ,c_prog_param_start_date)
  
  call set_param_lng    (m_param_backup_mps  ,args ,c_prog_param_backup_mps)
  call set_param_lng    (m_param_backup_mpc  ,args ,c_prog_param_backup_mpc)
  
  m_param_backup_allow_ui=args.has_arg(c_prog_param_backup_allow_ui)
  
  call set_param_str    (m_param_app_name    ,args ,c_prog_param_app_name)
  call set_param_str    (m_param_mail_cfg    ,args ,c_prog_param_mail_cfg)
  call set_param_str    (m_param_log_dir     ,args ,c_prog_param_log_dir)
  
  m_param_log_sj=args.has_arg(c_prog_param_log_sj)
  
  m_param_rpl_event=args.has_arg(c_prog_param_rpl_event)
  
  m_param_pause_after_start=args.has_arg(c_prog_param_pause_after_start)
 end sub 'load_args
 
 'properties -------------------------------------------------------------
 public property get param_source_gdb()
  param_source_gdb=m_param_source_gdb
 end property 'param_source_gdb

 '------------------------------------------------------------------------
 public property get param_source_user()
  param_source_user=m_param_source_user
 end property 'param_source_user

 '------------------------------------------------------------------------
 public property get param_source_pswd()
  param_source_pswd=m_param_source_pswd
 end property 'param_source_pswd

 '------------------------------------------------------------------------
 public property get param_pack_gdb()
  param_pack_gdb=m_param_pack_gdb
 end property 'param_pack_gdb

 '------------------------------------------------------------------------
 public property get param_backup_tables()
  set param_backup_tables=m_param_backup_tables
 end property

 '------------------------------------------------------------------------
 public property get param_start_date()
  param_start_date=m_param_start_date
 end property 'param_start_date
 
 '------------------------------------------------------------------------
 public property get param_backup_mps()
  param_backup_mps=m_param_backup_mps
 end property 'param_backup_mps

 '------------------------------------------------------------------------
 public property get param_backup_mpc()
  param_backup_mpc=m_param_backup_mpc
 end property 'param_backup_mpc

 '------------------------------------------------------------------------
 public property get param_backup_allow_ui()
  param_backup_allow_ui=m_param_backup_allow_ui
 end property

 '------------------------------------------------------------------------
 public property get param_app_name()
  param_app_name=m_param_app_name
 end property 'param_app_name

 '------------------------------------------------------------------------
 public property get param_mail_cfg()
  param_mail_cfg=m_param_mail_cfg
 end property 'param_mail_cfg

 '------------------------------------------------------------------------
 public property get param_log_dir()
  param_log_dir=m_param_log_dir
 end property

 '------------------------------------------------------------------------
 public property get param_log_sj()
  param_log_sj=m_param_log_sj
 end property

 '------------------------------------------------------------------------
 public property get param_rpl_event()
  param_rpl_event=m_param_rpl_event
 end property

 '------------------------------------------------------------------------
 public property get param_pause_after_start()
  param_pause_after_start=m_param_pause_after_start
 end property

 '    ----------------------------
 
 '    
 private sub load_table_list(file_name)
  if(m_param_backup_tables is nothing)then
   set m_param_backup_tables=createobject("LCPI.DBS.Utility.Vector")
  end if
  
  dim fso
  set fso=createobject("Scripting.FileSystemObject")
  
  dim file
  set file=fso.OpenTextFile(file_name,1,false)
  
  'call su_process_last_error("open file ["&file_name&"]")
  
  dim t
  
  while(not file.AtEndOfStream)
   t=trim(file.ReadLine)
   
   'su_process_last_error("read line from file ["&file_name&"]")
   
   if(t<>"")then
    call m_param_backup_tables.PushBack(t)
   end if
  wend
 end sub'load_table_list
 
 '  
 private sub reg_backup_table(table_name)
  if(m_param_backup_tables is nothing)then
   set m_param_backup_tables=createobject("LCPI.DBS.Utility.Vector")
  end if

  call m_param_backup_tables.PushBack(table_name)
 end sub 'reg_backup_table
 
 '  
 private sub set_param_str_req(byref x,args,name)
  if(not args.has_arg(name))then
   call print_error_and_exit("not defined program argument ["&name&"]")
  end if
 
  dim t
  
  t=trim(args.arg_by_name(name).value)
 
  if(len(t)=0)then
   call print_error_and_exit("empty value of program argument ["&name&"]")
  end if

  x=t
 end sub 'set_param_str_req
 
 '------------------------------------------------------------------------
 '  
 private sub set_param_str(byref x,args,name)
  if(not args.has_arg(name))then
   exit sub
  end if

  dim t

  t=trim(args.arg_by_name(name).value)

  if(len(t)=0)then
   call print_error_and_exit("empty value of program argument ["&name&"]")
  end if

  x=t
 end sub 'set_param_str

 '------------------------------------------------------------------------
 '  
 private sub set_param_lng(byref x,args,name)
  if(not args.has_arg(name))then
   exit sub
  end if
  
  dim t
  
  t=trim(args.arg_by_name(name).value)
  
  if(not IsNumeric(t))then
   call print_error_and_exit("incorrect integer value of program argument ["&name&"]")
  end if
  
  x=clng(t)
 end sub 'set_param_lng

 '------------------------------------------------------------------------
 private sub print_error_and_exit(msg)
  call su_print_error_and_exit(-1,msg)
 end sub 'print_error_and_exit
end class 't_params_rpb_pack

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

