'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'      
'                                       . 1  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
const c_prog_param_terrain_id           = "terrain_id"
const c_prog_param_terrain_global_id    = "terrain_global_id"
const c_prog_param_process_unk_terrain  = "process_unk_terrain"
const c_prog_param_pack_id              = "pack_id"
const c_prop_param_pack_all             = "pack_all"
const c_prop_param_ignore_restored      = "ir"
const c_prog_param_target_gdb           = "target"
const c_prog_param_pack_gdb             = "pack"

const c_prog_param_mail_cfg             = "mail_cfg"
const c_prog_param_app_name             = "app_name"

const c_prog_param_group_log_files      = "group_log_files"

const c_prog_param_log_dir              = "log_dir"
const c_prog_param_log_sj               = "log_sj"

const c_prog_param_rpl_event            = "rpl_event"

const c_prog_param_pause_after_start    = "pause_after_start"

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_params_rpr_pack

class t_params_rpr_pack
 private c_err_source
 
 '-------------------------
 private m_param_terrain_id
 private m_param_terrain_global_id
 private m_param_process_unk_terrain
 private m_param_pack_id
 private m_param_pack_all
 private m_param_ignore_restored
 private m_param_target_gdb
 private m_param_pack_gdb

 private m_param_mail_cfg
 private m_param_app_name

 private m_param_log_dir
 private m_param_log_sj

 private m_param_group_log_files

 private m_param_rpl_event

 private m_param_pause_after_start

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_params_rpr_pack"
  
  call init()
 end sub 'class_initialize
 
 ' ----------------------------------------------------------
 public sub init()
  m_param_terrain_id           =null
  m_param_terrain_global_id    =null
  m_param_process_unk_terrain  =false
  m_param_pack_id              =null
  m_param_pack_all             =false
  m_param_ignore_restored      =false
  m_param_target_gdb           =empty
  m_param_pack_gdb             =empty
  m_param_log_dir              =empty
  
  m_param_app_name             ="RESTORE SINGLE RPL_PACK"
  m_param_mail_cfg             =empty
  
  m_param_log_sj               =false
  
  m_param_group_log_files      =false
  
  m_param_rpl_event            =false
  
  m_param_pause_after_start    =false
 end sub 'init
 
 '    ----------------------------------
 public sub load_args(args)
  m_param_pack_all=args.has_arg(c_prop_param_pack_all)
  
  m_param_ignore_restored=args.has_arg(c_prop_param_ignore_restored)

  m_param_process_unk_terrain=args.has_arg(c_prog_param_process_unk_terrain)

  if(m_param_pack_all)then
   '    
   call set_param_lng(m_param_terrain_id         ,args ,c_prog_param_terrain_id)
   call set_param_str(m_param_terrain_global_id  ,args ,c_prog_param_terrain_global_id)

  else
   '     ,   
   '    

   call set_param_lng_vector_req(m_param_pack_id    ,args ,c_prog_param_pack_id)
   call set_param_lng(m_param_terrain_id            ,args ,c_prog_param_terrain_id)
   call set_param_str(m_param_terrain_global_id     ,args ,c_prog_param_terrain_global_id)
   
   if(IsNull(m_param_terrain_id) and IsNull(m_param_terrain_global_id))then
    call err.raise(-1,c_err_source,"not defined argument with terrain [global] id.")
   end if
  end if
  
  if((not IsNull(m_param_terrain_id)) and (not IsNull(m_param_terrain_global_id)))then
   call err.raise(-1,c_err_source,"can't use ["&c_prog_param_terrain_id&"] and "& _
                                  "["&c_prog_param_terrain_global_id&"] in one time.")
  end if
  
  call set_param_str_req(m_param_target_gdb  ,args ,c_prog_param_target_gdb)
  call set_param_str_req(m_param_pack_gdb    ,args ,c_prog_param_pack_gdb)

  call set_param_str    (m_param_app_name    ,args ,c_prog_param_app_name)
  call set_param_str    (m_param_mail_cfg    ,args ,c_prog_param_mail_cfg)
  call set_param_str    (m_param_log_dir     ,args ,c_prog_param_log_dir)

  m_param_log_sj=args.has_arg(c_prog_param_log_sj)

  m_param_group_log_files   =args.has_arg(c_prog_param_group_log_files)
  m_param_rpl_event         =args.has_arg(c_prog_param_rpl_event)
  m_param_pause_after_start =args.has_arg(c_prog_param_pause_after_start)
 end sub 'load_args

 'properties -------------------------------------------------------------
 public property get param_pack_all()
  param_pack_all=m_param_pack_all
 end property
 
 '------------------------------------------------------------------------
 public property get param_ignore_restored()
  param_ignore_restored=m_param_ignore_restored
 end property
 
 '------------------------------------------------------------------------
 public property get param_terrain_id()
  param_terrain_id=m_param_terrain_id
 end property

 '------------------------------------------------------------------------
 public property get param_terrain_global_id()
  param_terrain_global_id=m_param_terrain_global_id
 end property

 '------------------------------------------------------------------------
 public property get param_process_unk_terrain()
  param_process_unk_terrain=m_param_process_unk_terrain
 end property

 '------------------------------------------------------------------------
 public property get param_pack_id()
  set param_pack_id=m_param_pack_id
 end property

 '------------------------------------------------------------------------
 public property get param_target_gdb()
  param_target_gdb=m_param_target_gdb
 end property

 '------------------------------------------------------------------------
 public property get param_pack_gdb()
  param_pack_gdb=m_param_pack_gdb
 end property
 
 '------------------------------------------------------------------------
 public property get param_app_name()
  param_app_name=m_param_app_name
 end property

 '------------------------------------------------------------------------
 public property get param_mail_cfg()
  param_mail_cfg=m_param_mail_cfg
 end property

 '------------------------------------------------------------------------
 public property get param_log_dir()
  param_log_dir=m_param_log_dir
 end property

 '------------------------------------------------------------------------
 public property get param_log_sj()
  param_log_sj=m_param_log_sj
 end property

 '------------------------------------------------------------------------
 public property get param_group_log_files()
  param_group_log_files=m_param_group_log_files
 end property

 '------------------------------------------------------------------------
 public property get param_rpl_event()
  param_rpl_event=m_param_rpl_event
 end property

 '------------------------------------------------------------------------
 public property get param_pause_after_start()
  param_pause_after_start=m_param_pause_after_start
 end property

 '    ----------------------------

 '  
 private sub set_param_str_req(byref x,args,name)
  if(not args.has_arg(name))then
   call print_error_and_exit("not defined program argument ["&name&"]")
  end if

  dim t

  t=trim(args.arg_by_name(name).value)

  if(len(t)=0)then
   call print_error_and_exit("empty value of program argument ["&name&"]")
  end if

  x=t
 end sub 'set_param_str_req

 '------------------------------------------------------------------------
 '  
 private sub set_param_lng_req(byref x,args,name)
  if(not args.has_arg(name))then
   call print_error_and_exit("not defined program argument ["&name&"]")
  end if

  dim t

  t=trim(args.arg_by_name(name).value)

  if(not IsNumeric(t))then
   call print_error_and_exit("incorrect integer value of program argument ["&name&"]")
  end if

  x=clng(t)
 end sub 'set_param_lng_req
 
 '------------------------------------------------------------------------
 private sub set_param_lng_vector_req(byref x,args,name)
  if(not args.has_arg(name))then
   call print_error_and_exit("not defined program argument ["&name&"]")
  end if
  
  dim t
  set t = createobject("LCPI.DBS.Utility.Vector")
  
  dim arg
  for each arg in args.get_args(name)

   if(not IsNumeric(trim(arg.value)))then
    call print_error_and_exit("incorrect integer value of program argument ["&name&"]")
   end if

   call t.pushback(clng(trim(arg.value)))
  next' arg
  
  set x = t
 end sub'set_param_lng_vector_req

 '------------------------------------------------------------------------
 '  
 private sub set_param_str(byref x,args,name)
  if(not args.has_arg(name))then
   exit sub
  end if

  dim t

  t=trim(args.arg_by_name(name).value)

  if(len(t)=0)then
   call print_error_and_exit("empty value of program argument ["&name&"]")
  end if

  x=t
 end sub 'set_param_str

 '------------------------------------------------------------------------
 '  
 private sub set_param_lng(byref x,args,name)
  if(not args.has_arg(name))then
   exit sub
  end if

  dim t

  t=trim(args.arg_by_name(name).value)

  if(not IsNumeric(t))then
   call print_error_and_exit("incorrect integer value of program argument ["&name&"]")
  end if

  x=clng(t)
 end sub 'set_param_lng

 '------------------------------------------------------------------------
 private sub print_error_and_exit(msg)
  call su_print_error_and_exit(-1,msg)
 end sub 'print_error_and_exit
end class 't_params_rpr_pack

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

