'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'     
'                                       . 27  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'  XML-  

const c_ptd_xml_tag_ROOT                       ="params"

const c_ptd_xml_tag_prog_name                  ="prog_name"

const c_ptd_xml_tag_lock_file                  ="lock_file"
const c_ptd_xml_tag_gbak_exe                   ="gbak_exe"

const c_ptd_xml_tag_mail_cfg                   ="mail_cfg"
const c_ptd_xml_tag_log_dir                    ="log_dir"
const c_ptd_xml_tag_log_file                   ="log_file"
const c_ptd_xml_tag_gbk_dir                    ="gbk_dir"
const c_ptd_xml_tag_zip_dir                    ="zip_dir"

const c_ptd_xml_tag_db_source                  ="source"
const c_ptd_xml_tag_db_target                  ="target"

const c_ptd_xml_tag_db_host                    ="host"
const c_ptd_xml_tag_db_location                ="location"
const c_ptd_xml_tag_db_user                    ="user"
const c_ptd_xml_tag_db_password                ="password"

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_params_transfer_database

class t_params_transfer_database
 private c_err_source

 private m_param_prog_name
 
 private m_source_db_descr
 private m_target_db_descr

 private m_param_gbak_exe
 private m_param_lock_file

 private m_param_mail_cfg
 private m_param_log_dir
 private m_param_log_file

 private m_param_gbk_dir
 private m_param_zip_dir
 
 'constructor ------------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_params_transfer_database"
  
  call init()
 end sub 'class_initialize
 
 '------------------------------------------------------------------------
 private sub init()
  m_param_prog_name="Transfer_Database"
  
  set m_source_db_descr =new t_db_descr
  set m_target_db_descr =new t_db_descr
  
  m_param_gbak_exe  =empty
  m_param_lock_file =empty
  m_param_mail_cfg  =empty
  m_param_log_dir   =empty
  m_param_log_file  =empty
  m_param_gbk_dir   =empty
  m_param_zip_dir   =empty
 end sub 'init
 
 'properties -------------------------------------------------------------
 public property get param_prog_name()
  param_prog_name=m_param_prog_name
 end property
 
 public property get source_db_descr()
  set source_db_descr=m_source_db_descr
 end property
 
 public property get target_db_descr()
  set target_db_descr=m_target_db_descr
 end property
 
 public property get param_gbak_exe()
  param_gbak_exe=m_param_gbak_exe
 end property
 
 public property get param_lock_file()
  param_lock_file=m_param_lock_file
 end property
 
 public property get param_mail_cfg()
  param_mail_cfg=m_param_mail_cfg
 end property
 
 public property get param_log_dir()
  param_log_dir=m_param_log_dir
 end property
 
 public property get param_log_file()
  param_log_file=m_param_log_file
 end property
 
 public property get param_gbk_dir()
  param_gbk_dir=m_param_gbk_dir
 end property
 
 public property get param_zip_dir()
  param_zip_dir=m_param_zip_dir
 end property
 
 'load from file ---------------------------------------------------------
 public sub load(param_file_location)
  dim s
 
  dim xml_doc
  set xml_doc=xml_load_param_file(param_file_location,c_err_source)

  'ROOT tag -------------------------------------
  dim node_root
  set node_root=xml_get_node(xml_doc,c_ptd_xml_tag_ROOT,true)

  call xml_read_prop_str(node_root,c_ptd_xml_tag_prog_name ,false,m_param_prog_name)
  call xml_read_prop_str(node_root,c_ptd_xml_tag_lock_file ,true ,m_param_lock_file)
  call xml_read_prop_str(node_root,c_ptd_xml_tag_gbak_exe  ,true ,m_param_gbak_exe)

  call xml_read_prop_str(node_root,c_ptd_xml_tag_mail_cfg  ,false,m_param_mail_cfg)

  call xml_read_prop_str(node_root,c_ptd_xml_tag_log_dir   ,true ,m_param_log_dir)
  call xml_read_prop_str(node_root,c_ptd_xml_tag_log_file  ,true ,m_param_log_file)
  
  call xml_read_prop_str(node_root,c_ptd_xml_tag_gbk_dir   ,true ,m_param_gbk_dir)
  call xml_read_prop_str(node_root,c_ptd_xml_tag_zip_dir   ,true ,m_param_zip_dir)
  
  'source tag -----------------------------------
  dim node_db
  set node_db=xml_get_node(node_root,c_ptd_xml_tag_db_source,true)

  if(xml_read_prop_str(node_db,c_ptd_xml_tag_db_host,false,s))then
   m_source_db_descr.host=s
  end if
  
  if(xml_read_prop_str(node_db,c_ptd_xml_tag_db_location,true,s))then
   m_source_db_descr.location=s
  end if
  
  if(xml_read_prop_str(node_db,c_ptd_xml_tag_db_user,true,s))then
   m_source_db_descr.user_name=s
  end if
   
  if(xml_read_prop_str(node_db,c_ptd_xml_tag_db_password,true,s))then
   m_source_db_descr.password=s
  end if

  'target tag -----------------------------------
  set node_db=xml_get_node(node_root,c_ptd_xml_tag_db_target,true)

  if(xml_read_prop_str(node_db,c_ptd_xml_tag_db_location,true,s))then
   m_target_db_descr.location=s
  end if

  if(xml_read_prop_str(node_db,c_ptd_xml_tag_db_user,true,s))then
   m_target_db_descr.user_name=s
  end if

  if(xml_read_prop_str(node_db,c_ptd_xml_tag_db_password,true,s))then
   m_target_db_descr.password=s
  end if
 end sub 'load
end class 't_params_transfer_database

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

