option explicit

dim fso
set fso=createobject("Scripting.FileSystemObject")

dim file_names
set file_names=createobject("Scripting.Dictionary")

dim incl_names
set incl_names=createobject("Scripting.Dictionary")

call build_lists(".",file_names,incl_names)

wscript.echo "+++++++++++++++++++"

dim include
for each include in incl_names.Keys
 if(not file_names.Exists(include))then
  wscript.echo "not found:"&include
 end if
next

call wscript.quit(0)

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
sub build_lists(byval dir,byval file_names,byval incl_names)
 wscript.echo ">"&dir

 dim cur_folder
 set cur_folder=fso.GetFolder(dir)

 dim file
 for each file in cur_folder.Files
  if(ucase(fso.GetExtensionName(file.name))="DSX")then
   if(file_names.Exists(fso.GetBaseName(file.name)))then
    call err.raise("Dublicate:"&file.name)
   end if
   
   call file_names.Add(fso.GetBaseName(file.name),0)
   
   call process_includes(file.path,incl_names)
  end if
 next 'file
 
 dim sdir
 
 for each file in cur_folder.SubFolders
  if(dir<>"" and dir<>".")then
   sdir=fso.BuildPath(dir,file.name)
  else
   sdir=file.name
  end if
  
  call build_lists(sdir,file_names,incl_names)
 next 'file
 
end sub
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
sub process_includes(file_path,incl_names)
 wscript.echo "File:"&file_path

 '  
 dim file
 set file=fso.OpenTextFile(file_path)

 dim filestr
 filestr=""

 while not file.AtEndOfStream
  filestr=filestr&file.ReadLine&vbCrLf
 wend

 dim xml_doc
 set xml_doc=createobject("MSXML2.DOMDocument")

 call xml_doc.loadXML(filestr)

 dim xml_err
 set xml_err=xml_doc.parseError
 
 if(xml_err.errorCode<>0)then
  dim msg

  msg="Error in parameter file ["&file_path&"]"&vbCrLf
  msg=msg&"reason:"&xml_err.reason&vbCrLf
  msg=msg&"line:"&cstr(xml_err.line)&" col:"&cstr(xml_err.linepos)&vbCrLf

  call err.raise(-1,"process_includes",msg)
 end if
 
 dim incls
 set incls=xml_doc.selectNodes("backup_script/body/script/include")
 
 dim i
 dim a_name
 for each i in incls
  set a_name=i.attributes.getnameditem("name")

  if(a_name is nothing)then
   call err.raise(-1,"process_includes","name attribute not found")
  end if
  
  wscript.echo "include:"&a_name.text
  
  incl_names(a_name.text)=0
 next
 
end sub 'process_includes

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

