'*******************************************************************************
 '        
 '   , 18.05.2007
'*******************************************************************************

Option Explicit

'*******************************************************************************
'                    t_task_for_address_item_processing
'*******************************************************************************

'       TYPE_ADDRESS_ITEM
Class t_task_for_address_item_processing
  Private m_base          ' t_task_base_code
  Private m_db_descr

  Private m_user          '  
  Private m_pswd          ' 
  Private m_maps          '     

  Private m_root_log_dir

  '-----------------------------------------------------------------------------
  ' 
  Private Sub class_initialize()
    Set m_base     = New t_task_base_code
    Set m_db_descr = Nothing

    m_user         = Null
    m_pswd         = Null
    Set m_maps     = Nothing

    m_base.error_source = TypeName(Me)
  End Sub  ' class_initialize

  '-----------------------------------------------------------------------------
  '  
  Public Sub init(log, db_descr, user, pswd, ai_maps, root_log_dir)
    Set m_base.log  = log
    Set m_base.prog = Nothing

    Set m_db_descr  = db_descr

    m_user          = user
    m_pswd          = pswd
    Set m_maps      = ai_maps

    m_root_log_dir  = root_log_dir
  End Sub  ' init

  '-----------------------------------------------------------------------------
  '                               Public 
  '-----------------------------------------------------------------------------

  Public Property Get title()
    title = "REMOVE_DUBLICATE_ADDRESS_ITEM"

    If (Not (m_db_descr Is Nothing)) Then
      title = title & " - [" & m_db_descr.data_source & "]"
    End If
  End Property  ' title

  '-----------------------------------------------------------------------------
  '                                Public 
  '-----------------------------------------------------------------------------

  Public Sub depended_on_task(task)
    Call m_base.depended_on_task(task, True)
  End Sub  ' depended_on_task

  '-----------------------------------------------------------------------------
  '    
  Public Function can_start()
    can_start = m_base.can_start()
  End Function  ' can_start

  '-----------------------------------------------------------------------------
  '    
  Public Function is_active()
    is_active = m_base.is_active()
  End Function  ' is_active

  '-----------------------------------------------------------------------------
  '    
  Public Function is_finished()
    is_finished = m_base.is_finished()
  End Function  ' is_finished

  '-----------------------------------------------------------------------------
  Public Function get_exit_code()
    get_exit_code = m_base.get_exit_code()
  End Function  ' get_exit_code

  '-----------------------------------------------------------------------------
  '  
  Public Function run(mng)
    run = False

    Dim p_arg

    Dim own_log_dir
    own_log_dir = su_create_own_log_dir_for_db(m_root_log_dir, m_db_descr.location)

    Dim own_log_file
    own_log_file = own_log_dir & "\prog_address_item_processing.log"

    p_arg = "prog_address_item_processing.wsf"         &  _
            " /db """  & m_db_descr.data_source & """" & _
            " /user """  & m_user               & """" & _
            " /pswd """  & m_pswd               & """" & _
            get_maps_param(m_maps)                     & _
            " /log """ & own_log_file           & """"

    Dim prog : Set prog = New t_prog_executor
    Set prog.log = m_base.log

    If (prog.exec(p_arg, me.title)) Then
      Set m_base.prog = prog
      run = True
    End If
  End Function  ' run

  '-----------------------------------------------------------------------------
  Public Sub deactivate(mng)
  End Sub ' deactivate

  '-----------------------------------------------------------------------------
  '                               Private 
  '-----------------------------------------------------------------------------

  '      
  Private Function get_maps_param(maps)
    get_maps_param = vbNullString

    If (maps Is Nothing) Then Exit Function
    If (maps.Count < 1) Then Exit Function

    Dim map_item
    For Each map_item In maps
      get_maps_param = get_maps_param & " /map """ & map_item & """"
    Next
  End Function  ' get_maps_param

  '-----------------------------------------------------------------------------
End Class  ' t_task_for_address_item_processing

'*******************************************************************************