'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'     
'                                          . 27  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_task_for_backup_db

class t_task_for_backup_db
 private m_base                   'class t_task_base_code
 private m_fso
 
 private m_gbak_exe
 private m_gbak_service
 private m_db_descr               'class t_db_descr
 private m_backup_path
 
 private m_gbk_location          ' 

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  set m_base     =new t_task_base_code
  set m_fso      =su_create_object("Scripting.FileSystemObject")
  
  set m_db_descr =nothing
  
  m_base.error_source=typename(me)
 end sub 'class_initialize

 'properties -------------------------------------------------------------
 public property get title()
  dim t
  
  if(not (m_db_descr is nothing))then
   t=" - ["&m_db_descr.data_source&"]"
  end if
  
  title="GBAK.BACKUP"&t
 end property 'get title

 '------------------------------------------------------------------------
 public property get gbk_location()
  gbk_location=m_gbk_location
 end property
 
 '------------------------------------------------------------------------
 public property get gdb_descr()
  set gdb_descr = m_db_descr
 end property

 ' ----------------------------------------------------------
 public sub init(log,           _
                 gbak_exe,      _
                 db_descr,      _
                 backup_path)
  set m_base.log  =log
                 
  set m_base.prog = nothing

  set m_db_descr  = db_descr

  m_gbak_exe      = gbak_exe
  m_backup_path   = backup_path
 end sub 'init
 
 '------------------------------------------------------------------------
 public sub init2(log,           _
                  gbak_exe,      _
                  gbak_service,  _
                  db_descr,      _
                  backup_path)
  call init(log,gbak_exe,db_descr,backup_path)

  m_gbak_service=gbak_service
 end sub 'init2

 '------------------------------------------------------------------------
 public sub depended_on_task(task)
  call m_base.depended_on_task(task,true)
 end sub 'depended_on_task

 '    -----------------------------------
 public function can_start()
  can_start=m_base.can_start()
 end function 'can_start

 '    --------------------------------------
 public function is_active()
  is_active=m_base.is_active()
 end function 'is_active

 '------------------------------------------------------------------------
 public function is_finished()
  is_finished=m_base.is_finished()
 end function 'is_finished

 '------------------------------------------------------------------------
 public function get_exit_code()
  get_exit_code=m_base.get_exit_code()
 end function 'get_exit_code

 '------------------------------------------------------------------------
 public function run(mng)
  run=false

  dim database_file_name
  database_file_name=su_get_database_file_name(m_db_descr.location)

  '  
  if(m_fso.FolderExists(m_backup_path))then
   '  
   'DONE:    
   
   do while(true)
    call wscript.sleep(1100)

    m_gbk_location=m_fso.BuildPath(m_backup_path, _
                                   m_fso.GetBaseName(database_file_name)&"_"&su_gen_ts_str()&".gbk")

    if(not m_fso.FileExists(m_gbk_location))then exit do

    call m_base.log_msg(typename(me)&": WAIT FOR GENERATE UNIQUE FILE NAME")
   loop
  elseif(m_fso.GetExtensionName(m_backup_path)="")then
   call err.raise(-1,typename(me),"BACKUP FOLDER ["&m_backup_path&"] NOT FOUND")
  else
   '       .
   m_gbk_location=m_backup_path
   
   if(not m_fso.FolderExists(m_fso.GetParentFolderName(m_gbk_location)))then
    call err.raise(-1,typename(me),"BACKUP FOLDER ["&m_fso.GetParentFolderName(m_gbk_location)&"] NOT FOUND")
   end if

   '    
   if(m_fso.FileExists(m_gbk_location))then
    call err.raise(-1,typename(me),"BACKUP FILE ["&m_gbk_location&"] ALREADY EXISTS.")
   end if
  end if 'm_backup_path -      
  
  '        
  dim log_location
  log_location=m_fso.BuildPath _
                (m_fso.GetParentFolderName(m_gbk_location), _
                 m_fso.GetBaseName(m_gbk_location)&".log")

  dim p_arg,p_title

  if(m_gbak_service<>"")then
   dim service_path

   if(trim(m_db_descr.host)<>"")then
    service_path=trim(m_db_descr.host)&":"&m_gbak_service
   end if

   p_arg=m_gbak_exe&" """&m_db_descr.location&""""& _
                    " -SERVICE """&service_path&""""& _
                    " -USER "&m_db_descr.user_name& _
                    " -PASSWORD "&m_db_descr.password&" -B -V -G "& _
                    " """&m_gbk_location&""" -Y """&log_location&""""

   p_title=me.title&" TO ["&m_gbk_location&"] THROUGH SERVICE ["&m_gbak_service&"]"
  else
   p_arg=m_gbak_exe&" """&m_db_descr.data_source&""""& _
                    " -USER "&m_db_descr.user_name& _
                    " -PASSWORD "&m_db_descr.password&" -B -V -G "& _
                    " """&m_gbk_location&""" -Y """&log_location&""""

   p_title=me.title&" TO ["&m_gbk_location&"]"
  end if

  dim prog
  set prog=new t_prog_executor
  set prog.log=m_base.log

  if(prog.exec(p_arg,p_title))then
   set m_base.prog=prog
   run=true
  else
   run=false
  end if
 end function 'run
 
 '------------------------------------------------------------------------
 public sub deactivate(mng)
 end sub'deactivate
end class 't_task_for_backup_db

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
