'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'      
'             26.07.2005
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class t_task_for_build_report_last_restored_packs
 private c_err_source
 private m_base
 private m_target_db
 private m_host_name
 private m_exit_code
 private m_is_finished

 ' ------------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_task_for_build_report_last_restored_packs"
  
  set m_base=new t_task_base_code
  m_host_name="localhost"

  m_is_finished=false
  m_exit_code=-1
  
  m_base.error_source=c_err_source
 end sub'class_initialize
 
 'properties -------------------------------------------------------------
 public property set log(x)
  set m_base.log=x
 end property

 '------------------------------------------------------------------------
 public property let host_name(x)
  m_host_name=x
 end property
 
'    -----------------------------------
 public function can_start()
  can_start=m_base.can_start()
 end function 'can_start

  '------------------------------------------------------------------------
 property get title()
  title=c_err_source
 end property
 
 '    --------------------------------------
 public function is_active()
  is_active=false '     
 end function 'is_active
 
 '------------------------------------------------------------------------
 public function get_exit_code()
  get_exit_code=m_exit_code
 end function 'get_exit_code

 '------------------------------------------------------------------------
 public function is_finished()
  is_finished=m_is_finished
 end function 'is_finished


 '------------------------------------------------------------------------
 private function build_target_location()
  if(m_host_name="")then
   build_target_location=m_target_db
  else
   build_target_location=m_host_name&":"&m_target_db
  end if
 end function'build_target_location

 ' ----------------------------------------------------------
 public sub init(target_db)
  m_target_db = target_db
 end sub'init
 
 '------------------------------------------------------------------------
 public sub depended_on_task(task,success)
  call m_base.depended_on_task(task,success)
 end sub'depended_on_task
 
 '------------------------------------------------------------------------
 public function run(mng)
  const c_cw_num  = 4
  const c_cw_name = 57
  const c_cw_date = 21
  const c_cw_id   = 9

  run=false

  dim cn
  set cn = su_create_object("ADODB.Connection")
  cn.Provider="LCPI.IBProvider"
  cn.IsolationLevel=65536
  
  dim cn_str

  cn_str="location="&build_target_location()&";"& _
         "ctype=win1251;"& _
         "ole db services=0"

  call cn.open(cn_str,"gamer","vermut")
  
  call cn.BeginTrans()
  
  dim cmd
  set cmd=su_create_object("ADODB.Command")

  cmd.ActiveConnection=cn

  cmd.CommandText="select r.terrain_id,max(r.pack_id)"&vbCrLf& _
                  "from rpl_restored_pack r join rpl_terrain t"&vbCrLf& _
                  "on r.terrain_id=t.terrain_id and t.enabled<>0"&vbCrLf& _
                  "group by r.terrain_id"

  dim main_rs
  set main_rs=cmd.execute
  
  if(main_rs.eof) then
   m_exit_code=0
   m_is_finished=true
   run=true
   exit function
  end if
  
  dim pack_id,terrain_id,info_rs

  cmd.CommandText="select r.restore_date,r.pack_create_date,t.name"&vbCrLf& _
                   "from rpl_restored_pack r join rpl_terrain t"&vbCrLf& _
                   "on r.terrain_id=t.terrain_id"&vbCrLf& _
                   "where r.terrain_id=? and r.pack_id=?"

  cmd.ActiveConnection = cn
  
  call m_base.log_msg("Target:"&build_target_location())
                  
  dim msg,strnum

  strnum = 0
  msg = su_lstr("Terrain:",c_cw_name)&su_lstr("pack_create_date:",c_cw_date)& _
        su_lstr("restore_date:",c_cw_date)&su_lstr("pack_id:",c_cw_id)& _
        su_lstr("terrain_id:",c_cw_id)&vbCrLf

  while(not main_rs.eof)

   terrain_id = main_rs("terrain_id").value
   pack_id    = main_rs("max").value
   
   cmd(0) = terrain_id
   cmd(1) = pack_id
   
   set info_rs = cmd.execute
   
   strnum = strnum + 1
   msg = msg&su_lstr(cstr(strnum)&".",c_cw_num)
   msg = msg&su_lstr(info_rs("name").value,c_cw_name-c_cw_num)
   msg = msg&su_lstr(su_date_to_str(info_rs("pack_create_date").value),c_cw_date)
   msg = msg&su_lstr(su_date_to_str(info_rs("restore_date").value),c_cw_date)
   msg = msg&su_lstr(su_cstr_sn(pack_id),c_cw_id)
   msg = msg&su_lstr(su_cstr_sn(terrain_id),c_cw_id)&vbCrLf
   
   main_rs.movenext
  wend
  
  call cn.CommitTrans()

  dim db_name
  db_name = su_get_database_file_name(build_target_location())

  dim s
  s = len(db_name)

  do while(s>=1)
   select case mid(db_name,s,1)
    case "."
     exit do
   end select

   s=s-1
  loop

  if(s<>0) then
   db_name = left(db_name,s-1)
  end if

  call m_base.log.add_file("Last packs in "&db_name,msg)
  
  m_exit_code=0
  m_is_finished=true

  run=true
 end function'run
 
 '------------------------------------------------------------------------
 public sub deactivate(mng)
 end sub'deactivate

end class't_task_for_build_report_last_restored_packs
