'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'        
'                                          . 30  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_task_for_make_restore_rpl_db

class t_task_for_make_restore_rpl_db
 private c_err_source
 private m_base
 private m_fso

 private m_gbak_exe
 private m_gbk_dir '  GBK   
 private m_gdb_dir '  GDB ...

 private m_exit_code
 private m_is_finished

 ',       
 '      deactivate  
 private m_task_for_finish_packs_restore

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  c_err_source=typename(me)
  
  '-------------
  set m_base=nothing
  set m_fso =nothing
  set m_task_for_finish_packs_restore=nothing
  
  '-------------
  set m_base=new t_task_base_code
  set m_fso =su_create_object("Scripting.FileSystemObject")
  
  set m_task_for_finish_packs_restore=new t_task_for_wait_all
  
  m_base.error_source=c_err_source

  m_exit_code   =-1
  m_is_finished =false
 end sub 'class_initialize
 
 'properties -------------------------------------------------------------
 property get title()
  title=c_err_source
 end property
 
 '------------------------------------------------------------------------
 public property get task_for_finish_packs_restore()
  set task_for_finish_packs_restore=m_task_for_finish_packs_restore
 end property
 
 ' ----------------------------------------------------------
 public sub init(log,gbak_exe,gbk_dir,gdb_dir)
  call m_task_for_finish_packs_restore.init(log,"WAIT RESTORE ALL RPL GDB FILES")

  set m_base.log=log

  m_gbak_exe =gbak_exe
  m_gbk_dir  =gbk_dir
  m_gdb_dir  =gdb_dir

  m_exit_code   =-1
  m_is_finished =false
 end sub 'init

 '------------------------------------------------------------------------
 public sub depended_on_task(task)
  call m_base.depended_on_task(task,true)
 end sub 'depended_on_task

 '    -----------------------------------
 public function can_start()
  can_start=m_base.can_start()
 end function 'can_start

 '    --------------------------------------
 public function is_active()
  is_active=false '     
 end function 'is_active

 '------------------------------------------------------------------------
 public function get_exit_code()
  get_exit_code=m_exit_code
 end function 'get_exit_code

 '------------------------------------------------------------------------
 public function is_finished()
  is_finished=m_is_finished
 end function 'is_finished

 '------------------------------------------------------------------------
 public function run(mng)
  run=false

  '  GDB/GBK 
  dim gdb_files
  dim gbk_files

  set gdb_files=su_create_object("LCPI.DBS.Utility.Vector")
  set gbk_files=su_create_object("LCPI.DBS.Utility.Vector")

  if(not su_scan_files(m_base.log,gdb_files,m_gdb_dir,"gdb"))then
   exit function
  end if

  if(not su_scan_files(m_base.log,gbk_files,m_gbk_dir,"gbk"))then
   exit function
  end if

  ' GBK    GDB 
  dim gdb_dic
  set gdb_dic=su_create_object("Scripting.Dictionary")

  dim file
  for each file in gdb_files
   call m_base.log_msg("RESTORED RPL PACK: "&m_fso.GetBaseName(file.name))
   
   gdb_dic.item(ucase(m_fso.GetBaseName(file.name)))=0
  next 'file

  dim task
  dim gdb_descr

  for each file in gbk_files
   if(gdb_dic.Exists(ucase(m_fso.GetBaseName(file.name))))then
    call m_base.log_msg("RPL PACK ["&file.name&"] ALREADY RESTORED")
   else
    '   
    call m_base.log_msg("RPL PACK ["&file.name&"] NEED RESTORE")

    set task=new t_task_for_restore_db

    set gdb_descr=new t_db_descr

    gdb_descr.location  =m_fso.BuildPath(m_gdb_dir,m_fso.GetBaseName(file.Name))&".gdb"
    gdb_descr.user_name ="gamer"
    gdb_descr.password  ="vermut"

    call task.init(m_base.log,m_gbak_exe,file.Path,gdb_descr)

    '  
    call mng.add_task(task)

    call m_task_for_finish_packs_restore.depended_on_task(task,true)
   end if
  next 'file

  '-------------------------------------------------------------
  call mng.add_task(m_task_for_finish_packs_restore)

  m_exit_code=0
  m_is_finished=true
  
  run=true
 end function 'run
 
 '------------------------------------------------------------------------
 public sub deactivate(mng)
 end sub 'deactivate
end class 't_task_for_make_restore_rpl_db

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
