'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'      
'                                         . 02  2007 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_task_for_sweep_db

class t_task_for_rebuild_index_stats
 private m_base                   'class t_task_base_code
 private m_db_descr
 private m_root_log_dir

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  set m_base     =new t_task_base_code
  set m_db_descr =nothing

  m_base.error_source=typename(me)
 end sub 'class_initialize

 'properties -------------------------------------------------------------
 public property get title()
  dim t
  t = ""

  if(not(m_db_descr is nothing))then
   t = " - ["&m_db_descr.data_source&"]"
  end if

  title="REBUILD_INDEX_STATS"&t
 end property 'title
 
 ' ----------------------------------------------------------
 public sub init(log,           _
                 db_descr,      _
                 root_log_dir)
  set m_base.log  =log

  set m_base.prog = nothing

  set m_db_descr  = db_descr
  
  m_root_log_dir=root_log_dir
 end sub 'init

 '------------------------------------------------------------------------
 public sub depended_on_task(task)
  call m_base.depended_on_task(task,true)
 end sub 'depended_on_task

 '    -----------------------------------
 public function can_start()
  can_start=m_base.can_start()
 end function 'can_start

 '    --------------------------------------
 public function is_active()
  is_active=m_base.is_active()
 end function 'is_active

 '------------------------------------------------------------------------
 public function is_finished()
  is_finished=m_base.is_finished()
 end function 'is_finished

 '------------------------------------------------------------------------
 public function get_exit_code()
  get_exit_code=m_base.get_exit_code()
 end function 'get_exit_code

 '------------------------------------------------------------------------
 public function run(mng)
  stop

  run=false

  dim p_arg

  dim own_log_dir
  own_log_dir=su_create_own_log_dir_for_db(m_root_log_dir,m_db_descr.location)

  dim own_log_file
  own_log_file=own_log_dir&"\rebuild_index_stats.log"

  p_arg="prog_rebuild_index_statistics.wsf"&  _
        " /db """&m_db_descr.data_source&""""& _
        " /user "&m_db_descr.user_name& _
        " /pswd "&m_db_descr.password& _
        " /log """&own_log_file&""""& _
        " /silent"
                   
  dim prog
  set prog=new t_prog_executor
  set prog.log=m_base.log

  if(prog.exec(p_arg,me.title))then
   set m_base.prog=prog
   run=true
  else
   run=false
  end if
 end function 'run

 '------------------------------------------------------------------------
 public sub deactivate(mng)
 end sub'deactivate
end class 't_task_for_rebuild_index_stats

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
