'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'     
'                                          . 28  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_task_for_remove_backup_files

class t_task_for_remove_backup_files
 private c_err_source

 private m_base
 private m_backup_task  'class t_task_for_backup_db (object)
                        '        
 private m_fso
 
 private m_backup_base_name
 
 private m_is_finished
 private m_exit_code
 
 'constructor ------------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_task_for_remove_backup_files"
  
  set m_base         =new t_task_base_code
  set m_backup_task  =nothing
  set m_fso          =su_create_object("Scripting.FileSystemObject")

  m_base.error_source=c_err_source
  
  m_is_finished=false
  m_exit_code  =-1
 end sub 'class_initialize
 
 'properties -------------------------------------------------------------
 public property get title()
  title="REMOVE BACKUP FILES ["&m_backup_base_name&"]"
 end property
 
 ' ----------------------------------------------------------
 public sub init(log,backup_task)
  m_is_finished=false
  m_exit_code  =-1

  set m_base.log=log

  if(not IsObject(backup_task))then
   m_backup_task=backup_task
  else
   set m_backup_task=backup_task

   '     
   call depended_on_task(backup_task,true)
  end if
 end sub 'init
 
 '------------------------------------------------------------------------
 public sub depended_on_task(byval task,byval success_finish)
  call m_base.depended_on_task(task,success_finish)
 end sub 'depended_on_task

 '    -----------------------------------
 public function can_start()
  can_start=m_base.can_start()
 end function 'can_start

 '    --------------------------------------
 public function is_active()
  is_active=false
 end function 'is_active

 '------------------------------------------------------------------------
 public function is_finished()
  is_finished=m_is_finished
 end function 'is_finished

 '------------------------------------------------------------------------
 public function get_exit_code()
  get_exit_code=m_exit_code
 end function 'get_exit_code

 '------------------------------------------------------------------------
 public function run(mng)
  run=false
  
  m_is_finished=true
  m_exit_code=0      '      
  
  dim gbk_location
  if(IsObject(m_backup_task))then
   gbk_location=m_backup_task.gbk_location
  else
   gbk_location=m_backup_task
  end if
  
  dim gbk_path
  dim gbk_base_name
  
  gbk_path      =m_fso.GetParentFolderName(gbk_location)
  gbk_base_name =m_fso.GetBaseName(gbk_location)
  
  '---------------------------------------
  m_backup_base_name=gbk_base_name
  
  '    
  if(not m_fso.FolderExists(gbk_path))then
   call m_base.log_warning(1,"GBK FOLDER ["&gbk_path&"] NOT FOUND")

   exit function
  end if
  
  dim file
  dim file_name
  dim err_code
  dim err_descr
  
  for each file in m_fso.GetFolder(gbk_path).Files
   if(ucase(m_fso.GetBaseName(file.Name))=ucase(gbk_base_name))then
    file_name=file.Name

    on error resume next
    
    call file.Delete(true) '     
    
    err_code=err.number
    err_descr=err.description
    
    on error goto 0
    
    call err.Clear()
    
    if(err_code=0)then
     call m_base.log_msg("REMOVE FILE ["&file_name&"]")
    else
     '    -     
     
     call m_base.log_warning(err_code,"FAIL REMOVE FILE ["&file_name&"]"&vbCrLf&err_descr)
    end if
   end if '     
  next 'file
  
  run=true
 end function 'run

 '------------------------------------------------------------------------
 public sub deactivate(mng)
 end sub'deactivate
end class 't_task_for_remove_backup_files
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

