'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'      
'                                                  . 19.08.2004

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_task_for_remove_gdb_file

class t_task_for_remove_gdb_file
 private c_err_source
 
 private m_base
 private m_fso
 private m_gdb_location
 
 private m_exit_code
 private m_is_finished

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_task_for_remove_gdb_file"
  
  set m_base=new t_task_base_code
  set m_fso =su_create_object("Scripting.FileSystemObject")
  
  m_base.error_source="t_task_for_remove_gdb_file"

  m_exit_code    =-1
  m_is_finished  =false
 end sub 'class_initialize
 
 'properties -------------------------------------------------------------
 public property set log (x)
  set m_base.log=x
 end property

 '------------------------------------------------------------------------
 public property get title()
  title="REMOVE DATABASE FILE ["&m_gdb_location&"]"
 end property

 ' ----------------------------------------------------------
 public sub init(gdb_location)
  m_exit_code    =-1
  m_is_finished  =false
  
  m_gdb_location=gdb_location
 end sub 'init
 
 '------------------------------------------------------------------------
 public sub depended_on_task(task)
  call m_base.depended_on_task(task,true)
 end sub 'depended_on_task

 '    -----------------------------------
 public function can_start()
  can_start=m_base.can_start()
 end function 'can_start

 '    --------------------------------------
 public function is_active()
  is_active=false
 end function 'is_active

 '------------------------------------------------------------------------
 public function get_exit_code()
  get_exit_code=m_exit_code
 end function 'get_exit_code

 '------------------------------------------------------------------------
 public function is_finished()
  is_finished=m_is_finished
 end function 'is_finished
 
 '  ---------------------------------------------------------
 public function run(mng)
  run=false

  if(not m_fso.FileExists(m_gdb_location))then
   call m_base.log_warning(-1,"GDB FILE ["&m_gdb_location&"] NOT FOUND")
  else
   '1    
   '2   

   dim new_gdb_name
   new_gdb_name=m_fso.GetFileName(m_gdb_location)&"_for_remove_"&su_gen_ts_str()
   
   if(not rename_file(m_gdb_location,new_gdb_name))then
    exit function
   end if
   
   if(not delete_file(m_fso.BuildPath(m_fso.GetParentFolderName(m_gdb_location),new_gdb_name)))then
    exit function
   end if
  end if
  
  m_exit_code=0
  m_is_finished=true
  
  run=true
 end function 'run
 
 '------------------------------------------------------------------------
 public sub deactivate(mng)
 end sub 'deactivate

 '------------------------------------------------------------------------
 private function rename_file(file_location,new_name)
  rename_file=false
 
  call m_base.log_msg("RENAME FILE ["&file_location&"] TO ["&new_name&"]")

  dim err_code
  dim err_source
  dim err_descr

  dim file
  set file=m_fso.GetFile(file_location)

  on error resume next
  
  file.Name=new_name
  
  err_code   = err.number
  err_source = err.source
  err_descr  = err.description
  
  call err.clear()
  
  on error goto 0
  
  if(err_code<>0)then
   call m_base.log_error(err_code,"FAIL REMAME FILE ["&file_location&"]"&vbCrLf&err_descr)
  end if

  rename_file=(err_code=0)
 end function 'rename_file
 
 '------------------------------------------------------------------------
 private function delete_file(file_location)
  delete_file=false
  
  call m_base.log_msg("DELETE FILE ["&file_location&"]")
  
  dim err_code
  dim err_source
  dim err_descr

  on error resume next

  call m_fso.DeleteFile(file_location,true)

  err_code   = err.number
  err_source = err.source
  err_descr  = err.description

  call err.clear()

  on error goto 0

  if(err_code<>0)then
   call m_base.log_error(err_code,"FAIL REMOVE FILE ["&file_location&"]"&vbCrLf&err_descr)
  end if

  delete_file=(err_code=0)
 end function 'delete_file
end class 't_task_for_remove_gdb_file
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

