'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'     
'                                          . 27  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_task_for_replace_db

'      m_dest_db_location
'  m_restore_task.
'

class t_task_for_replace_db
 private c_err_source
 
 private m_base
 private m_restore_task 'class t_task_for_restore_db_after_backup
 private m_fso
 
 private m_dest_db_location '     
 private m_prev_db_location '    
                            '    

 'ROOT-    .   
 '     dest_db_location    
 '    
 private m_prev_db_archive_dir

 private m_is_finished
 private m_exit_code

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_task_for_replace_db"
  
  set m_base          =new t_task_base_code
  set m_restore_task  =nothing
  set m_fso           =su_create_object("Scripting.FileSystemObject")
  
  m_base.error_source=c_err_source

  m_is_finished=false
  m_exit_code  =-1
 end sub 'constructor
 
 'properties -------------------------------------------------------------
 public property set log (x)
  set m_base.log=x
 end property

 '------------------------------------------------------------------------
 public property get title()
  title="REPLACE DATABASE ["&m_dest_db_location&"]"
 end property

 '------------------------------------------------------------------------
 public property get prev_db_location()
  prev_db_location=m_prev_db_location
 end property
 
 ' ----------------------------------------------------------
 public sub init(restore_task,dest_db_location,prev_db_archive_dir)
  m_is_finished=false
  m_exit_code  =-1

  set m_restore_task=restore_task
  
  call depended_on_task(restore_task)
  
  m_dest_db_location=dest_db_location
  
  m_prev_db_archive_dir=prev_db_archive_dir
 end sub 'init

 '------------------------------------------------------------------------
 public sub depended_on_task(task)
  call m_base.depended_on_task(task,true)
 end sub 'depended_on_task

 '    -----------------------------------
 public function can_start()
  can_start=m_base.can_start()
 end function 'can_start

 '    --------------------------------------
 public function is_active()
  is_active=false
 end function 'is_active

 '------------------------------------------------------------------------
 public function is_finished()
  is_finished=m_is_finished
 end function 'is_finished

 '------------------------------------------------------------------------
 public function get_exit_code()
  get_exit_code=m_exit_code
 end function 'get_exit_code

 '------------------------------------------------------------------------
 public function run(mng)
  run=false
  
  dim err_code
  dim err_descr

  dim gdb_location
  gdb_location=m_restore_task.gdb_location
  
  dim tmp_gdb_location
  tmp_gdb_location=gdb_location&"_tmp"
  
  '   . ,    
  if(not rename_file(gdb_location,tmp_gdb_location,true))then
   exit function
  end if

  '  
  wscript.sleep(1100)

  dim new_dest_old_file_location
  new_dest_old_file_location=m_fso.GetParentFolderName(m_dest_db_location)&"\"& _
                             m_fso.GetBaseName(m_dest_db_location)& _
                             "_"&su_gen_ts_str()&"."& _
                             m_fso.GetExtensionName(m_dest_db_location)&"_bak"
                         
  if(not rename_file(m_dest_db_location,new_dest_old_file_location,false))then
   '     ,  
   '        

   '    
   m_prev_db_location=tmp_gdb_location
  else
   '       
   if(not rename_file(tmp_gdb_location,m_dest_db_location,true))then
    '   -  ,    ,   
   
    '     
    if(not rename_file(new_dest_old_file_location,m_dest_db_location,true))then
     call m_base.log_error(-1,"PESEC !!! PLEASE SET ["&tmp_gdb_location&"] AS "& _
                           "["&m_dest_db_location&"] !!!!")
    end if
   
    exit function
   end if

   '    
   m_prev_db_location=new_dest_old_file_location
  end if
  
  '    
  m_is_finished=true
  m_exit_code  =0

  run=true
 end function 'run
 
 '------------------------------------------------------------------------
 public sub deactivate(mng)
  if(m_exit_code<>0)then exit sub
 
  '     
  if(not m_fso.FileExists(m_prev_db_location))then
   exit sub
  end if
 
  '         
  if(not m_fso.FolderExists(m_prev_db_archive_dir))then
   call m_base.log_error(-1,"BACKUP FOLDER ["&m_prev_db_archive_dir&"] NOT FOUND")
   exit sub
  end if
  
  dim archive_dir
  archive_dir=m_fso.BuildPath(m_prev_db_archive_dir,m_fso.GetBaseName(m_dest_db_location))
  
  if(not m_fso.FolderExists(archive_dir))then
   '        
   if(not create_folder(archive_dir))then exit sub
  end if
  
  '       
  dim move_task
  set move_task=new t_task_for_zip_and_move_old_db
  
  set move_task.log=m_base.log
  
  call move_task.init(m_prev_db_location,archive_dir)
  
  call mng.add_task(move_task)
 end sub'deactivate

 '  -------------------------------------------------
 'cur_file_must_be_exists==true,     
 '
 'return: false -     
 private function rename_file(byval cur_file_name, _
                              byval new_file_name, _
                              byval cur_file_must_be_exists)
  rename_file=false

  call m_base.log_msg("RENAME ["&cur_file_name&"] TO ["&new_file_name&"]")

  '    -----------------
  if(not m_fso.FileExists(cur_file_name))then
   if(cur_file_must_be_exists)then
    call m_base.log_error(-1,"RENAMED FILE ["&cur_file_name&"] NOT FOUND")
   else
    call m_base.log_warning(-1,"RENAMED FILE ["&cur_file_name&"] NOT FOUND")
    
    rename_file=true
   end if
   
   exit function
  end if
  
  '      ------------------------
  if(m_fso.FileExists(new_file_name))then
   call m_base.log_error(-1,"FILE WITH NEW NAME ["&new_file_name&"] ALREADY EXISTS")

   exit function
  end if
  
  '  ---------------------------------------------
  new_file_name=m_fso.GetFileName(new_file_name)
  
  dim err_code
  dim err_descr

  on error resume next
  m_fso.GetFile(cur_file_name).Name=new_file_name
  
  err_code  =err.number
  err_descr =err.description
  
  call err.Clear()
  
  on error goto 0
  
  if(err_code<>0)then
   call m_base.log_error(err_code,"FAIL RENAME FILE ["&cur_file_name&"] TO ["&new_file_name&"]")
   
   exit function
  end if
  
  rename_file=true
 end function 'rename_file

 '------------------------------------------------------------------------
 private function create_folder(folder_location)
  create_folder=false
  
  dim err_code
  dim err_descr
  
  on error resume next
  
  call m_fso.CreateFolder(folder_location)
  
  err_code  =err.number
  err_descr =err.description
  
  call err.clear()
  
  on error goto 0
  
  if(err_code<>0)then
   call m_base.log_error(err_code,"FAIL CREATE FOLDER ["&folder_location&"]")
   exit function
  end if
  
  create_folder=true
 end function 'create_folder
end class 't_task_for_replace_db

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

