'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'        ()
'                                       . 22  2005 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_task_for_reserve_backup_files_in_storages

class t_task_for_reserve_backup_files_in_storages
 private c_err_source
 
 private m_base                 'class t_task_base_code
 private m_fso
 
 private m_zip_backup_task      'class t_task_for_zip_backup_files
 private m_storages             '    
 
 private m_is_finished
 private m_exit_code
 
 private m_copy_tasks           'LCPI.DBS.Utility.Vector
 
 'constructor ------------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_task_for_reserve_backup_files_in_storages"
  
  set m_base=new t_task_base_code
  
  set m_fso=su_create_object("Scripting.FileSystemObject")
  
  m_base.error_source=c_err_source
  
  set m_zip_backup_task =nothing
  set m_storages        =nothing
  
  m_is_finished  =false
  m_exit_code    =-1
  
  set m_copy_tasks =nothing
 end sub 'class_initialize
 
 'properties -------------------------------------------------------------
 public property get title()
  title="RESERVE BACKUP FILES"
 end property 'title
 
 '------------------------------------------------------------------------
 public sub init(log,               _
                 zip_backup_task,   _
                 storages)
  set m_base.log=log
  
  set m_zip_backup_task=zip_backup_task
  
  set m_storages=storages

  '      
  call m_base.depended_on_task(zip_backup_task,false)

  m_is_finished  =false
  m_exit_code    =-1
  
  set m_copy_tasks=nothing
 end sub 'init

 '    -----------------------------------
 public function can_start()
  can_start=m_base.can_start()
 end function 'can_start

 '    --------------------------------------
 public function is_active()
  is_active=false
 end function 'is_active

 '------------------------------------------------------------------------
 public function is_finished()
  is_finished=false

  if(m_is_finished)then
   'TODO:      
   dim res
   
   res=true

   if(not (m_copy_tasks is nothing))then
    dim ct
    
    for each ct in m_copy_tasks
     res=res and ct.is_finished()
     
     if(not res)then exit for
    next 'ct
   end if

   is_finished=res
  end if 'm_is_finished
 end function 'is_finished

 '------------------------------------------------------------------------
 public function get_exit_code()
  get_exit_code=m_exit_code
 end function 'get_exit_code

 '  ---------------------------------------------------------
 public function run(mng)
  run=true
  
  '     
  m_is_finished=true

  '   ,    -    
  '     
  m_exit_code=0

  if(m_storages is nothing)then
   exit function
  end if
  
  '     
  dim source_file
  
  'stop
  
  if(m_zip_backup_task.get_exit_code()=0)then
   '    
   source_file=m_zip_backup_task.get_dest_location()
  else
   '!     -    !
   source_file=m_zip_backup_task.get_source_location()
  end if
  
  call m_base.log_msg("RESERVE ["&source_file&"]")
  
  '    
  dim copy_task
  
  dim storage
  
  dim prog_title
  dim prog_arg
  
  set m_copy_tasks=su_create_object("LCPI.DBS.Utility.Vector")
  
  for each storage in m_storages
   storage=su_cstr_sn(storage)
  
   call m_base.log_msg("create task for copy to ["&storage&"]")
   
   prog_title="RESERVE ["&source_file&"] IN ["&storage&"]"
   
   prog_arg="cscript.exe prog\prog_reserve_file_in_storage.wsf /src """&source_file&""" "
   prog_arg=prog_arg&" /dest """&storage&""""
   
   set copy_task=new t_task_for_prog

   call copy_task.init(m_base.log,prog_arg,prog_title)
   
   call mng.add_task(copy_task)
   
   '     
   call m_copy_tasks.PushBack(copy_task)
  next 'storage
  
 end function 'run

 '   -------------------------------------------
 public sub deactivate(mng)
 end sub'deactivate
end class 't_task_for_reserve_backup_files_in_storages
