'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'    .
'                                          . 30  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_task_for_restore_db

class t_task_for_restore_db
 private m_base
 private m_fso

 private m_gbak_exe
 private m_gbk_file_location
 
 private m_gdb_descr   'class t_db_descr
 
 private m_log_file_location
 
 'constructor ------------------------------------------------------------
 private sub class_initialize()
  set m_base=new t_task_base_code
  set m_fso=su_create_object("Scripting.FileSystemObject")
  
  m_base.error_source=typename(me)
 end sub 'class_initialize
 
 '------------------------------------------------------------------------
 public property get title()
  dim t
  
  if(m_gdb_descr is nothing)then
   t="???"
  else
   t=m_gdb_descr.location
  end if
 
  title="GBAK.RESTORE ["&m_gbk_file_location&"] TO ["&t&"]"
 end property 'title
 
 ' ----------------------------------------------------------
 public sub init(log,                 _
                 gbak_exe,            _
                 gbk_file_location,   _
                 gdb_descr)
  set m_base.log=log
 
  m_gbak_exe=gbak_exe

  m_gbk_file_location=gbk_file_location
  
  set m_gdb_descr=gdb_descr

  set m_base.prog=nothing
 end sub 'init
 
 '------------------------------------------------------------------------
 public sub depended_on_task(task)
  call m_base.depended_on_task(task,true)
 end sub 'depended_on_task

 '    -----------------------------------
 public function can_start()
  can_start=m_base.can_start()
 end function 'can_start

 '    --------------------------------------
 public function is_active()
  is_active=m_base.is_active()
 end function 'is_active

 '------------------------------------------------------------------------
 public function get_exit_code()
  get_exit_code=m_base.get_exit_code()
 end function 'get_exit_code

 '------------------------------------------------------------------------
 public function is_finished()
  is_finished=m_base.is_finished()
 end function 'is_finished

 '------------------------------------------------------------------------
 public function run(mng)
  run=false
  
  '    
  if(not m_fso.FileExists(m_gbk_file_location))then
   call m_base.log_error(-1,"BACKUP FILE ["&m_gbk_file_location&"] NOT FOUND")
   exit function
  end if
  
  '     
  if(m_fso.FileExists(m_gdb_descr.location))then
   call m_base.log_error(-1,"DATABASE FILE ["&m_gdb_descr.location&"] ALREADY EXISTS")
   exit function
  end if
  
  '  -    
  m_log_file_location= _
   m_fso.BuildPath(m_fso.GetParentFolderName(m_gbk_file_location), _
                   m_fso.GetBaseName(m_gbk_file_location)&"_restore_"&su_gen_ts_str()&".log")
  

  '  GBAK.exe
  dim p_arg
  p_arg=m_gbak_exe&" """&m_gbk_file_location&""""& _
        " -USER "&m_gdb_descr.user_name& _
        " -PASSWORD "&m_gdb_descr.password&" -C -G -V "& _
        """localhost:"&m_gdb_descr.location&""" "&_
        " -Y """&m_log_file_location&""""

  dim prog
  set prog=new t_prog_executor
  set prog.log=m_base.log
  
  if(prog.exec(p_arg,title))then
   set m_base.prog=prog
   run=true
  end if
 end function 'run
 
 '------------------------------------------------------------------------
 public sub deactivate(prog)
  dim err_code
  dim err_descr
  
  err_code=get_exit_code()

  if(err_code=0)then
   '    
   on error resume next
   m_fso.DeleteFile(m_log_file_location)
   
   err_code=err.number
   err_descr=err.description
   
   on error goto 0
   
   call err.clear()
   
   if(err_code<>0)then
    call m_base.log_warning(err_code,"FAIL REMOVE LOG FILE ["&m_log_file_location&"]")
   end if
  else
   call m_base.log_error(err_code,"FAIL RESTORE BACKUP. SEE LOG FILE ["&m_log_file_location&"]")
   
   '      
   on error resume next
   m_fso.DeleteFile(m_gdb_descr.location)

   err_code=err.number
   err_descr=err.description

   on error goto 0

   call err.clear()

   if(err_code<>0)then
    call m_base.log_error(err_code,"FAIL REMOVE BAD DATABASE FILE ["&m_gdb_descr.location&"]")
   end if
  end if
 end sub 'deactivate
end class 't_task_for_restore_db
