'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'        
'                                          . 28  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_task_for_restore_db_after_backup

class t_task_for_restore_db_after_backup
 private m_base
 private m_fso
 private m_backup_task
 private m_gbak_exe
 private m_gbak_service
 private m_db_local_path '      
 private m_db_user
 private m_db_password
 
 private m_db_descr      '  

 dim m_gdb_location
 dim m_log_location

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  set m_base        =new t_task_base_code
  set m_fso         =su_create_object("Scripting.FileSystemObject")
  set m_backup_task =nothing
  set m_db_descr    =new t_db_descr
  
  m_base.error_source=typename(me)
 end sub 'class_initialize

 'properties -------------------------------------------------------------
 public property get title()
  title="GBAK.RESTORE - ["&m_gdb_location&"]"
 end property

 '------------------------------------------------------------------------
 '      
 public property get gdb_location()
  gdb_location=m_gdb_location
 end property
 
 '------------------------------------------------------------------------
 '   
 public property get gdb_descr()
  set gdb_descr = m_db_descr
 end property
 
 ' ----------------------------------------------------------
 public sub init(log,                _
                 backup_task,        _
                 gbak_exe,           _
                 gbak_service,       _
                 db_local_path,      _
                 db_user,            _
                 db_password)
  set m_base.log=log

  set m_base.prog=nothing

  set m_backup_task=backup_task
  
  '     
  call m_base.depended_on_task(backup_task,true)

  '    
  m_gbak_exe            = gbak_exe
  m_gbak_service        = gbak_service
  m_db_local_path       = db_local_path
  m_db_user             = db_user
  m_db_password         = db_password
  
  m_db_descr.location   = ""
 end sub 'init

 '------------------------------------------------------------------------
 public sub depended_on_task(task)
  call m_base.depended_on_task(task,true)
 end sub 'depended_on_task

 '    -----------------------------------
 public function can_start()
  can_start=m_base.can_start()
 end function 'can_start

 '    --------------------------------------
 public function is_active()
  is_active=m_base.is_active()
 end function 'is_active

 '------------------------------------------------------------------------
 public function is_finished()
  is_finished=m_base.is_finished()
 end function 'is_finished

 '------------------------------------------------------------------------
 public function get_exit_code()
  get_exit_code=m_base.get_exit_code()
 end function 'get_exit_code

 '------------------------------------------------------------------------
 public function run(mng)
  run=false
  
  '  ,     
  if(not m_fso.FolderExists(m_db_local_path))then
   call m_base.log_error(-1,"DB FOLDER ["&m_db_local_path&"] NOT FOUND")
   
   exit function
  end if
  
  '    
  dim gbk_location
  gbk_location=m_backup_task.gbk_location
  
  if(not m_fso.FileExists(gbk_location))then
   call m_base.log_error(-1,"GBK FILE ["&gbk_location&"] NOT FOUND")
   
   exit function
  end if
  
  '        ==  
  dim gdb_path_and_base_name
  gdb_path_and_base_name=m_fso.BuildPath(m_db_local_path,m_fso.GetBaseName(gbk_location)&"_restored")
  
  dim gdb_location
  gdb_location=gdb_path_and_base_name&".gdb"
  
  if(m_fso.FileExists(gdb_location))then
   call m_base.log_error(-1,"GDB FILE ["&gdb_location&"] ALREADY EXISTS")
   
   exit function
  end if
  
  dim log_location
  log_location=gdb_path_and_base_name&".log"
  
  '    
  dim p_arg
  dim p_title
  
  p_title="GBAK.RESTORE ["&gdb_location&"]"

  if(m_gbak_service<>"")then
   p_arg=m_gbak_exe&" """&gbk_location&""""& _
         " -SE ""localhost:"&m_gbak_service&""""& _
         " -USER "&m_db_user& _
         " -PAS "&m_db_password&" -C -V -G """&gdb_location&""" -Y """&log_location&""""
 
   p_title="GBAK.RESTORE ["&gdb_location&"] THROUGH SERVICE ["&m_gbak_service&"]"
  else
   p_arg=m_gbak_exe&" """&gbk_location&""""& _
         " -USER "&m_db_user& _
         " -PAS "&m_db_password&" -C -V -G ""localhost:"&gdb_location&""" -Y """&log_location&""""

   p_title="GBAK.RESTORE ["&gdb_location&"]"
  end if

  dim prog
  set prog=new t_prog_executor
  
  set prog.log=m_base.log
  
  m_gdb_location=gdb_location
  m_log_location=log_location
  
  if(prog.exec(p_arg,p_title))then
   set m_base.prog=prog
   
   run=true
  end if
 end function 'run

 '------------------------------------------------------------------------
 public sub deactivate(mng)
  'TODO:      ,    
  '        ,  ,     
  '           
  dim msg
  
  if(get_exit_code()=0)then
   '   
   m_db_descr.host     = "localhost"
   m_db_descr.location = gdb_location
   m_db_descr.user_name= m_db_user
   m_db_descr.password = m_db_password

   m_fso.DeleteFile(m_log_location)
  end if
 end sub'deactivate
end class 't_task_for_restore_db_after_backup

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

