'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'     .
'                                        . 2  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_rpl_for_restore_rpl_next_pack_ctx

class t_rpl_for_restore_rpl_next_pack_ctx
 private m_cn
 private m_sel_restored_info_cmd
 private m_has_pack_cmd
 private m_get_pack_by_id_cmd
 private m_get_pack_by_num_cmd
 private m_get_last_pack
 private m_current_terrain_descr

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  set m_cn                   =nothing
  
  set m_sel_restored_info_cmd=nothing
  set m_has_pack_cmd         =nothing
  set m_get_pack_by_id_cmd   =nothing
  set m_get_pack_by_num_cmd  =nothing
  set m_get_last_pack        =nothing
  
  set m_current_terrain_descr=nothing
  
 end sub 'class_initialize
 
 'properties -------------------------------------------------------------
 public property get cn()
  if(m_cn is nothing)then
   set m_cn=su_create_object("ADODB.Connection")

   m_cn.Provider="LCPI.IBProvider"

   m_cn.IsolationLevel=65536
  end if

  set cn=m_cn
 end property 'cn

 '------------------------------------------------------------------------
 public property get current_terrain_global_id()
  if(m_current_terrain_descr is nothing)then
   current_terrain_global_id=null
  else
   current_terrain_global_id=m_current_terrain_descr.global_id
  end if
 end property

 '------------------------------------------------------------------------
 public property set current_terrain_descr(x)
  set m_current_terrain_descr=x
 end property
 
 '------------------------------------------------------------------------
 public function get_restored_pack_info(terrain_global_id, pack_id)
                                        
  if(m_sel_restored_info_cmd is nothing)then
   set m_sel_restored_info_cmd=su_create_object("ADODB.Command")
   
   m_sel_restored_info_cmd.activeconnection=m_cn
   
   m_sel_restored_info_cmd.commandtext= _
    "select p.*"&vbCrLf& _
    "from rpl_restored_pack p join rpl_terrain t"&vbCrLf& _
    "on p.terrain_id=t.terrain_id"&vbCrLf& _
    "where t.terrain_global_id=? and p.pack_id=?"
  end if
  
  m_sel_restored_info_cmd(0)=terrain_global_id
  m_sel_restored_info_cmd(1)=pack_id
  
  set get_restored_pack_info=m_sel_restored_info_cmd.execute()
 end function 'get_restored_pack_info
 
 '------------------------------------------------------------------------
 public function get_restored_packs_by_cat_num(terrain_global_id, _
                                               pack_cat, _
                                               pack_num)

  if(m_get_pack_by_num_cmd is nothing)then
   set m_get_pack_by_num_cmd=su_create_object("ADODB.Command")

   m_get_pack_by_num_cmd.ActiveConnection=m_cn

   m_get_pack_by_num_cmd.CommandText= _
    "select *"&vbCrLf& _
    "from rpl_restored_pack p join rpl_terrain t on p.terrain_id=t.terrain_id"&vbCrLf& _
    "where t.terrain_global_id=? and p.pack_cat=? and p.pack_num=?"
  end if

  m_get_pack_by_num_cmd(0)=terrain_global_id
  m_get_pack_by_num_cmd(1)=pack_cat
  m_get_pack_by_num_cmd(2)=pack_num
  
  set get_restored_packs_by_cat_num=m_get_pack_by_num_cmd.execute()
 end function 'get_restored_packs_by_cat_num
 
 '------------------------------------------------------------------------
 public function get_last_pack(terrain_global_id)
  if(m_get_last_pack is nothing)then
   set m_get_last_pack=su_create_object("ADODB.Command")
  end if
   
  m_get_last_pack.activeconnection=m_cn
  
  m_get_last_pack.commandtext= _
   "select p.*"&vbCrLF& _
   "from rpl_restored_pack p join rpl_terrain t"&vbCrLf& _
   "on p.terrain_id=t.terrain_id"&vbCrLF& _
   "where t.terrain_global_id = ?"&vbCrLf& _
   "order by p.pack_id desc"
   
  m_get_last_pack(0) = terrain_global_id
  
  dim rs
  set rs = m_get_last_pack.Execute()
  
  if(rs.eof)then
   set get_last_pack = nothing
   exit function
  end if

  set get_last_pack = rs
 end function'get_last_pack

 '------------------------------------------------------------------------
 public function target_has_rest_pack_by_id(terrain_global_id, _
                                            pack_id)

  if(m_get_pack_by_id_cmd is nothing)then
   set m_get_pack_by_id_cmd=su_create_object("ADODB.Command")
   
   m_get_pack_by_id_cmd.ActiveConnection=m_cn
   
   m_get_pack_by_id_cmd.CommandText= _
    "select rec_id"&vbCrLf& _
    "from rpl_restored_pack p join rpl_terrain t on p.terrain_id=t.terrain_id"&vbCrLf& _
    "where t.terrain_global_id=? and p.pack_id=?"
  end if
  
  m_get_pack_by_id_cmd(0)=terrain_global_id
  m_get_pack_by_id_cmd(1)=pack_id
  
  target_has_rest_pack_by_id=not m_get_pack_by_id_cmd.Execute().eof
 end function 'target_has_rest_pack_by_id

 '------------------------------------------------------------------------
 public function target_has_rest_pack_by_num(terrain_global_id,pack_cat,pack_num)
  target_has_rest_pack_by_num= _
   not get_restored_packs_by_cat_num(terrain_global_id,pack_cat,pack_num).eof
 end function 'target_has_rest_pack_by_num

 '------------------------------------------------------------------------
 'true -      terrain_id
 
 public function target_has_rest_packs_from_terrain(terrain_id)
  if(m_has_pack_cmd is nothing)then
   set m_has_pack_cmd=su_create_object("ADODB.Command")
   
   m_has_pack_cmd.activeconnection=m_cn
   
   m_has_pack_cmd.commandtext= _
    "select rec_id"&vbCrLf& _
    "from rpl_restored_pack p join rpl_terrain t on p.terrain_id=t.terrain_id"&vbCrLf& _
    "where t.terrain_global_id=?"
  end if
  
  m_has_pack_cmd(0)=terrain_id

  target_has_rest_packs_from_terrain=not m_has_pack_cmd.execute().eof
 end function 'target_has_rest_packs_from_terrain
 
end class 't_rpl_for_restore_rpl_next_pack_ctx

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_rpl_for_restore_rpl_packs

' 
'  [W] log
'  [W] host_name - optional. default "localhost"
'  [M] init(...)

class t_rpl_for_restore_rpl_packs
 private c_err_source
 
 private m_base
 private m_fso
 private m_rpl_packs
 private m_prog        '     
 private m_task_scan   '    
 private m_cur_pack    '  

 private m_host_name      '   .   - localhost
 private m_target_db      '   
 private m_log_files_dir  ' log-    
 
 private m_fail_rpl_packs '     
 
 private m_smtp_server
 private m_sender_id
 
 private m_exit_code
 private m_is_finished
 
 'constructor ------------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_rpl_for_restore_rpl_packs"
  
  set m_base       =new t_task_base_code
  set m_fso        =su_create_object("Scripting.FileSystemObject")
  set m_rpl_packs  =nothing
  set m_prog       =new t_prog_executor
  set m_task_scan  =nothing
  set m_cur_pack   =nothing

  set m_fail_rpl_packs=su_create_object("LCPI.DBS.Utility.Vector")

  m_base.error_source=c_err_source

  m_host_name="localhost"

  m_exit_code=0
  m_is_finished=false
 end sub 'class_initialize
 
 'properties -------------------------------------------------------------
 public property set log(x)
  set m_base.log=x
 end property
 
 '------------------------------------------------------------------------
 public property get title()
  title="RPL RESTORE PACK ["&build_target_location()&"]"
 end property
 
 '------------------------------------------------------------------------
 public property let host_name(x)
  m_host_name=x
 end property
 
 '------------------------------------------------------------------------
 private function build_target_location()
  if(m_host_name="")then
   build_target_location=m_target_db
  else
   build_target_location=m_host_name&":"&m_target_db
  end if 
 end function 'build_target_location
 
 '------------------------------------------------------------------------
 private function build_target_name()
  dim db_name
  db_name = su_get_database_file_name(build_target_location())

  dim s
  s = len(db_name)

  do while(s>=1)
   select case mid(db_name,s,1)
    case "."
     exit do
   end select

   s=s-1
  loop

  if(s<>0) then
   db_name = left(db_name,s-1)
  end if
  
  build_target_name = db_name
 end function
 
 ' ----------------------------------------------------------
 'target_db -    
 'task_scan - t_task_for_scan_rpl_packs
 
 'TODO:       target_db
 
 public sub init(target_db,          _
                 task_scan,          _
                 log_files_root_dir, _
                 smtp_server,        _
                 sender_id)

  m_target_db     =target_db
  m_log_files_dir =su_create_own_log_dir_for_db(log_files_root_dir,target_db)
  
  set m_task_scan  =task_scan
  set m_base.prog  =nothing
  set m_rpl_packs  =nothing
  set m_cur_pack   =nothing
  
  m_smtp_server    =smtp_server
  m_sender_id      =sender_id
  
  '       
  call depended_on_task(task_scan)
 end sub 'init
 
 '------------------------------------------------------------------------
 public sub depended_on_task(task)
  call m_base.depended_on_task(task,true)
 end sub 'depended_on_task

 '    -----------------------------------
 public function can_start()
  can_start=m_base.can_start()
 end function 'can_start

 '    --------------------------------------
 public function is_active()
  is_active=m_base.is_active()
 end function 'is_active

 '------------------------------------------------------------------------
 public function get_exit_code()
  get_exit_code=m_exit_code
 end function 'get_exit_code

 '------------------------------------------------------------------------
 public function is_finished()
  is_finished=m_is_finished
 end function 'is_finished

 'properties -------------------------------------------------------------
 public function fail_rpl_packs()
  set fail_rpl_packs=m_fail_rpl_packs
 end function 'fail_rpl_packs

 '------------------------------------------------------------------------
 public function run(mng)
  run=false
  
  m_exit_code=-1
  
  set m_cur_pack=nothing

  if(m_rpl_packs is nothing)then
   '  
   set m_rpl_packs=su_create_object("LCPI.DBS.Utility.Vector")

   call m_rpl_packs.Assign(m_task_scan.rpl_packs)

   call m_fail_rpl_packs.Clear()
  end if

  '---------------
  set m_base.prog  =nothing
  set m_cur_pack   =nothing

  dim err_code
  dim err_descr

  on error resume next

  set m_cur_pack=get_next_rpl_pack(mng)

  err_code  =err.number
  err_descr =err.description

  call err.clear()

  on error goto 0

  if(err_code<>0)then
   set m_cur_pack=nothing

   call m_base.log_error(err_code,err_descr)

   m_exit_code=err_code

   exit function
  end if

  if(not(m_cur_pack is nothing))then
   if(m_cur_pack.IsEmpty())then
    set m_cur_pack=nothing
   end if
  end if

  '    
  if(not (m_cur_pack is nothing))then
   call m_base.log_msg("RPL RESTORE         :"&get_packs_descr(m_cur_pack))
   call m_base.log_msg("TARGET DATABASE     :"&build_target_location())
   call m_base.log_msg("RPL PACK GDB        :"&m_cur_pack.Front.gdb_file.path)
   call m_base.log_msg("PACK DATE CREATE    :"&su_date_to_str(m_cur_pack.Front.pack_date_create))
   call m_base.log_msg("CUR PACK QUEUE SIZE :"&cstr(m_rpl_packs.Count))

   set m_prog.log=m_base.log

   dim p_arg

   p_arg="cscript.exe prog\prog_rpr_pack.wsf "

   '  
   ' terrain_id
   ' pack_id
   ' target_gdb
   ' pack_gdb
   ' log_files_dir

   'p_arg=p_arg&" /process_unk_terrain "

   p_arg=p_arg&" /terrain_global_id """&cstr(m_cur_pack.Front.terrain_global_id)&""" "
   p_arg=p_arg&                         get_pack_ids_str(m_cur_pack,"/pack_id ")
   p_arg=p_arg&" /target """&           build_target_location()&""""
   p_arg=p_arg&" /pack ""localhost:"&   m_cur_pack.front.gdb_file.path&""""
   p_arg=p_arg&" /log_dir """&          m_log_files_dir&""""
   p_arg=p_arg&" /log_sj"
   p_arg=p_arg&" /group_log_files"

   '        run

   if(m_prog.exec(p_arg,title))then
    '    
    set m_base.prog=m_prog
   else
    call m_base.log_error(-1,"FAIL START RPL RESTORE PROCESS")
   end if
  end if

  '----------------
  m_exit_code=0
  run=true
 end function 'run
 
 '------------------------------------------------------------------------
 public sub deactivate(mng)
  dim msg
  dim pack

  if(not (m_cur_pack is nothing))then
   if(not m_cur_pack.IsEmpty())then
   '   
   
    '      , m_base.get_exit_code()  -1
    dim prog_exit_code
    prog_exit_code=m_base.get_exit_code()

    if(prog_exit_code<>0)then
     msg="FAIL RPL.RESTORE "&get_packs_descr(m_cur_pack)&vbCrLf&_
         "TARGET Database:["&build_target_location()&"]"

     call m_base.log_error(prog_exit_code,msg)

     '  
     
     for each pack in m_cur_pack
      call m_fail_rpl_packs.PushBack(pack)
     next'pack

    else
     msg="PACK RESTORED "&get_packs_descr(m_cur_pack)&vbCrLf&_
         "TARGET Database:["&build_target_location()&"]"

     m_base.error_source = m_base.error_source&"_"&build_target_name()

     call m_base.log_success(msg)

     m_base.error_source=c_err_source

    end if

   end if
  end if
 
  set m_cur_pack=nothing
 
  if(m_exit_code<>0 or m_rpl_packs.IsEmpty())then
   m_is_finished=true
   exit sub
  end if
  
  '   
  call mng.add_task(me)
 end sub 'deactivate
 
 '------------------------------------------------------------------------
 private function get_next_rpl_pack(mng)
  const c_max_packs= 100

  set get_next_rpl_pack=nothing
  
  dim ctx
  set ctx=new t_rpl_for_restore_rpl_next_pack_ctx
  
  '    
  
  'TODO:  gamer  vermut
  dim cn_str
  
  cn_str="location="&build_target_location()&";"& _
         "ctype=win1251;"& _
         "ole db services=0"
  
  call ctx.cn.open(cn_str,"gamer","vermut")

  ctx.cn.IsolationLevel=65536 'adXactRepeatableRead

  call ctx.cn.BeginTrans()

  '-----------------------------------------------
  '    

  set ctx.current_terrain_descr=rpl_get_current_terrain_descr(ctx.cn)

  '-----------------------------------------------
  set get_next_rpl_pack = su_create_object("LCPI.DBS.Utility.Vector")

  dim p
  
  do while(true)
   if(m_rpl_packs.IsEmpty())then
    exit do
   end if
  
   set p=m_rpl_packs.front
  
   '  
   if(not get_next_rpl_pack.IsEmpty())then
    if(p.gdb_file.path<>get_next_rpl_pack.Front.gdb_file.path)then
     exit do '    GDB 
    end if
    
    if(p.terrain_global_id<>get_next_rpl_pack.Front.terrain_global_id)then
     exit do '    
    end if
   end if
   
   if(test_rpl_pack(ctx,p,mng,get_next_rpl_pack))then
    call get_next_rpl_pack.pushback(p)
   end if 'test_rpl_pack
   
   call m_rpl_packs.Remove(0)
  loop
  
  call ctx.cn.CommitTrans()
  call ctx.cn.Close()

  call m_base.log_msg("get_next_rpl_pack: "&get_next_rpl_pack.Count&" record(s).")
 end function 'get_next_rpl_pack
 
 '------------------------------------------------------------------------
 private function test_rpl_pack(ctx,pack_descr,mng,cur_packs)
  test_rpl_pack=false

  call m_base.log_msg("")
  call m_base.log_msg("TARGET       : "&build_target_location())
  call m_base.log_msg("TEST RPL_PACK: "&pack_descr.get_descr(true))

  call m_base.log_msg("TEST 1.")

  if(su_equal_db_value(ctx.current_terrain_global_id,pack_descr.terrain_global_id))then
   exit function '    
  end if

  '    ----------------------------------
  call m_base.log_msg("TEST 2.")

  if(not restore_of_pack_from_known_terrain(pack_descr))then
   '   
   call m_fail_rpl_packs.pushback(pack_descr)

   exit function '    
  end if


  '       --
  call m_base.log_msg("TEST 3.")

  if(source_terrain_is_disabled(pack_descr.terrain_global_id))then
   '   
   call m_fail_rpl_packs.pushback(pack_descr)

   exit function '    
  end if

  '    ------------------------------------------
  call m_base.log_msg("TEST 4.")

  if(not check_pack_create_date(ctx,pack_descr,cur_packs))then
   '    
  
   '     
   call m_fail_rpl_packs.pushback(pack_descr)

   exit function
  end if
  
  '     ------------------------------------
  call m_base.log_msg("TEST 5.")

  if(not check_pack_cat_num(ctx,pack_descr,cur_packs))then
   '   
  
   '     
   call m_fail_rpl_packs.pushback(pack_descr)

   exit function
  end if

  '    -----------------------------------
  call m_base.log_msg("TEST 6.")

  if(not check_prev_pack(ctx,pack_descr,cur_packs))then
   '     
   call m_fail_rpl_packs.pushback(pack_descr)

   '    
   call mail_previos_pack_is_missing(pack_descr,ctx,mng,cur_packs)
   
   exit function '    .    
  end if
  
  '   ---------------------------------------
  call m_base.log_msg("TEST 7.")

  if(pack_is_restored(ctx,pack_descr))then
   exit function '   
  end if

  '    --------------------
  call m_base.log_msg("TEST 8.")

  if(not last_check__can_restore_rpl_pack(ctx,pack_descr))then
   '     
   call m_fail_rpl_packs.pushback(pack_descr)

   exit function
  end if

  '   ---------------------------------------
  call m_base.log_msg("TEST_RPL_PACK - OK.")

  test_rpl_pack=true
 end function 'test_rpl_pack

 '------------------------------------------------------------------------
 private function restore_of_pack_from_known_terrain(pack_descr)
  restore_of_pack_from_known_terrain=true
 end function 'restore_of_pack_from_known_terrain
 
 '------------------------------------------------------------------------
 private function source_terrain_is_disabled(terrain_global_id)
  source_terrain_is_disabled=true
  
  dim p
  for each p in m_fail_rpl_packs
   if(p.terrain_global_id=terrain_global_id)then
    exit function
   end if
  next 'p
  
  source_terrain_is_disabled=false
 end function 'restore_of_pack_is_disabled

 '------------------------------------------------------------------------
 'pack_descr - t_rpl_pack_descr
 private function check_pack_create_date(ctx,pack_descr,cur_packs)
  check_pack_create_date=false

  if(IsNull(pack_descr.pack_date_create))then
   call send_rpl_pack_error_msg(pack_descr,"NULL RPL-Pack Create Date")
   
   exit function
  end if
  
  if(VarType(pack_descr.pack_date_create)<>vbDate)then
   call send_rpl_pack_error_msg(pack_descr, _
                                "Incorrect VB-Type of RPL-Pack Create Date:"& _
                                cstr(VarType(pack_descr.pack_date_create)))
   exit function
  end if

  if(pack_descr.pack_date_create>=Now())then
   call send_rpl_pack_error_msg(pack_descr, _
                                "ACHTUNG! Incorrect RPL-Pack Create Date:"& _
                                su_date_to_str(pack_descr.pack_date_create))
   exit function
  end if

  '    cur_packs
  
  if(not cur_packs.IsEmpty())then
   if(pack_descr.pack_date_create<cur_packs.Back.pack_date_create)then
     msg=    "BAD ORDER OF RPL-PACK DATE CREATE IN QUEUE:"&vbCrLf
     msg=msg&"Current Pack [pack_id:"&su_cstr_sn(pack_descr.pack_id)&"]: "& _
             su_date_to_str(pack_descr.pack_date_create)&vbCrLf
     msg=msg&"Prev Pack [pack_id:"&su_cstr_sn(cur_packs.Back.pack_id)&"]: "& _
             su_date_to_str(cur_packs.Back.pack_date_create)&vbCrLf

     call send_rpl_pack_error_msg(pack_descr,msg)

     exit function
   end if
  end if

  check_pack_create_date=true

 end function 'check_pack_create_date

 '------------------------------------------------------------------------
 '    
 private function check_pack_cat_num(ctx,pack_descr,cur_packs)
  '  ,    false
  check_pack_cat_num=false
 
  ' cur_packs
  
  dim x
  dim msg
  
  dim err_msgs
  set err_msgs=su_create_object("LCPI.DBS.Utility.Vector")

  for each x in cur_packs
   if(pack_descr.pack_cat=x.pack_cat and _
      pack_descr.pack_num=x.pack_num) then
      
    msg="FOUND DUBLICATE [PACK_CAT, PACK_NUM] IN QUEUE:"&vbCrLf& _
        "Wait pack: [pack_id:"&su_cstr_sn(x.pack_id)&"] "& _
         "pack_cat:"&su_cstr_sn(x.pack_cat)&" "& _
         "pack_num:"&su_cstr_sn(x.pack_num)
         
    call err_msgs.PushBack(msg)
   end if
  next 'x
  
  '    
  dim rs
  set rs=ctx.get_restored_packs_by_cat_num(pack_descr.terrain_global_id, _
                                           pack_descr.pack_cat, _
                                           pack_descr.pack_num)
  
  while not rs.eof
    if(rs("PACK_ID").value<>pack_descr.pack_id)then
     msg="FOUND RESTORED RPL-PACK WITH DUBLICATE [PACK_CAT, PACK_NUM]:"&vbCrLf& _
         "  pack_id:"&su_cstr_sn(rs("PACK_ID").value)&vbCrLf& _
         "  pack_cat:"&su_cstr_sn(rs("PACK_CAT").value)&vbCrLf& _
         "  pack_num:"&su_cstr_sn(rs("PACK_NUM").value)&vbCrLf& _
         "  create_date:"&su_date_to_str(rs("PACK_CREATE_DATE").value)&vbCrLf& _
         "  restore_date:"&su_date_to_str(rs("RESTORE_DATE").value)

     call err_msgs.PushBack(msg)
    end if

   call rs.movenext()
  wend
  
  check_pack_cat_num=err_msgs.IsEmpty()

  if(err_msgs.IsEmpty())then
   check_pack_cat_num=true
  else
   check_pack_cat_num=false

   '  
   call send_rpl_pack_error_msgs(pack_descr,err_msgs)
  end if

 end function 'check_pack_cat_num

 '------------------------------------------------------------------------
 private function pack_is_restored(ctx,pack_descr)
  pack_is_restored=false

  dim rs
  set rs=ctx.get_restored_pack_info(pack_descr.terrain_global_id,pack_descr.pack_id)

  dim err_msgs
  set err_msgs=createobject("LCPI.DBS.Utility.Vector")

  do while(not rs.eof)
   ' - , ,   
   pack_is_restored=true

   '   
   if(not IsNull(rs("pack_create_date").value))then
    if(pack_descr.pack_date_create<>rs("pack_create_date").value)then
     call err_msgs.PushBack _
          ("Different date create."&vbCrLf&_
           "Target RecID:"&su_cstr_sn(rs("rec_id").value)&vbCrLf& _
           "Target DB Date:"&su_date_to_str(rs("pack_create_date").value))
    end if
   end if 'pack_create_date is not null

   '  
   if(pack_descr.pack_cat<>rs("pack_cat").value)then
     call err_msgs.PushBack _
          ("Different pack category."&vbCrLf&_
           "Target RecID:"&su_cstr_sn(rs("rec_id").value)&vbCrLf& _
           "Target Pack Cat:"&su_cstr_sn(rs("pack_cat").value))
   end if

   '  
   if(pack_descr.pack_num<>rs("pack_num").value)then
     call err_msgs.PushBack _
          ("Different pack number."&vbCrLf&_
           "Target RecID:"&su_cstr_sn(rs("rec_id").value)&vbCrLf& _
           "Target Pack Number:"&su_cstr_sn(rs("pack_num").value))
   end if

   call rs.movenext()
  loop 'not rs.eof

  if(not err_msgs.IsEmpty())then
   '     
   call m_fail_rpl_packs.PushBack(pack_descr)

   '  
   call send_rpl_pack_error_msgs(pack_descr,err_msgs)
  end if ' 
 end function 'pack_is_restored
 
 '------------------------------------------------------------------------
 ' err_msgs - LCPI.DBS.Utility.Vector   
 private sub send_rpl_pack_error_msgs(pack_descr,err_msgs)
  dim msg
  dim i
   
  for i=0 to err_msgs.Count-1
   if(msg<>"")then
    msg=msg&vbCrLf&"----------"&vbCrLf
   end if
    
   msg=msg&su_fnum(i,3)&". "&err_msgs(i)
  next 'i

  call send_rpl_pack_error_msg(pack_descr,msg)
 end sub 'send_rpl_pack_error_msgs
 
 '------------------------------------------------------------------------
 ' err_msg -    
 private sub send_rpl_pack_error_msg(byval pack_descr,byval err_msg)
  dim msg
  
  msg="Terrain:"&cstr(pack_descr.terrain_name)&vbCrLf& _
      "TerrainGlobalID:"&cstr(pack_descr.terrain_global_id)&vbCrLf&_
      "PackID:"&su_cstr_sn(pack_descr.pack_id)&vbCrLf&_
      "PackCat:"&su_cstr_sn(pack_descr.pack_cat)&vbCrLf&_
      "PackNum:"&su_cstr_sn(pack_descr.pack_num)&vbCrLf&_
      "Created:"&su_date_to_str(pack_descr.pack_date_create)&vbCrLf&_
      "GDB:"&pack_descr.gdb_file.path&vbCrLf&vbCrLf&_
      err_msg

  call m_base.log_error(-1,msg)
 end sub 'send_rpl_pack_error_msg

 '------------------------------------------------------------------------
 private function check_prev_pack(ctx,pack_descr,cur_packs)
  check_prev_pack=true
  
  if(ctx.target_has_rest_pack_by_id(pack_descr.terrain_global_id, _
                                    pack_descr.pack_id-1))then
   '  
   exit function
  end if
  
  if(not (IsNull(pack_descr.pack_cat) or IsNull(pack_descr.pack_num)))then
   '    

   'TODO:     

   if(pack_descr.pack_cat=2)then
    '     SNAPSHOT 
    '    
    exit function
   end if

   if(ctx.target_has_rest_pack_by_num(pack_descr.terrain_global_id, _
                                      pack_descr.pack_cat,   _
                                      pack_descr.pack_num-1))then
    exit function
   end if
  end if
  
  if(not cur_packs.IsEmpty())then
   if((pack_descr.terrain_global_id = cur_packs.Back.terrain_global_id) _
       and _
      (pack_descr.pack_id-1= cur_packs.Back.pack_id))then
    exit function
   end if
   
   if((pack_descr.terrain_global_id = cur_packs.Back.terrain_global_id)_
       and _
      ((pack_descr.pack_cat = cur_packs.Back.pack_cat) _
        and _
       (pack_descr.pack_num - 1 = cur_packs.Back.pack_num)))then
       
    exit function
   end if
  end if

  'DONE:       
  ' -       prog_rpr_pack
  ' -         
  '    __ .
  
  if((not ctx.target_has_rest_packs_from_terrain(pack_descr.terrain_global_id)) _
     and _
    (cur_packs.IsEmpty())) then
   '  -     
   exit function
  end if

  'DONE:     
  dim msg
  
  msg="CAN'T RESTORE RPL.PACK "&pack_descr.get_descr(true)&vbCrLf& _
      "PREVIOUS RPL PACK NOT FOUND."&vbCrLf& _
      "TARGET DATABASE: "&build_target_location()
      
  call m_base.log_error(-1,msg)
  
  check_prev_pack=false
 end function 'check_prev_pack
 
 '------------------------------------------------------------------------
 '    

 private function last_check__can_restore_rpl_pack(ctx,pack_descr)
  last_check__can_restore_rpl_pack=false
  
  if(not last_check__prev_date_create(ctx,pack_descr))then
   exit function '     
  end if

  last_check__can_restore_rpl_pack=true
 end function 'last_check__can_restore_rpl_pack

 '------------------------------------------------------------------------
 private function last_check__prev_date_create(ctx,pack_descr)
  last_check__prev_date_create=false

  '     
  ' ,       cur_packs 
  '       -      
  dim rs
  set rs=ctx.get_last_pack(pack_descr.terrain_global_id)

  dim msg
  dim rs_pack_create_date

  if(not (rs is nothing))then
   ', ,     ,
   ' ,  .

   rs_pack_create_date=rs("PACK_CREATE_DATE").value

   if(not IsNull(rs_pack_create_date))then
    if(pack_descr.pack_date_create<rs_pack_create_date)then
     msg=    "BAD ORDER OF RPL-PACK DATE CREATE:"&vbCrLf
     msg=msg&"Current Pack [pack_id:"&su_cstr_sn(pack_descr.pack_id)&"]: "& _
             su_date_to_str(pack_descr.pack_date_create)&vbCrLf
     msg=msg&"Last Restored Pack [pack_id:"&su_cstr_sn(rs("PACK_ID").value)&"]: "& _
             su_date_to_str(rs_pack_create_date)&vbCrLf

     call m_base.log_error(-1,msg)

     exit function
    end if
   end if
  end if

  set rs=nothing

  last_check__prev_date_create=true
 end function 'last_check__prev_date_create

 '-------------------------------------------------------------------------
 private sub mail_previos_pack_is_missing(pack_descr,ctx,mng,cur_packs)

  if(IsEmpty(m_sender_id) or IsEmpty(m_smtp_server))then
   call m_base.log_warning(0,"Sender_id or smtp server is unknown")
   exit sub
  else
   if(m_sender_id = "" or m_smtp_server = "")then
    call m_base.log_warning(0,"Sender_id or smtp server is unknown")
    exit sub
   end if
  end if

  dim cmd
  set cmd = su_create_object("ADODB.Command")

  cmd.activeconnection = ctx.cn

  cmd.commandtext = "select txt_data from get_prop_in_named_container("&vbCrLf& _
                    "(select sts_container_name from rpl_terrain"&vbCrLF& _
                    "where terrain_global_id = ?),'re_rpl_terrain_info')"

  cmd(0) = pack_descr.terrain_global_id

  dim rs
  set rs = cmd.execute
  
  dim data_txt
  dim toids

  if (not rs.eof)then
   data_txt = rs("txt_data").value

   if(data_txt<>"")then
   
    call get_toids(data_txt,toids)
    if(toids = "")then
     call m_base.log_warning(0,"Mail receiver not configured in "&build_target_name)
     exit sub
    end if

    dim task_mail
    set task_mail = new t_task_for_send_mail
    set task_mail.log = m_base.log
    
    dim prev_pack
    set prev_pack = ctx.get_last_pack(pack_descr.terrain_global_id)
    
    dim prev_pack_create_date
    
    if(prev_pack is nothing)then
     prev_pack_create_date = su_date_to_str(cur_packs.Back.pack_date_create)
    else
     prev_pack_create_date = su_date_to_str(prev_pack("pack_create_date").value)
    end if

    dim msg
    msg= _
     " ["&pack_descr.terrain_name&"]"&vbCrLf&_
     "  ."&vbCrLf&vbCrLf& _
     "    "&prev_pack_create_date&"."&vbCrLf& _
     "       "&pack_descr.pack_date_create&vbCrLf& _
      vbCrLf&_
     ",     E-Mail    , "& _
      "    "&prev_pack_create_date&"  "&pack_descr.pack_date_create&"."&vbCrLf&vbCrLf& _
     "."

    call task_mail.init(toids, _
                        m_sender_id, _
                        m_smtp_server, _
                        "    ", _
                        msg, _
                        nothing)
                        
    call mng.add_task(task_mail)
   else
    call m_base.log_warning(0,"Mail receiver not configured in "&build_target_name)
   end if
  end if

 end sub 'mail_previos_pack_is_missing
 
 '------------------------------------------------------------------------
 private sub get_toids(data_txt,toids)
  dim xml_doc
  
  set xml_doc = su_create_object("MSXML2.DOMDocument")
  xml_doc.LoadXML(data_txt)
  
  dim rpl_mail_operator
  set rpl_mail_operator=xml_doc.selectSingleNode("data/rpl_operator_mail")
  
  toids = trim(rpl_mail_operator.text)
 end sub 'get_toids
 
 '------------------------------------------------------------------------
 private function get_packs_descr(v_packs)
  dim t

  t="TerrainGlobalID ["&cstr(v_packs.Front.terrain_global_id)&"] - " _
     &v_packs.Front.terrain_name & vbCrLf
  
  t=t&"PackIDs: "&get_pack_ids_str(v_packs,"")

  get_packs_descr=t
 end function'get_packs_descr
 
 '------------------------------------------------------------------------
 private function get_pack_ids_str(v_packs,add_str)
  dim t
  dim pack
  for each pack in v_packs
   t=t&add_str&cstr(pack.pack_id)&" "
  next'pack
  
  get_pack_ids_str = t
 end function'get_pack_ids_str
 
end class 't_rpl_for_restore_rpl_packs

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

