'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'        
'                                        . 2  2004 

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_task_for_rpl_backup

class t_task_for_rpl_backup
 private c_err_source

 private m_base

 private m_source_db_descr    ' class t_db_descr
 private m_pack_db_descr      ' class t_db_descr

 private m_root_log_dir            '    -

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_task_for_rpl_backup"

  set m_base=new t_task_base_code

  m_base.error_source=c_err_source

  set m_source_db_descr = nothing
  set m_pack_db_descr   = nothing
 end sub 'class_initialize

 'properties -------------------------------------------------------------
 public property set log(x)
  set m_base.log=x
 end property

 '------------------------------------------------------------------------
 public property get title()
  dim t1,t2

  if(not (m_source_db_descr is nothing))then t1=m_source_db_descr.data_source

  if(not (m_pack_db_descr is nothing))then t2=m_pack_db_descr.data_source

  title="RPL.BACKUP ["&t1&"] TO ["&t2&"]"
 end property 'title

 ' ----------------------------------------------------------
 public sub init(source_db_descr,pack_db_descr,root_log_dir)
  set m_source_db_descr =source_db_descr
  set m_pack_db_descr   =pack_db_descr

  m_root_log_dir=root_log_dir

  set m_base.prog=nothing
 end sub 'init

 '------------------------------------------------------------------------
 public sub depended_on_task(task)
  call m_base.depended_on_task(task,true)
 end sub 'depended_on_task

 '    -----------------------------------
 public function can_start()
  can_start=m_base.can_start()
 end function 'can_start

 '    --------------------------------------
 public function is_active()
  is_active=m_base.is_active()
 end function 'is_active

 '------------------------------------------------------------------------
 public function get_exit_code()
  get_exit_code=m_base.get_exit_code()
 end function 'get_exit_code

 '------------------------------------------------------------------------
 public function is_finished()
  is_finished=m_base.is_finished()
 end function 'is_finished

 '------------------------------------------------------------------------
 public function run(mng)
  run=false

  dim own_log_dir
  own_log_dir=su_create_own_log_dir_for_db(m_root_log_dir,m_source_db_descr.location)

  '      
  dim p_arg
  p_arg="prog_rpb_pack.wsf"                                          & _
           " /source """      & m_source_db_descr.data_source & """" & _
           " /source_user """ & m_source_db_descr.user_name   & """" & _
           " /source_pswd """ & m_source_db_descr.password    & """" & _
           " /pack """        & m_pack_db_descr.data_source   & """" & _
           " /backup_mps 40000"                                      & _
           " /backup_mpc 320"                                        & _
           " /log_dir """     & own_log_dir                   & """" & _
           " /log_sj"

  dim prog
  set prog=new t_prog_executor

  set prog.log=m_base.log

  if(prog.exec(p_arg,title))then
   set m_base.prog=prog

   run=true
  end if
 end function 'run

 '------------------------------------------------------------------------
 public sub deactivate(prog)
 end sub 'deactivate
end class 't_task_for_rpl_backup
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

