'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'        
'                                                   .     18.08.2005
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class t_task_for_save_sts_and_dsx
 private c_err_source
 private m_base
 private m_db_descr
 private m_dir_str

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  c_err_source = "t_task_for_save_sts_and_dsx"
  set m_base = new t_task_base_code

  m_base.error_source = c_err_source
 end sub'class_initialize

 '    -----------------------------------
 public function can_start()
  can_start=m_base.can_start()
 end function 'can_start

  '-----------------------------------------------------------------------------
  '                               Public 
  '-----------------------------------------------------------------------------

  Public Property Get title()
    title = "ARCHIVE_SETTINGS_DSX"

    If (Not (m_db_descr Is Nothing)) Then
      title = title & " - [" & m_db_descr.data_source & "]"
    End If
  End Property  ' title

 '    --------------------------------------
 public function is_active()
  is_active=m_base.is_active()
 end function 'is_active

 '------------------------------------------------------------------------
 public function is_finished()
  is_finished=m_base.is_finished()
 end function 'is_finished

 '------------------------------------------------------------------------
 public function get_exit_code()
  get_exit_code=m_base.get_exit_code()
 end function 'get_exit_code

  '------------------------------------------------------------------------
 public sub depended_on_task(task,success)
  call m_base.depended_on_task(task,success)
 end sub'depended_on_task

 '------------------------------------------------------------------------
 private function build_target_location()
  if(m_db_descr.host="")then
   build_target_location=m_db_descr.data_source
  else
   build_target_location=m_db_descr.host&":"&m_db_descr.data_source
  end if
 end function'build_target_location

 '------------------------------------------------------------------------
 public sub init(log,db_descr,save_dir)
  set m_base.log  = log

  set m_db_descr  = db_descr

  m_dir_str = save_dir
 end sub 'init

 '------------------------------------------------------------------------
 public function run(mng)
  run=false

  '------
  dim prog_arg

  prog_arg = "prog_archive_sts_dsx.wsf "& _
              "/db """&m_db_descr.data_source&""" "& _
              "/user "&m_db_descr.user_name&" "& _
              "/pswd "&m_db_descr.password&" "& _
              "/dir """&m_dir_str&""" "& _
              "/no_event"

  '------
  dim prog_title

  prog_title="BACKUP STS/DSX OF "&m_db_descr.data_source

  '------     
  dim prog
  set prog=new t_prog_executor
  set prog.log=m_base.log

  run=prog.exec(prog_arg,prog_title)

  if(run)then
   set m_base.prog=prog
  end if
 end function

 '------------------------------------------------------------------------
 public sub deactivate(mng)

 end sub
end class't_task_for_save_sts_and_dsx


