'*******************************************************************************
 '        
 '   , 22.06.2007
'*******************************************************************************

Option Explicit

'*******************************************************************************
'                      t_task_for_send_archive_by_mail
'*******************************************************************************

'        
Class t_task_for_send_archive_by_mail
  Private m_base          ' t_task_base_code

  Private m_smtp_server   ' SMPT-
  Private m_mail_config   '  
  Private m_subject       '  

  Private m_task_archive  '  

  '-----------------------------------------------------------------------------
  ' 
  Private Sub class_initialize()
    Set m_base         = New t_task_base_code

    Set m_task_archive = Nothing
  End Sub  ' class_initialize

  '-----------------------------------------------------------------------------
  '  
  Public Sub init(log, smtp_server, mail_config, subj, task_archive)
    Set m_base.log  = log
    Set m_base.prog = Nothing

    m_smtp_server      = smtp_server
    m_mail_config      = mail_config
    m_subject          = subj

    Set m_task_archive = task_archive
  End Sub  ' init

  '-----------------------------------------------------------------------------
  '                               Public 
  '-----------------------------------------------------------------------------

  Public Property Get title()
    title = "SEND_ARCHIVE_BY_MAIL"

    If (su_is_not_empty_object(m_task_archive)) Then
      Dim file_path : file_path = m_task_archive.get_dest_location()

      If (su_is_not_empty_string(file_path)) Then
        title = title & " [" & file_path & "]"
      End If
    End If
  End Property  ' title

  '-----------------------------------------------------------------------------
  '                                Public 
  '-----------------------------------------------------------------------------

  Public Sub depended_on_task(task)
    Call m_base.depended_on_task(task, True)
  End Sub  ' depended_on_task

  '-----------------------------------------------------------------------------
  '    
  Public Function can_start()
    can_start = m_base.can_start()
  End Function  ' can_start

  '-----------------------------------------------------------------------------
  '    
  Public Function is_active()
    is_active = m_base.is_active()
  End Function  ' is_active

  '-----------------------------------------------------------------------------
  '    
  Public Function is_finished()
    is_finished = m_base.is_finished()
  End Function  ' is_finished

  '-----------------------------------------------------------------------------
  Public Function get_exit_code()
    get_exit_code = m_base.get_exit_code()
  End Function  ' get_exit_code

  '-----------------------------------------------------------------------------
  '  
  Public Function run(mng)
    run = False

    '-----------------------------------
    '    
    If (su_is_empty_object(m_task_archive)) Then
      Call send_error(err_code,err_source,err_descr)
      Call m_base.log.send_error(-1, TypeName(Me) & " -> run", "NOT SET ARCHIVE TASK")
      Exit Function
    End If

    Dim file_path : file_path = m_task_archive.get_dest_location()

    '    
    If (su_is_empty_string(file_path)) Then
      Call m_base.log.send_error(-1, TypeName(Me) & " -> run", "EMPTY ARCHIVE FILENAME")
      Exit Function
    End If

    '    
    If (su_is_empty_string(m_mail_config)) Then
      Call m_base.log.send_error(-1, TypeName(Me) & " -> run", "EMPTY CONFIG FILENAME")
      Exit Function
    End If

    '    
    If (su_is_empty_string(m_subject)) Then
      Call m_base.log.send_error(-1, TypeName(Me) & " -> run", "EMPTY SUBJECT")
      Exit Function
    End If

    Dim fso : Set fso = su_create_object("Scripting.FileSystemObject")

    '     
    If (Not fso.FileExists(file_path)) Then
      Call m_base.log.send_error(-1, TypeName(Me) & " -> run", "ARCHIVE FILE [" & file_path & "] NOT FOUND")
      Exit Function
    End If

    '    
    If (Not fso.FileExists(m_mail_config)) Then
      Call m_base.log.send_error(-1, TypeName(Me) & " -> run", "CONFIG FILE [" & m_mail_config & "] NOT FOUND")
      Exit Function
    End If

    '-----------------------------------

    Dim smtp_param : smtp_param = vbNullString
    If (su_is_not_empty_string(m_smtp_server)) Then
      smtp_param = " /server """ & m_smtp_server & """"
    End If

    Dim p_arg
    p_arg = "prog_mailer.wsf"                       & _
            " /cfg_file """  & m_mail_config & """" & _
                               smtp_param           & _
            " /subj """      & m_subject     & """" & _
            " /attach """    & file_path     & """"

    Dim prog : Set prog = New t_prog_executor
    Set prog.log = m_base.log

    If (prog.exec(p_arg, me.title)) Then
      Set m_base.prog = prog
      run = True
    End If
  End Function  ' run

  '-----------------------------------------------------------------------------
  Public Sub deactivate(mng)
  End Sub ' deactivate

  '-----------------------------------------------------------------------------
End Class  ' t_task_for_send_archive_by_mail

'*******************************************************************************