'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'    RPL_JOURNAL     
'                                       . 31  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_task_for_start_rpl_backup

class t_task_for_start_rpl_backup
 private c_err_source
 
 private m_base
 private m_fso
 private m_gbak_exe
 private m_source_db_descr             'class t_db_descr

 'GBK   
 private m_template_rpl_pack_gbk

 ',      
 private m_temp_gdb_dir

 ',      
 private m_target_gdb_dir

 '   - 
 private m_log_dir

 '------------------------------------------------------------------------
 private m_last_task   '   

 private m_exit_code
 private m_is_finished

 '------------------------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_task_for_start_rpl_backup"
  
  set m_base            =new t_task_base_code
  set m_fso             =su_create_object("Scripting.FileSystemObject")
  set m_source_db_descr =nothing
  
  m_base.error_source=c_err_source

  set m_last_task=nothing

  m_exit_code  =-1
  m_is_finished=false
 end sub 'class_initialize
 
 'properties -------------------------------------------------------------
 public property set log(x)
  set m_base.log=x
 end property

 '------------------------------------------------------------------------
 public property get title()
  dim t
  
  if(m_source_db_descr is nothing)then
   t="???"
  else
   t=m_source_db_descr.data_source
  end if
 
  title="STARTER OF RPL.BACKUP FOR ["&t&"]"
 end property 'title
 
 ' ----------------------------------------------------------
 public sub init(gbak_exe, _
                 source_db_descr, _
                 template_rpl_pack_gbk, _
                 temp_gdb_dir, _
                 target_gdb_dir, _
                 log_dir)
  m_gbak_exe               = gbak_exe
  set m_source_db_descr    = source_db_descr
  m_template_rpl_pack_gbk  = template_rpl_pack_gbk

  m_temp_gdb_dir   =trim(temp_gdb_dir)
  m_target_gdb_dir =trim(target_gdb_dir)

  m_log_dir        =log_dir

  set m_base.prog=nothing

  set m_last_task=nothing
  
  m_exit_code  =-1
  m_is_finished=false
 end sub 'init
 
 '------------------------------------------------------------------------
 public sub depended_on_task(task)
  call m_base.depended_on_task(task,true)
 end sub 'depended_on_task

 '    -----------------------------------
 public function can_start()
  can_start=m_base.can_start()
 end function 'can_start

 '    --------------------------------------
 public function is_active()
  is_active=false
 end function 'is_active

 '------------------------------------------------------------------------
 public function get_exit_code()
  get_exit_code=m_exit_code
 end function 'get_exit_code

 '------------------------------------------------------------------------
 public function is_finished()
  'TODO:      RPL.BACKUP
  if(m_last_task is nothing)then
   is_finished=m_is_finished
  else
   is_finished=m_last_task.is_finished()
  end if
 end function 'is_finished

 '------------------------------------------------------------------------
 public function run(mng)
  run=false

  dim cn
  set cn=su_create_object("ADODB.Connection")
  
  cn.Provider="LCPI.IBProvider"
  
  call cn.Open("location="&m_source_db_descr.data_source&";ctype=win1251;"& _
               "ole db services=0", _
               m_source_db_descr.user_name, _
               m_source_db_descr.password)
               
  cn.IsolationLevel=65536
  
  call cn.BeginTrans()
  
  dim cmd
  set cmd=su_create_object("ADODB.Command")
  
  cmd.activeconnection=cn
  
  cmd.commandtext="select * from rpl_journal where pack_id is null"
  
  if(not cmd.execute.eof)then
   '    .   
   '   
   
   call m_base.log_msg("RPL JOURNAL HAS NOT PROCESSED RECORDS")

   '       
   dim err_count
   
   err_count=0
   
   '----------
   if(len(m_temp_gdb_dir)=0)then
    call m_base.log_error(-1,"        .")
    
    err_count=err_count+1
   end if

   '----------
   if(len(m_target_gdb_dir)=0)then
    call m_base.log_error(-1,"    GDB-   .")

    err_count=err_count+1
   end if

   '----------
   if(len(m_template_rpl_pack_gbk)=0)then
    call m_base.log_error(-1,"  GBK-    .")

    err_count=err_count+1
   end if

   '----------
   if(len(m_log_dir)=0)then
    call m_base.log_error(-1,"     - .")

    err_count=err_count+1
   end if

   '------------------------------------
   '0.      
   dim current_terrain_descr
   set current_terrain_descr=rpl_get_current_terrain_descr(cn)

   dim current_terrain_global_id

   if(current_terrain_descr is nothing)then
    current_terrain_global_id=null
   else
    current_terrain_global_id=current_terrain_descr.global_id
   end if

   if(IsNull(current_terrain_global_id))then
    call m_base.log_error(-1,"   ["&m_source_db_descr.location&"]")

    err_count=err_count+1
   end if

   if(err_count<>0)then
    exit function
   end if

   '------------------------------------
   '1.    
   '    -    ,     

   dim rpl_pack_location
   
   '  
   rpl_pack_location="RPL_PACK_"&su_gen_ts_str()&"_"&cstr(current_terrain_global_id)&".gdb"
   
   '      
   rpl_pack_location=m_fso.BuildPath(m_temp_gdb_dir,rpl_pack_location)

   '    
   dim rpl_pack_descr
   set rpl_pack_descr=new t_db_descr
   
   rpl_pack_descr.location  = rpl_pack_location
   rpl_pack_descr.user_name = "gamer"
   rpl_pack_descr.password  = "vermut"

   '--------------------------------
   dim restore_pack_task
   set restore_pack_task=new t_task_for_restore_db
   
   call restore_pack_task.init(m_base.log, _
                               m_gbak_exe, _
                               m_template_rpl_pack_gbk, _
                               rpl_pack_descr)
   
   call mng.add_task(restore_pack_task)
   
   '--------------------------------
   '2.  
   dim rpl_backup_task
   set rpl_backup_task=new t_task_for_rpl_backup
   set rpl_backup_task.log=m_base.log

   call rpl_backup_task.init(m_source_db_descr, _
                             rpl_pack_descr,    _
                             m_log_dir)
   
   '       
   call rpl_backup_task.depended_on_task(restore_pack_task)
   
   call mng.add_task(rpl_backup_task)
   
   '---------------------------------
   '3.  
   
   dim finish_task
   set finish_task=new t_task_for_finish_rpl_backup
   
   set finish_task.log=m_base.log
   
   call finish_task.init(rpl_pack_descr,m_target_gdb_dir)
   
   '     
   '     
   call finish_task.depended_on_task(rpl_backup_task,false)
   
   call mng.add_task(finish_task)
   
   '---------------------------------
   set m_last_task=finish_task
  end if
  
  call cn.CommitTrans()
  
  m_is_finished=true
  m_exit_code=0
  
  run=true
 end function 'run
 
 '------------------------------------------------------------------------
 public function deactivate(mng)
 end function 'deactivate
end class 't_task_for_start_rpl_backup

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
