'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'       
'                                         . 31  2005 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_task_for_sweep_db

class t_task_for_sweep_db
 private m_base                   'class t_task_base_code

 private m_gfix_exe
 private m_db_descr

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  set m_base     =new t_task_base_code
  set m_db_descr =nothing

  m_base.error_source=typename(me)
 end sub 'class_initialize

 'properties -------------------------------------------------------------
 public property get title()
  dim t
  t = ""

  if(not(m_db_descr is nothing))then
   t = " - ["&m_db_descr.data_source&"]"
  end if

  title="GFIX.SWEEP"&t
 end property 'title
 
 ' ----------------------------------------------------------
 public sub init(log,           _
                 gfix_exe,      _
                 db_descr)
  set m_base.log  =log

  set m_base.prog = nothing

  set m_db_descr  = db_descr
  
  m_gfix_exe      = gfix_exe
 end sub 'init

 '------------------------------------------------------------------------
 public sub depended_on_task(task)
  call m_base.depended_on_task(task,true)
 end sub 'depended_on_task

 '    -----------------------------------
 public function can_start()
  can_start=m_base.can_start()
 end function 'can_start

 '    --------------------------------------
 public function is_active()
  is_active=m_base.is_active()
 end function 'is_active

 '------------------------------------------------------------------------
 public function is_finished()
  is_finished=m_base.is_finished()
 end function 'is_finished

 '------------------------------------------------------------------------
 public function get_exit_code()
  get_exit_code=m_base.get_exit_code()
 end function 'get_exit_code

 '------------------------------------------------------------------------
 public function run(mng)
  run=false

  dim p_arg

  p_arg=m_gfix_exe&" """&m_db_descr.data_source&""""& _
                   " -SWEEP"& _
                   " -USER "&m_db_descr.user_name& _
                   " -PASSWORD "&m_db_descr.password
                   
  dim prog
  set prog=new t_prog_executor
  set prog.log=m_base.log

  if(prog.exec(p_arg,me.title))then
   set m_base.prog=prog
   run=true
  else
   run=false
  end if
 end function 'run

 '------------------------------------------------------------------------
 public sub deactivate(mng)
 end sub'deactivate
end class 't_task_for_sweep_db

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
