'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'              .    24.01.2006 .
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

option explicit
'-------------------------------------------------------------------------
class t_task_for_terminate_processes
 private c_err_source
 private m_base
 
 private m_args
 private m_tmp_file

 private m_exit_code
 private m_is_finished
 
 
 ' ------------------------------------------------------------
 public sub class_initialize()
  c_err_source="t_task_for_terminate_processes"
  
  set m_base = new t_task_base_code
  set m_tmp_file = new t_temp_file

  m_is_finished=false
  m_exit_code=-1
  
  m_base.error_source = c_err_source
 end sub'class_initialize
 
 'properties -------------------------------------------------------------
 public property set log(x)
  set m_base.log=x
 end property
 
 '    -----------------------------------
 public function can_start()
  can_start=m_base.can_start()
 end function 'can_start

  '------------------------------------------------------------------------
 property get title()
  title=c_err_source
 end property

 '    --------------------------------------
 public function is_active()
  is_active=m_base.is_active()
 end function 'is_active

 '------------------------------------------------------------------------
 public function get_exit_code()
  get_exit_code=m_base.get_exit_code()
 end function 'get_exit_code

 '------------------------------------------------------------------------
 public function is_finished()
  is_finished=m_base.is_finished()
 end function 'is_finished

 '------------------------------------------------------------------------
 ' machine - ,    
 public sub init(db_descr, db_charset, _
                 terminate_file, cfg_file, kill_min, kill_hour, kill_day)
  
  '      
  m_args = "cscript.exe prog\prog_proc_terminate.wsf"& _
                   " /db "&db_descr.data_source&       _
                   " /db_user "&db_descr.user_name&    _
                   " /db_pswd "&db_descr.password&     _
                   " /db_charset "&db_charset&         _
                   " /terminate "&terminate_file&      _
                   " /cfg_file "&cfg_file&             _
                   " /kill_min "&kill_min&             _
                   " /kill_hour "&kill_hour&           _
                   " /kill_day "&kill_day
  
 end sub'init
 
 '------------------------------------------------------------------------
 public function run(mng)
  '    ----------------------------
  run =false

  dim prog
  set prog = new t_prog_executor
  
  set prog.log=m_base.log

  if(prog.exec(m_args,"[Terminate Processes]"))then
   set m_base.prog=prog
   run = true
  end if

  '---------------
 end function'run
 
 '------------------------------------------------------------------------
 public sub deactivate(mng)
  dim err_code

  err_code=get_exit_code()

  if(err_code<>0)then
   if(not (m_base.log is nothing))then
    call m_base.log.send_warning(err_code,"FAIL TERMINATE PROCESS.","")
   end if
  else
   if(not(m_base.log is nothing))then
    call m_base.log.send_msg("TERMINATE PROCESS COMPLETE")
   else
    call wscript.echo("TERMINATE PROCESS COMPLETE")
   end if
  end if

 end sub'deactivate
 
end class't_task_for_terminate_processes
