'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'       
'                                          . 29  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_task_for_unzip_rpl_pack

class t_task_for_unzip_rpl_pack
 private c_err_source
 
 private m_base
 private m_fso
 
 private m_zip_file            '  
 private m_dest_dir            '       
 private m_tmp_dir             '       
 private m_tmp_subdir_prefix   '  
 
 private m_own_tmp_dir_location

 private m_exit_code
 private m_is_finished
 
 'constructor ------------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_task_for_unzip_rpl_pack"
  
  set m_base =new t_task_base_code
  set m_fso  =su_create_object("Scripting.FileSystemObject")
  
  m_base.error_source=c_err_source
  
  '-------------
  m_exit_code=-1
  m_is_finished=false
 end sub 'class_initialize

 'properties -------------------------------------------------------------
 public property set log(x)
  set m_base.log=x
 end property

 '------------------------------------------------------------------------
 public property get title()
  title="RPL.UNZIP_IN_FILE ["&m_zip_file&"]"
 end property

 ' ----------------------------------------------------------
 public sub init(zip_file, _
                 dest_dir, _
                 tmp_dir,  _
                 tmp_subdir_prefix)
  m_zip_file = trim(zip_file)
  m_dest_dir = dest_dir
  m_tmp_dir  = tmp_dir
  
  m_tmp_subdir_prefix= tmp_subdir_prefix

  '-------------
  m_exit_code=-1
  m_is_finished=false
 end sub 'init
 
 '------------------------------------------------------------------------
 public sub depended_on_task(task)
  call m_base.depended_on_task(task,true)
 end sub 'depended_on_task

 '    -----------------------------------
 public function can_start()
  can_start=m_base.can_start()
 end function 'can_start

 '    --------------------------------------
 public function is_active()
  is_active=m_base.is_active()
 end function 'is_active

 '------------------------------------------------------------------------
 public function get_exit_code()
  get_exit_code=m_exit_code
 end function 'get_exit_code

 '------------------------------------------------------------------------
 public function is_finished()
  is_finished=m_is_finished
 end function 'is_finished

 '------------------------------------------------------------------------
 public function run(mng)
  run=false

  if(m_zip_file="")then
   call m_base.log_error(-1,"EMPTY ZIP FILE NAME")
   exit function
  end if

  '      (  deactivate)
  if(not create_tmp_folder())then
   exit function
  end if
  
  '       -----------
  dim p_arg

  if(not make_prog_arg(p_arg))then
   exit function
  end if
  
  dim prog
  set prog=new t_prog_executor
  set prog.log=m_base.log
  
  if(prog.exec(p_arg,title))then
   set m_base.prog=prog
   run=true
  end if
 end function 'run

 '------------------------------------------------------------------------
 public sub deactivate(mng)
  '   ,       
  if(m_base.is_active())then
   call m_base.log_error(-1,"ARCHIVATOR IS ACTIVE !!!")
   exit sub
  end if

  '  
  if(m_base.get_exit_code()<>0)then
   exit sub
  end if

  '    
  m_is_finished=true

  '      GBK 
  dim err_code,err_source,err_descr

  on error resume next

  call su_move_files(m_own_tmp_dir_location,m_dest_dir)

  err_code   = err.number
  err_source = err.source
  err_descr  = err.description
  
  call err.clear()

  on error goto 0
  
  if(err_code<>0)then
   call m_base.log.send_error(err_code,err_source,err_descr)
   
   exit sub
  end if
  
  '      
  m_exit_code=0
  
  '     -    
  
  call m_base.log_msg("REMOVE ZIP FILE ["&m_zip_file&"]")

  on error resume next
  call m_fso.DeleteFile(m_zip_file,true)
  
  err_code=err.number
  err_descr=err.description
  
  call err.clear()
  
  on error goto 0
  
  if(err_code<>0)then
   call m_base.log_error(err_code,"FAIL REMOVE ZIP FILE ["&m_zip_file&"]"&vbCrLf&err_descr)
  end if
  
  '   
  on error resume next
  call m_fso.DeleteFolder(m_own_tmp_dir_location,true)

  err_code=err.number
  err_descr=err.description

  call err.clear()
  
  on error goto 0

  if(err_code<>0)then
   call m_base.log_error(err_code,"FAIL REMOVE OWN TEMP FOLDER ["&m_own_tmp_dir_location&"]"&vbCrLf&err_descr)
  end if
 end sub 'deactivate
 
 '  -------------------------------------------------
 private function create_tmp_folder()
  create_tmp_folder=false
  
  dim err_code
  dim err_descr
  
  '       
  if(not m_fso.FolderExists(m_tmp_dir))then
   call m_base.log_error(-1,"ROOT DIR ["&m_tmp_dir&"] FOR TEMP FOLDER NOT FOUND")
   exit function
  end if

  '       
  m_own_tmp_dir_location= _
   m_fso.BuildPath(m_tmp_dir,m_tmp_subdir_prefix&m_fso.GetFileName(m_zip_file))
  
  '     
  if(m_fso.FileExists(m_own_tmp_dir_location))then
   call m_base.log_error(-1,"FOUND FILE WITH EQUAL OWN TEMP FOLDER NAME: ["&m_own_tmp_dir_location&"]")
   exit function
  end if
  
  dim own_folder
  set own_folder=nothing
  
  if(not m_fso.FolderExists(m_own_tmp_dir_location))then
   on error resume next
   
   set own_folder=m_fso.CreateFolder(m_own_tmp_dir_location)
   
   err_code  =err.number
   err_descr =err.description

   call err.clear()

   on error goto 0

   if(err_code<>0)then
    call m_base.log_error _
     (err_code,"FAIL CREATE OWN TEMP FOLDER ["&m_own_tmp_dir_location&"]"&vbCrLf&err_descr)

    exit function
   end if
  else
   on error resume next
   set own_folder=m_fso.GetFolder(m_own_tmp_dir_location)
   on error goto 0
  end if 'own folder not found

  '   
  if(own_folder is nothing)then
   call m_base.log_error _
    (-1,"FAIL GET OWN TEMP FOLDER ["&m_own_tmp_dir_location&"]"&vbCrLf&err_descr)
    
   exit function
  end if
  
  '   
  dim file
  dim file_path
  
  for each file in own_folder.files
   file_path=file.path
   
   m_base.log_warning("REMOVE FILE FROM OWN TEMP FOLDER: ["&file_path&"]")
   
   on error resume next
   call file.Delete(true)
   
   err_code=err.number
   err_descr=err.description
   
   on error goto 0
   
   call err.clear()
   
   if(err_code<>0)then
    call m_base.log_error(err_code, _
                          "FAIL DELETE FILE FROM OWN TEMP FOLDER: ["&file_path&"]"&vbCrLf&_
                          err_descr)
    exit function
   end if
  next 'file
  
  create_tmp_folder=true
 end function 'create_tmp_folder
 
 '------------------------------------------------------------------------
 'return: true - no error
 private function make_prog_arg(byref prog_arg)
  make_prog_arg=false

  dim zip_ext
  zip_ext=lcase(m_fso.GetExtensionName(m_zip_file))

  select case(zip_ext)
   case "rar"
    prog_arg="rar.exe e "

   case "zip"
    prog_arg="pkzip32 -extract "
    
   case else
    call m_base.log_error(-1,"Unknown archive file extension ["&zip_ext&"]")
    
    exit function
  end select 'zip_ext
  
  prog_arg=prog_arg&" """&m_zip_file&""" *.gbk """&m_own_tmp_dir_location&""""
  
  make_prog_arg=true
 end function 'make_prog_arg
end class't_task_for_unzip_rpl_pack

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

