'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'       
'                                          . 9  2005 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_task_for_zip_and_move_db_after_restore

class t_task_for_zip_and_move_db_after_restore
 private c_err_source
 
 private m_base
 private m_restore_task 'class t_task_for_restore_db_after_backup
 private m_fso
 
 private m_db_location '     
 private m_prev_db_location '   

 private m_db_archive_dir

 private m_is_finished
 private m_exit_code

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_task_for_zip_and_move_db_after_restore"
  
  set m_base          =new t_task_base_code
  set m_restore_task  =nothing
  set m_fso           =su_create_object("Scripting.FileSystemObject")
  
  m_base.error_source=c_err_source

  m_is_finished=false
  m_exit_code  =-1
 end sub 'constructor
 
 'properties -------------------------------------------------------------
 public property set log (x)
  set m_base.log=x
 end property

 '------------------------------------------------------------------------
 public property get title()
  title="ZIP AND MOVE DATABASE ["&m_db_location&"]"
 end property
 
 ' ----------------------------------------------------------
 public sub init(restore_task,db_location,db_archive_dir)
  m_is_finished=false
  m_exit_code  =-1

  set m_restore_task=restore_task
  
  call depended_on_task(restore_task)
  
  m_db_archive_dir=db_archive_dir
  
  m_prev_db_location=db_location
 end sub 'init

 '------------------------------------------------------------------------
 public sub depended_on_task(task)
  call m_base.depended_on_task(task,true)
 end sub 'depended_on_task

 '    -----------------------------------
 public function can_start()
  can_start=m_base.can_start()
 end function 'can_start

 '    --------------------------------------
 public function is_active()
  is_active=false
 end function 'is_active

 '------------------------------------------------------------------------
 public function is_finished()
  is_finished=m_is_finished
 end function 'is_finished

 '------------------------------------------------------------------------
 public function get_exit_code()
  get_exit_code=m_exit_code
 end function 'get_exit_code

 '------------------------------------------------------------------------
 public function run(mng)
  run=false
  
  m_db_location = m_restore_task.gdb_location
  
  '    
  if(not m_fso.FileExists(m_db_location))then
   exit function
  end if

  '         
  if(not m_fso.FolderExists(m_db_archive_dir))then
   call m_base.log_error(-1,"BACKUP FOLDER ["&m_db_archive_dir&"] NOT FOUND")
   exit function
  end if  
  
  dim archive_dir
  archive_dir=m_fso.BuildPath(m_db_archive_dir,m_fso.GetBaseName(m_prev_db_location))

  if(not m_fso.FolderExists(archive_dir))then
   '        
   if(not create_folder(archive_dir))then exit function
  end if
  
  '       
  dim move_task
  set move_task=new t_task_for_zip_and_move_old_db

  set move_task.log=m_base.log

  call move_task.init(m_db_location,archive_dir)

  call mng.add_task(move_task)
  
  '    
  m_is_finished=true
  m_exit_code  =0

  run=true
 end function 'run
 
 '------------------------------------------------------------------------
 public sub deactivate(mng)
 end sub'deactivate
 
  '------------------------------------------------------------------------
 private function create_folder(folder_location)
  create_folder=false

  dim err_code
  dim err_descr

  on error resume next

  call m_fso.CreateFolder(folder_location)

  err_code  =err.number
  err_descr =err.description

  call err.clear()

  on error goto 0

  if(err_code<>0)then
   call m_base.log_error(err_code,"FAIL CREATE FOLDER ["&folder_location&"]")
   exit function
  end if

  create_folder=true
 end function 'create_folder
 
end class 't_task_for_zip_and_move_db_after_restore

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

