'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'     GDB 
'                                        . 10  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_task_for_zip_and_move_old_db

class t_task_for_zip_and_move_old_db
 private c_err_source
 
 private m_base
 private m_fso
 private m_file_name  '  
 private m_dest_dir   '  
 
 private m_max_archive_count '     
 
 private m_zip_arg    '  
 
 'constructor ------------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_task_for_zip_and_move_old_db"
  
  set m_base=new t_task_base_code
  set m_fso =su_create_object("Scripting.FileSystemObject")
  
  m_base.error_source=c_err_source
  
  m_max_archive_count=5
  
  m_zip_arg="rar.exe a -ep "
 end sub 'class_initialize
 
 ' ----------------------------------------------------------
 public sub init(file_name,dest_dir)
  m_file_name =file_name
  m_dest_dir  =dest_dir
 end sub 'init
 
 'properties -------------------------------------------------------------
 public property set log(x)
  set m_base.log=x
 end property 'log
 
 public property get title()
  title="ZIP AND MOVE OLD DATABASE ["&m_file_name&"]"
 end property
 
 '------------------------------------------------------------------------
 public sub depended_on_task(task)
  call m_base.depended_on_task(task,true)
 end sub 'depended_on_task

 '    -----------------------------------
 public function can_start()
  can_start=m_base.can_start()
 end function 'can_start

 '    --------------------------------------
 public function is_active()
  is_active=m_base.is_active()
 end function 'is_active

 '------------------------------------------------------------------------
 public function is_finished()
  is_finished=m_base.is_finished()
 end function 'is_finished

 '------------------------------------------------------------------------
 public function get_exit_code()
  get_exit_code=m_base.get_exit_code()
 end function 'get_exit_code

 '------------------------------------------------------------------------
 public function run(mng)
  run=false
  
  '  
  if(not m_fso.FileExists(m_file_name))then
   call m_base.log_error(-1,"FILE ["&m_file_name&"] NOT FOUND")
   exit function
  end if
  
  '    
  if(not m_fso.FolderExists(m_dest_dir))then
   call m_base.log_error(-1,"DEST FOLDER ["&m_dest_dir&"] NOT FOUND")
   exit function
  end if
  
  '    
  dim dest_location
  dest_location=m_fso.BuildPath(m_dest_dir,m_fso.GetBaseName(m_file_name))
  
  dim prog
  set prog=new t_prog_executor
  
  set prog.log=m_base.log
  
  dim prog_arg
  prog_arg=m_zip_arg&" """&dest_location&""" """&m_file_name&""""
  
  if(prog.exec(prog_arg,"ZIP:["&m_file_name&"]"))then
   set m_base.prog=prog
   run=true
  end if
 end function 'run
 
 '------------------------------------------------------------------------
 public sub deactivate(mng)
  '   
  call delete_file(m_file_name)
  
  '       
  call delete_old_archives()
 end sub 'deactivate
 
 '------------------------------------------------------------------------
 private sub delete_file(file_location)
  if(not m_fso.FileExists(file_location))then exit sub
 
  dim err_code
  dim err_descr
  
  on error resume next

  call m_fso.DeleteFile(file_location,true)

  err_code  =err.number
  err_descr =err.description

  on error goto 0

  if(err_code<>0)then
   call m_base.log_error(err_code,"FAIL DELETE FILE ["&file_location&"]"&vbCrLf& _
                                err_descr)
  else
   call m_base.log_msg("DELETE FILE ["&file_location&"]")
  end if
 end sub 'delete_file

 '------------------------------------------------------------------------
 private sub delete_old_archives()
  dim f
  
  dim file_names
  set file_names=su_create_object("LCPI.DBS.Utility.Vector")
  
  for each f in m_fso.GetFolder(m_dest_dir).Files
   file_names.PushBack(f.Path)
  next 'f
  
  call sort_buble(file_names,new t_su_string_compare)
  
  '   m_max_archive_count 
  dim i
  for i=0 to (file_names.count-1-m_max_archive_count)
   call delete_file(file_names(i))
  next
 end sub 'delete_old_archives
end class 'class t_task_for_zip_and_move_old_db

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

