'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'       
'                                          . 27  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'pkzip32      :(
'         .

'          
'       -    

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_task_for_zip_backup_files

class t_task_for_zip_backup_files
 private c_err_source

 private m_base          'class t_task_base_code
 private m_fso

 private m_backup_task   'class t_task_for_backup_db (object)
                         '        

 private m_add_ts_suffix '      

 private m_zip_arg       '  
 private m_zip_dir      't_archive_dir -  
 private m_zip_ext       '  
 
 private m_dest_location '   
 
 private m_title
 
 'constructor ------------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_task_for_zip_backup_files"
 
  set m_base        =new t_task_base_code
  set m_backup_task =nothing
  set m_fso         =su_create_object("Scripting.FileSystemObject")
  m_add_ts_suffix   =false
  
  m_base.error_source=c_err_source
  
  m_zip_arg="rar.exe a -ep "
  m_zip_ext="rar"
  m_title  ="ZIP BACKUP FILES"
 end sub 'class_initialize
 
 '------------------------------------------------------------------------
 public function get_source_location()
  if(IsObject(m_backup_task))then
   get_source_location=m_backup_task.gbk_location
  else
   get_source_location=m_backup_task
  end if
 end function 'get_source_location
 
 '------------------------------------------------------------------------
 public function get_dest_location()
  get_dest_location=m_dest_location
 end function 'get_dest_location
 
 'properties -------------------------------------------------------------
 public property get title()
  title=m_title
 end property

 '------------------------------------------------------------------------
 public property let add_ts_suffix(x)
  m_add_ts_suffix=x
 end property
 
 '------------------------------------------------------------------------
 public property get add_ts_suffix()
  add_ts_suffix=m_add_ts_suffix
 end property
 
 ' ----------------------------------------------------------
 
 'zip_dir - t_archive_dir       
 
 public sub init(log,backup_task,zip_dir)
  set m_base.log=log
  
  set m_base.prog=nothing
  
  if(not IsObject(backup_task))then
   m_backup_task=backup_task
  else
   set m_backup_task=backup_task

   '      
   call m_base.depended_on_task(backup_task,true)
  end if
  
  if(IsObject(zip_dir))then
   if(zip_dir is nothing)then
    call err.raise(-1,c_err_source,"NULL pointer on archive dir object!")
   end if
  
   set m_zip_dir=zip_dir
  else
   set m_zip_dir=new t_archive_dir
  
   m_zip_dir.path=zip_dir
  end if
 end sub 'init
 
 '    -----------------------------------
 public function can_start()
  can_start=m_base.can_start()
 end function 'can_start

 '    --------------------------------------
 public function is_active()
  is_active=m_base.is_active()
 end function 'is_active

 '------------------------------------------------------------------------
 public function is_finished()
  is_finished=m_base.is_finished()
 end function 'is_finished

 '------------------------------------------------------------------------
 public function get_exit_code()
  get_exit_code=m_base.get_exit_code()
 end function 'get_exit_code

 '------------------------------------------------------------------------
 public function run(mng)
  run=false

  dim gbk_location
  gbk_location=get_source_location()

  '    
  if(not m_fso.FileExists(gbk_location))then
   call err.raise(-1,c_err_source,"GBAK FILE ["&gbk_location&"] NOT FOUND")
  end if
  
  dim gbk_base_name '   
  dim gbk_path      ' 

  gbk_base_name =m_fso.GetBaseName(gbk_location)
  gbk_path      =m_fso.GetParentFolderName(gbk_location)
 
  '   
  if(not m_fso.FolderExists(m_zip_dir.path))then
   call err.raise(-1,c_err_source,"ZIP FOLDER ["&m_zip_dir.path&"] NOT FOUND")
  end if
 
  '   
  dim zip_path
  zip_path=m_zip_dir.path
  
  dim zip_folder

  if(m_zip_dir.create_subdir)then
   call wscript.sleep(1010)
   
   zip_path=m_fso.BuildPath(zip_path,su_gen_ts_str())
   
   call m_base.log_msg("CREATE SUBFOLDER ["&zip_path&"]")
   
   set zip_folder=m_fso.CreateFolder(zip_path)
  else
   set zip_folder=m_fso.GetFolder(zip_path)
  end if
  
  '     
  dim zip_base_name
  zip_base_name=gbk_base_name

  if(m_add_ts_suffix)then
   wscript.sleep(1100)
   
   zip_base_name=zip_base_name&"_"&su_gen_ts_str()
  end if

  dim file
  for each file in zip_folder.files
   if(m_fso.GetBaseName(file.Name)=zip_base_name)then
    call err.raise(-1,c_err_source,"IN ZIP FOLDER ["&zip_path&"] FOUND FILE WITH EQUAL BASE NAME ["&file.Name&"]")
   end if
  next 'file
  
  '   
  dim source_files
  dim dest_files
  
  source_files =m_fso.BuildPath(gbk_path,gbk_base_name&".*")

  m_dest_location=m_fso.BuildPath(zip_path,zip_base_name)
  
  if(m_zip_ext<>"")then
   m_dest_location=m_dest_location&"."&m_zip_ext
  end if
  
  dim prog_arg
  prog_arg=m_zip_arg

  if(m_zip_dir.volume<>"")then
   prog_arg=prog_arg&" -v"&m_zip_dir.volume
  end if

  prog_arg=prog_arg&" """&m_dest_location&""" """&source_files&""""

  dim prog
  set prog=new t_prog_executor
  set prog.log=m_base.log
 
  m_title="ZIP ["&source_files&"]"
 
  if(prog.exec(prog_arg,m_title))then
   set m_base.prog=prog
   run=true
  end if
 end function 'run

 '------------------------------------------------------------------------
 public sub deactivate(mng)
 end sub'deactivate
end class 't_task_for_zip_backup_files

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
