'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' 
'                                           . 27  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'    
' [R] title
'         
' [F] is_active()
'       return: true      
' [F] run(mng)
'        
'       return: true    
' [F] get_exit_code()
'         
'          
' [F] can_start()
'       true -    
' [S] deactivate(mng)
'              
'       mng -  
'

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_active_task_descr

'  

class t_active_task_descr
 private m_task
 private m_start_ts  ' 
 
 'constructor ------------------------------------------------------------
 private sub class_initialize()
  set m_task=nothing
  m_start_ts=null
 end sub 'class_initialize
 
 'properties -------------------------------------------------------------
 public property get task()
  set task=m_task
 end property
 
 public property get start_ts()
  start_ts=m_start_ts
 end property
 
 ' ----------------------------------------------------------
 public sub init(task,start_ts)
  set m_task  =task
  m_start_ts  =start_ts
 end sub 'init
end class 't_active_task_descr

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_task_manager

class t_task_manager
 private c_err_source

 private m_log
 private m_max_active_task_count'    

 private m_active_tasks  '   (t_active_task_descr)
 private m_tasks         ' ,  

 'constructor ------------------------------------------------------------
 private sub class_initialize
  c_err_source=typename(me)
 
  set m_log=nothing
 
  m_max_active_task_count=2

  set m_active_tasks=su_create_object("LCPI.DBS.Utility.Vector")
  set m_tasks=su_create_object("LCPI.DBS.Utility.Vector")
  
  wscript.echo "CREATE TASK MANAGER"
 end sub 'class_initialize
 
 'properties -------------------------------------------------------------
 public property set log(x)
  set m_log=x
 end property 'log
 
 '------------------------------------------------------------------------
 public property get log()
  set log=m_log
 end property

 '------------------------------------------------------------------------
 public property let max_active_task_count(x)
  if(x<1)then x=1
 
  m_max_active_task_count=x
 end property
 
 '------------------------------------------------------------------------
 public property get max_active_task_count()
  max_active_task_count=m_max_active_task_count
 end property
 
 '------------------------------------------------------------------------
 '  
 public property get cur_active_task_count()
  cur_active_task_count=m_active_tasks.count
 end property

 '------------------------------------------------------------------------
 '   
 public property get wait_task_count()
  wait_task_count=m_tasks.count
 end property

 '   ------------------------------------------------
 public sub add_task(task)
  call m_tasks.PushBack(task)
 end sub 'add_task
 
 '   -------------------------------------------------
 'return: true -    
 public function process()
  '   
  dim i_task
  dim task
  dim task_descr

  dim err_code
  dim err_source
  dim err_descr
  
  dim msg_str
  dim finish_ts

  dim beg_task_count
  dim run_result
  dim run_ts

  '  
  beg_task_count=m_active_tasks.Count

  for i_task=m_active_tasks.Count-1 to 0 step -1
   set task_descr =m_active_tasks(i_task)
   set task       =task_descr.task

   if(not task.is_active())then
    call log_msg("- - - - - - - - - - - - - - - - - - - ")
   
    ' 
    finish_ts=now()
    
    msg_str="RUN TS:"&su_date_to_str(task_descr.start_ts)&" "& _
            "END TS:"&su_date_to_str(finish_ts)&" "& _
            "DURATION:"&cstr(su_date_diff(task_descr.start_ts,finish_ts))

    call m_active_tasks.Remove(i_task)

    on error resume next
    
    '        exit_code 
    call task.deactivate(me)

    err_code   =err.number
    err_source =err.source
    err_descr  =err.description

    call err.clear()

    on error goto 0
   
    if(err_code<>0)then
     if(not(m_log is nothing))then
      call m_log.send_error(err_code,err_source,err_descr)
     end if
    end if
   
    '----------------------------
    if(task.get_exit_code()=0)then
     msg_str="[SUCCESS] "&msg_str
    
     call log_msg("END TASK: "&task.title&vbCrLf&msg_str)
    else
     msg_str="[FAILED] "&msg_str

     call log_error(task.get_exit_code(),"FAIL TASK: "&task.title&vbCrLf&msg_str)
    end if

    call log_DoneTask(task.get_exit_code(),task.title,msg_str)
   end if 'task is not active
  next 'i_task
  
  if(m_active_tasks.count<>beg_task_count)then
   call log_msg("")
  end if

  '  
  do while(true)
   if(m_max_active_task_count<=m_active_tasks.Count)then exit do

   beg_task_count=m_tasks.Count

   for i_task=0 to m_tasks.Count-1
    set task=m_tasks(i_task)

    if(task.can_start())then
     call m_tasks.Remove(i_task)
     
     run_ts=now()
     
     call log_msg("------------------------------------")
     call log_msg("RUN TASK ["&su_date_to_str(run_ts)&"]: "&task.title)
     
     on error resume next

     run_result=task.Run(me)
     
     err_code   =err.number
     err_source =err.source
     err_descr  =err.description
     
     call err.clear()
     
     on error goto 0
     
     if(err_code<>0)then
      run_result=false
      
      if(not(m_log is nothing))then
       call m_log.send_error(err_code,err_source,err_descr)
      end if
     end if
     
     '----------------------------
     if(run_result)then
      set task_descr=new t_active_task_descr
      
      call task_descr.init(task,run_ts)
      
      call m_active_tasks.PushBack(task_descr)
     else
      call log_error(-1,"FAIL RUN TASK: "&task.title)
      
      call log_DoneTask(-1,task.title,"FAIL RUN. "&err_descr)
     end if
     
     exit for
    end if
   next 'i_task
   
   '    ,     
   if(beg_task_count=m_tasks.Count)then
    exit do
   end if
  loop
  
  process=not m_active_tasks.IsEmpty()
 end function 'process

 '    ---------------------------------------------
 public sub run(period)
  dim msg
  msg="SLEEP "&period&" ms."
  
  while(me.process())
   wscript.echo msg&" [task:"&cstr(cur_active_task_count)&"/"& _
                                   cstr(wait_task_count)&"]"

   call wscript.sleep(period)
  wend
 end sub 'run

 'trace methods ----------------------------------------------------------
 private sub log_msg(msg)
  if(not (m_log is nothing))then
   call m_log.send_msg(msg)
  end if
 end sub 'log_msg

 '------------------------------------------------------------------------
 private sub log_error(err_code,err_descr)
  if(not(m_log is nothing))then
   call m_log.send_error(err_code,c_err_source,err_descr)
  end if
 end sub 'log_error

 '------------------------------------------------------------------------
 private sub log_DoneTask(err_code,source,descr)
  if(not(m_log is nothing))then
   call m_log.send_success_ex("AllTasks",err_code,source,descr)
  end if
 end sub 'log_DoneTask
end class 't_task_manager
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

