'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'      B/R   
'                                         . 29  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_task_group_for_br_primary_db

'
' 1.   GBAK.BACKUP              [first_task]             [!full_BR - last_task]
' 2.1  ZIP
' 2.2  GBAK.RESTORE             [full_BR]
' 3.1  REMOVE GBK files
' 3.2  REPLACE DATABASE         [full_BR - last_task]

'  c_pnt_DB_BR_xxx  ../prog/params/t_prog_params_night_tasks.vbs
class t_task_group_for_br_primary_db
 private m_fso

 private m_task_for_backup                't_task_for_backup_db
 private m_task_for_zip                   't_task_for_zip_backup_files
 private m_task_for_reserve_in_storages   't_task_for_reserve_backup_files_in_storages
 private m_task_for_restore               't_task_for_restore_db_after_backup
 private m_task_for_remove_backup_files   't_task_for_remove_backup_files
 private m_task_for_replace_database      't_task_for_replace_db
 private m_task_for_sweep_db              't_task_for_sweep_db
 private m_task_for_zip_after_bsr         't_task_for_zip_and_move_db_after_restore

 '    
 private m_last_task

 'constructor ------------------------------------------------------------
 private sub class_initialize()
  set m_fso=su_create_object("Scripting.FileSystemObject")
 
  set m_task_for_backup                         = nothing
  set m_task_for_zip                            = nothing
  set m_task_for_reserve_in_storages            = nothing
  set m_task_for_restore                        = nothing
  set m_task_for_remove_backup_files            = nothing
  set m_task_for_replace_database               = nothing
  set m_task_for_sweep_db                       = nothing
  set m_task_for_zip_after_bsr                  = nothing

  set m_last_task                               = nothing
 end sub 'class_initialize

 '------------------------------------------------------------------------
 public property get first_task()
  set first_task=m_task_for_backup
 end property
 
 '------------------------------------------------------------------------
 public property get last_task()
  set last_task=m_last_task
 end property
 
 '      ------------------------
 
 'storages  - LCPI.DBS.Utility.Vector c    

 public sub build(byval mng,               _
                  byval BR_type,           _
                  byval source_db_descr,   _
                  byval target_db_descr,   _
                  byval gbak_exe,          _
                  byval gbak_service,      _
                  byval gfix_exe,          _
                  byval gbk_path,          _
                  byval zip_path,          _
                  byval storages)
                  
  select case BR_type
   case c_pnt_db_BR_B,c_pnt_db_BR_backup_only
    call build_backup_task(mng,             _
                           gbak_exe,        _
                           gbak_service,    _
                           source_db_descr, _
                           gbk_path,        _
                           zip_path)

   case c_pnt_db_BR_BR, c_pnt_db_BR_full
    call build_BR_task(mng,             _
                       gbak_exe,        _
                       gbak_service,    _
                       source_db_descr, _
                       gbk_path,        _
                       zip_path,        _
                       target_db_descr)

   case c_pnt_db_BR_BS
    call build_BS_task(mng,             _
                       gbak_exe,        _
                       gbak_service,    _
                       gfix_exe,        _
                       source_db_descr, _
                       gbk_path,        _
                       zip_path)
    
   case c_pnt_db_BR_S
    call build_S_task(mng,gfix_exe,source_db_descr)
    
   case c_pnt_db_BR_BSR
    call build_BSR_task(mng,             _
                        gbak_exe,        _
                        gbak_service,    _
                        gfix_exe,        _
                        source_db_descr, _
                        gbk_path,        _
                        zip_path,        _
                        target_db_descr)
    
   case else
    exit sub
  end select'BR_types

  'DONE:        
  '         

  if(not(m_task_for_zip is nothing) and (not (storages is nothing)))then
   set m_task_for_reserve_in_storages=new t_task_for_reserve_backup_files_in_storages

   call m_task_for_reserve_in_storages.init(mng.log, _
                                            m_task_for_zip, _
                                            storages)

   call mng.add_task(m_task_for_reserve_in_storages)

   ' gbk       
   call m_task_for_remove_backup_files.depended_on_task(m_task_for_reserve_in_storages,false)
  end if
 end sub 'build 

 '-------------------------------------------------------------------------
 private sub build_backup_task(mng,             _
                               gbak_exe,        _
                               gbak_service,    _
                               source_db_descr, _
                               gbk_path,        _
                               zip_path)
  set m_last_task = init_backup_task(mng,                _
                                     gbak_exe,           _
                                     gbak_service,       _
                                     source_db_descr,    _
                                     gbk_path,           _
                                     zip_path)
 end sub'build_backup_task
 
 '-------------------------------------------------------------------------
 private sub build_BR_task(mng,             _
                           gbak_exe,        _
                           gbak_service,    _
                           source_db_descr, _
                           gbk_path,        _
                           zip_path,        _
                           target_db_descr)
  call init_backup_task(mng,             _
                        gbak_exe,        _
                        gbak_service,    _
                        source_db_descr, _
                        gbk_path,        _
                        zip_path)
  
  call init_restore_task(mng,             _
                         gbak_exe,        _
                         gbak_service,    _
                         target_db_descr, _
                         m_fso.GetParentFolderName(target_db_descr.location))
  
  '     
  set m_task_for_replace_database=new t_task_for_replace_db
  set m_task_for_replace_database.log=mng.log

  call m_task_for_replace_database.init(m_task_for_restore, _
                                        target_db_descr.location, _
                                        zip_path.path)

  call mng.add_task(m_task_for_replace_database)

  '     (  )
  set m_last_task=m_task_for_replace_database
 end sub'build_BR_task
 
 '-------------------------------------------------------------------------
 private sub build_BS_task(mng,             _
                           gbak_exe,        _
                           gbak_service,    _
                           gfix_exe,        _
                           source_db_descr, _
                           gbk_path,        _
                           zip_path)
  dim backup
  set backup=init_backup_task(mng,             _
                              gbak_exe,        _
                              gbak_service,    _
                              source_db_descr, _
                              gbk_path,        _
                              zip_path)
  
  dim sweep
  set sweep=init_sweep_task(mng,gfix_exe,source_db_descr)
  
  '      
  call sweep.depended_on_task(backup)

  set m_last_task = sweep
 end sub'build_BS_task
 
 '-------------------------------------------------------------------------
 private sub build_S_task(mng,gfix_exe,source_db_descr)  
  set m_last_task = init_sweep_task(mng,gfix_exe,source_db_descr)
 end sub'build_S_task
 
 '-------------------------------------------------------------------------
 private sub build_BSR_task(mng,             _
                            gbak_exe,        _
                            gbak_service,    _
                            gfix_exe,        _
                            source_db_descr, _
                            gbk_path,        _
                            zip_path,        _
                            target_db_descr)
  dim backup
  set backup=init_backup_task(mng,             _
                              gbak_exe,        _
                              gbak_service,    _
                              source_db_descr, _
                              gbk_path,        _
                              zip_path)

  call init_restore_task(mng,             _
                         gbak_exe,        _
                         gbak_service,    _
                         target_db_descr, _
                         zip_path.path)
  
  set m_task_for_zip_after_bsr = new t_task_for_zip_and_move_db_after_restore

  call m_task_for_zip_after_bsr.init(m_task_for_restore,target_db_descr.location,zip_path.path)

  call mng.add_task(m_task_for_zip_after_bsr)
  
  dim sweep
  set sweep=init_sweep_task(mng,gfix_exe,source_db_descr)
  
  '      
  call sweep.depended_on_task(backup)

  set m_last_task = sweep
 end sub'build_BSR_task
 
 '----------------      ----------------
 private function init_backup_task(mng,             _
                                   gbak_exe,        _
                                   gbak_service,    _
                                   source_db_descr, _
                                   gbk_path,        _
                                   zip_path)
  set m_task_for_backup=new t_task_for_backup_db

  set init_backup_task=m_task_for_backup
  
  call m_task_for_backup.init2(mng.log,         _
                               gbak_exe,        _
                               gbak_service,    _
                               source_db_descr, _
                               gbk_path)

  call mng.add_task(m_task_for_backup)

  '   
  set m_task_for_zip=new t_task_for_zip_backup_files

  call m_task_for_zip.init(mng.log,m_task_for_backup,zip_path)

  call mng.add_task(m_task_for_zip)

  '      
  set m_task_for_remove_backup_files=new t_task_for_remove_backup_files

  call m_task_for_remove_backup_files.init(mng.log,m_task_for_backup)

  call mng.add_task(m_task_for_remove_backup_files)

  ' gbk    __ 
  call m_task_for_remove_backup_files.depended_on_task(m_task_for_zip,true)
 end function'init_backup_task
 
 '-----         --------------
 private sub init_restore_task(mng,               _
                               gbak_exe,          _
                               gbak_service,      _
                               target_db_descr,   _
                               dest_path)
  set m_task_for_restore=new t_task_for_restore_db_after_backup
  
  call m_task_for_restore.init(mng.log,                   _
                               m_task_for_backup,         _
                               gbak_exe,                  _
                               gbak_service,              _
                               dest_path,                 _
                               target_db_descr.user_name, _
                               target_db_descr.password)
                                 
  ' gbk    __ 
  call m_task_for_remove_backup_files.depended_on_task(m_task_for_restore,true)

  call mng.add_task(m_task_for_restore)
  
 end sub'init_restore_task
 
 '-------------------------------------------------------------------------
 private function init_sweep_task(mng,gfix_exe,source_db_descr)
  set m_task_for_sweep_db = new t_task_for_sweep_db

  call m_task_for_sweep_db.init(mng.log,gfix_exe,source_db_descr)

  call mng.add_task(m_task_for_sweep_db)
  
  set init_sweep_task=m_task_for_sweep_db
 end function'init_sweep_task

end class 't_task_group_for_br_primary_db

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

