'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'        
'                                            . 29  2004 .

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
option explicit

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'class t_task_group_for_unzip_rpl_packs

'     build_tasks

class t_task_group_for_unzip_rpl_packs
 private c_err_source
 private m_fso             'FileSystemObject

 private m_tasks           '  

 '   
 private m_param_IN_zip_path           '  
 private m_param_TMP_zip_path          '  
 private m_param_TMP_unzip_gbk_path    '    
 private m_param_TMP_gbk_path          '  

 '------------------------------------------------------------------------
 private sub class_initialize()
  c_err_source="t_task_group_for_unzip_rpl_packs"
  
  set m_fso  =su_create_object("Scripting.FileSystemObject")
  set m_tasks=su_create_object("LCPI.DBS.Utility.Vector")
 end sub 'class_initialize
 
 'properties -------------------------------------------------------------
 public property get tasks()
  set tasks=m_tasks
 end property
 
 '   --------------------------------------------
 public property let param_IN_zip_path(v)
  m_param_IN_zip_path=v
 end property 'param_IN_zip_path
 
 '------------------------------------------------------------------------
 public property let param_TMP_zip_path(v)
  m_param_TMP_zip_path=v
 end property 'param_TMP_zip_path

 '------------------------------------------------------------------------
 public property let param_TMP_gbk_path(v)
  m_param_TMP_gbk_path=v
 end property 'param_TMP_gbk_path

 '------------------------------------------------------------------------
 public property let param_TMP_unzip_gbk_path(v)
  m_param_TMP_unzip_gbk_path=v
 end property 'param_TMP_unzip_gbk_path

 '   --------------------------------------------
 'return true -  
 public function build_tasks(task_mng)
  build_tasks=false
 
  '0     IN_zip_path  TMP_zip_path
  dim err_code,err_descr,err_source

  on error resume next

  call su_move_files(m_param_IN_zip_path,m_param_TMP_zip_path)

  err_code   = err.number
  err_source = err.source
  err_descr  = err.description

  err.clear()

  on error goto 0
  
  if(err_code<>0)then
   call task_mng.log.send_error(err_code,err_source,err_descr)

   exit function
  end if


  '1   
  dim zip_files
  set zip_files=su_create_object("LCPI.DBS.Utility.Vector")

  call scan_files(zip_files,m_param_TMP_zip_path,"zip")
  call scan_files(zip_files,m_param_TMP_zip_path,"rar")

  '2        
  dim tmp_dir_prefix
  tmp_dir_prefix="tmp_"&su_gen_ts_str()&"_"

  '3      
  dim file

  for each file in zip_files
   call add_unzip_task(task_mng,file,tmp_dir_prefix)
  next 'file
  
  build_tasks=true
 end function 'build_tasks
 
 '------------------------------------------------------------------------
 private function add_unzip_task(task_mng,zip_file,tmp_dir_prefix)
  dim task
  set task=new t_task_for_unzip_rpl_pack
  
  set task.log=task_mng.log

  call task.init(zip_file.Path, _
                 m_param_TMP_gbk_path, _
                 m_param_TMP_unzip_gbk_path, _
                 tmp_dir_prefix)
 
  call task_mng.add_task(task)
 
  '   
  call m_tasks.PushBack(task)
 
  set add_unzip_task=task
 end function 'add_unzip_task

 '------------------------------------------------------------------------
 private sub scan_files(file_list,path,file_ext)
  dim folder

  set folder=m_fso.GetFolder(path)

  dim files

  set files=folder.Files

  dim file

  for each file in files
   if(ucase(m_fso.GetExtensionName(file.Name))=ucase(file_ext))then
    file_list.PushBack(file)
   end if
  next 'file
 end sub 'scan_files
end class 't_task_group_for_unzip_rpl_packs

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

